# NREL's Reference OpenSource Controller (ROSCO) toolbox for wind turbine applications
NREL's Reference OpenSource Controller (ROSCO) for wind turbine applications is a toolset designed to ease controller use and implementation for the wind turbine researcher. Some primary capabilities include:
* A reference controller with industry-standard functionality 
* Generic tuning of NREL's ROSCO controller
* Simple 1-DOF turbine simulations for quick controller capability verifications
* Parsing of OpenFAST input and output files

## Part of the WETO Stack

ROSCO is primarily developed with the support of the U.S. Department of Energy and is part of the [WETO Software Stack](https://nrel.github.io/WETOStack). For more information and other integrated modeling software, see:
- [Portfolio Overview](https://nrel.github.io/WETOStack/portfolio_analysis/overview.html)
- [Entry Guide](https://nrel.github.io/WETOStack/_static/entry_guide/index.html)
- [OpenFAST Workshop](https://nrel.github.io/WETOStack/workshops/user_workshops_2024.html#openfast-ecosystem)


## Introduction
The NREL Reference OpenSource Controller (ROSCO) provides an open, modular and fully adaptable baseline wind turbine controller to the scientific community. The ROSCO toolbox leverages this architecture and implementation to provide a generic tuning process for the controller. Because of the open character and modular set-up, scientists are able to collaborate and contribute in making continuous improvements to the code for the controller and the toolbox. The ROSCO controller is implemented in FORTRAN, while the remainder of the toolset is a mostly-python code base with a number of functionalities.

* [ROSCO](https://github.com/NREL/ROSCO/tree/main/ROSCO) - the fortran source code for the ROSCO controller. 
* [Examples](https://github.com/NREL/ROSCO/tree/main/Examples) - short working examples of the capabilities of the ROSCO toolbox. 
* [Tune_Cases](https://github.com/NREL/ROSCO/tree/main/Tune_Cases) - example generic tuning scripts for a number of open-source reference turbines.
* [Test_Cases](https://github.com/NREL/ROSCO/tree/main/Test_Cases) - numerous NREL 5MW bases cases to run for controller updates and comparisons. A "test-suite", if you will...
* [Matlab_Toolbox](https://github.com/NREL/ROSCO/tree/main/Matlab_Toolbox) - MATLAB scripts to parse and plot simulation output data.
* [ofTools](https://github.com/NREL/ROSCO/tree/main/ROSCO_toolbox/ofTools) - A number of scripts to facilitate usage of OpenFAST and manage OpenFAST input and output files. 
* [linear](https://github.com/NREL/ROSCO/tree/main/ROSCO_toolbox/linear) - Scripts to aid with the use of linear models for controller tuning and simplified simulation. 


## Documentation
All relevant documentation about the ROSCO toolbox and ROSCO controller can be found at through [ROSCO's readthedocs webpage](https://rosco.readthedocs.io/en/latest/). Here, users can find the information on [installing the ROSCO tools](https://rosco.readthedocs.io/en/latest/source/install.html) for control purposes. Additionally, there is information on the [standard workflow](https://rosco.readthedocs.io/en/latest/source/standard_use.html), details of the input files, use cases for the ROSCO tool-chain, and more. 

## Issues and Discussion
If you find issues with any of the code that resides in this repository, it is encouraged for you to open a [GitHub issue](https://github.com/NREL/ROSCO/issues). If you have general questions or comments regarding the code, please start a [discussion via GitHub](https://github.com/NREL/ROSCO/discussions). We encourage you to use these resources for all ROSCO-related questions and comments, rather than other resources such as the FAST forums. This helps us keep ROSCO-related items centralized, and provides a singular place for the community to look when they have questions that might arise. Please keep in mind that we will do our very best to respond in a timely manner, but may take a few days to get back to you if you catch us during a busy time. 

## Compatibility
The ROSCO control library should be compatible with any multi-physics simulator that uses the Bladed-style ``avrSWAP``; this includes any version of OpenFAST.
OpenFAST (after version 3.5.0) has an extended avrSWAP with additional sensors and actuators that can be enabled in the DISCON.IN file using ``Ext_Interface``.  
Simulators other than OpenFAST should have ``Ext_Interface`` set to 0.

The python-based ROSCO toolbox for tuning control inputs reads an OpenFAST input file during that process. 
The ``openfast-io`` package is now used for input file reading and writing.  
The currently compatible version can be found in the ``environment.yml`` file.
OpenFAST inputs used in the controller tuning process should be consistent with that version.


## Contributing
If it wasn't obvious from _open-source_ being in the title of the tool-set, this is an open-source code base that we would love for the community to contribute to. If you find yourself fixing any bugs, writing new routines, or even making small typo changes, please submit a [pull request](https://github.com/NREL/ROSCO/pulls). 

## Survey
Please help us better understand the ROSCO user-base and how we can improve rosco through this brief survey:
[ROSCO toolchain survey](https://forms.office.com/Pages/ResponsePage.aspx?id=fp3yoM0oVE-EQniFrufAgGWnC45k8q5Kl90RBkHijqBUN0JTNzBJT1QwMjIzNDhCWDlDTUZPWDdMWC4u)

## Referencing
To reference the ROSCO source code directly, please use the following DOI:
[![DOI](https://zenodo.org/badge/220498357.svg)](https://zenodo.org/badge/latestdoi/220498357)

If the ROSCO Toolbox played a role in your research, please cite it. This software can be
cited as:

   NREL: ROSCO. Version 2.4.1, https://github.com/NREL/ROSCO, 2021.

For LaTeX users:

```
@misc{ROSCO_toolbox_2021,
    author = {NREL},
    title = {{ROSCO. Version 2.4.1}},
    year = {2021},
    publisher = {GitHub},
    journal = {GitHub repository},
    url = {https://github.com/NREL/ROSCO}
    }
```
If the ROSCO generic tuning theory and implementation played a roll in your research, please cite the following paper
```
@Article{wes-2021-19,
AUTHOR = {Abbas, N. and Zalkind, D. and Pao, L. and Wright, A.},
TITLE = {A Reference Open-Source Controller for Fixed and Floating Offshore Wind Turbines},
JOURNAL = {Wind Energy Science Discussions},
VOLUME = {2021},
YEAR = {2021},
PAGES = {1--33},
URL = {https://wes.copernicus.org/preprints/wes-2021-19/},
DOI = {10.5194/wes-2021-19}
}
```

## Additional Contributors and Acknowledgments
Primary contributions to ROSCO have been provided by researchers the National Renewable Energy Laboratory and the University of Colorado Boulder. Additionally, the ROSCO controller was built upon the foundations of the [Delft Research Controller](https://github.com/TUDelft-DataDrivenControl/DRC_Fortran). Much of the intellect behind these contributions has been inspired or derived from an extensive amount of work in the literature. The bulk of this has been cited through the primary publications about this work. 

# Simulink Implementation of ROSCO
A simulink version of ROSCO has been created for rapid prototyping of new control ideas. The results do not exactly match results from the .DLL version of ROSCO due to the way that Simulink handles initial conditions. These differences change the wind speed estimate slightly and propogate to differences in the torque control and pitch saturation. The following modules in ROSCO have been implemented in Simulink:
  - TSR tracking torque control
  - PI gain-scheduled pitch control
  - Setpoint smoothing control
  - Extended Kalman Filter wind speed estimator
  - Pitch Saturation
  - Floating feedback control
  
The modules not currently implemented include:
  - k\omega^2 torque control
  - Individual pitch control
  - Shutdown control
  - Flap control
  
`runFAST.m` can be used to load the ROSCO parameters from a .IN file, using `load_ROSCO_params.m`.  Add the `matlab-toolbox` [repository](https://github.com/OpenFAST/matlab-toolbox) to your matlab path.
  

# OpenFAST Tools
A set of OpenFAST tools is provided to ease the use of the ROSCO toolbox in conjuction with [OpenFAST](https://github.com/openfast/openfast).

OpenFAST can be installed using conda-forge using
```
conda install -c conda-forge openfast
```

Note that most of these scripts are copy and pasted from [weis's aeroleasticse](https://github.com/WISDEM/WEIS/tree/master/weis/aeroelasticse)

### case_gen
The scripts found in the case_gen folder can be used to run large sets of openfast simulations. This can be done ad-hoc, or for specific DLCs. 

### fast_io
The scripts in the fast_io folder are generally used to read or write OpenFAST input files. Note that all files starting with "FAST_*" should generally be the same as those found in aeroelasticse (amongst a few other scripts). 
- output_processing.py can be used to read OpenFAST output binary or text files, and then plot the output time series or power spectra.
- read_fast_input.py can be used to generically read OpenFAST input decks in a somewhat more flexible way than that in FAST_reader.py, so may be useful if the user's OpenFAST input files are out of date. 

# Examples
We offer some example scripts to showcase the functionalities of the ROSCO toolbox. This offers a non-inclusive overview of some of the primary functionalities of the ROSCO toolbox. Enjoy!

Examples: 
1. Load and save a turbine model. Prints some basic turbine data, and saves the turbine.
2. Load a turbine model from saved pickle, make a Cp surface plot.
3. Run CCblade, save a rotor performance text file.
4. Load a turbine model and tune the controller.
5. Run and plot a simple simple step wind simulation.
6. Load a turbine, tune a controller, run an OpenFAST simulation.
7. Load saved turbine, tune controller, plot minimum pitch schedule.
8. Plot some OpenFAST output data.
9. Run turbsim to compile binary.
10. Tune a controller for distributed aerodynamic control.
11. Generate simplified linear models, save the parameters to a file.
12. Run robust controller tuning
13. Tune and run a controller with IPC
14. Tune a controller with OpenLoop control commands inputs

# Tuning cases
Here are some instructions on how to use the generic tuning capabilities of the ROSCO toolbox. 

## Basic Steps
The basic steps are as follows

1. Fill out the .yaml input file to tune the controller
2. Run `tune_ROSCO.py`, or your own version of it.
3. Copy `DISCON.IN` and `Cp_Ct_Cq.txt` (or similar) to the desired folder for your wind turbine model.
4. Ensure that `PerfFileName` in `DISCON.IN` points to the proper name and location of `Cp_Ct_Cq.*.txt`
5. Ensure that `DLL_InFile` in the OpenFAST ServoDyn input file properly points to `DISCON.IN`.
6. Enjoy the results. Possibly retune your controller. 

## The .yaml File
We use a .yaml file to define the inputs to the generic controlling scripts. This .yaml file defines three different dictionaries with a number of parameters. The parameters that must be defined in [the documentation](https://rosco.readthedocs.io/en/latest/source/rosco_toolbox.html#the-rosco-toolbox-tuning-file)


### The controller parameters
The controller flags have some default values for the ROSCO controller implementation (provided in the previous section). This, subsequently, leaves four turbine parameters that the user must decide `zeta_pc`, `omega_pc`, `zeta_vs`, and `omega_vs`. The example .yaml scripts provided offer some insight into what these values might be for different sizes and types of turbines. Generally speaking, we desire slower responses in the the variable speed (vs) torque controller. This equates to `zeta_vs = 1` and `omega_vs = 0.3` for the NREL 5MW wind turbine. These values tend to translate fairly well to larger turbines, but decreasing `omega_vs = 0.3` may be desired. For the pitch controller, the NREL 5MW turbine was tuned such that `zeta_pc = 0.7`, and `omega_pc = 0.6` in the legacy controller. As a high level rule of thumb, increasing the desired damping to be over-damped (`zeta_pc ~ 1.0`) and the natural frequency to be much slower (`omega_pc = 0.2`) seems to produce smoother wind turbine responses in large turbines with highly flexible rotors. 


## Running a tuning case
As mentioned above, a sample tuning script `tune_ROSCO.py` is provided. This script only needs the first line to be modified to point to the desired `*.yaml` file, and will produce the necessary input files for the controller. The curious user should feel free to modify and change this file. A simple addition is to include the use of `sim.py` to run a simple 1DOF simulation case to verify controller tuning - `example_06.py` shows some of this functionally. Other uses include running OpenFAST directly (see `example_08.py`), plotting system outputs (functionality pending), or visualizing results from ccblade rotor performance analysis (Cp surface is plotted currently).

**NOTICE**

This directory includes WAMIT output files for hydrostatics, radiation, and both first- and second-order wave excitation.  The first-order excitation file (.3 extension) supports all wave headings, whereas the second-order excitation files (.12d and .12s extensions) are only provided for the 0-degree incident wave heading.  The HydroDyn flags, WvDiffQTF and WvSumQTF, can be used to activate or deactivate the inclusion of the second-order effects files, depending on the desired wave loading.  The WAMIT out-files (labeled as .out.wamit) are also included.

The WAMIT input files are included in two subdirectories, one for first order and one for second order. The first-order setup (used for the .1 and .3 files) include zero- and infinite-frequency radiation entries and include wave excitation at all headings in 10 degree increments. The second-order settings (used for the .12s and .12d files) use a reduced frequency range and only the zero degree wave excitation heading to reduce computational expense.

Note that the center of gravity is moved to the origin in the first-order WAMIT input file to remove the contributions from gravity to the hydrostatic stiffness in *.hst. The moment from gravity is added separately by OpenFAST. 

! ROSCO Registry
! This file is automatically generated by write_registry.py using ROSCO v2.10.1
! For any modification to the registry, please edit the rosco_types.yaml accordingly
 
MODULE ROSCO_Types
USE, INTRINSIC :: ISO_C_Binding
USE Constants
IMPLICIT NONE

Character(*), PARAMETER     :: rosco_version = '2.10.1'             ! ROSCO version

TYPE, PUBLIC :: ControlParameters
    INTEGER(IntKi)                :: ZMQ_ID                      ! 0000 - 9999, Identifier of the rosco, used for zeromq interface only
    INTEGER(IntKi)                :: LoggingLevel                ! 0 - write no debug files, 1 - write standard output .dbg-file, 2 - write standard output .dbg-file and complete avrSWAP-array .dbg2-file
    INTEGER(IntKi)                :: Echo                        ! 0 - no Echo, 1 - Echo input data to <RootName>.echo
    INTEGER(IntKi)                :: Ext_Interface               ! 0 - use standard bladed interface, 1 - Use the extened DLL interface introduced in OpenFAST 3.5.0.
    REAL(DbKi)                    :: DT_Out                      ! Output time step
    INTEGER(IntKi)                :: n_DT_Out                    ! output every this many steps
    INTEGER(IntKi)                :: n_DT_ZMQ                    ! Send measurements to ZMQ after this many time steps
    INTEGER(IntKi)                :: F_LPFType                   ! Low pass filter on the rotor and generator speed {1 - first-order low-pass filter, 2 - second-order low-pass filter}, [rad/s]
    REAL(DbKi)                    :: F_LPFCornerFreq             ! Corner frequency (-3dB point) in the first-order low-pass filter, [rad/s]
    REAL(DbKi)                    :: F_LPFDamping                ! Damping coefficient [used only when F_FilterType = 2]
    INTEGER(IntKi)                :: F_NumNotchFilts             ! Number of notch filters
    INTEGER(IntKi)                :: F_GenSpdNotch_N             ! Number of gen speed notch filters
    INTEGER(IntKi), DIMENSION(:), ALLOCATABLE     :: F_GenSpdNotch_Ind           ! Indices of gen speed notch filters
    INTEGER(IntKi)                :: F_TwrTopNotch_N             ! Number of tower top notch filters
    INTEGER(IntKi), DIMENSION(:), ALLOCATABLE     :: F_TwrTopNotch_Ind           ! Indices of tower top notch filters
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: F_NotchFreqs                ! Natural frequencies of notch filters, [rad/s]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: F_NotchBetaNum              ! Notch Filter Numerator damping (determines width)
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: F_NotchBetaDen              ! Notch Filter Numerator damping (determines depth?)
    REAL(DbKi)                    :: F_SSCornerFreq              ! Corner frequency (-3dB point) in the first order low pass filter for the setpoint smoother [rad/s]
    REAL(DbKi)                    :: F_WECornerFreq              ! Corner frequency (-3dB point) in the first order low pass filter for the wind speed estimate [rad/s]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: F_FlCornerFreq              ! Corner frequency (-3dB point) in the second order low pass filter of the tower-top fore-aft motion for floating feedback control [rad/s].
    REAL(DbKi)                    :: F_FlHighPassFreq            ! Natural frequency of first-roder high-pass filter for nacelle fore-aft motion [rad/s].
    REAL(DbKi)                    :: F_YawErr                    ! Corner low pass filter corner frequency for yaw controller [rad/s].
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: F_FlpCornerFreq             ! Corner frequency (-3dB point) in the second order low pass filter of the blade root bending moment for flap control [rad/s].
    REAL(DbKi)                    :: F_VSRefSpdCornerFreq        ! Corner frequency (-3dB point) in the first order low pass filter of the generator speed reference used for TSR tracking torque control [rad/s].
    INTEGER(IntKi)                :: TRA_Mode                    ! Tower Fore-Aft control mode {0 - no fore-aft control, 1 - Tower fore-aft damping, 2 -Frequency exclusion zone, 3- Options 1 and 2}
    REAL(DbKi)                    :: TRA_ExclSpeed               ! Rotor speed for exclusion [LSS] [rad/s]
    REAL(DbKi)                    :: TRA_ExclBand                ! One-half of the total frequency exclusion band. Torque controller reference will be TRA_ExclFreq +/- TRA_ExlBand [rad/s]
    REAL(DbKi)                    :: TRA_RateLimit               ! Time constant for gain change when in exclusion zone [s]
    INTEGER(IntKi)                :: TD_Mode                     ! Tower Fore-Aft control mode {0 - no fore-aft control, 1 - Tower fore-aft damping, 2 -Frequency exclusion zone, 3- Options 1 and 2}
    REAL(DbKi)                    :: FA_HPFCornerFreq            ! Corner frequency (-3dB point) in the high-pass filter on the fore-aft acceleration signal [rad/s]
    REAL(DbKi)                    :: FA_IntSat                   ! Integrator saturation (maximum signal amplitude contrbution to pitch from FA damper), [rad]
    REAL(DbKi)                    :: FA_KI                       ! Integral gain for the fore-aft tower damper controller, -1 = off / >0 = on [rad s/m]
    INTEGER(IntKi)                :: IPC_ControlMode             ! Turn Individual Pitch Control (IPC) for fatigue load reductions (pitch contribution) {0 - off, 1 - 1P reductions, 2 - 1P+2P reductions}
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: IPC_Vramp                   ! Wind speeds for IPC cut-in sigma function [m/s]
    REAL(DbKi)                    :: IPC_IntSat                  ! Integrator saturation (maximum signal amplitude contrbution to pitch from IPC)
    INTEGER(IntKi)                :: IPC_SatMode                 ! IPC Saturation method IPC Saturation method (0 - no saturation (except by PC_MinPit), 1 - saturate by PS_BldPitchMin, 2 - saturate sotfly (full IPC cycle) by PC_MinPit, 3 - saturate softly by PS_BldPitchMin)
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: IPC_KP                      ! Integral gain for the individual pitch controller, [-].
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: IPC_KI                      ! Integral gain for the individual pitch controller, [-].
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: IPC_aziOffset               ! Phase offset added to the azimuth angle for the individual pitch controller, [rad].
    REAL(DbKi)                    :: IPC_CornerFreqAct           ! Corner frequency of the first-order actuators model, to induce a phase lag in the IPC signal {0 - Disable}, [rad/s]
    INTEGER(IntKi)                :: PC_ControlMode              ! Blade pitch control mode {0 - No pitch, fix to fine pitch, 1 - active PI blade pitch control}
    INTEGER(IntKi)                :: PC_GS_n                     ! Amount of gain-scheduling table entries
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: PC_GS_angles                ! Gain-schedule table - pitch angles
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: PC_GS_KP                    ! Gain-schedule table - pitch controller kp gains
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: PC_GS_KI                    ! Gain-schedule table - pitch controller ki gains
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: PC_GS_KD                    ! Gain-schedule table - pitch controller kd gains
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: PC_GS_TF                    ! Gain-schedule table - pitch controller tf gains (derivative filter)
    REAL(DbKi)                    :: PC_MaxPit                   ! Maximum physical pitch limit, [rad].
    REAL(DbKi)                    :: PC_MinPit                   ! Minimum physical pitch limit, [rad].
    REAL(DbKi)                    :: PC_MaxRat                   ! Maximum pitch rate (in absolute value) in pitch controller, [rad/s].
    REAL(DbKi)                    :: PC_MinRat                   ! Minimum pitch rate (in absolute value) in pitch controller, [rad/s].
    REAL(DbKi)                    :: PC_RefSpd                   ! Desired (reference) HSS speed for pitch controller, [rad/s].
    REAL(DbKi)                    :: PC_FinePit                  ! Record 5 - Below-rated pitch angle set-point (deg) [used only with Bladed Interface]
    REAL(DbKi)                    :: PC_Switch                   ! Angle above lowest minimum pitch angle for switch [rad]
    INTEGER(IntKi)                :: VS_ControlMode              ! Generator torque control mode in below rated conditions {0 - no torque control, 1 - komega^2 with PI trans, 2 - WSE TSR Tracking, 3 - Power TSR Tracking, 4 - Torque TSR Tracking}
    INTEGER(IntKi)                :: VS_ConstPower               ! Constant power torque control
    INTEGER(IntKi)                :: VS_FBP                      ! Fixed blade pitch control mode in above rated conditions {0 - variable pitch (defer to PC_ControlMode and VS_ConstPower), 1 - P/omega overspeed control law, 2 - PI reference tracking based on WSE lookup table, 3 - PI reference tracking based on torque lookup table (must have VS_FBP_Tau be a monotonic function)}
    REAL(DbKi)                    :: VS_GenEff                   ! Generator efficiency mechanical power -> electrical power [-]
    REAL(DbKi)                    :: VS_ArSatTq                  ! Above rated generator torque PI control saturation, [Nm]
    REAL(DbKi)                    :: VS_MaxRat                   ! Maximum torque rate (in absolute value) in torque controller, [Nm/s].
    REAL(DbKi)                    :: VS_MaxTq                    ! Maximum generator torque in Region 3 (HSS side), [Nm].
    REAL(DbKi)                    :: VS_MinTq                    ! Minimum generator torque (HSS side), [Nm].
    REAL(DbKi)                    :: VS_MinOMSpd                 ! Optimal mode minimum speed, [rad/s]
    REAL(DbKi)                    :: VS_Rgn2K                    ! Generator torque constant in Region 2 (HSS side), N-m/(rad/s)^2
    REAL(DbKi)                    :: VS_RtPwr                    ! Wind turbine rated power [W]
    REAL(DbKi)                    :: VS_RtTq                     ! Rated torque, [Nm].
    REAL(DbKi)                    :: VS_RefSpd                   ! Rated generator speed [rad/s]
    INTEGER(IntKi)                :: VS_n                        ! Number of controller gains
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: VS_KP                       ! Proportional gain for generator PI torque controller, used in the transitional 2.5 region
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: VS_KI                       ! Integral gain for generator PI torque controller, used in the transitional 2.5 region
    REAL(DbKi)                    :: VS_TSRopt                   ! Power-maximizing region 2 tip-speed ratio [rad]
    INTEGER(IntKi)                :: VS_FBP_n                    ! Number of operating schedule entries for fixed blade pitch control
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: VS_FBP_U                    ! Operating schedule for fixed blade pitch control - Wind speed
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: VS_FBP_Omega                ! Operating schedule for fixed blade pitch control - Generator speed
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: VS_FBP_Tau                  ! Operating schedule for fixed blade pitch control - Generator torque
    INTEGER(IntKi)                :: SS_Mode                     ! Setpoint Smoother mode {0 - no setpoint smoothing, 1 - introduce setpoint smoothing}
    REAL(DbKi)                    :: SS_VSGain                   ! Variable speed torque controller setpoint smoother gain, [-].
    REAL(DbKi)                    :: SS_PCGain                   ! Collective pitch controller setpoint smoother gain, [-].
    INTEGER(IntKi)                :: PRC_Mode                    ! Power reference tracking mode, 0- use standard rotor speed set points, 1- use PRC rotor speed setpoints
    INTEGER(IntKi)                :: PRC_Comm                    ! Power reference communication mode, 0- use constant DISCON inputs, 1- use open loop inputs, 2- use ZMQ inputs
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: PRC_WindSpeeds              ! Array of wind speeds used in rotor speed vs. wind speed lookup table
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: PRC_GenSpeeds               ! Array of rotor speeds corresponding to PRC_WindSpeeds
    INTEGER(IntKi)                :: PRC_n                       ! Number of elements in PRC_WindSpeeds and PRC_GenSpeeds array
    REAL(DbKi)                    :: PRC_LPF_Freq                ! Frequency of the low pass filter on the wind speed estimate used to set PRC_GenSpeeds [rad/s]
    REAL(DbKi)                    :: PRC_R_Torque                ! Power rating through changing the rated torque, default is 1, effective above rated [-]
    REAL(DbKi)                    :: PRC_R_Speed                 ! Power rating through changing the rated generator speed, default is 1, effective above rated [-]
    REAL(DbKi)                    :: PRC_R_Pitch                 ! Power rating through changing the fine pitch angle, default is 1, effective below rated [-]
    INTEGER(IntKi)                :: PRC_Table_n                 ! Number of elements in PRC_R to _Pitch table
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: PRC_Pitch_Table             ! Table of fine pitch versus PRC_R_Table, length should be PRC_Table_n [rad]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: PRC_R_Table                 ! Table of turbine rating versus fine pitch (PRC_Pitch_Table), length should be PRC_Table_n, default is 1 [-]
    INTEGER(IntKi)                :: WE_Mode                     ! Wind speed estimator mode {0 - One-second low pass filtered hub height wind speed, 1 - Imersion and Invariance Estimator (Ortega et al.)
    REAL(DbKi)                    :: WE_BladeRadius              ! Blade length [m]
    INTEGER(IntKi)                :: WE_CP_n                     ! Amount of parameters in the Cp array
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: WE_CP                       ! Parameters that define the parameterized CP(\lambda) function
    REAL(DbKi)                    :: WE_Gamma                    ! Adaption gain of the wind speed estimator algorithm [m/rad]
    REAL(DbKi)                    :: WE_GearboxRatio             ! Gearbox ratio, >=1  [-]
    REAL(DbKi)                    :: WE_Jtot                     ! Total drivetrain inertia, including blades, hub and casted generator inertia to LSS [kg m^2]
    REAL(DbKi)                    :: WE_RhoAir                   ! Air density [kg m^-3]
    CHARACTER(1024)               :: PerfFileName                ! File containing rotor performance tables (Cp,Ct,Cq)
    INTEGER(IntKi), DIMENSION(:), ALLOCATABLE     :: PerfTableSize               ! Size of rotor performance tables, first number refers to number of blade pitch angles, second number referse to number of tip-speed ratios
    INTEGER(IntKi)                :: WE_FOPoles_N                ! Number of first-order system poles used in EKF
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: WE_FOPoles_v                ! Wind speeds corresponding to first-order system poles [m/s]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: WE_FOPoles                  ! First order system poles
    INTEGER(IntKi)                :: Y_ControlMode               ! Yaw control mode {0 - no yaw control, 1 - yaw rate control}
    REAL(DbKi)                    :: Y_uSwitch                   ! Wind speed to switch between Y_ErrThresh. If zero, only the first value of Y_ErrThresh is used [m/s]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: Y_ErrThresh                 ! Error threshold [rad]. Turbine begins to yaw when it passes this
    REAL(DbKi)                    :: Y_Rate                      ! Yaw rate [rad/s]
    REAL(DbKi)                    :: Y_MErrSet                   ! Yaw alignment error, setpoint (for wake steering) [rad]
    REAL(DbKi)                    :: Y_IPC_IntSat                ! Integrator saturation (maximum signal amplitude contrbution to pitch from yaw-by-IPC)
    REAL(DbKi)                    :: Y_IPC_KP                    ! Yaw-by-IPC proportional controller gain Kp
    REAL(DbKi)                    :: Y_IPC_KI                    ! Yaw-by-IPC integral controller gain Ki
    INTEGER(IntKi)                :: PS_Mode                     ! Pitch saturation mode {0 - no peak shaving, 1 -  implement pitch saturation}
    INTEGER(IntKi)                :: PS_BldPitchMin_N            ! Number of values in minimum blade pitch lookup table (should equal number of values in PS_WindSpeeds and PS_BldPitchMin)
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: PS_WindSpeeds               ! Wind speeds corresponding to minimum blade pitch angles [m/s]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: PS_BldPitchMin              ! Minimum blade pitch angles [rad]
    INTEGER(IntKi)                :: SU_Mode                     ! Startup mode {0 - no startup procedure, 1 - enable startup}
    REAL(DbKi)                    :: SU_StartTime                ! Time to start start up routine
    REAL(DbKi)                    :: SU_FW_MinDuration           ! Free-wheel minimum duration [s]
    REAL(DbKi)                    :: SU_RotorSpeedThresh         ! Rotor speed threshhold to switch from freewheel to loads [rad/s]
    REAL(DbKi)                    :: SU_RotorSpeedCornerFreq     ! Cutoff Frequency for first order low-pass filter for rotor speed for startup, [rad/s]
    INTEGER(IntKi)                :: SU_LoadStages_N             ! Number of load staged for startup (should equal number of values in SU_LoadStages, SU_LoadRampDuration and SU_LoadHoldDuration) [-]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: SU_LoadStages               ! Array containing loads as a fraction of full generator torque during startup [-]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: SU_LoadRampDuration         ! Array containing ramp duration to reach the corresponding partial loads during startup [s]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: SU_LoadHoldDuration         ! Array containing duration to hold the partial loads during startup [s]
    INTEGER(IntKi)                :: SD_Mode                     ! Shutdown mode {0 - no shutdown procedure, 1 - enable shutdown}
    REAL(DbKi)                    :: SD_TimeActivate             ! Time to acitvate shutdown modes, [s]
    INTEGER(IntKi)                :: SD_EnablePitch              ! Shutdown when collective blade pitch exceeds a threshold, [-]
    INTEGER(IntKi)                :: SD_EnableYawError           ! Shutdown when yaw error exceeds a threshold, [-]
    INTEGER(IntKi)                :: SD_EnableGenSpeed           ! Shutdown when generator speed exceeds a threshold, [-]
    INTEGER(IntKi)                :: SD_EnableTime               ! Shutdown at a predefined time, [-]
    REAL(DbKi)                    :: SD_MaxPit                   ! Maximum blade pitch angle to initiate shutdown, [rad]
    REAL(DbKi)                    :: SD_PitchCornerFreq          ! Cutoff Frequency for first order low-pass filter for blade pitch angle for shutdown, [rad/s]
    REAL(DbKi)                    :: SD_MaxYawError              ! Maximum yaw error to initiate shutdown, [deg]
    REAL(DbKi)                    :: SD_YawErrorCornerFreq       ! Cutoff Frequency for first order low-pass filter for yaw error for shutdown, [rad/s]
    REAL(DbKi)                    :: SD_MaxGenSpd                ! Maximum generator speed to initiate shutdown, [rad/s]
    REAL(DbKi)                    :: SD_GenSpdCornerFreq         ! Cutoff Frequency for first order low-pass filter for generator speed for shutdown, [rad/s]
    REAL(DbKi)                    :: SD_Time                     ! Shutdown time, [s]
    INTEGER(IntKi)                :: SD_Method                   ! Shutdown method {1 - Reduce generator torque and increase blade pitch}, [-]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: SD_MaxTorqueRate            ! Maximum torque rate for shutdown, [Nm/s]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: SD_MaxPitchRate             ! Maximum pitch rate used for shutdown, [rad/s]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: SD_StagePitch               ! Array containing the pitch angle to reach in each shutdown stage [rad]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: SD_StageTime                ! Array containing the time to spend in each shutdown stage [s]
    INTEGER(IntKi)                :: SD_Stage_N                  ! Number of shutdown stages (should equal number of values in SD_MaxPitchRate and SD_MaxTorqueRate) [-]
    INTEGER(IntKi)                :: Fl_Mode                     ! Floating specific feedback mode {0 - no nacelle velocity feedback, 1 - nacelle velocity feedback}
    INTEGER(IntKi)                :: Fl_n                        ! Number of Fl_Kp for gain scheduling
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: Fl_Kp                       ! Nacelle velocity proportional feedback gain [s]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: Fl_U                        ! Wind speeds for scheduling Fl_Kp [m/s]
    INTEGER(IntKi)                :: Flp_Mode                    ! Flap actuator mode {0 - off, 1 - fixed flap position, 2 - PI flap control}
    REAL(DbKi)                    :: Flp_Angle                   ! Fixed flap angle (degrees)
    REAL(DbKi)                    :: Flp_Kp                      ! PI flap control proportional gain
    REAL(DbKi)                    :: Flp_Ki                      ! PI flap control integral gain
    REAL(DbKi)                    :: Flp_MaxPit                  ! Maximum (and minimum) flap pitch angle [rad]
    CHARACTER(1024)               :: OL_Filename                 ! Input file with open loop timeseries
    INTEGER(IntKi)                :: OL_Mode                     ! Open loop control mode {0 - no open loop control, 1 - open loop control vs. time, 2 - open loop control vs. wind speed}
    INTEGER(IntKi)                :: OL_BP_Mode                  ! Open loop control mode {0 - no open loop control, 1 - open loop control vs. time, 2 - open loop control vs. wind speed}
    REAL(DbKi)                    :: OL_BP_FiltFreq              ! First order low pass filter cutoff frequency for open loop breakpoint
    INTEGER(IntKi)                :: Ind_Breakpoint              ! The column in OL_Filename that contains the breakpoint (time if OL_Mode = 1)
    INTEGER(IntKi), DIMENSION(:), ALLOCATABLE     :: Ind_BldPitch                ! The columns in OL_Filename that contains the blade pitch inputs (1,2,3) in rad
    INTEGER(IntKi)                :: Ind_GenTq                   ! The column in OL_Filename that contains the generator torque in Nm
    INTEGER(IntKi)                :: Ind_YawRate                 ! The column in OL_Filename that contains the generator torque in Nm
    INTEGER(IntKi)                :: Ind_R_Speed                 ! The column in OL_Filename that contains the R_Speed input
    INTEGER(IntKi)                :: Ind_R_Torque                ! The column in OL_Filename that contains the R_Torque input
    INTEGER(IntKi)                :: Ind_R_Pitch                 ! The column in OL_Filename that contains the R_Pitch input
    INTEGER(IntKi)                :: Ind_Azimuth                 ! The column in OL_Filename that contains the desired azimuth position in rad (used if OL_Mode = 2)
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: RP_Gains                    ! PID gains and Tf on derivative term for rotor position control (used if OL_Mode = 2)
    INTEGER(IntKi), DIMENSION(:), ALLOCATABLE     :: Ind_CableControl            ! The column in OL_Filename that contains the cable control inputs in m
    INTEGER(IntKi), DIMENSION(:), ALLOCATABLE     :: Ind_StructControl           ! The column in OL_Filename that contains the structural control inputs in various units
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: OL_Breakpoints              ! Open loop breakpoints in timeseries
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: OL_BldPitch1                ! Open loop blade pitch 1 timeseries
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: OL_BldPitch2                ! Open loop blade pitch 2 timeseries
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: OL_BldPitch3                ! Open loop blade pitch 3 timeseries
    REAL(DbKi), DIMENSION(:,:), ALLOCATABLE     :: OL_CableControl             ! None
    REAL(DbKi), DIMENSION(:,:), ALLOCATABLE     :: OL_StructControl            ! None
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: OL_GenTq                    ! Open loop generator torque timeseries
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: OL_YawRate                  ! Open loop yaw rate timeseries
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: OL_Azimuth                  ! Open loop azimuth timeseries
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: OL_R_Speed                  ! Open loop R_Speed timeseries
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: OL_R_Torque                 ! Open loop R_Torque timeseries
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: OL_R_Pitch                  ! Open loop R_Pitch timeseries
    REAL(DbKi), DIMENSION(:,:), ALLOCATABLE     :: OL_Channels                 ! Open loop channels in timeseries
    INTEGER(IntKi)                :: PA_Mode                     ! Pitch actuator mode {0 - not used, 1 - first order filter, 2 - second order filter}
    REAL(DbKi)                    :: PA_CornerFreq               ! Pitch actuator bandwidth/cut-off frequency [rad/s]
    REAL(DbKi)                    :: PA_Damping                  ! Pitch actuator damping ratio [-, unused if PA_Mode = 1]
    INTEGER(IntKi)                :: AWC_Mode                    ! Active wake control mode [0 - unused, 1 - complex number method, 2 - Coleman transform method]
    INTEGER(IntKi)                :: AWC_NumModes                ! AWC- Number of modes to include [-]
    INTEGER(IntKi), DIMENSION(:), ALLOCATABLE     :: AWC_n                       ! AWC azimuthal mode [-]
    INTEGER(IntKi), DIMENSION(:), ALLOCATABLE     :: AWC_harmonic                ! AWC Coleman transform harmonic [-]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: AWC_freq                    ! AWC frequency [Hz]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: AWC_amp                     ! AWC amplitude [deg]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: AWC_clockangle              ! AWC clocking angle [deg]
    REAL(DbKi)                    :: AWC_phaseoffset             ! AWC azimuth offset for Coleman transform [deg]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: AWC_CntrGains               ! AWC KP and KI/KR gain of the controller [-]
    INTEGER(IntKi)                :: PF_Mode                     ! Pitch actuator fault mode {0 - not used, 1 - offsets on one or more blades}
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: PF_Offsets                  ! Pitch actuator fault offsets for blade 1-3 [rad/s]
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: PF_TimeStuck                ! Time for pitch actuator fault to be stuck for blade 1-3 [s]
    INTEGER(IntKi)                :: Ext_Mode                    ! External control mode (0 - not used, 1 - call external control library)
    CHARACTER(1024)               :: DLL_FileName                ! File name of external dynamic library
    CHARACTER(1024)               :: DLL_InFile                  ! Name of input file called by dynamic library (DISCON.IN, e.g.)
    CHARACTER(1024)               :: DLL_ProcName                ! Process name of subprocess called in DLL_Filename (Usually DISCON)
    INTEGER(IntKi)                :: ZMQ_Mode                    ! Flag for ZeroMQ (0-off, 1-yaw}
    CHARACTER(256)                :: ZMQ_CommAddress             ! Comm Address to zeroMQ client
    REAL(DbKi)                    :: ZMQ_UpdatePeriod            ! Integer for zeromq update frequency
    INTEGER(IntKi)                :: CC_Mode                     ! Flag for ZeroMQ (0-off, 1-yaw}
    INTEGER(IntKi)                :: CC_Group_N                  ! Number of cable control groups
    REAL(DbKi)                    :: CC_ActTau                   ! Time constant for line actuator [s]
    INTEGER(IntKi), DIMENSION(:), ALLOCATABLE     :: CC_GroupIndex               ! Cable control group indices
    INTEGER(IntKi)                :: StC_Mode                    ! Flag for StC Control
    INTEGER(IntKi)                :: StC_Group_N                 ! Number of cable control groups
    INTEGER(IntKi), DIMENSION(:), ALLOCATABLE     :: StC_GroupIndex              ! Cable control group indices
    REAL(DbKi)                    :: PC_RtTq99                   ! 99% of the rated torque value, using for switching between pitch and torque control, [Nm].
    REAL(DbKi)                    :: VS_MaxOMTq                  ! Maximum torque at the end of the below-rated region 2, [Nm]
    REAL(DbKi)                    :: VS_MinOMTq                  ! Minimum torque at the beginning of the below-rated region 2, [Nm]
END TYPE ControlParameters

TYPE, PUBLIC :: WE
    REAL(DbKi)                    :: om_r                        ! Estimated rotor speed [rad/s]
    REAL(DbKi)                    :: v_t                         ! Estimated wind speed, turbulent component [m/s]
    REAL(DbKi)                    :: v_m                         ! Estimated wind speed, 10-minute averaged [m/s]
    REAL(DbKi)                    :: v_h                         ! Combined estimated wind speed [m/s]
    REAL(DbKi), DIMENSION(3,3)     :: P                           ! Covariance estiamte
    REAL(DbKi), DIMENSION(3,1)     :: xh                          ! Estimated state matrix
    REAL(DbKi), DIMENSION(3,1)     :: K                           ! Kalman gain matrix
END TYPE WE

TYPE, PUBLIC :: FilterParameters
    REAL(DbKi), DIMENSION(1024)     :: lpf1_a1                     ! First order filter - Denominator coefficient 1
    REAL(DbKi), DIMENSION(1024)     :: lpf1_a0                     ! First order filter - Denominator coefficient 0
    REAL(DbKi), DIMENSION(1024)     :: lpf1_b1                     ! First order filter - Numerator coefficient 1
    REAL(DbKi), DIMENSION(1024)     :: lpf1_b0                     ! First order filter - Numerator coefficient 0
    REAL(DbKi), DIMENSION(1024)     :: lpf1_InputSignalLast        ! First order filter - Previous input
    REAL(DbKi), DIMENSION(1024)     :: lpf1_OutputSignalLast       ! First order filter - Previous output
    REAL(DbKi), DIMENSION(1024)     :: lpf2_a2                     ! Second order filter - Denominator coefficient 2
    REAL(DbKi), DIMENSION(1024)     :: lpf2_a1                     ! Second order filter - Denominator coefficient 1
    REAL(DbKi), DIMENSION(1024)     :: lpf2_a0                     ! Second order filter - Denominator coefficient 0
    REAL(DbKi), DIMENSION(1024)     :: lpf2_b2                     ! Second order filter - Numerator coefficient 2
    REAL(DbKi), DIMENSION(1024)     :: lpf2_b1                     ! Second order filter - Numerator coefficient 1
    REAL(DbKi), DIMENSION(1024)     :: lpf2_b0                     ! Second order filter - Numerator coefficient 0
    REAL(DbKi), DIMENSION(1024)     :: lpf2_InputSignalLast2       ! Second order filter - Previous input 2
    REAL(DbKi), DIMENSION(1024)     :: lpf2_OutputSignalLast2      ! Second order filter - Previous output 2
    REAL(DbKi), DIMENSION(1024)     :: lpf2_InputSignalLast1       ! Second order filter - Previous input 1
    REAL(DbKi), DIMENSION(1024)     :: lpf2_OutputSignalLast1      ! Second order filter - Previous output 1
    REAL(DbKi), DIMENSION(1024)     :: lpfV_a2                     ! Second order filter - Denominator coefficient 1
    REAL(DbKi), DIMENSION(1024)     :: lpfV_a1                     ! Second order filter - Denominator coefficient 1
    REAL(DbKi), DIMENSION(1024)     :: lpfV_a0                     ! Second order filter - Denominator coefficient 0
    REAL(DbKi), DIMENSION(1024)     :: lpfV_b2                     ! Second order filter - Numerator coefficient 2
    REAL(DbKi), DIMENSION(1024)     :: lpfV_b1                     ! Second order filter - Numerator coefficient 1
    REAL(DbKi), DIMENSION(1024)     :: lpfV_b0                     ! Second order filter - Numerator coefficient 0
    REAL(DbKi), DIMENSION(1024)     :: lpfV_InputSignalLast2       ! Second order filter - Previous input 2
    REAL(DbKi), DIMENSION(1024)     :: lpfV_OutputSignalLast2      ! Second order filter - Previous output 2
    REAL(DbKi), DIMENSION(1024)     :: lpfV_InputSignalLast1       ! Second order filter - Previous input 1
    REAL(DbKi), DIMENSION(1024)     :: lpfV_OutputSignalLast1      ! Second order filter - Previous output 1
    REAL(DbKi), DIMENSION(1024)     :: hpf_InputSignalLast         ! High pass filter - Previous output 1
    REAL(DbKi), DIMENSION(1024)     :: hpf_OutputSignalLast        ! High pass filter - Previous output 1
    REAL(DbKi), DIMENSION(1024)     :: nfs_OutputSignalLast1       ! Notch filter slopes previous output 1
    REAL(DbKi), DIMENSION(1024)     :: nfs_OutputSignalLast2       ! Notch filter slopes previous output 2
    REAL(DbKi), DIMENSION(1024)     :: nfs_InputSignalLast1        ! Notch filter slopes previous input 1
    REAL(DbKi), DIMENSION(1024)     :: nfs_InputSignalLast2        ! Notch filter slopes previous input 1
    REAL(DbKi), DIMENSION(1024)     :: nfs_b2                      ! Notch filter slopes numerator coefficient 2
    REAL(DbKi), DIMENSION(1024)     :: nfs_b0                      ! Notch filter slopes numerator coefficient 0
    REAL(DbKi), DIMENSION(1024)     :: nfs_a2                      ! Notch filter slopes denominator coefficient 2
    REAL(DbKi), DIMENSION(1024)     :: nfs_a1                      ! Notch filter slopes denominator coefficient 1
    REAL(DbKi), DIMENSION(1024)     :: nfs_a0                      ! Notch filter slopes denominator coefficient 0
    REAL(DbKi), DIMENSION(1024)     :: nf_OutputSignalLast1        ! Notch filter previous output 1
    REAL(DbKi), DIMENSION(1024)     :: nf_OutputSignalLast2        ! Notch filter previous output 2
    REAL(DbKi), DIMENSION(1024)     :: nf_InputSignalLast1         ! Notch filter previous input 1
    REAL(DbKi), DIMENSION(1024)     :: nf_InputSignalLast2         ! Notch filter previous input 2
    REAL(DbKi), DIMENSION(1024)     :: nf_b2                       ! Notch filter numerator coefficient 2
    REAL(DbKi), DIMENSION(1024)     :: nf_b1                       ! Notch filter numerator coefficient 1
    REAL(DbKi), DIMENSION(1024)     :: nf_b0                       ! Notch filter numerator coefficient 0
    REAL(DbKi), DIMENSION(1024)     :: nf_a1                       ! Notch filter denominator coefficient 1
    REAL(DbKi), DIMENSION(1024)     :: nf_a0                       ! Notch filter denominator coefficient 0
END TYPE FilterParameters

TYPE, PUBLIC :: rlParams
    REAL(DbKi), DIMENSION(1024)     :: LastSignal                  ! Last input signal
END TYPE rlParams

TYPE, PUBLIC :: piParams
    REAL(DbKi), DIMENSION(1024)     :: ITerm                       ! Integrator term
    REAL(DbKi), DIMENSION(1024)     :: ITermLast                   ! Previous integrator term
    REAL(DbKi), DIMENSION(1024)     :: ITerm2                      ! Integrator term - second integrator
    REAL(DbKi), DIMENSION(1024)     :: ITermLast2                  ! Previous integrator term - second integrator
    REAL(DbKi), DIMENSION(1024)     :: ELast                       ! Previous error term for derivative
END TYPE piParams

TYPE, PUBLIC :: resParams
    REAL(DbKi), DIMENSION(1024)     :: res_OutputSignalLast1       ! Previous output signal
    REAL(DbKi), DIMENSION(1024)     :: res_OutputSignalLast2       ! Previous output signal - second integrator
    REAL(DbKi), DIMENSION(1024)     :: res_InputSignalLast1        ! Previous input signal
    REAL(DbKi), DIMENSION(1024)     :: res_InputSignalLast2        ! Previous input signal - second integrator
END TYPE resParams

TYPE, PUBLIC :: LocalVariables
    INTEGER(IntKi)                :: iStatus                     ! Initialization status
    INTEGER(IntKi)                :: AlreadyInitialized = 0      ! Has ROSCO already been initialized (0-no, 1-yes)
    INTEGER(IntKi)                :: RestartWSE                  ! Restart WSE flag, 0 - restart, 1- not, to mirror iStatus
    REAL(DbKi)                    :: Time                        ! Time [s]
    REAL(DbKi)                    :: DT                          ! Time step [s]
    LOGICAL                       :: WriteThisStep               ! Write an output line this time step
    INTEGER(IntKi)                :: n_DT                        ! number of timesteps since start
    REAL(DbKi)                    :: Time_Last                   ! Last time [s]
    REAL(DbKi)                    :: VS_GenPwr                   ! Generator power [W]
    REAL(DbKi)                    :: GenSpeed                    ! Generator speed (HSS) [rad/s]
    REAL(DbKi)                    :: RotSpeed                    ! Rotor speed (LSS) [rad/s]
    REAL(DbKi)                    :: NacHeading                  ! Nacelle heading of the turbine w.r.t. north [deg]
    REAL(DbKi)                    :: NacVane                     ! Nacelle vane angle [deg]
    REAL(DbKi)                    :: NacVaneF                    ! Filtered nacelle vane angle [deg]
    REAL(DbKi)                    :: WindDir                     ! Compassed wind direction, accounting for nacelle heading [deg]
    REAL(DbKi)                    :: HorWindV                    ! Hub height wind speed m/s
    REAL(DbKi)                    :: HorWindV_F                  ! Filtered hub height wind speed m/s
    REAL(DbKi)                    :: rootMOOP(3)                 ! Blade root bending moment [Nm]
    REAL(DbKi)                    :: rootMOOPF(3)                ! Filtered Blade root bending moment [Nm]
    REAL(DbKi)                    :: BlPitch(3)                  ! Blade pitch [rad]
    REAL(DbKi)                    :: BlPitchCMeas                ! Mean (collective) blade pitch [rad]
    REAL(DbKi)                    :: Azimuth                     ! Rotor aziumuth angle [rad]
    REAL(DbKi)                    :: OL_Azimuth                  ! Rotor aziumuth angle [rad]
    REAL(DbKi)                    :: AzUnwrapped                 ! Rotor aziumuth angle [rad]
    REAL(DbKi)                    :: AzError                     ! Azimuth error angle [rad]
    REAL(DbKi)                    :: GenTqAz                     ! Gen torque command due to azimuth error
    REAL(DbKi)                    :: AzBuffer(2)                 ! Current and last rotor aziumuth angles [rad]
    INTEGER(IntKi)                :: NumBl                       ! Number of blades [-]
    REAL(DbKi)                    :: FA_Acc_TT                   ! Tower fore-aft acceleration [m/s^2], in fixed tower-top reference frame
    REAL(DbKi)                    :: SS_Acc_TT                   ! Tower side-to-side acceleration [m/s^2], in fixed tower-top reference frame
    REAL(DbKi)                    :: FA_Acc_Nac                  ! Tower fore-aft acceleration [m/s^2] in nacelle reference frame
    REAL(DbKi)                    :: NacIMU_FA_RAcc              ! Tower fore-aft acceleration [rad/s^2]
    REAL(DbKi)                    :: FA_AccHPF                   ! High-pass filtered fore-aft acceleration [m/s^2]
    REAL(DbKi)                    :: FA_AccHPFI                  ! Tower velocity, high-pass filtered and integrated fore-aft acceleration [m/s]
    REAL(DbKi)                    :: FA_PitCom(3)                ! Tower fore-aft vibration damping pitch contribution [rad]
    REAL(DbKi)                    :: VS_RefSpd                   ! Torque control generator speed set point [rad/s]
    REAL(DbKi)                    :: VS_RefSpd_TSR               ! Torque control generator speed set point based on optimal TSR (unfiltered) [rad/s]
    REAL(DbKi)                    :: VS_RefSpd_TRA               ! Torque control generator speed set point after freq avoidance [rad/s]
    REAL(DbKi)                    :: VS_RefSpd_RL                ! Torque control generator speed set point after rate limit [rad/s]
    REAL(DbKi)                    :: PC_RefSpd                   ! Generator speed set point of pitch controller [rad/s]
    REAL(DbKi)                    :: PC_RefSpd_SS                ! Generator speed set point of pitch controller after setpoint smoothing [rad/s]
    REAL(DbKi)                    :: PC_RefSpd_PRC               ! Generator speed set point of pitch controller after power ref control [rad/s]
    REAL(DbKi)                    :: RotSpeedF                   ! Filtered LSS (rotor) speed [rad/s].
    REAL(DbKi)                    :: GenSpeedF                   ! Filtered HSS (generator) speed [rad/s].
    REAL(DbKi)                    :: GenTq                       ! Electrical generator torque, [Nm].
    REAL(DbKi)                    :: GenTqMeas                   ! Measured generator torque [Nm]
    REAL(DbKi)                    :: GenArTq                     ! Electrical generator torque, for above-rated PI-control [Nm].
    REAL(DbKi)                    :: GenBrTq                     ! Electrical generator torque, for below-rated PI-control [Nm].
    REAL(DbKi)                    :: VS_KOmega2_GenTq            ! Calculation of torque signal used by K*Omega^2 controller
    REAL(DbKi)                    :: VS_ConstPwr_GenTq           ! Calculation of constant-power torque signal
    REAL(DbKi)                    :: IPC_PitComF(3)              ! Commanded pitch of each blade as calculated by the individual pitch controller, F stands for low-pass filtered [rad].
    REAL(DbKi)                    :: PC_KP                       ! Proportional gain for pitch controller at rated pitch (zero) [s].
    REAL(DbKi)                    :: PC_KI                       ! Integral gain for pitch controller at rated pitch (zero) [-].
    REAL(DbKi)                    :: PC_KD                       ! Differential gain for pitch controller at rated pitch (zero) [-].
    REAL(DbKi)                    :: PC_TF                       ! First-order filter parameter for derivative action
    REAL(DbKi)                    :: PC_MaxPit                   ! Maximum pitch setting in pitch controller (variable) [rad].
    REAL(DbKi)                    :: PC_MinPit                   ! Minimum pitch setting in pitch controller (variable) [rad].
    REAL(DbKi)                    :: PC_PitComT                  ! Total command pitch based on the sum of the proportional and integral terms [rad].
    REAL(DbKi)                    :: PC_PitComT_Last             ! Last total command pitch based on the sum of the proportional and integral terms [rad].
    REAL(DbKi)                    :: BlPitchCMeasF               ! Filtered collective pitch read from turbine/simulator [rad].
    REAL(DbKi)                    :: PC_PitComT_IPC(3)           ! Total command pitch based on the sum of the proportional and integral terms, including IPC term [rad].
    REAL(DbKi)                    :: PC_PwrErr                   ! Power error with respect to rated power [W]
    REAL(DbKi)                    :: PC_SpdErr                   ! Current speed error (pitch control) [rad/s].
    REAL(DbKi)                    :: IPC_AxisTilt_1P             ! Integral of the direct axis, 1P
    REAL(DbKi)                    :: IPC_AxisYaw_1P              ! Integral of quadrature, 1P
    REAL(DbKi)                    :: IPC_AxisTilt_2P             ! Integral of the direct axis, 2P
    REAL(DbKi)                    :: IPC_AxisYaw_2P              ! Integral of quadrature, 2P
    REAL(DbKi)                    :: axisTilt_1P                 ! Tilt moment, 1P
    REAL(DbKi)                    :: axisYaw_1P                  ! Yaw moment, 1P
    REAL(DbKi)                    :: axisYawF_1P                 ! Filtered yaw moment, 1P
    REAL(DbKi)                    :: axisTilt_2P                 ! Tilt moment, 2P
    REAL(DbKi)                    :: axisYaw_2P                  ! Yaw moment, 2P
    REAL(DbKi)                    :: axisYawF_2P                 ! Filtered yaw moment, 2P
    REAL(DbKi)                    :: IPC_KI(2)                   ! Integral gain for IPC, after ramp [-]
    REAL(DbKi)                    :: IPC_KP(2)                   ! Proportional gain for IPC, after ramp [-]
    REAL(DbKi)                    :: IPC_IntSat                  ! Integrator saturation (maximum signal amplitude contrbution to pitch from IPC)
    INTEGER(IntKi)                :: PC_State                    ! State of the pitch control system
    REAL(DbKi)                    :: PitCom(3)                   ! Commanded pitch of each blade the last time the controller was called [rad].
    REAL(DbKi)                    :: PitCom_SD(3)                ! Commanded pitch of each blade due to shutdown [rad].
    REAL(DbKi)                    :: PitComAct(3)                ! Actuated pitch command of each blade [rad].
    REAL(DbKi)                    :: SS_DelOmegaF                ! Filtered setpoint shifting term defined in setpoint smoother [rad/s].
    REAL(DbKi)                    :: TestType                    ! Test variable, no use
    REAL(DbKi)                    :: Kp_Float                    ! Local, instantaneous Kp_Float, scheduled on wind speed, if desired
    REAL(DbKi)                    :: VS_MaxTq                    ! Maximum allowable generator torque [Nm].
    REAL(DbKi)                    :: VS_LastGenTrq               ! Commanded electrical generator torque the last time the controller was called [Nm].
    REAL(DbKi)                    :: VS_LastGenPwr               ! Commanded electrical generator torque the last time the controller was called [Nm].
    REAL(DbKi)                    :: VS_MechGenPwr               ! Mechanical power on the generator axis [W]
    REAL(DbKi)                    :: VS_SpdErrAr                 ! Current speed error for region 2.5 PI controller (generator torque control) [rad/s].
    REAL(DbKi)                    :: VS_SpdErrBr                 ! Current speed error for region 1.5 PI controller (generator torque control) [rad/s].
    REAL(DbKi)                    :: VS_SpdErr                   ! Current speed error for tip-speed-ratio tracking controller (generator torque control) [rad/s].
    INTEGER(IntKi)                :: VS_State                    ! State of the torque control system
    REAL(DbKi)                    :: VS_Rgn3Pitch                ! Pitch angle at which the state machine switches to region 3, [rad].
    REAL(DbKi)                    :: WE_Vw                       ! Estimated wind speed [m/s]
    REAL(DbKi)                    :: WE_Vw_F                     ! Filtered estimated wind speed [m/s]
    REAL(DbKi)                    :: WE_VwI                      ! Integrated wind speed quantity for estimation [m/s]
    REAL(DbKi)                    :: WE_VwIdot                   ! Differentiated integrated wind speed quantity for estimation [m/s]
    INTEGER(IntKi)                :: WE_Op                       ! WSE Operational state (0- not operating, 1-operating)
    INTEGER(IntKi)                :: WE_Op_Last                  ! Last WSE Operational state (0- not operating, 1-operating)
    REAL(DbKi)                    :: VS_LastGenTrqF              ! Differentiated integrated wind speed quantity for estimation [m/s]
    REAL(DbKi)                    :: PRC_WSE_F                   ! Filtered wind speed estimate for power reference control
    REAL(DbKi)                    :: PRC_R_Speed                 ! Instantaneous PRC_R_Speed
    REAL(DbKi)                    :: PRC_R_Torque                ! Instantaneous PRC_R_Torque
    REAL(DbKi)                    :: PRC_R_Pitch                 ! Instantaneous PRC_R_Pitch
    REAL(DbKi)                    :: PRC_R_Total                 ! Instantaneous PRC_R_Total
    REAL(DbKi)                    :: PRC_Min_Pitch               ! Instantaneous PRC_Min_Pitch
    REAL(DbKi)                    :: PS_Min_Pitch                ! Instantaneous peak shaving
    REAL(DbKi)                    :: OL_Index                    ! Open loop indexing variable (time or wind speed)
    INTEGER(IntKi)                :: SU_Stage                    ! Current stage of startup procedure (0- Startup not active, 1- Free-wheeling, 2,3,.. - Load stage 1,2...etc)
    REAL(DbKi)                    :: SU_LoadStageStartTime       ! Time at which the current startup load stage started
    REAL(DbKi)                    :: SU_RotSpeedF                ! Rotor speed signal filtered for startup
    INTEGER(IntKi)                :: SD_Trigger                  ! Shutdown trigger (1 - shutdown due to pitch, 2 - shutdown due to yaw error, 3 - shutdown due to generator speed, 4 - shutdown due to time)
    REAL(DbKi)                    :: SD_BlPitchF                 ! Blade pitch signal filtered for shutdown
    REAL(DbKi)                    :: SD_NacVaneF                 ! Nacelle vane signal filtered for shutdown
    REAL(DbKi)                    :: SD_GenSpeedF                ! Generator speed signal filtered for shutdown
    INTEGER(IntKi)                :: SD_Stage                    ! Current stage of shutdown procedure (0- Shutdown not active, 1- First pitch/torque rate, 2,3,...)
    REAL(DbKi)                    :: SD_StageStartTime           ! Time at which the current shutdown stage started
    REAL(DbKi)                    :: SD_MaxPitchRate             ! Maximum pitch rate during current shutdown stage [rad/s]
    REAL(DbKi)                    :: SD_MaxTorqueRate            ! Maximum torque rate during current shutdown stage [Nm/s]
    REAL(DbKi)                    :: GenTq_SD                    ! Electrical generator torque command for shutdown, [Nm].
    REAL(DbKi)                    :: Fl_PitCom                   ! Shutdown, .FALSE. if inactive, .TRUE. if active
    REAL(DbKi)                    :: NACIMU_FA_AccF              ! None
    REAL(DbKi)                    :: FA_AccF                     ! Filtered fore-aft acceleration in rotation frame, ready for control
    INTEGER(IntKi)                :: FA_Hist                     ! Hysteresis state for tower resonance avoidance.
    REAL(DbKi)                    :: TRA_LastRefSpd              ! Last reference generator speed
    REAL(DbKi)                    :: VS_RefSpeed                 ! Torque controller reference speed
    REAL(DbKi)                    :: PtfmTDX                     ! Platform motion -- Displacement TDX (m)')
    REAL(DbKi)                    :: PtfmTDY                     ! Platform motion -- Displacement TDY (m)')
    REAL(DbKi)                    :: PtfmTDZ                     ! Platform motion -- Displacement TDZ (m)')
    REAL(DbKi)                    :: PtfmRDX                     ! Platform motion -- Displacement RDX (rad)')
    REAL(DbKi)                    :: PtfmRDY                     ! Platform motion -- Displacement RDY (rad)')
    REAL(DbKi)                    :: PtfmRDZ                     ! Platform motion -- Displacement RDZ (rad)')
    REAL(DbKi)                    :: PtfmTVX                     ! Platform motion -- Velocity     TVX (m/s)')
    REAL(DbKi)                    :: PtfmTVY                     ! Platform motion -- Velocity     TVY (m/s)')
    REAL(DbKi)                    :: PtfmTVZ                     ! Platform motion -- Velocity     TVZ (m/s)')
    REAL(DbKi)                    :: PtfmRVX                     ! Platform motion -- Velocity     RVX (rad/s)')
    REAL(DbKi)                    :: PtfmRVY                     ! Platform motion -- Velocity     RVY (rad/s)')
    REAL(DbKi)                    :: PtfmRVZ                     ! Platform motion -- Velocity     RVZ (rad/s)')
    REAL(DbKi)                    :: PtfmTAX                     ! Platform motion -- Acceleration TAX (m/s^2)')
    REAL(DbKi)                    :: PtfmTAY                     ! Platform motion -- Acceleration TAY (m/s^2)')
    REAL(DbKi)                    :: PtfmTAZ                     ! Platform motion -- Acceleration TAZ (m/s^2)')
    REAL(DbKi)                    :: PtfmRAX                     ! Platform motion -- Acceleration RAX (rad/s^2)')
    REAL(DbKi)                    :: PtfmRAY                     ! Platform motion -- Acceleration RAY (rad/s^2)')
    REAL(DbKi)                    :: PtfmRAZ                     ! Platform motion -- Acceleration RAZ (rad/s^2)')
    REAL(DbKi)                    :: CC_DesiredL(12)             ! None
    REAL(DbKi)                    :: CC_ActuatedL(12)            ! None
    REAL(DbKi)                    :: CC_ActuatedDL(12)           ! None
    REAL(DbKi)                    :: StC_Input(12)               ! None
    REAL(DbKi)                    :: Flp_Angle(3)                ! Flap Angle (rad)
    REAL(DbKi)                    :: RootMyb_Last(3)             ! Last blade root bending moment (Nm)
    INTEGER(IntKi)                :: ACC_INFILE_SIZE             ! Length of parameter input filename
    CHARACTER, DIMENSION(:), ALLOCATABLE     :: ACC_INFILE                  ! Parameter input filename
    LOGICAL                       :: restart                     ! Restart flag
    COMPLEX(DbKi)                 :: AWC_complexangle(3)         ! Complex angle for each blade, sum of modes?
    REAL(DbKi)                    :: TiltMean                    ! Mean tilt blade moment [Nm]
    REAL(DbKi)                    :: YawMean                     ! Mean yaw blade moment [Nm]
    INTEGER(IntKi)                :: ZMQ_ID                      ! 0000 - 9999, Identifier of the rosco, used for zeromq interface only
    REAL(DbKi)                    :: ZMQ_YawOffset               ! Yaw offset command, [rad]
    REAL(DbKi)                    :: ZMQ_TorqueOffset            ! Torque offset command, [Nm]
    REAL(DbKi)                    :: ZMQ_PitOffset(3)            ! Pitch command offset provided by ZeroMQ
    REAL(DbKi)                    :: ZMQ_R_Speed                 ! R_Speed command provided by ZeroMQ
    REAL(DbKi)                    :: ZMQ_R_Torque                ! R_Torque command provided by ZeroMQ
    REAL(DbKi)                    :: ZMQ_R_Pitch                 ! R_Pitch command provided by ZeroMQ
    TYPE(WE)                      :: WE                          ! Wind speed estimator parameters derived type
    TYPE(FilterParameters)        :: FP                          ! Filter parameters derived type
    TYPE(piParams)                :: piP                         ! PI parameters derived type
    TYPE(resParams)               :: resP                        ! PR parameters derived type
    TYPE(rlParams)                :: rlP                         ! Rate limiter parameters derived type
END TYPE LocalVariables

TYPE, PUBLIC :: ObjectInstances
    INTEGER(IntKi)                :: instLPF                     ! Low-pass filter instance
    INTEGER(IntKi)                :: instSecLPF                  ! Second order low-pass filter instance
    INTEGER(IntKi)                :: instSecLPFV                 ! Second order low-pass filter instance
    INTEGER(IntKi)                :: instHPF                     ! High-pass filter instance
    INTEGER(IntKi)                :: instNotchSlopes             ! Notch filter slopes instance
    INTEGER(IntKi)                :: instNotch                   ! Notch filter instance
    INTEGER(IntKi)                :: instPI                      ! PI controller instance
    INTEGER(IntKi)                :: instRes                     ! PR controller instance
    INTEGER(IntKi)                :: instRL                      ! Rate limiter instance
END TYPE ObjectInstances

TYPE, PUBLIC :: PerformanceData
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: TSR_vec                     ! TSR vector for performance surfaces
    REAL(DbKi), DIMENSION(:), ALLOCATABLE     :: Beta_vec                    ! Blade pitch vector for performance surfaces [deg]
    REAL(DbKi), DIMENSION(:,:), ALLOCATABLE     :: Cp_mat                      ! Power coefficient surface
    REAL(DbKi), DIMENSION(:,:), ALLOCATABLE     :: Ct_mat                      ! Thrust coefficient surface
    REAL(DbKi), DIMENSION(:,:), ALLOCATABLE     :: Cq_mat                      ! Torque coefficient surface
END TYPE PerformanceData

TYPE, PUBLIC :: DebugVariables
    REAL(DbKi)                    :: WE_Cp                       ! Cp that WSE uses to determine aerodynamic torque [-]
    REAL(DbKi)                    :: WE_b                        ! Pitch that WSE uses to determine aerodynamic torque [-]
    REAL(DbKi)                    :: WE_w                        ! Rotor Speed that WSE uses to determine aerodynamic torque [-]
    REAL(DbKi)                    :: WE_t                        ! Torque that WSE uses [-]
    REAL(DbKi)                    :: WE_Vm                       ! Mean wind speed component in WSE [m/s]
    REAL(DbKi)                    :: WE_Vt                       ! Turbulent wind speed component in WSE [m/s]
    REAL(DbKi)                    :: WE_Vw                       ! Estimated wind speed in WSE [m/s]
    REAL(DbKi)                    :: WE_lambda                   ! TSR in WSE [rad]
    REAL(DbKi)                    :: PC_PICommand                ! Commanded collective pitch from pitch PI controller [rad]
    REAL(DbKi)                    :: GenSpeedF                   ! Filtered generator speed [rad/s]
    REAL(DbKi)                    :: RotSpeedF                   ! Filtered rotor speed [rad/s]
    REAL(DbKi)                    :: NacIMU_FA_AccF              ! Filtered NacIMU_FA_RAcc [rad/s]
    REAL(DbKi)                    :: FA_AccF                     ! Filtered FA_Acc [m/s]
    REAL(DbKi)                    :: Fl_PitCom                   ! Floating contribution to the pitch command [rad]
    REAL(DbKi)                    :: PC_MinPit                   ! Minimum blade pitch angle [rad]
    REAL(DbKi)                    :: axisTilt_1P                 ! Tilt component of coleman transformation, 1P
    REAL(DbKi)                    :: axisYaw_1P                  ! Yaw component of coleman transformation, 1P
    REAL(DbKi)                    :: axisTilt_2P                 ! Tilt component of coleman transformation, 2P
    REAL(DbKi)                    :: axisYaw_2P                  ! Yaw component of coleman transformation, 2P
    REAL(DbKi)                    :: YawRateCom                  ! Commanded yaw rate [rad/s].
    REAL(DbKi)                    :: NacHeadingTarget            ! Target nacelle heading [deg].
    REAL(DbKi)                    :: NacVaneOffset               ! Nacelle vane angle with offset [deg].
    REAL(DbKi)                    :: Yaw_Err                     ! Yaw error [deg].
    REAL(DbKi)                    :: YawState                    ! State of yaw controller
    REAL(DbKi)                    :: VS_RefSpd                   ! Torque control generator speed set point [rad/s]
    REAL(DbKi)                    :: PC_RefSpd                   ! Generator speed set point of pitch controller [rad/s]
END TYPE DebugVariables

TYPE, PUBLIC :: ErrorVariables
    INTEGER(IntKi)                :: size_avcMSG                 ! None
    INTEGER(C_INT)                :: aviFAIL                     ! A flag used to indicate the success of this DLL call set as follows: 0 if the DLL call was successful, >0 if the DLL call was successful but cMessage should be issued as a warning messsage, <0 if the DLL call was unsuccessful or for any other reason the simulation is to be stopped at this point with cMessage as the error message.
    INTEGER(C_INT)                :: ErrStat                     ! An error status flag used by OpenFAST processes
    CHARACTER(:), ALLOCATABLE     :: ErrMsg                      ! a Fortran version of the C string argument (not considered an array here) [subtract 1 for the C null-character]
END TYPE ErrorVariables

TYPE, PUBLIC :: ExtDLL_Type
    INTEGER(C_INTPTR_T)           :: FileAddr                    ! The address of file FileName. (RETURN value from LoadLibrary ) [Windows]
    TYPE(C_PTR)                   :: FileAddrX = C_NULL_PTR      ! The address of file FileName. (RETURN value from dlopen ) [Linux]
    TYPE(C_FUNPTR)                :: ProcAddr(3)                 ! The address of procedure ProcName. (RETURN value from GetProcAddress or dlsym) [initialized to Null for pack/unpack]
    CHARACTER(1024)               :: FileName                    ! The name of the DLL file including the full path to the current working directory.
    CHARACTER(1024)               :: ProcName(3) = ""            ! The name of the procedure in the DLL that will be called.
END TYPE ExtDLL_Type

TYPE, PUBLIC :: ExtControlType
    REAL(ReKi), DIMENSION(:), ALLOCATABLE     :: avrSWAP                     ! The swap array- used to pass data to and from the DLL controller [see Bladed DLL documentation]
END TYPE ExtControlType

END MODULE ROSCO_Types

module ZeroMQInterface
   USE, INTRINSIC :: ISO_C_BINDING, only: C_CHAR, C_DOUBLE, C_NULL_CHAR
   IMPLICIT NONE
   ! 

CONTAINS
    SUBROUTINE UpdateZeroMQ(LocalVar, CntrPar, ErrVar)
        USE ROSCO_Types, ONLY : LocalVariables, ControlParameters, ErrorVariables
        IMPLICIT NONE
        TYPE(LocalVariables),    INTENT(INOUT) :: LocalVar
        TYPE(ControlParameters), INTENT(INOUT) :: CntrPar
        TYPE(ErrorVariables),    INTENT(INOUT) :: ErrVar

        character(256) :: zmq_address
        real(C_DOUBLE) :: setpoints(8)
        real(C_DOUBLE) :: turbine_measurements(17)
        CHARACTER(*), PARAMETER                 :: RoutineName = 'UpdateZeroMQ'

        ! C interface with ZeroMQ client
#ifdef ZMQ_CLIENT
        interface
            subroutine zmq_client(zmq_address, measurements, setpoints) bind(C, name='zmq_client')
                import :: C_CHAR, C_DOUBLE
                implicit none
                character(C_CHAR), intent(out) :: zmq_address(*)
                real(C_DOUBLE) :: measurements(17)
                real(C_DOUBLE) :: setpoints(8)
            end subroutine zmq_client
        end interface
#endif

        ! Communicate if threshold has been reached
        IF ( MOD(LocalVar%n_DT, CntrPar%n_DT_ZMQ) == 0 .OR. LocalVar%iStatus == -1 ) THEN
            ! Collect measurements to be sent to ZeroMQ server
            turbine_measurements(1) = LocalVar%ZMQ_ID
            turbine_measurements(2) = LocalVar%iStatus
            turbine_measurements(3) = LocalVar%Time
            turbine_measurements(4) = LocalVar%VS_MechGenPwr
            turbine_measurements(5) = LocalVar%VS_GenPwr
            turbine_measurements(6) = LocalVar%GenSpeed
            turbine_measurements(7) = LocalVar%RotSpeed
            turbine_measurements(8) = LocalVar%GenTqMeas
            turbine_measurements(9) = LocalVar%NacHeading
            turbine_measurements(10) = LocalVar%NacVane
            turbine_measurements(11) = LocalVar%HorWindV
            turbine_measurements(12) = LocalVar%rootMOOP(1)
            turbine_measurements(13) = LocalVar%rootMOOP(2)
            turbine_measurements(14) = LocalVar%rootMOOP(3)
            turbine_measurements(15) = LocalVar%FA_Acc_TT
            turbine_measurements(16) = LocalVar%NacIMU_FA_RAcc
            turbine_measurements(17) = LocalVar%Azimuth

            write (zmq_address, '(A,A)') TRIM(CntrPar%ZMQ_CommAddress), C_NULL_CHAR
#ifdef ZMQ_CLIENT
            call zmq_client(zmq_address, turbine_measurements, setpoints)
#else
            ! Add RoutineName to error message
            ErrVar%aviFAIL = -1
            IF (CntrPar%ZMQ_Mode > 0) THEN
                ErrVar%ErrMsg = ' >> The ZeroMQ client has not been properly installed, ' &
                                //'please install it to use ZMQ_Mode > 0.'
                ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
            ENDIF
#endif

            ! write (*,*) 'ZeroMQInterface: torque setpoint from ssc: ', setpoints(1)
            ! write (*,*) 'ZeroMQInterface: yaw setpoint from ssc: ', setpoints(2)
            ! write (*,*) 'ZeroMQInterface: pitch 1 setpoint from ssc: ', setpoints(3)
            ! write (*,*) 'ZeroMQInterface: pitch 2 setpoint from ssc: ', setpoints(4)
            ! write (*,*) 'ZeroMQInterface: pitch 3 setpoint from ssc: ', setpoints(5)
            LocalVar%ZMQ_TorqueOffset = setpoints(1)
            LocalVar%ZMQ_YawOffset = setpoints(2)
            LocalVar%ZMQ_PitOffset(1) = setpoints(3)
            LocalVar%ZMQ_PitOffset(2) = setpoints(4)
            LocalVar%ZMQ_PitOffset(3) = setpoints(5)
            LocalVar%ZMQ_R_Speed = setpoints(6)
            LocalVar%ZMQ_R_Torque = setpoints(7)
            LocalVar%ZMQ_R_Pitch = setpoints(8)
            
        ENDIF


    END SUBROUTINE UpdateZeroMQ
end module ZeroMQInterface

! Copyright 2019 NREL

! Licensed under the Apache License, Version 2.0 (the "License"); you may not use
! this file except in compliance with the License. You may obtain a copy of the
! License at http://www.apache.org/licenses/LICENSE-2.0

! Unless required by applicable law or agreed to in writing, software distributed
! under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
! CONDITIONS OF ANY KIND, either express or implied. See the License for the
! specific language governing permissions and limitations under the License.
! -------------------------------------------------------------------------------------------

! This module contains the primary controller routines

MODULE Controllers

    USE, INTRINSIC :: ISO_C_Binding
    USE Functions
    USE Filters
    USE ControllerBlocks

    IMPLICIT NONE

CONTAINS
!-------------------------------------------------------------------------------------------------------------------------------
    SUBROUTINE PitchControl(avrSWAP, CntrPar, LocalVar, objInst, DebugVar, ErrVar)
    ! Blade pitch controller, generally maximizes rotor speed below rated (region 2) and regulates rotor speed above rated (region 3)
    !       PC_State = PC_State_Disabled (0), fix blade pitch to fine pitch angle (PC_FinePit)
    !       PC_State = PC_State_Disabled (1), is gain scheduled PI controller 
        USE ROSCO_Types, ONLY : ControlParameters, LocalVariables, ObjectInstances, DebugVariables, ErrorVariables
        
        ! Inputs
        REAL(ReKi),              INTENT(INOUT)       :: avrSWAP(*)   ! The swap array, used to pass data to, and receive data from the DLL controller.
        TYPE(ControlParameters),    INTENT(INOUT)       :: CntrPar
        TYPE(LocalVariables),       INTENT(INOUT)       :: LocalVar
        TYPE(ObjectInstances),      INTENT(INOUT)       :: objInst
        TYPE(DebugVariables),       INTENT(INOUT)       :: DebugVar
        TYPE(ErrorVariables),       INTENT(INOUT)       :: ErrVar

        ! Allocate Variables:
        INTEGER(IntKi)                                  :: K            ! Index used for looping through blades.

        CHARACTER(*),               PARAMETER           :: RoutineName = 'PitchControl'

        ! ------- Blade Pitch Controller --------
        ! Load PC State
        IF (LocalVar%PC_State == PC_State_Enabled) THEN ! PI BldPitch control
            LocalVar%PC_MaxPit = CntrPar%PC_MaxPit
        ELSE ! debug mode, fix at fine pitch
            LocalVar%PC_MaxPit = CntrPar%PC_FinePit
        END IF

        ! Hold blade pitch at last value
        ! If:
        !   In pre-startup mode (before freewheeling)
        IF ((CntrPar%SU_Mode > 0) .AND. (LocalVar%SU_Stage == -1)) THEN
            LocalVar%PC_MaxPit = LocalVar%BlPitchCMeas
            LocalVar%PC_MinPit = LocalVar%BlPitchCMeas
        END IF
        
        ! Compute (interpolate) the gains based on previously commanded blade pitch angles and lookup table:
        LocalVar%PC_KP = interp1d(CntrPar%PC_GS_angles, CntrPar%PC_GS_KP, LocalVar%BlPitchCMeasF, ErrVar) ! Proportional gain
        LocalVar%PC_KI = interp1d(CntrPar%PC_GS_angles, CntrPar%PC_GS_KI, LocalVar%BlPitchCMeasF, ErrVar) ! Integral gain
        LocalVar%PC_KD = interp1d(CntrPar%PC_GS_angles, CntrPar%PC_GS_KD, LocalVar%BlPitchCMeasF, ErrVar) ! Derivative gain
        LocalVar%PC_TF = interp1d(CntrPar%PC_GS_angles, CntrPar%PC_GS_TF, LocalVar%BlPitchCMeasF, ErrVar) ! TF gains (derivative filter) !NJA - need to clarify
        
        ! Compute the collective pitch command associated with the proportional and integral gains:
        LocalVar%PC_PitComT = PIController(LocalVar%PC_SpdErr, LocalVar%PC_KP, LocalVar%PC_KI, LocalVar%PC_MinPit, LocalVar%PC_MaxPit, LocalVar%DT, LocalVar%BlPitch(1), LocalVar%piP, LocalVar%restart, objInst%instPI)
        DebugVar%PC_PICommand = LocalVar%PC_PitComT

        ! Find individual pitch control contribution
        IF ((CntrPar%IPC_ControlMode >= 1) .OR. (CntrPar%Y_ControlMode == 2)) THEN
            CALL IPC(CntrPar, LocalVar, objInst, DebugVar, ErrVar)
        ELSE
            LocalVar%IPC_PitComF = 0.0 ! THIS IS AN ARRAY!!
        END IF
        
        ! Include tower fore-aft tower vibration damping control
        IF (CntrPar%TD_Mode > 0) THEN
            CALL ForeAftDamping(CntrPar, LocalVar, objInst)
        ELSE
            LocalVar%FA_PitCom = 0.0 ! THIS IS AN ARRAY!!
        ENDIF
        
        ! Pitch Saturation
        IF (CntrPar%PS_Mode > 0) THEN
            LocalVar%PC_MinPit = PitchSaturation(LocalVar,CntrPar,objInst,DebugVar, ErrVar)
            LocalVar%PC_MinPit = max(LocalVar%PC_MinPit, CntrPar%PC_FinePit)
        ELSE
            LocalVar%PC_MinPit = CntrPar%PC_FinePit
        ENDIF
        DebugVar%PC_MinPit = LocalVar%PC_MinPit
        
        ! FloatingFeedback
        IF (CntrPar%Fl_Mode > 0) THEN
            LocalVar%Fl_PitCom = FloatingFeedback(LocalVar, CntrPar, objInst, ErrVar)
            DebugVar%FL_PitCom = LocalVar%Fl_PitCom
            LocalVar%PC_PitComT = LocalVar%PC_PitComT + LocalVar%Fl_PitCom
        ENDIF
        
        ! Saturate collective pitch commands:
        LocalVar%PC_PitComT = saturate(LocalVar%PC_PitComT, LocalVar%PC_MinPit, CntrPar%PC_MaxPit)                    ! Saturate the overall command using the pitch angle limits
        LocalVar%PC_PitComT = ratelimit(LocalVar%PC_PitComT, CntrPar%PC_MinRat, CntrPar%PC_MaxRat, LocalVar%DT, LocalVar%restart, LocalVar%rlP,objInst%instRL,LocalVar%BlPitchCMeas) ! Saturate the overall command of blade K using the pitch rate limit
        LocalVar%PC_PitComT_Last = LocalVar%PC_PitComT

        ! Combine and saturate all individual pitch commands in software
        DO K = 1,LocalVar%NumBl ! Loop through all blades, add IPC contribution and limit pitch rate
            LocalVar%PitCom(K) = LocalVar%PC_PitComT + LocalVar%FA_PitCom(K) 
            LocalVar%PitCom(K) = saturate(LocalVar%PitCom(K), LocalVar%PC_MinPit, CntrPar%PC_MaxPit)                    ! Saturate the command using the pitch saturation limits
            LocalVar%PitCom(K) = LocalVar%PitCom(K) + LocalVar%IPC_PitComF(K)                                          ! Add IPC
            
            ! Hard IPC saturation by peak shaving limit
            IF (CntrPar%IPC_SatMode == 1) THEN
                LocalVar%PitCom(K) = saturate(LocalVar%PitCom(K), LocalVar%PC_MinPit, CntrPar%PC_MaxPit)  
            END IF
            
            ! Add ZeroMQ pitch commands
            LocalVar%PitCom(K) = LocalVar%PitCom(K) + LocalVar%ZMQ_PitOffset(K)

            ! Rate limit                  
            LocalVar%PitCom(K) = ratelimit(LocalVar%PitCom(K), CntrPar%PC_MinRat, CntrPar%PC_MaxRat, LocalVar%DT, LocalVar%restart, LocalVar%rlP,objInst%instRL,LocalVar%BlPitch(K)) ! Saturate the overall command of blade K using the pitch rate limit
        END DO 

        ! Open Loop control, use if
        !   Open loop mode active         Using OL blade pitch control      
        IF (CntrPar%OL_Mode > 0) THEN
            IF (LocalVar%Time >= CntrPar%OL_Breakpoints(1)) THEN    ! Time > first open loop breakpoint
                IF (CntrPar%Ind_BldPitch(1) > 0) THEN
                    LocalVar%PitCom(1) = interp1d(CntrPar%OL_Breakpoints,CntrPar%OL_BldPitch1,LocalVar%OL_Index, ErrVar)
                ENDIF

                IF (CntrPar%Ind_BldPitch(2) > 0) THEN
                    LocalVar%PitCom(2) = interp1d(CntrPar%OL_Breakpoints,CntrPar%OL_BldPitch2,LocalVar%OL_Index, ErrVar)
                ENDIF

                IF (CntrPar%Ind_BldPitch(3) > 0) THEN
                    LocalVar%PitCom(3) = interp1d(CntrPar%OL_Breakpoints,CntrPar%OL_BldPitch3,LocalVar%OL_Index, ErrVar)
                ENDIF
            ENDIF
        ENDIF

        ! Active wake control
        IF (CntrPar%AWC_Mode > 0) THEN
            CALL ActiveWakeControl(CntrPar, LocalVar, DebugVar, objInst)
        ENDIF

        ! Shutdown
        IF (LocalVar%SD_Trigger == 0) THEN
            LocalVar%PitCom_SD = LocalVar%PitCom
        ! If shutdown is not triggered, PitCom_SD tracks PitCom.
        ELSE
            IF (CntrPar%SD_Method == 1 .OR. CntrPar%SD_Method == 2) THEN
                DO K = 1,LocalVar%NumBl
                    LocalVar%PitCom_SD(K) = LocalVar%PitCom_SD(K) + LocalVar%SD_MaxPitchRate*LocalVar%DT
                END DO
            ENDIF
            LocalVar%PitCom = LocalVar%PitCom_SD
            ! When shutdown is triggered (SD_Trigger \=0), pitch to feather.
            ! Note that in some instances (like a downwind rotor), we may want to pitch to a stall angle.
        ENDIF
        
       
        ! Place pitch actuator here, so it can be used with or without open-loop
        DO K = 1,LocalVar%NumBl ! Loop through all blades, add IPC contribution and limit pitch rate
            IF (CntrPar%PA_Mode > 0) THEN
                IF (CntrPar%PA_Mode == 1) THEN
                    LocalVar%PitComAct(K) = LPFilter(LocalVar%PitCom(K), LocalVar%DT, CntrPar%PA_CornerFreq, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instLPF)
                ELSE IF (CntrPar%PA_Mode == 2) THEN
                    LocalVar%PitComAct(K) = SecLPFilter(LocalVar%PitCom(K),LocalVar%DT,CntrPar%PA_CornerFreq,CntrPar%PA_Damping,LocalVar%FP,LocalVar%iStatus,LocalVar%restart,objInst%instSecLPF)
                END IF  
            ELSE
                LocalVar%PitComAct(K) = LocalVar%PitCom(K)
            ENDIF
        END DO

        ! Hardware saturation: using CntrPar%PC_MinPit
        DO K = 1,LocalVar%NumBl ! Loop through all blades, add IPC contribution and limit pitch rate
            ! Saturate the pitch command using the overall (hardware) limit
            LocalVar%PitComAct(K) = saturate(LocalVar%PitComAct(K), CntrPar%PC_MinPit, CntrPar%PC_MaxPit)
            ! Saturate the overall command of blade K using the pitch rate limit
            LocalVar%PitComAct(K) = ratelimit(LocalVar%PitComAct(K), CntrPar%PC_MinRat, CntrPar%PC_MaxRat, LocalVar%DT, LocalVar%restart, LocalVar%rlP,objInst%instRL,LocalVar%BlPitch(K)) ! Saturate the overall command of blade K using the pitch rate limit
        END DO

        ! Add pitch actuator fault for blade K
        IF (CntrPar%PF_Mode == 1) THEN
            DO K = 1, LocalVar%NumBl
                ! This assumes that the pitch actuator fault overides the Hardware saturation
                LocalVar%PitComAct(K) = LocalVar%PitComAct(K) + CntrPar%PF_Offsets(K)
            END DO
        ! Blade pitch stuck at last value
        ELSEIF (CntrPar%PF_Mode == 2) THEN
            DO K = 1, LocalVar%NumBl
                IF (LocalVar%Time > CntrPar%PF_TimeStuck(K)) THEN
                    LocalVar%PitComAct(K) = LocalVar%BlPitch(K)
                END IF
            END DO
        END IF

        ! Command the pitch demanded from the last
        ! call to the controller (See Appendix A of Bladed User's Guide):
        avrSWAP(42) = LocalVar%PitComAct(1)   ! Use the command angles of all blades if using individual pitch
        avrSWAP(43) = LocalVar%PitComAct(2)   ! "
        avrSWAP(44) = LocalVar%PitComAct(3)   ! "
        avrSWAP(45) = LocalVar%PitComAct(1)   ! Use the command angle of blade 1 if using collective pitch

        ! Add RoutineName to error message
        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
        ENDIF
    END SUBROUTINE PitchControl
!-------------------------------------------------------------------------------------------------------------------------------  
    SUBROUTINE VariableSpeedControl(avrSWAP, CntrPar, LocalVar, objInst, ErrVar)
    ! Generator torque controller
    !       VS_State = VS_State_Error             (0), Error state, for debugging purposes, GenTq = VS_RtTq
    !       VS_State = VS_State_Region_1_5        (1), Region 1(.5) operation, torque control to keep the rotor at cut-in speed towards the Cp-max operational curve
    !       VS_State = VS_State_Region_2          (2), Region 2 operation, maximum rotor power efficiency (Cp-max) tracking using K*omega^2 law, fixed fine-pitch angle in BldPitch controller
    !       VS_State = VS_State_Region_2_5        (3), Region 2.5, transition between below and above-rated operating conditions (near-rated region) using PI torque control
    !       VS_State = VS_State_Region_3_ConstTrq (4), above-rated operation using pitch control (constant torque mode)
    !       VS_State = VS_State_Region_3_ConstPwr (5), above-rated operation using pitch and torque control (constant power mode)
    !       VS_State = VS_State_PI                (6), Tip-Speed-Ratio tracking PI controller (ignore state machine)
        USE ROSCO_Types, ONLY : ControlParameters, LocalVariables, ObjectInstances, ErrorVariables
        ! Inputs
        REAL(ReKi),                 INTENT(INOUT)       :: avrSWAP(*)    ! The swap array, used to pass data to, and receive data from, the DLL controller.
        TYPE(ControlParameters),    INTENT(INOUT)       :: CntrPar
        TYPE(LocalVariables),       INTENT(INOUT)       :: LocalVar
        TYPE(ObjectInstances),      INTENT(INOUT)       :: objInst
        TYPE(ErrorVariables),       INTENT(INOUT)       :: ErrVar

        CHARACTER(*),               PARAMETER           :: RoutineName = 'VariableSpeedControl'

        ! Allocate Variables

        ! -------- Variable-Speed Torque Controller --------

        ! Pre-compute generator torque values for K*Omega^2 and constant power
        LocalVar%VS_KOmega2_GenTq = CntrPar%VS_Rgn2K*LocalVar%GenSpeedF*LocalVar%GenSpeedF
        LocalVar%VS_ConstPwr_GenTq = (CntrPar%VS_RtPwr/(CntrPar%VS_GenEff/100.0))/LocalVar%GenSpeedF * LocalVar%PRC_R_Torque

        ! Determine maximum torque saturation limit, VS_MaxTq
        IF (CntrPar%VS_FBP == VS_FBP_Variable_Pitch) THEN 
            ! Variable pitch mode        
            IF (CntrPar%VS_ConstPower == VS_Mode_ConstPwr) THEN
                LocalVar%VS_MaxTq = min(LocalVar%VS_ConstPwr_GenTq, CntrPar%VS_MaxTq)
            ELSE
                LocalVar%VS_MaxTq = CntrPar%VS_RtTq * LocalVar%PRC_R_Torque
            END IF
        ELSE   
            ! Constant pitch, max torque is control parameter
            LocalVar%VS_MaxTq = CntrPar%VS_MaxTq  
        ENDIF 

        ! Optimal Tip-Speed-Ratio tracking controller (reference generated in subroutine ComputeVariablesSetpoints)
        IF ((CntrPar%VS_ControlMode == VS_Mode_WSE_TSR) .OR. \
            (CntrPar%VS_ControlMode == VS_Mode_Power_TSR) .OR. \
            (CntrPar%VS_ControlMode == VS_Mode_Torque_TSR)) THEN


            ! PI controller
            LocalVar%GenTq = PIController( &
                                        LocalVar%VS_SpdErr, &
                                        CntrPar%VS_KP(1), &
                                        CntrPar%VS_KI(1), &
                                        CntrPar%VS_MinTq, LocalVar%VS_MaxTq, &
                                        LocalVar%DT, LocalVar%VS_LastGenTrq, LocalVar%piP, LocalVar%restart, objInst%instPI)

            ! Saturate control input to Region 3 constant-power value if FBP mode is set to constant-power overspeed (no need for explicit transition region)
            IF (CntrPar%VS_FBP == VS_FBP_Power_Overspeed) THEN
                LocalVar%GenTq = MIN(LocalVar%VS_ConstPwr_GenTq, LocalVar%GenTq)
            ENDIF

        ! K*Omega^2 control law with PI torque control in transition regions
        ELSEIF (CntrPar%VS_ControlMode == VS_Mode_KOmega) THEN
            ! Update PI loops for region 1.5 and 2.5 PI control
            LocalVar%GenArTq = PIController(LocalVar%VS_SpdErrAr, CntrPar%VS_KP(1), CntrPar%VS_KI(1), CntrPar%VS_MaxOMTq, CntrPar%VS_ArSatTq, LocalVar%DT, CntrPar%VS_MaxOMTq, LocalVar%piP, LocalVar%restart, objInst%instPI)
            LocalVar%GenBrTq = PIController(LocalVar%VS_SpdErrBr, CntrPar%VS_KP(1), CntrPar%VS_KI(1), CntrPar%VS_MinTq, CntrPar%VS_MinOMTq, LocalVar%DT, CntrPar%VS_MinOMTq, LocalVar%piP, LocalVar%restart, objInst%instPI)

            ! State machine if switching to blade pitch control
            IF (LocalVar%VS_State == VS_State_Region_1_5) THEN ! Region 1.5
                LocalVar%GenTq = LocalVar%GenBrTq
            ELSEIF (LocalVar%VS_State == VS_State_Region_2) THEN ! Region 2
                LocalVar%GenTq = LocalVar%VS_KOmega2_GenTq
            ELSEIF (LocalVar%VS_State == VS_State_Region_2_5) THEN ! Region 2.5
                LocalVar%GenTq = LocalVar%GenArTq
            ELSEIF (LocalVar%VS_State == VS_State_Region_3_ConstTrq) THEN ! Region 3, constant torque
                LocalVar%GenTq = CntrPar%VS_RtTq
            ELSEIF (LocalVar%VS_State == VS_State_Region_3_ConstPwr) THEN ! Region 3, constant power
                LocalVar%GenTq = LocalVar%VS_ConstPwr_GenTq
            ELSEIF (LocalVar%VS_State == VS_State_Region_3_FBP) THEN ! Region 3, fixed blade pitch
                ! Constant power overspeed
                IF (CntrPar%VS_FBP == VS_FBP_Power_Overspeed) THEN
                    ! K*Omega^2 in Region 2 or constant power overspeed in Region 3
                    LocalVar%GenTq = MIN(LocalVar%VS_ConstPwr_GenTq, LocalVar%VS_KOmega2_GenTq)
                ! Reference-tracking in Region 3
                ELSEIF ((CntrPar%VS_FBP == VS_FBP_WSE_Ref) .OR. (CntrPar%VS_FBP == VS_FBP_Torque_Ref)) THEN
                    LocalVar%GenTq = LocalVar%GenArTq
                ENDIF
            END IF

        ELSE        ! VS_ControlMode of 0
            LocalVar%GenTq = 0
        ENDIF
        
        
        ! Shutdown
        IF (LocalVar%SD_Trigger == 0) THEN
            LocalVar%GenTq_SD = LocalVar%GenTq
        ELSE 
            IF (CntrPar%SD_Method == 1 .OR. CntrPar%SD_Method == 2) THEN
                LocalVar%GenTq_SD = LocalVar%GenTq_SD - LocalVar%SD_MaxTorqueRate*LocalVar%DT
                LocalVar%GenTq_SD = saturate(LocalVar%GenTq_SD, CntrPar%VS_MinTq, CntrPar%VS_MaxTq)
            ENDIF
            LocalVar%GenTq = LocalVar%GenTq_SD
        ENDIF

        ! Saturate based on most stringent defined maximum
        LocalVar%GenTq = saturate(LocalVar%GenTq, CntrPar%VS_MinTq, MIN(CntrPar%VS_MaxTq, LocalVar%VS_MaxTq))

        ! Saturate the commanded torque using the torque rate limit
        LocalVar%GenTq = ratelimit(LocalVar%GenTq, -CntrPar%VS_MaxRat, CntrPar%VS_MaxRat, LocalVar%DT, LocalVar%restart, LocalVar%rlP,objInst%instRL)    ! Saturate the command using the torque rate limit

        ! Open loop torque control
        IF ((CntrPar%OL_Mode > 0) .AND. (CntrPar%Ind_GenTq > 0)) THEN
            ! Get current OL GenTq, applies for OL_Mode 1 and 2
            IF (LocalVar%Time >= CntrPar%OL_Breakpoints(1)) THEN
                LocalVar%GenTq = interp1d(CntrPar%OL_Breakpoints,CntrPar%OL_GenTq,LocalVar%OL_Index,ErrVar)
            ENDIF
            
            ! Azimuth tracking control
            IF (CntrPar%OL_Mode == 2) THEN
                
                ! Push, pop and unwrap azimuth buffer 
                ! Initialize
                IF (LocalVar%iStatus == 0) THEN
                    LocalVar%AzBuffer(1) = LocalVar%Azimuth
                    LocalVar%AzBuffer(2) = LocalVar%Azimuth
                ENDIF
                LocalVar%AzBuffer(1) = LocalVar%AzBuffer(2)
                LocalVar%AzBuffer(2) = LocalVar%Azimuth
                LocalVar%AzBuffer = UNWRAP(LocalVar%AzBuffer, ErrVar)
                LocalVar%AzUnwrapped = LocalVar%AzBuffer(2)

                ! Current desired Azimuth, error
                LocalVar%OL_Azimuth = interp1d(CntrPar%OL_Breakpoints,CntrPar%OL_Azimuth,LocalVar%Time,ErrVar)
                LocalVar%AzError = LocalVar%OL_Azimuth - LocalVar%AzUnwrapped 

                LocalVar%GenTqAz = PIDController(LocalVar%AzError, CntrPar%RP_Gains(1), CntrPar%RP_Gains(2), CntrPar%RP_Gains(3), CntrPar%RP_Gains(4), -LocalVar%VS_MaxTq * 2, LocalVar%VS_MaxTq * 2, LocalVar%DT, 0.0_DbKi, LocalVar%piP, LocalVar%restart, objInst, LocalVar)
                LocalVar%GenTq = LocalVar%GenTq + LocalVar%GenTqAz

            ENDIF

        ENDIF

        ! Reset the value of LocalVar%VS_LastGenTrq to the current values:
        LocalVar%VS_LastGenTrq = LocalVar%GenTq
        LocalVar%VS_LastGenPwr = LocalVar%VS_GenPwr
        
        ! Set the command generator torque (See Appendix A of Bladed User's Guide):
        avrSWAP(47) = MAX(0.0_DbKi, LocalVar%VS_LastGenTrq)  ! Demanded generator torque, prevent negatives.

        ! Add RoutineName to error message
        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
        ENDIF

    END SUBROUTINE VariableSpeedControl
!-------------------------------------------------------------------------------------------------------------------------------
    SUBROUTINE YawRateControl(avrSWAP, CntrPar, LocalVar, objInst, DebugVar, ErrVar)
        ! Yaw rate controller
        !       Y_ControlMode = 0, No yaw control
        !       Y_ControlMode = 1, Yaw rate control using yaw drive

        ! TODO: Lots of R2D->D2R, this should be cleaned up.
        ! TODO: The constant offset implementation is sort of circular here as a setpoint is already being defined in SetVariablesSetpoints. This could also use cleanup
        USE ROSCO_Types, ONLY : ControlParameters, LocalVariables, ObjectInstances, DebugVariables, ErrorVariables
    
        REAL(ReKi), INTENT(INOUT) :: avrSWAP(*) ! The swap array, used to pass data to, and receive data from, the DLL controller.
    
        TYPE(ControlParameters), INTENT(INOUT)    :: CntrPar
        TYPE(LocalVariables), INTENT(INOUT)       :: LocalVar
        TYPE(ObjectInstances), INTENT(INOUT)      :: objInst
        TYPE(DebugVariables), INTENT(INOUT)       :: DebugVar
        TYPE(ErrorVariables), INTENT(INOUT)       :: ErrVar

        ! Allocate Variables
        REAL(DbKi), SAVE :: NacVaneOffset                          ! For offset control
        INTEGER, SAVE :: YawState                               ! Yawing left(-1), right(1), or stopped(0)
        REAL(DbKi)       :: WindDirPlusOffset                     ! Instantaneous wind direction minus the assigned vane offset (deg)
        REAL(DbKi)       :: WindDirPlusOffsetCosF                 ! Time-filtered x-component of WindDirPlusOffset (deg)
        REAL(DbKi)       :: WindDirPlusOffsetSinF                 ! Time-filtered y-component of WindDirPlusOffset (deg)
        REAL(DbKi)       :: NacHeadingTarget                       ! Time-filtered wind direction minus the assigned vane offset (deg)
        REAL(DbKi), SAVE :: NacHeadingError                        ! Yaw error (deg)
        REAL(DbKi)       :: YawRateCom                             ! Commanded yaw rate (deg/s)
        REAL(DbKi)       :: deadband                               ! Allowable yaw error deadband (deg)
        REAL(DbKi)       :: Time                                   ! Current time
        INTEGER, SAVE :: Tidx                                   ! Index i: commanded yaw error is interpolated between i and i+1
        
        IF (CntrPar%Y_ControlMode == 1) THEN

            ! Compass wind directions in degrees
            LocalVar%WindDir = wrap_180(LocalVar%NacHeading + LocalVar%NacVane)

            ! Initialize
            IF (LocalVar%iStatus == 0) THEN
                YawState = 0
                Tidx = 1
            ENDIF
            
            ! Compute/apply offset
            IF (CntrPar%ZMQ_Mode == 1) THEN
                NacVaneOffset = LocalVar%ZMQ_YawOffset
            ELSE
                NacVaneOffset = CntrPar%Y_MErrSet ! (deg) # Offset from setpoint
            ENDIF

            ! Update filtered wind direction
            WindDirPlusOffset = wrap_180(LocalVar%WindDir + NacVaneOffset) ! (deg)
            WindDirPlusOffsetCosF = LPFilter(cos(WindDirPlusOffset*D2R), LocalVar%DT, CntrPar%F_YawErr, LocalVar%FP, LocalVar%iStatus, .FALSE., objInst%instLPF) ! (-)
            WindDirPlusOffsetSinF = LPFilter(sin(WindDirPlusOffset*D2R), LocalVar%DT, CntrPar%F_YawErr, LocalVar%FP, LocalVar%iStatus, .FALSE., objInst%instLPF) ! (-)
            NacHeadingTarget = wrap_180(atan2(WindDirPlusOffsetSinF, WindDirPlusOffsetCosF) * R2D) ! (deg)

            ! ---- Now get into the guts of the control ----
            ! Yaw error
            NacHeadingError = wrap_180(NacHeadingTarget - LocalVar%NacHeading)
			
            ! Check for deadband
            IF (LocalVar%WE_Vw_F .le. CntrPar%Y_uSwitch) THEN
                deadband = CntrPar%Y_ErrThresh(1)
            ELSE
                deadband = CntrPar%Y_ErrThresh(2)
            ENDIF

            ! yawing right
            IF (YawState == 1) THEN 
                IF (NacHeadingError .le. 0) THEN
                    ! stop yawing
                    YawRateCom = 0.0
                    YawState = 0 
                ELSE
                    ! persist
                    YawRateCom = CntrPar%Y_Rate
                    YawState = 1 
                ENDIF
            ! yawing left
            ELSEIF (YawState == -1) THEN 
                IF (NacHeadingError .ge. 0) THEN
                    ! stop yawing
                    YawRateCom = 0.0
                    YawState = 0 
                ELSE
                    ! persist
                    YawRateCom = -CntrPar%Y_Rate
                    YawState = -1 
                ENDIF
            ! Initiate yaw if outside yaw error threshold
            ELSE
                IF (NacHeadingError .gt. deadband) THEN
                    YawState = 1 ! yaw right
                ENDIF

                IF (NacHeadingError .lt. -deadband) THEN
                    YawState = -1 ! yaw left
                ENDIF

                YawRateCom = 0.0 ! if YawState is not 0, start yawing on the next time step
            ENDIF

            ! Output yaw rate command in rad/s
            avrSWAP(48) = YawRateCom * D2R

            ! If using open loop yaw rate control, overwrite controlled output
            ! Open loop yaw rate control - control input in rad/s
            IF ((CntrPar%OL_Mode > 0) .AND. (CntrPar%Ind_YawRate > 0)) THEN
                IF (LocalVar%Time >= CntrPar%OL_Breakpoints(1)) THEN
                    avrSWAP(48) = interp1d(CntrPar%OL_Breakpoints,CntrPar%OL_YawRate,LocalVar%OL_Index, ErrVar)
                ENDIF
            ENDIF

            ! Save for debug
            DebugVar%YawRateCom       = YawRateCom
            DebugVar%NacHeadingTarget = NacHeadingTarget
            DebugVar%NacVaneOffset    = NacVaneOffset
            DebugVar%YawState         = YawState
            DebugVar%Yaw_Err          = NacHeadingError
        END IF
    END SUBROUTINE YawRateControl
!-------------------------------------------------------------------------------------------------------------------------------
    SUBROUTINE IPC(CntrPar, LocalVar, objInst, DebugVar, ErrVar)
        ! Individual pitch control subroutine
        !   - Calculates the commanded pitch angles for IPC employed for blade fatigue load reductions at 1P and 2P
        !   - Includes yaw by IPC

        USE ROSCO_Types, ONLY : ControlParameters, LocalVariables, ObjectInstances, DebugVariables, ErrorVariables
        
        TYPE(ControlParameters),    INTENT(INOUT)       :: CntrPar
        TYPE(LocalVariables),       INTENT(INOUT)       :: LocalVar
        TYPE(ObjectInstances),      INTENT(INOUT)       :: objInst
        TYPE(DebugVariables),       INTENT(INOUT)        :: DebugVar
        TYPE(ErrorVariables),       INTENT(INOUT)        :: ErrVar

        ! Local variables
        REAL(DbKi)                  :: PitComIPC(3), PitComIPCF(3), PitComIPC_1P(3), PitComIPC_2P(3)
        INTEGER(IntKi)              :: i, K                                    ! Integer used to loop through gains and turbine blades
        REAL(DbKi)                  :: axisYawIPC_1P                           ! IPC contribution with yaw-by-IPC component
        REAL(DbKi)                  :: Y_MErr, Y_MErrF, Y_MErrF_IPC            ! Unfiltered and filtered yaw alignment error [rad]
        
        CHARACTER(*),               PARAMETER           :: RoutineName = 'IPC'

        ! Body
        ! Pass rootMOOPs through the Coleman transform to get the tilt and yaw moment axis
        CALL ColemanTransform(LocalVar%rootMOOPF, LocalVar%Azimuth, NP_1, LocalVar%axisTilt_1P, LocalVar%axisYaw_1P)
        CALL ColemanTransform(LocalVar%rootMOOPF, LocalVar%Azimuth, NP_2, LocalVar%axisTilt_2P, LocalVar%axisYaw_2P)

        ! High-pass filter the MBC yaw component and filter yaw alignment error, and compute the yaw-by-IPC contribution
        IF (CntrPar%Y_ControlMode == 2) THEN
            Y_MErr = wrap_360(LocalVar%NacHeading + LocalVar%NacVane)
            Y_MErrF = LPFilter(Y_MErr, LocalVar%DT, CntrPar%F_YawErr, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instSecLPF)
            Y_MErrF_IPC = PIController(Y_MErrF, CntrPar%Y_IPC_KP, CntrPar%Y_IPC_KI, -CntrPar%Y_IPC_IntSat, CntrPar%Y_IPC_IntSat, LocalVar%DT, 0.0_DbKi, LocalVar%piP, LocalVar%restart, objInst%instPI)
        ELSE
            LocalVar%axisYawF_1P = LocalVar%axisYaw_1P
            Y_MErrF = 0.0
            Y_MErrF_IPC = 0.0
        END IF

        ! Soft cutin with sigma function 
        DO i = 1,2
            LocalVar%IPC_KP(i) = sigma(LocalVar%WE_Vw, CntrPar%IPC_Vramp(1), CntrPar%IPC_Vramp(2), 0.0_DbKi, CntrPar%IPC_KP(i), ErrVar)
            LocalVar%IPC_KI(i) = sigma(LocalVar%WE_Vw, CntrPar%IPC_Vramp(1), CntrPar%IPC_Vramp(2), 0.0_DbKi, CntrPar%IPC_KI(i), ErrVar)
        END DO

        ! Handle saturation limit, depends on IPC_SatMode
        IF (CntrPar%IPC_SatMode == 2) THEN
            ! Saturate to min allowed pitch angle, softly using IPC_IntSat
            LocalVar%IPC_IntSat = min(CntrPar%IPC_IntSat,LocalVar%BlPitchCMeas - CntrPar%PC_MinPit)
        ELSEIF (CntrPar%IPC_SatMode == 3) THEN
            ! Saturate to peak shaving, softly using IPC_IntSat
            LocalVar%IPC_IntSat = min(CntrPar%IPC_IntSat,LocalVar%BlPitchCMeas - LocalVar%PC_MinPit)
        ELSE
            LocalVar%IPC_IntSat = CntrPar%IPC_IntSat
        ENDIF
        
        ! Integrate the signal and multiply with the IPC gain
        IF (CntrPar%IPC_ControlMode >= 1 .AND. CntrPar%Y_ControlMode /= 2)  THEN
            LocalVar%IPC_axisTilt_1P = PIController(LocalVar%axisTilt_1P, LocalVar%IPC_KP(1), LocalVar%IPC_KI(1), -LocalVar%IPC_IntSat, LocalVar%IPC_IntSat, LocalVar%DT, 0.0_DbKi, LocalVar%piP, LocalVar%restart, objInst%instPI) 
            LocalVar%IPC_axisYaw_1P = PIController(LocalVar%axisYawF_1P, LocalVar%IPC_KP(1), LocalVar%IPC_KI(1), -LocalVar%IPC_IntSat, LocalVar%IPC_IntSat, LocalVar%DT, 0.0_DbKi, LocalVar%piP, LocalVar%restart, objInst%instPI) 
            
            IF (CntrPar%IPC_ControlMode >= 2) THEN
                LocalVar%IPC_axisTilt_2P = PIController(LocalVar%axisTilt_2P, LocalVar%IPC_KP(2), LocalVar%IPC_KI(2), -LocalVar%IPC_IntSat, LocalVar%IPC_IntSat, LocalVar%DT, 0.0_DbKi, LocalVar%piP, LocalVar%restart, objInst%instPI) 
                LocalVar%IPC_axisYaw_2P = PIController(LocalVar%axisYawF_2P, LocalVar%IPC_KP(2), LocalVar%IPC_KI(2), -LocalVar%IPC_IntSat, LocalVar%IPC_IntSat, LocalVar%DT, 0.0_DbKi, LocalVar%piP, LocalVar%restart, objInst%instPI) 
            END IF
        ELSE
            LocalVar%IPC_axisTilt_1P = 0.0
            LocalVar%IPC_axisYaw_1P = 0.0
            LocalVar%IPC_axisTilt_2P = 0.0
            LocalVar%IPC_axisYaw_2P = 0.0
        ENDIF
        
        ! Add the yaw-by-IPC contribution
        axisYawIPC_1P = LocalVar%IPC_axisYaw_1P + Y_MErrF_IPC
        
        ! Pass direct and quadrature axis through the inverse Coleman transform to get the commanded pitch angles
        CALL ColemanTransformInverse(LocalVar%IPC_axisTilt_1P, axisYawIPC_1P, LocalVar%Azimuth, NP_1, CntrPar%IPC_aziOffset(1), PitComIPC_1P)
        CALL ColemanTransformInverse(LocalVar%IPC_axisTilt_2P, LocalVar%IPC_axisYaw_2P, LocalVar%Azimuth, NP_2, CntrPar%IPC_aziOffset(2), PitComIPC_2P)
        
        ! Sum nP IPC contributions and store to LocalVar data type
        DO K = 1,LocalVar%NumBl
            PitComIPC(K) = PitComIPC_1P(K) + PitComIPC_2P(K)
            
            ! Optionally filter the resulting signal to induce a phase delay
            IF (CntrPar%IPC_CornerFreqAct > 0.0) THEN
                PitComIPCF(K) = LPFilter(PitComIPC(K), LocalVar%DT, CntrPar%IPC_CornerFreqAct, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instLPF)
            ELSE
                PitComIPCF(K) = PitComIPC(K)
            END IF
            
            LocalVar%IPC_PitComF(K) = PitComIPCF(K)
        END DO


        ! Add RoutineName to error message
        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
        ENDIF

    END SUBROUTINE IPC
!-------------------------------------------------------------------------------------------------------------------------------
    SUBROUTINE ForeAftDamping(CntrPar, LocalVar, objInst)
        ! Fore-aft damping controller, reducing the tower fore-aft vibrations using pitch

        USE ROSCO_Types, ONLY : ControlParameters, LocalVariables, ObjectInstances
        
        ! Local variables
        INTEGER(IntKi) :: K    ! Integer used to loop through turbine blades

        TYPE(ControlParameters), INTENT(INOUT)  :: CntrPar
        TYPE(LocalVariables), INTENT(INOUT)     :: LocalVar
        TYPE(ObjectInstances), INTENT(INOUT)    :: objInst
        
        ! Body
        LocalVar%FA_AccHPFI = PIController(LocalVar%FA_AccHPF, 0.0_DbKi, CntrPar%FA_KI, -CntrPar%FA_IntSat, CntrPar%FA_IntSat, LocalVar%DT, 0.0_DbKi, LocalVar%piP, LocalVar%restart, objInst%instPI)
        
        ! Store the fore-aft pitch contribution to LocalVar data type
        DO K = 1,LocalVar%NumBl
            LocalVar%FA_PitCom(K) = LocalVar%FA_AccHPFI
        END DO
        
    END SUBROUTINE ForeAftDamping
!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION FloatingFeedback(LocalVar, CntrPar, objInst, ErrVar) 
    ! FloatingFeedback defines a minimum blade pitch angle based on a lookup table provided by DISON.IN
    !       Fl_Mode = 0, No feedback
    !       Fl_Mode = 1, Proportional feedback of nacelle velocity (translational)
    !       Fl_Mode = 2, Proportional feedback of nacelle velocity (rotational)
        USE ROSCO_Types, ONLY : LocalVariables, ControlParameters, ObjectInstances, ErrorVariables
        IMPLICIT NONE
        ! Inputs
        TYPE(ControlParameters), INTENT(IN)     :: CntrPar
        TYPE(LocalVariables), INTENT(INOUT)     :: LocalVar 
        TYPE(ObjectInstances), INTENT(INOUT)    :: objInst
        TYPE(ErrorVariables), INTENT(INOUT)     :: ErrVar
        ! Allocate Variables 
        REAL(DbKi)                      :: FA_vel ! Tower fore-aft velocity [m/s]
        REAL(DbKi)                      :: NacIMU_FA_vel ! Tower fore-aft pitching velocity [rad/s]

        ! Gain scheduling
        LocalVar%Kp_Float = interp1d(CntrPar%Fl_U,CntrPar%Fl_Kp,LocalVar%WE_Vw_F,ErrVar)       ! Schedule based on WSE
        
        ! Calculate floating contribution to pitch command
        FA_vel = PIController(LocalVar%FA_AccF, 0.0_DbKi, 1.0_DbKi, -100.0_DbKi , 100.0_DbKi ,LocalVar%DT, 0.0_DbKi, LocalVar%piP, LocalVar%restart, objInst%instPI) ! NJA: should never reach saturation limits....
        NacIMU_FA_vel = PIController(LocalVar%NacIMU_FA_AccF, 0.0_DbKi, 1.0_DbKi, -100.0_DbKi , 100.0_DbKi ,LocalVar%DT, 0.0_DbKi, LocalVar%piP, LocalVar%restart, objInst%instPI) ! NJA: should never reach saturation limits....        
! Mod made by A. Wright: use the gain scheduled value of KPfloat in the floating fb equ's below (instead of the old value of CntrPar%Fl_Kp), for either value of CntrPar%Fl_Mode...        
        if (CntrPar%Fl_Mode == 1) THEN
            FloatingFeedback = (0.0_DbKi - FA_vel) * LocalVar%Kp_Float ! Mod made by A. Wright: use the gain scheduled value of KPfloat in the floating fb equ's below (instead of the old value of CntrPar%Fl_Kp), for either value of CntrPar%Fl_Mode...
        ELSEIF (CntrPar%Fl_Mode == 2) THEN
            FloatingFeedback = (0.0_DbKi - NacIMU_FA_vel) *LocalVar%Kp_Float ! Mod made by A. Wright: use the gain scheduled value of KPfloat in the floating fb equ's below (instead of the old value of CntrPar%Fl_Kp), for either value of CntrPar%Fl_Mode...
        END IF

    END FUNCTION FloatingFeedback
!-------------------------------------------------------------------------------------------------------------------------------
    SUBROUTINE FlapControl(avrSWAP, CntrPar, LocalVar, objInst)
        ! Yaw rate controller
        !       Y_ControlMode = 0, No yaw control
        !       Y_ControlMode = 1, Simple yaw rate control using yaw drive
        !       Y_ControlMode = 2, Yaw by IPC (accounted for in IPC subroutine)
        USE ROSCO_Types, ONLY : ControlParameters, LocalVariables, ObjectInstances
    
        REAL(ReKi), INTENT(INOUT) :: avrSWAP(*) ! The swap array, used to pass data to, and receive data from, the DLL controller.
    
        TYPE(ControlParameters), INTENT(INOUT)    :: CntrPar
        TYPE(LocalVariables), INTENT(INOUT)       :: LocalVar
        TYPE(ObjectInstances), INTENT(INOUT)      :: objInst
        ! Internal Variables
        INTEGER(IntKi)              :: K
        REAL(DbKi)                  :: RootMyb_Vel(3)
        REAL(DbKi)                  :: RootMyb_VelErr(3)
        REAL(DbKi)                  :: axisTilt_1P, axisYaw_1P    ! Direct axis and quadrature axis outputted by Coleman transform, 1P
        REAL(DbKi)                  :: Flp_axisTilt_1P, Flp_axisYaw_1P ! Flap command in direct and quadrature axis coordinates
        ! Flap control
        IF (CntrPar%Flp_Mode > 0) THEN
            IF (LocalVar%iStatus == 0) THEN
                LocalVar%RootMyb_Last(1) = 0 - LocalVar%rootMOOP(1)
                LocalVar%RootMyb_Last(2) = 0 - LocalVar%rootMOOP(2)
                LocalVar%RootMyb_Last(3) = 0 - LocalVar%rootMOOP(3)
                ! Initial Flap angle
                LocalVar%Flp_Angle(1) = CntrPar%Flp_Angle
                LocalVar%Flp_Angle(2) = CntrPar%Flp_Angle
                LocalVar%Flp_Angle(3) = CntrPar%Flp_Angle
                ! Initialize controller
                IF (CntrPar%Flp_Mode == 2) THEN
                    LocalVar%Flp_Angle(K) = PIIController(RootMyb_VelErr(K), 0 - LocalVar%Flp_Angle(K), CntrPar%Flp_Kp, CntrPar%Flp_Ki, 0.05_DbKi, -CntrPar%Flp_MaxPit , CntrPar%Flp_MaxPit , LocalVar%DT, 0.0_DbKi, LocalVar%piP, LocalVar%restart, objInst%instPI)
                ENDIF
            
            ! Steady flap angle
            ELSEIF (CntrPar%Flp_Mode == 1) THEN
                LocalVar%Flp_Angle(1) = LocalVar%Flp_Angle(1) 
                LocalVar%Flp_Angle(2) = LocalVar%Flp_Angle(2) 
                LocalVar%Flp_Angle(3) = LocalVar%Flp_Angle(3) 

            ! PII flap control
            ELSEIF (CntrPar%Flp_Mode == 2) THEN
                DO K = 1,LocalVar%NumBl
                    ! Find flap angle command - includes an integral term to encourage zero flap angle
                    LocalVar%Flp_Angle(K) = PIIController(-LocalVar%rootMOOPF(K), 0 - LocalVar%Flp_Angle(K), CntrPar%Flp_Kp, CntrPar%Flp_Ki, 0.05_DbKi, -CntrPar%Flp_MaxPit , CntrPar%Flp_MaxPit , LocalVar%DT, 0.0_DbKi, LocalVar%piP, LocalVar%restart, objInst%instPI)
                    ! Saturation Limits
                    LocalVar%Flp_Angle(K) = saturate(LocalVar%Flp_Angle(K), -CntrPar%Flp_MaxPit, CntrPar%Flp_MaxPit) * R2D
                END DO

            ! Cyclic flap Control
            ELSEIF (CntrPar%Flp_Mode == 3) THEN
                ! Pass rootMOOPs through the Coleman transform to get the tilt and yaw moment axis
                CALL ColemanTransform(LocalVar%rootMOOPF, LocalVar%Azimuth, NP_1, axisTilt_1P, axisYaw_1P)

                ! Apply PI control
                Flp_axisTilt_1P = PIController(axisTilt_1P, CntrPar%Flp_Kp, CntrPar%Flp_Ki, -CntrPar%Flp_MaxPit, CntrPar%Flp_MaxPit, LocalVar%DT, 0.0_DbKi, LocalVar%piP, LocalVar%restart, objInst%instPI) 
                Flp_axisYaw_1P = PIController(axisYaw_1P, CntrPar%Flp_Kp, CntrPar%Flp_Ki, -CntrPar%Flp_MaxPit, CntrPar%Flp_MaxPit, LocalVar%DT, 0.0_DbKi, LocalVar%piP, LocalVar%restart, objInst%instPI) 
            
                ! Pass direct and quadrature axis through the inverse Coleman transform to get the commanded pitch angles
                CALL ColemanTransformInverse(Flp_axisTilt_1P, Flp_axisYaw_1P, LocalVar%Azimuth, NP_1, 0.0_DbKi, LocalVar%Flp_Angle)
                
            ENDIF

            ! Send to AVRSwap
            avrSWAP(120) = LocalVar%Flp_Angle(1)   ! Send flap pitch command (deg)
            avrSWAP(121) = LocalVar%Flp_Angle(2)   ! Send flap pitch command (deg)
            avrSWAP(122) = LocalVar%Flp_Angle(3)   ! Send flap pitch command (deg)
        ELSE
            RETURN
        ENDIF
    END SUBROUTINE FlapControl


!-------------------------------------------------------------------------------------------------------------------------------
    SUBROUTINE ActiveWakeControl(CntrPar, LocalVar, DebugVar, objInst)
        ! Active wake controller
        !       AWC_Mode = 0, No active wake control
        !       AWC_Mode = 1, SNL active wake control
        !       AWC_Mode = 2, Coleman Transform-based active wake control
        !       AWC_Mode = 3, Closed-loop Proportional-integral (PI) active wake control
        !       AWC_Mode = 4, Closed-loop Proportional-resonant (PR) active wake control
        !       AWC_Mode = 5, Strouhal transformation based closed-loop active wake control
        USE ROSCO_Types, ONLY : ControlParameters, LocalVariables, DebugVariables, ObjectInstances

        TYPE(ControlParameters), INTENT(INOUT)    :: CntrPar
        TYPE(DebugVariables), INTENT(INOUT)       :: DebugVar
        TYPE(LocalVariables), INTENT(INOUT)       :: LocalVar
        TYPE(ObjectInstances), INTENT(INOUT)      :: objInst

        ! Local vars
        REAL(DbKi), PARAMETER      :: phi1 = 0.0                       ! Phase difference from first to first blade
        REAL(DbKi), PARAMETER      :: phi2 = 2.0/3.0*PI                ! Phase difference from first to second blade
        REAL(DbKi), PARAMETER      :: phi3 = 4.0/3.0*PI                ! Phase difference from first to third blade
        REAL(DbKi), DIMENSION(3)      :: AWC_angle
        COMPLEX(DbKi), DIMENSION(3)   :: AWC_complexangle
        COMPLEX(DbKi)              :: complexI = (0.0, 1.0)
        INTEGER(IntKi)             :: Imode, K                         ! Index used for looping through AWC modes, blades
        REAL(DbKi)                 :: clockang                         ! Clock angle for AWC pitching
        REAL(DbKi)                 :: omega                            ! angular frequency for AWC pitching in Hz
        REAL(DbKi)                 :: amp                              ! amplitude for AWC pitching in degrees
        REAL(DbKi), DIMENSION(2)   :: AWC_TiltYaw = [0.0, 0.0]         ! AWC tilt and yaw pitch signals
        REAL(DbKi), DIMENSION(2)   :: Error = [0.0, 0.0]               ! Error in transformed tilt and yaw signals
        REAL(DbKi), DIMENSION(2)   :: FixedFrameM                      ! Measured tilt moment
        REAL(DbKi)                 :: StrAzimuth                       ! Strouhal transformed "azimuth" angle
        REAL(DbKi)                 :: StartTime = 0.0                  ! Start time of closed-loop AWC


        ! Compute the AWC pitch settings, complex number approach
        IF (CntrPar%AWC_Mode == 1) THEN

            LocalVar%AWC_complexangle = 0.0D0

            DO Imode = 1,CntrPar%AWC_NumModes
                clockang = CntrPar%AWC_clockangle(Imode)*PI/180.0_DbKi
                omega = CntrPar%AWC_freq(Imode)*PI*2.0_DbKi
                AWC_angle(1) = omega * LocalVar%Time - CntrPar%AWC_n(Imode) * (LocalVar%Azimuth + phi1 + clockang)
                AWC_angle(2) = omega * LocalVar%Time - CntrPar%AWC_n(Imode) * (LocalVar%Azimuth + phi2 + clockang)
                AWC_angle(3) = omega * LocalVar%Time - CntrPar%AWC_n(Imode) * (LocalVar%Azimuth + phi3 + clockang)
                ! Add the forcing contribution to LocalVar%AWC_complexangle
                amp = CntrPar%AWC_amp(Imode)*PI/180.0_DbKi
                DO K = 1,LocalVar%NumBl ! Loop through all blades
                    LocalVar%AWC_complexangle(K) = LocalVar%AWC_complexangle(K) + amp * EXP(complexI * (AWC_angle(K)))
                END DO
            END DO

            DO K = 1,LocalVar%NumBl ! Loop through all blades, apply AWC_angle
                LocalVar%PitCom(K) = LocalVar%PitCom(K) + REAL(LocalVar%AWC_complexangle(K))
            END DO

        ! Open-loop Coleman transform method
        ELSEIF (CntrPar%AWC_Mode == 2) THEN

            ! Calculate reference OL blade signals
            AWC_TiltYaw = [0.0, 0.0]
            DO Imode = 1,CntrPar%AWC_NumModes
                AWC_TiltYaw(Imode) = D2R*CntrPar%AWC_amp(Imode)*sin(LocalVar%Time*2*PI*CntrPar%AWC_freq(Imode) + CntrPar%AWC_clockangle(Imode)*D2R)
                IF (CntrPar%AWC_NumModes == 1) THEN
                    AWC_TiltYaw(2) = D2R*CntrPar%AWC_amp(1)*sin(LocalVar%Time*2*PI*CntrPar%AWC_freq(1) + 2*CntrPar%AWC_clockangle(1)*D2R)
                ENDIF
                
                ! Inverse Coleman Transformation with phase offset
                CALL ColemanTransformInverse(AWC_TiltYaw(1), AWC_TiltYaw(2), LocalVar%Azimuth, CntrPar%AWC_harmonic(Imode), CntrPar%AWC_phaseoffset*D2R, AWC_angle)
            END DO

            DO K = 1,LocalVar%NumBl ! Loop through all blades, apply AWC_angle
                LocalVar%PitCom(K) = LocalVar%PitCom(K) + AWC_angle(K)
            END DO

            ! DEBUG VARIABLES
            DebugVar%axisTilt_2P = AWC_TiltYaw(1)
            DebugVar%axisYaw_2P = AWC_TiltYaw(2)
            CALL ColemanTransform(LocalVar%BlPitch, LocalVar%Azimuth, CntrPar%AWC_harmonic(1), AWC_TiltYaw(1), AWC_TiltYaw(2))

            DebugVar%axisTilt_1P = AWC_TiltYaw(1)
            DebugVar%axisYaw_1P = AWC_TiltYaw(2)
        
        ! Closed-loop PI / PR controller
        ELSEIF ((CntrPar%AWC_Mode == 3) .OR. (CntrPar%AWC_Mode == 4)) THEN

            !! If AWC_harmonic > 0, use AWC_NumModes=2
        
            CALL ColemanTransform(LocalVar%rootMOOPF, LocalVar%Azimuth, CntrPar%AWC_harmonic(1), FixedFrameM(1), FixedFrameM(2))

            IF (CntrPar%AWC_harmonic(1) == 0) THEN
                ! Calculate mean moments, subtract later to get zero-mean tilt and yaw
                LocalVar%TiltMean = LocalVar%TiltMean + FixedFrameM(1)
                StartTime = 1/CntrPar%AWC_freq(1)
            ENDIF

            IF (LocalVar%Time .GT. StartTime) THEN
                DO Imode = 1,CntrPar%AWC_NumModes
                    Error(Imode) = CntrPar%AWC_amp(Imode)*sin(LocalVar%Time*2*PI*CntrPar%AWC_freq(Imode) + CntrPar%AWC_clockangle(Imode)*D2R) &
                                        + (FixedFrameM(Imode) - LocalVar%TiltMean/(LocalVar%n_DT+1))

                    IF (CntrPar%AWC_Mode == 4) THEN
                        AWC_TiltYaw(Imode) = ResController(Error(Imode), CntrPar%AWC_CntrGains(1), CntrPar%AWC_CntrGains(2), CntrPar%AWC_freq(Imode), & 
                                                            CntrPar%PC_MinPit, CntrPar%PC_MaxPit, LocalVar%DT, LocalVar%resP, LocalVar%restart, objInst%instRes)
                    ELSE
                        AWC_TiltYaw(Imode) = PIController(Error(Imode), CntrPar%AWC_CntrGains(1), CntrPar%AWC_CntrGains(2), CntrPar%PC_MinPit, CntrPar%PC_MaxPit, &
                                                            LocalVar%DT, 0.0_DbKi, LocalVar%piP, LocalVar%restart, objInst%instPI)
                    ENDIF
                ENDDO
            ENDIF

            ! Pass tilt and yaw axis through the inverse Coleman transform to get the commanded pitch angles
            CALL ColemanTransformInverse(AWC_TiltYaw(1), AWC_TiltYaw(2), &
                                         LocalVar%Azimuth, CntrPar%AWC_harmonic(1), CntrPar%AWC_phaseoffset*D2R, AWC_angle)
            
            DO K = 1,LocalVar%NumBl ! Loop through all blades, apply AWC_angle
                IF (CntrPar%AWC_harmonic(1) == 0) THEN
                    LocalVar%PitCom(K) = LocalVar%PitCom(K) + AWC_TiltYaw(1)
                ELSE
                    LocalVar%PitCom(K) = LocalVar%PitCom(K) + AWC_angle(K)
                ENDIF
            END DO

            ! DEBUG VARIABLES
            DebugVar%axisTilt_1P = AWC_TiltYaw(1)
            DebugVar%axisYaw_1P = -FixedFrameM(1) + LocalVar%TiltMean/(LocalVar%n_DT+1)
            DebugVar%axisTilt_2P = CntrPar%AWC_amp(1)*sin(LocalVar%Time*2*PI*CntrPar%AWC_freq(1) + CntrPar%AWC_clockangle(1)*D2R)
            DebugVar%axisYaw_2P = Error(1)

        ! Closed-loop Strouhal transform method
        ELSEIF (CntrPar%AWC_Mode == 5) THEN

            StrAzimuth = wrap_360(360*LocalVar%Time*CntrPar%AWC_freq(1))*D2R

            CALL ColemanTransform(LocalVar%rootMOOPF, LocalVar%Azimuth, CntrPar%AWC_harmonic(1), FixedFrameM(1), FixedFrameM(2))
            
            ! Calculate mean tilt and yaw moments to subtract
            LocalVar%TiltMean = LocalVar%TiltMean + FixedFrameM(1)
            LocalVar%YawMean = LocalVar%YawMean + FixedFrameM(2)

            ! Calculate error with zero-mean moments
            Error(1) = CntrPar%AWC_amp(1) + sin(StrAzimuth + CntrPar%AWC_clockangle(1)*D2R)*(FixedFrameM(1) - LocalVar%TiltMean/(LocalVar%n_DT+1)) &
                        + sin(StrAzimuth + CntrPar%AWC_clockangle(2)*D2R)*(FixedFrameM(2) - LocalVar%YawMean/(LocalVar%n_DT+1)) 

            ! PI Control
            IF (LocalVar%Time .GT. 1/CntrPar%AWC_freq(1)) THEN
                AWC_TiltYaw(1) = PIController(Error(1), CntrPar%AWC_CntrGains(1), CntrPar%AWC_CntrGains(2), &
                                    CntrPar%PC_MinPit, CntrPar%PC_MaxPit, LocalVar%DT, 0.0_DbKi, LocalVar%piP, LocalVar%restart, objInst%instPI)
            ENDIF

            ! Pass tilt and yaw axis through the inverse Strouhal + Coleman transform to get the commanded pitch angles
            CALL ColemanTransformInverse(sin(StrAzimuth + CntrPar%AWC_clockangle(1)*D2R)*AWC_TiltYaw(1), & ! Tilt signal (inverse Str transform)
                                            sin(StrAzimuth + CntrPar%AWC_clockangle(2)*D2R)*AWC_TiltYaw(1), & ! Yaw signal (inverse Str transform)
                                            LocalVar%Azimuth, CntrPar%AWC_harmonic(1), CntrPar%AWC_phaseoffset*D2R, AWC_angle)

            DO K = 1,LocalVar%NumBl ! Loop through all blades, apply AWC_angle
                LocalVar%PitCom(K) = LocalVar%PitCom(K) + AWC_angle(K)
            END DO

            ! DEBUG VARIABLES
            DebugVar%axisTilt_1P = sin(StrAzimuth + CntrPar%AWC_clockangle(1)*D2R)*AWC_TiltYaw(1)
            DebugVar%axisYaw_1P = -FixedFrameM(1) + LocalVar%TiltMean/(LocalVar%n_DT+1)
            DebugVar%axisTilt_2P = CntrPar%AWC_amp(1)*sin(StrAzimuth + CntrPar%AWC_clockangle(1)*D2R)
            DebugVar%axisYaw_2P = Error(1)


        ENDIF

    END SUBROUTINE ActiveWakeControl

!-------------------------------------------------------------------------------------------------------------------------------
    SUBROUTINE CableControl(avrSWAP, CntrPar, LocalVar, objInst, ErrVar)
        ! Cable controller
        !       CC_Mode = 0, No cable control, this code not executed
        !       CC_Mode = 1, User-defined cable control
        !       CC_Mode = 2, Position control, not yet implemented
        !
        ! Note that LocalVar%CC_Actuated*(), and CC_Desired() has a fixed max size of 12, which can be increased in rosco_types.yaml
        !
        USE ROSCO_Types, ONLY : ControlParameters, LocalVariables, ObjectInstances, ErrorVariables
    
        REAL(ReKi), INTENT(INOUT) :: avrSWAP(*) ! The swap array, used to pass data to, and receive data from, the DLL controller.
    
        TYPE(ControlParameters), INTENT(INOUT)    :: CntrPar
        TYPE(LocalVariables), INTENT(INOUT)       :: LocalVar
        TYPE(ObjectInstances), INTENT(INOUT)      :: objInst
        TYPE(ErrorVariables), INTENT(INOUT)      :: ErrVar
        
        ! Internal Variables
        Integer(IntKi)                            :: I_GROUP
        CHARACTER(*),               PARAMETER           :: RoutineName = 'StructuralControl'



        IF (CntrPar%CC_Mode == 1) THEN
            ! User defined control

            IF (LocalVar%Time > 500) THEN
                ! Shorten first group by 4 m
                LocalVar%CC_DesiredL(1) = -14.51
                LocalVar%CC_DesiredL(2) = 1.58
                LocalVar%CC_DesiredL(3) = -10.332


            END IF

        ELSEIF (CntrPar%CC_Mode == 2) THEN
            ! Open loop control
            ! DO I_GROUP = 1, CntrPar%CC_Group_N
            !     LocalVar%CC_DesiredL(I_GROUP) = interp1d(x,y,eq,ErrVar)

            DO I_GROUP = 1,CntrPar%CC_Group_N
                IF (CntrPar%Ind_CableControl(I_GROUP) > 0) THEN
                    LocalVar%CC_DesiredL(I_GROUP) = interp1d(CntrPar%OL_Breakpoints, &
                                                            CntrPar%OL_CableControl(I_GROUP,:), &
                                                            LocalVar%Time,ErrVar)
                ENDIF
            ENDDO



        END IF

        ! Convert desired to actuated line length and delta length for all groups

        DO I_GROUP = 1, CntrPar%CC_Group_N

            ! Get Actuated deltaL
            LocalVar%CC_ActuatedDL(I_GROUP) = SecLPFilter_Vel(LocalVar%CC_DesiredL(I_GROUP),LocalVar%DT,2*PI/CntrPar%CC_ActTau,REAL(1.0,DbKi), &
                                                                LocalVar%FP,LocalVar%iStatus,LocalVar%restart,objInst%instSecLPFV)

            ! Integrate
            LocalVar%CC_ActuatedL(I_GROUP) = PIController(LocalVar%CC_ActuatedDL(I_GROUP),0.0_DbKi,1.0_DbKi, &
                                                    -1000.0_DbKi,1000.0_DbKi,LocalVar%DT,LocalVar%CC_ActuatedDL(1), &
                                                    LocalVar%piP, LocalVar%restart, objInst%instPI)

        END DO

        ! Assign to avrSWAP
        DO I_GROUP = 1, CntrPar%CC_Group_N

            avrSWAP(CntrPar%CC_GroupIndex(I_GROUP)) = LocalVar%CC_ActuatedL(I_GROUP)
            avrSWAP(CntrPar%CC_GroupIndex(I_GROUP)+1) = LocalVar%CC_ActuatedDL(I_GROUP)

        END DO

        ! Add RoutineName to error message
        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
        ENDIF

    END SUBROUTINE CableControl

!-------------------------------------------------------------------------------------------------------------------------------
SUBROUTINE StructuralControl(avrSWAP, CntrPar, LocalVar, objInst, ErrVar)
        ! Cable controller
        !       StC_Mode = 0, No cable control, this code not executed
        !       StC_Mode = 1, User-defined cable control
        !       StC_Mode = 2, Ballast-like control, not yet implemented
        !
        ! Note that LocalVar%StC_Input() has a fixed max size of 12, which can be increased in rosco_types.yaml
        !
        USE ROSCO_Types, ONLY : ControlParameters, LocalVariables, ObjectInstances, ErrorVariables
    
        REAL(ReKi), INTENT(INOUT) :: avrSWAP(*) ! The swap array, used to pass data to, and receive data from, the DLL controller.
    
        TYPE(ControlParameters), INTENT(INOUT)    :: CntrPar
        TYPE(LocalVariables), INTENT(INOUT)       :: LocalVar
        TYPE(ObjectInstances), INTENT(INOUT)      :: objInst
        TYPE(ErrorVariables), INTENT(INOUT)      :: ErrVar

        
        ! Internal Variables
        Integer(IntKi)                            :: I_GROUP
        CHARACTER(*),               PARAMETER           :: RoutineName = 'StructuralControl'



        IF (CntrPar%StC_Mode == 1) THEN
            ! User defined control, step example

            IF (LocalVar%Time > 500) THEN
                ! Step change in input of -4500 N
                LocalVar%StC_Input(1) = -1.234e+06
                LocalVar%StC_Input(2) = 2.053e+06
                LocalVar%StC_Input(3) = -7.795e+05

            END IF


        ELSEIF (CntrPar%StC_Mode == 2) THEN


            DO I_GROUP = 1,CntrPar%StC_Group_N
                IF (CntrPar%Ind_StructControl(I_GROUP) > 0) THEN
                    LocalVar%StC_Input(I_GROUP) =  interp1d(CntrPar%OL_Breakpoints, &
                                                            CntrPar%OL_StructControl(I_GROUP,:), &
                                                            LocalVar%Time,ErrVar)
                ENDIF
            ENDDO



        END IF


        ! Assign to avrSWAP
        DO I_GROUP = 1, CntrPar%StC_Group_N
            avrSWAP(CntrPar%StC_GroupIndex(I_GROUP)) = LocalVar%StC_Input(I_GROUP)
        END DO

        ! Add RoutineName to error message
        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
        ENDIF

    END SUBROUTINE StructuralControl
!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION PIController(error, kp, ki, minValue, maxValue, DT, I0, piP, reset, inst)
        USE ROSCO_Types, ONLY : piParams

    ! PI controller, with output saturation

        IMPLICIT NONE
        ! Allocate Inputs
        REAL(DbKi),    INTENT(IN)         :: error
        REAL(DbKi),    INTENT(IN)         :: kp
        REAL(DbKi),    INTENT(IN)         :: ki
        REAL(DbKi),    INTENT(IN)         :: minValue
        REAL(DbKi),    INTENT(IN)         :: maxValue
        REAL(DbKi),    INTENT(IN)         :: DT
        INTEGER(IntKi), INTENT(INOUT)      :: inst
        REAL(DbKi),    INTENT(IN)         :: I0
        TYPE(piParams), INTENT(INOUT)  :: piP
        LOGICAL,    INTENT(IN)         :: reset     
        ! Allocate local variables
        INTEGER(IntKi)                      :: i                                            ! Counter for making arrays
        REAL(DbKi)                         :: PTerm                                        ! Proportional term

        ! Initialize persistent variables/arrays, and set inital condition for integrator term
        IF (reset) THEN
            piP%ITerm(inst) = I0
            piP%ITermLast(inst) = I0
            
            PIController = I0
        ELSE
            PTerm = kp*error
            piP%ITerm(inst) = piP%ITerm(inst) + DT*ki*error
            piP%ITerm(inst) = saturate(piP%ITerm(inst), minValue, maxValue)
            PIController = saturate(PTerm + piP%ITerm(inst), minValue, maxValue)
        
            piP%ITermLast(inst) = piP%ITerm(inst)
        END IF
        inst = inst + 1
        
    END FUNCTION PIController


!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION PIDController(error, kp, ki, kd, tf, minValue, maxValue, DT, I0, piP, reset, objInst, LocalVar)
        USE ROSCO_Types, ONLY : piParams, LocalVariables, ObjectInstances

    ! PI controller, with output saturation

        IMPLICIT NONE
        ! Allocate Inputs
        REAL(DbKi),    INTENT(IN)         :: error
        REAL(DbKi),    INTENT(IN)         :: kp
        REAL(DbKi),    INTENT(IN)         :: ki
        REAL(DbKi),    INTENT(IN)         :: kd
        REAL(DbKi),    INTENT(IN)         :: tf
        REAL(DbKi),    INTENT(IN)         :: minValue
        REAL(DbKi),    INTENT(IN)         :: maxValue
        REAL(DbKi),    INTENT(IN)         :: DT
        TYPE(ObjectInstances),      INTENT(INOUT)   :: objInst  ! all object instances (PI, filters used here)
        TYPE(LocalVariables),       INTENT(INOUT)   :: LocalVar

        REAL(DbKi),    INTENT(IN)           :: I0
        TYPE(piParams), INTENT(INOUT)       :: piP
        LOGICAL,    INTENT(IN)              :: reset     
        
        ! Allocate local variables
        INTEGER(IntKi)                      :: i                                            ! Counter for making arrays
        REAL(DbKi)                          :: PTerm, DTerm                                 ! Proportional, deriv. terms
        REAL(DbKi)                          :: EFilt                    ! Filtered error for derivative

        ! Always filter error
        EFilt = LPFilter(error, DT, tf, LocalVar%FP, LocalVar%iStatus, reset, objInst%instLPF)

        ! Initialize persistent variables/arrays, and set inital condition for integrator term
        IF (reset) THEN
            piP%ITerm(objInst%instPI) = I0
            piP%ITermLast(objInst%instPI) = I0
            piP%ELast(objInst%instPI) = 0.0_DbKi
            PIDController = I0
        ELSE
            ! Proportional
            PTerm = kp*error
            
            ! Integrate and saturate
            piP%ITerm(objInst%instPI) = piP%ITerm(objInst%instPI) + DT*ki*error
            piP%ITerm(objInst%instPI) = saturate(piP%ITerm(objInst%instPI), minValue, maxValue)

            ! Derivative (filtered)
            DTerm = kd * (EFilt - piP%ELast(objInst%instPI)) / DT
            
            ! Saturate all
            PIDController = saturate(PTerm + piP%ITerm(objInst%instPI) + DTerm, minValue, maxValue)
        
            ! Save lasts
            piP%ITermLast(objInst%instPI) = piP%ITerm(objInst%instPI)
            piP%ELast(objInst%instPI) = EFilt
        END IF
        objInst%instPI = objInst%instPI + 1
        
    END FUNCTION PIDController

!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION PIIController(error, error2, kp, ki, ki2, minValue, maxValue, DT, I0, piP, reset, inst)
    ! PI controller, with output saturation. 
    ! Added error2 term for additional integral control input
        USE ROSCO_Types, ONLY : piParams
        
        IMPLICIT NONE
        ! Allocate Inputs
        REAL(DbKi), INTENT(IN)         :: error
        REAL(DbKi), INTENT(IN)         :: error2
        REAL(DbKi), INTENT(IN)         :: kp
        REAL(DbKi), INTENT(IN)         :: ki2
        REAL(DbKi), INTENT(IN)         :: ki
        REAL(DbKi), INTENT(IN)         :: minValue
        REAL(DbKi), INTENT(IN)         :: maxValue
        REAL(DbKi), INTENT(IN)         :: DT
        INTEGER(IntKi), INTENT(INOUT)   :: inst
        REAL(DbKi), INTENT(IN)         :: I0
        TYPE(piParams), INTENT(INOUT) :: piP
        LOGICAL, INTENT(IN)         :: reset     
        ! Allocate local variables
        INTEGER(IntKi)                      :: i                                            ! Counter for making arrays
        REAL(DbKi)                         :: PTerm                                        ! Proportional term

        ! Initialize persistent variables/arrays, and set inital condition for integrator term
        IF (reset) THEN
            piP%ITerm(inst) = I0
            piP%ITermLast(inst) = I0
            piP%ITerm2(inst) = I0
            piP%ITermLast2(inst) = I0
            
            PIIController = I0
        ELSE
            PTerm = kp*error
            piP%ITerm(inst) = piP%ITerm(inst) + DT*ki*error
            piP%ITerm2(inst) = piP%ITerm2(inst) + DT*ki2*error2
            piP%ITerm(inst) = saturate(piP%ITerm(inst), minValue, maxValue)
            piP%ITerm2(inst) = saturate(piP%ITerm2(inst), minValue, maxValue)
            PIIController = PTerm + piP%ITerm(inst) + piP%ITerm2(inst)
            PIIController = saturate(PIIController, minValue, maxValue)
        
            piP%ITermLast(inst) = piP%ITerm(inst)
        END IF
        inst = inst + 1
        
    END FUNCTION PIIController

        !-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION ResController(error, kp, ki, freq, minValue, maxValue, DT, resP, reset, inst)
        USE ROSCO_Types, ONLY : resParams

    ! PI controller, with output saturation

        IMPLICIT NONE
        ! Allocate Inputs
        REAL(DbKi),    INTENT(IN)         :: error
        REAL(DbKi),    INTENT(IN)         :: kp
        REAL(DbKi),    INTENT(IN)         :: ki
        REAL(DbKi),    INTENT(IN)         :: freq
        REAL(DbKi),    INTENT(IN)         :: minValue
        REAL(DbKi),    INTENT(IN)         :: maxValue
        REAL(DbKi),    INTENT(IN)         :: DT
        INTEGER(IntKi), INTENT(INOUT)     :: inst
        TYPE(resParams), INTENT(INOUT)    :: resP
        LOGICAL,    INTENT(IN)            :: reset
        ! Allocate local variables
        REAL(DbKi)                        :: omega                                        ! Frequency
        REAL(DbKi)                        :: a0, a1, a2, b0, b1, b2

        omega = 2*PI*freq

        !! Tustin RC
        b0 = 4+omega**2*DT**2
        b1 = -8+2*omega**2*DT**2
        b2 = 4+omega**2*DT**2
        a0 = b0*kp + 2*DT*ki
        a1 = b1*kp 
        a2 = b2*kp - 2*DT*ki
        ! Initialize persistent variables/arrays, and set initial condition for integrator term
        IF (reset) THEN
            resP%res_OutputSignalLast1(inst)  = 0
            resP%res_OutputSignalLast2(inst)  = 0
            resP%res_InputSignalLast1(inst)   = 0
            resP%res_InputSignalLast2(inst)   = 0
        ELSE
            ResController = 1/b0*( -b1*resP%res_OutputSignalLast1(inst) - b2*resP%res_OutputSignalLast2(inst) &
                                    + a0*error + a1*resP%res_InputSignalLast1(inst) + a2*resP%res_InputSignalLast2(inst))
            ResController = saturate(ResController, minValue, maxValue)
        
            ! Save signals for next time step
            resP%res_InputSignalLast2(inst)   = resP%res_InputSignalLast1(inst)
            resP%res_InputSignalLast1(inst)   = error
            resP%res_OutputSignalLast2(inst)  = resP%res_OutputSignalLast1(inst)
            resP%res_OutputSignalLast1(inst)  = ResController
        END IF
        inst = inst + 1
        
    END FUNCTION ResController

!-------------------------------------------------------------------------------------------------------------------------------
END MODULE Controllers

! Copyright 2019 NREL

! Licensed under the Apache License, Version 2.0 (the "License"); you may not use
! this file except in compliance with the License. You may obtain a copy of the
! License at http://www.apache.org/licenses/LICENSE-2.0

! Unless required by applicable law or agreed to in writing, software distributed
! under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
! CONDITIONS OF ANY KIND, either express or implied. See the License for the
! specific language governing permissions and limitations under the License.
! -------------------------------------------------------------------------------------------
! This module contains all the filters and related subroutines

! Filters:
!       LPFilter: Low-pass filter
!       SecLPFilter: Second order low-pass filter
!       HPFilter: High-pass filter
!       NotchFilter: Notch filter
!       NotchFilterSlopes: Notch Filter with descending slopes
!       PreFilterMeasuredSignals: Pre-filter signals during each run iteration

MODULE Filters
!...............................................................................................................................
    USE Constants
    USE Functions
    IMPLICIT NONE

CONTAINS
!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION LPFilter(InputSignal, DT, CornerFreq, FP, iStatus, reset, inst, InitialValue)
    ! Discrete time Low-Pass Filter of the form:
    !                               Continuous Time Form:   H(s) = CornerFreq/(1 + CornerFreq)
    !                               Discrete Time Form:     H(z) = (b1z + b0) / (a1*z + a0)
    !
        USE ROSCO_Types, ONLY : FilterParameters
        TYPE(FilterParameters),       INTENT(INOUT)       :: FP 

        REAL(DbKi), INTENT(IN)         :: InputSignal
        REAL(DbKi), INTENT(IN)         :: DT                       ! time step [s]
        REAL(DbKi), INTENT(IN)         :: CornerFreq               ! corner frequency [rad/s]
        INTEGER(IntKi), INTENT(IN)      :: iStatus                  ! A status flag set by the simulation as follows: 0 if this is the first call, 1 for all subsequent time steps, -1 if this is the final call at the end of the simulation.
        INTEGER(IntKi), INTENT(INOUT)   :: inst                     ! Instance number. Every instance of this function needs to have an unique instance number to ensure instances don't influence each other.
        LOGICAL(4), INTENT(IN)      :: reset                    ! Reset the filter to the input signal
        REAL(DbKi), OPTIONAL,  INTENT(IN)          :: InitialValue           ! Value to set when reset 
        
        REAL(DbKi)                          :: InitialValue_           ! Value to set when reset

        ! Defaults
        InitialValue_ = InputSignal
        IF (PRESENT(InitialValue)) InitialValue_ = InitialValue  

        ! Initialization
        IF ((iStatus == 0) .OR. reset) THEN   
            FP%lpf1_OutputSignalLast(inst) = InitialValue_
            FP%lpf1_InputSignalLast(inst) = InitialValue_
            FP%lpf1_a1(inst) = 2 + CornerFreq*DT
            FP%lpf1_a0(inst) = CornerFreq*DT - 2
            FP%lpf1_b1(inst) = CornerFreq*DT
            FP%lpf1_b0(inst) = CornerFreq*DT
        ENDIF

        ! Define coefficients

        ! Filter
        LPFilter = 1.0/FP%lpf1_a1(inst) * (-FP%lpf1_a0(inst)*FP%lpf1_OutputSignalLast(inst) + FP%lpf1_b1(inst)*InputSignal + FP%lpf1_b0(inst)*FP%lpf1_InputSignalLast(inst))

        ! Save signals for next time step
        FP%lpf1_InputSignalLast(inst)  = InputSignal
        FP%lpf1_OutputSignalLast(inst) = LPFilter
        inst = inst + 1

    END FUNCTION LPFilter
!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION SecLPFilter(InputSignal, DT, CornerFreq, Damp, FP, iStatus, reset, inst, InitialValue)
    ! Discrete time Low-Pass Filter of the form:
    !                               Continuous Time Form:   H(s) = CornerFreq^2/(s^2 + 2*CornerFreq*Damp*s + CornerFreq^2)
    !                               Discrete Time From:     H(z) = (b2*z^2 + b1*z + b0) / (a2*z^2 + a1*z + a0)
        USE ROSCO_Types, ONLY : FilterParameters
        TYPE(FilterParameters),       INTENT(INOUT)       :: FP 
        REAL(DbKi), INTENT(IN)         :: InputSignal
        REAL(DbKi), INTENT(IN)         :: DT                       ! time step [s]
        REAL(DbKi), INTENT(IN)         :: CornerFreq               ! corner frequency [rad/s]
        REAL(DbKi), INTENT(IN)         :: Damp                     ! Dampening constant
        INTEGER(IntKi), INTENT(IN)      :: iStatus                  ! A status flag set by the simulation as follows: 0 if this is the first call, 1 for all subsequent time steps, -1 if this is the final call at the end of the simulation.
        INTEGER(IntKi), INTENT(INOUT)   :: inst                     ! Instance number. Every instance of this function needs to have an unique instance number to ensure instances don't influence each other.
        LOGICAL(4), INTENT(IN)          :: reset                    ! Reset the filter to the input signal
        REAL(DbKi), OPTIONAL,  INTENT(IN)          :: InitialValue           ! Value to set when reset 
        
        REAL(DbKi)                          :: InitialValue_           ! Value to set when reset

        ! Defaults
        InitialValue_ = InputSignal
        IF (PRESENT(InitialValue)) InitialValue_ = InitialValue  

        ! Initialization
        IF ((iStatus == 0) .OR. reset )  THEN
            FP%lpf2_OutputSignalLast1(inst)  = InitialValue_
            FP%lpf2_OutputSignalLast2(inst)  = InitialValue_
            FP%lpf2_InputSignalLast1(inst)   = InitialValue_
            FP%lpf2_InputSignalLast2(inst)   = InitialValue_
            
            ! Coefficients
            FP%lpf2_a2(inst) = DT**2.0*CornerFreq**2.0 + 4.0 + 4.0*Damp*CornerFreq*DT
            FP%lpf2_a1(inst) = 2.0*DT**2.0*CornerFreq**2.0 - 8.0
            FP%lpf2_a0(inst) = DT**2.0*CornerFreq**2.0 + 4.0 - 4.0*Damp*CornerFreq*DT
            FP%lpf2_b2(inst) = DT**2.0*CornerFreq**2.0
            FP%lpf2_b1(inst) = 2.0*DT**2.0*CornerFreq**2.0
            FP%lpf2_b0(inst) = DT**2.0*CornerFreq**2.0
        ENDIF

        ! Filter
        SecLPFilter = 1.0/FP%lpf2_a2(inst) * (FP%lpf2_b2(inst)*InputSignal + FP%lpf2_b1(inst)*FP%lpf2_InputSignalLast1(inst) + FP%lpf2_b0(inst)*FP%lpf2_InputSignalLast2(inst) - FP%lpf2_a1(inst)*FP%lpf2_OutputSignalLast1(inst) - FP%lpf2_a0(inst)*FP%lpf2_OutputSignalLast2(inst))

        ! Save signals for next time step
        FP%lpf2_InputSignalLast2(inst)   = FP%lpf2_InputSignalLast1(inst)
        FP%lpf2_InputSignalLast1(inst)   = InputSignal
        FP%lpf2_OutputSignalLast2(inst)  = FP%lpf2_OutputSignalLast1(inst)
        FP%lpf2_OutputSignalLast1(inst)  = SecLPFilter

        inst = inst + 1

    END FUNCTION SecLPFilter

!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION SecLPFilter_Vel(InputSignal, DT, CornerFreq, Damp, FP, iStatus, reset, inst, InitialValue)
    ! Discrete time Low-Pass Filter (output is velocity) of the form:
    !                               Continuous Time Form:   H(s) = s CornerFreq^2/(s^2 + 2*CornerFreq*Damp*s + CornerFreq^2)
    !                               Discrete Time From:     H(z) = (b2*z^2 + b1*z + b0) / (a2*z^2 + a1*z + a0)
        USE ROSCO_Types, ONLY : FilterParameters
        TYPE(FilterParameters),       INTENT(INOUT)       :: FP 
        REAL(DbKi), INTENT(IN)         :: InputSignal
        REAL(DbKi), INTENT(IN)         :: DT                       ! time step [s]
        REAL(DbKi), INTENT(IN)         :: CornerFreq               ! corner frequency [rad/s]
        REAL(DbKi), INTENT(IN)         :: Damp                     ! Dampening constant
        INTEGER(IntKi), INTENT(IN)      :: iStatus                  ! A status flag set by the simulation as follows: 0 if this is the first call, 1 for all subsequent time steps, -1 if this is the final call at the end of the simulation.
        INTEGER(IntKi), INTENT(INOUT)   :: inst                     ! Instance number. Every instance of this function needs to have an unique instance number to ensure instances don't influence each other.
        LOGICAL(4), INTENT(IN)          :: reset                    ! Reset the filter to the input signal
        REAL(DbKi), OPTIONAL,  INTENT(IN)          :: InitialValue           ! Value to set when reset 
        
        REAL(DbKi)                          :: InitialValue_           ! Value to set when reset

        ! Defaults
        InitialValue_ = InputSignal
        IF (PRESENT(InitialValue)) InitialValue_ = InitialValue  

        ! Initialization
        IF ((iStatus == 0) .OR. reset )  THEN
            FP%lpfV_OutputSignalLast1(inst)  = InitialValue_
            FP%lpfV_OutputSignalLast2(inst)  = InitialValue_
            FP%lpfV_InputSignalLast1(inst)   = InitialValue_
            FP%lpfV_InputSignalLast2(inst)   = InitialValue_
            
            ! Coefficients
            FP%lpfV_a2(inst) = DT**2.0*CornerFreq**2.0 + 4.0 + 4.0*Damp*CornerFreq*DT
            FP%lpfV_a1(inst) = 2.0*DT**2.0*CornerFreq**2.0 - 8.0
            FP%lpfV_a0(inst) = DT**2.0*CornerFreq**2.0 + 4.0 - 4.0*Damp*CornerFreq*DT
            FP%lpfV_b2(inst) = 2.0*DT*CornerFreq**2.0
            FP%lpfV_b1(inst) = 0.0
            FP%lpfV_b0(inst) = -2.0*DT*CornerFreq**2.0
        ENDIF

        ! Filter
        SecLPFilter_Vel = 1.0/FP%lpfV_a2(inst) * (FP%lpfV_b2(inst)*InputSignal + FP%lpfV_b1(inst)*FP%lpfV_InputSignalLast1(inst) + FP%lpfV_b0(inst)*FP%lpfV_InputSignalLast2(inst) - FP%lpfV_a1(inst)*FP%lpfV_OutputSignalLast1(inst) - FP%lpfV_a0(inst)*FP%lpfV_OutputSignalLast2(inst))

        ! Save signals for next time step
        FP%lpfV_InputSignalLast2(inst)   = FP%lpfV_InputSignalLast1(inst)
        FP%lpfV_InputSignalLast1(inst)   = InputSignal
        FP%lpfV_OutputSignalLast2(inst)  = FP%lpfV_OutputSignalLast1(inst)
        FP%lpfV_OutputSignalLast1(inst)  = SecLPFilter_Vel

        inst = inst + 1

    END FUNCTION SecLPFilter_Vel

!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION HPFilter( InputSignal, DT, CornerFreq, FP, iStatus, reset, inst, InitialValue)
    ! Discrete time High-Pass Filter
        USE ROSCO_Types, ONLY : FilterParameters
        TYPE(FilterParameters),       INTENT(INOUT)       :: FP 

        REAL(DbKi), INTENT(IN)     :: InputSignal
        REAL(DbKi), INTENT(IN)     :: DT                       ! time step [s]
        REAL(DbKi), INTENT(IN)     :: CornerFreq               ! corner frequency [rad/s]
        INTEGER(IntKi), INTENT(IN)     :: iStatus                  ! A status flag set by the simulation as follows: 0 if this is the first call, 1 for all subsequent time steps, -1 if this is the final call at the end of the simulation.
        INTEGER(IntKi), INTENT(INOUT)  :: inst                     ! Instance number. Every instance of this function needs to have an unique instance number to ensure instances don't influence each other.
        LOGICAL(4), INTENT(IN)  :: reset                    ! Reset the filter to the input signal
        ! Local
        REAL(DbKi)                 :: K                        ! Constant gain
        REAL(DbKi), OPTIONAL,  INTENT(IN)          :: InitialValue           ! Value to set when reset 
        
        REAL(DbKi)                          :: InitialValue_           ! Value to set when reset

        ! Defaults
        InitialValue_ = InputSignal
        IF (PRESENT(InitialValue)) InitialValue_ = InitialValue  

        ! Initialization
        IF ((iStatus == 0) .OR. reset)  THEN
            FP%hpf_OutputSignalLast(inst) = InitialValue_
            FP%hpf_InputSignalLast(inst) = InitialValue_
        ENDIF
        K = 2.0 / DT

        ! Body
        HPFilter = K/(CornerFreq + K)*InputSignal - K/(CornerFreq + K)*FP%hpf_InputSignalLast(inst) - (CornerFreq - K)/(CornerFreq + K)*FP%hpf_OutputSignalLast(inst)

        ! Save signals for next time step
        FP%HPF_InputSignalLast(inst)   = InputSignal
        FP%HPF_OutputSignalLast(inst)  = HPFilter
        inst = inst + 1

    END FUNCTION HPFilter
!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION NotchFilterSlopes(InputSignal, DT, CornerFreq, Damp, FP, iStatus, reset, inst, Moving, InitialValue)
    ! Discrete time inverted Notch Filter with descending slopes, G = CornerFreq*s/(Damp*s^2+CornerFreq*s+Damp*CornerFreq^2)
        USE ROSCO_Types, ONLY : FilterParameters
        TYPE(FilterParameters),       INTENT(INOUT)       :: FP 

        REAL(DbKi), INTENT(IN)                  :: InputSignal
        REAL(DbKi), INTENT(IN)                  :: DT               ! time step [s]
        REAL(DbKi), INTENT(IN)                  :: CornerFreq       ! corner frequency [rad/s]
        REAL(DbKi), INTENT(IN)                  :: Damp             ! Dampening constant
        INTEGER(IntKi), INTENT(IN)              :: iStatus          ! A status flag set by the simulation as follows: 0 if this is the first call, 1 for all subsequent time steps, -1 if this is the final call at the end of the simulation.
        INTEGER(IntKi), INTENT(INOUT)           :: inst             ! Instance number. Every instance of this function needs to have an unique instance number to ensure instances don't influence each other.
        LOGICAL(4), INTENT(IN)                  :: reset            ! Reset the filter to the input signal
        LOGICAL, OPTIONAL,  INTENT(IN)          :: Moving           ! Moving CornerFreq flag
        REAL(DbKi), OPTIONAL,  INTENT(IN)          :: InitialValue           ! Value to set when reset 

        LOGICAL                                 :: Moving_          ! Local version
        REAL(DbKi)                              :: CornerFreq_          ! Local version
        REAL(DbKi)                          :: InitialValue_           ! Value to set when reset

        ! Defaults
        InitialValue_ = InputSignal
        IF (PRESENT(InitialValue)) InitialValue_ = InitialValue  

        Moving_ = .FALSE.
        IF (PRESENT(Moving)) Moving_ = Moving   

        ! Saturate Corner Freq at 0
        IF (CornerFreq < 0) THEN 
            CornerFreq_ = 0
        ELSE
            CornerFreq_ = CornerFreq
        ENDIF
        
        ! Initialization
        IF ((iStatus == 0) .OR. reset) THEN
            FP%nfs_OutputSignalLast1(inst)  = InitialValue_
            FP%nfs_OutputSignalLast2(inst)  = InitialValue_
            FP%nfs_InputSignalLast1(inst)   = InitialValue_
            FP%nfs_InputSignalLast2(inst)   = InitialValue_
        ENDIF

        IF ((iStatus == 0) .OR. reset .OR. Moving_) THEN
            FP%nfs_b2(inst) = 2.0 * DT * CornerFreq_
            FP%nfs_b0(inst) = -FP%nfs_b2(inst)
            FP%nfs_a2(inst) = Damp*DT**2.0*CornerFreq_**2.0 + 2.0*DT*CornerFreq_ + 4.0*Damp
            FP%nfs_a1(inst) = 2.0*Damp*DT**2.0*CornerFreq_**2.0 - 8.0*Damp
            FP%nfs_a0(inst) = Damp*DT**2.0*CornerFreq_**2.0 - 2*DT*CornerFreq_ + 4.0*Damp
        ENDIF

        NotchFilterSlopes = 1.0/FP%nfs_a2(inst) * (FP%nfs_b2(inst)*InputSignal + FP%nfs_b0(inst)*FP%nfs_InputSignalLast1(inst) &
                            - FP%nfs_a1(inst)*FP%nfs_OutputSignalLast1(inst)  - FP%nfs_a0(inst)*FP%nfs_OutputSignalLast2(inst))

        ! Save signals for next time step
        FP%nfs_InputSignalLast2(inst)   = FP%nfs_InputSignalLast1(inst)
        FP%nfs_InputSignalLast1(inst)   = InputSignal          !Save input signal for next time step
        FP%nfs_OutputSignalLast2(inst)  = FP%nfs_OutputSignalLast1(inst)      !Save input signal for next time step
        FP%nfs_OutputSignalLast1(inst)  = NotchFilterSlopes
        inst = inst + 1

    END FUNCTION NotchFilterSlopes
!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION NotchFilter(InputSignal, DT, omega, betaNum, betaDen, FP, iStatus, reset, inst, InitialValue)
    ! Discrete time Notch Filter 
    !                               Continuous Time Form: G(s) = (s^2 + 2*omega*betaNum*s + omega^2)/(s^2 + 2*omega*betaDen*s + omega^2)
    !                               Discrete Time Form:   H(z) = (b2*z^2 +b1*z^2 + b0*z)/((z^2 +a1*z^2 + a0*z))
        USE ROSCO_Types, ONLY : FilterParameters
        TYPE(FilterParameters),       INTENT(INOUT)       :: FP 

        REAL(DbKi), INTENT(IN)     :: InputSignal
        REAL(DbKi), INTENT(IN)     :: DT                       ! time step [s]
        REAL(DbKi), INTENT(IN)     :: omega                    ! corner frequency [rad/s]
        REAL(DbKi), INTENT(IN)     :: betaNum                  ! Dampening constant in numerator of filter transfer function
        REAL(DbKi), INTENT(IN)     :: betaDen                  ! Dampening constant in denominator of filter transfer function
        INTEGER(IntKi), INTENT(IN)     :: iStatus                  ! A status flag set by the simulation as follows: 0 if this is the first call, 1 for all subsequent time steps, -1 if this is the final call at the end of the simulation.
        INTEGER(IntKi), INTENT(INOUT)  :: inst                     ! Instance number. Every instance of this function needs to have an unique instance number to ensure instances don't influence each other.
        LOGICAL(4), INTENT(IN)  :: reset                    ! Reset the filter to the input signal
        REAL(DbKi), OPTIONAL,  INTENT(IN)          :: InitialValue           ! Value to set when reset 
        ! Local
        REAL(DbKi)                 :: K                        ! Constant gain
        REAL(DbKi)                          :: InitialValue_           ! Value to set when reset

        ! Defaults
        InitialValue_ = InputSignal
        IF (PRESENT(InitialValue)) InitialValue_ = InitialValue  

        ! Initialization
        K = 2.0/DT
        IF ((iStatus == 0) .OR. reset) THEN
            FP%nf_OutputSignalLast1(inst)  = InitialValue_
            FP%nf_OutputSignalLast2(inst)  = InitialValue_
            FP%nf_InputSignalLast1(inst)   = InitialValue_
            FP%nf_InputSignalLast2(inst)   = InitialValue_
            FP%nf_b2(inst) = (K**2.0 + 2.0*omega*BetaNum*K + omega**2.0)/(K**2.0 + 2.0*omega*BetaDen*K + omega**2.0)
            FP%nf_b1(inst) = (2.0*omega**2.0 - 2.0*K**2.0)  / (K**2.0 + 2.0*omega*BetaDen*K + omega**2.0);
            FP%nf_b0(inst) = (K**2.0 - 2.0*omega*BetaNum*K + omega**2.0) / (K**2.0 + 2.0*omega*BetaDen*K + omega**2.0)
            FP%nf_a1(inst) = (2.0*omega**2.0 - 2.0*K**2.0)  / (K**2.0 + 2.0*omega*BetaDen*K + omega**2.0)
            FP%nf_a0(inst) = (K**2.0 - 2.0*omega*BetaDen*K + omega**2.0)/ (K**2.0 + 2.0*omega*BetaDen*K + omega**2.0)
        ENDIF
        
        ! Body
        NotchFilter = FP%nf_b2(inst)*InputSignal + FP%nf_b1(inst)*FP%nf_InputSignalLast1(inst) + FP%nf_b0(inst)*FP%nf_InputSignalLast2(inst) - FP%nf_a1(inst)*FP%nf_OutputSignalLast1(inst) - FP%nf_a0(inst)*FP%nf_OutputSignalLast2(inst)

        ! Save signals for next time step
        FP%nf_InputSignalLast2(inst)   = FP%nf_InputSignalLast1(inst)
        FP%nf_InputSignalLast1(inst)   = InputSignal                  ! Save input signal for next time step
        FP%nf_OutputSignalLast2(inst)  = FP%nf_OutputSignalLast1(inst)      ! Save input signal for next time step
        FP%nf_OutputSignalLast1(inst)  = NotchFilter
        inst = inst + 1

    END FUNCTION NotchFilter
!-------------------------------------------------------------------------------------------------------------------------------
    SUBROUTINE PreFilterMeasuredSignals(CntrPar, LocalVar, DebugVar, objInst, ErrVar)
    ! Prefilter shared measured wind turbine signals

        USE ROSCO_Types, ONLY : ControlParameters, LocalVariables, DebugVariables, ObjectInstances, ErrorVariables
        
        TYPE(ControlParameters), INTENT(INOUT)      :: CntrPar
        TYPE(LocalVariables),    INTENT(INOUT)      :: LocalVar
        TYPE(DebugVariables),    INTENT(INOUT)      :: DebugVar
        TYPE(ObjectInstances),   INTENT(INOUT)      :: objInst
        TYPE(ErrorVariables),   INTENT(INOUT)       :: ErrVar
        INTEGER(IntKi) :: K  ! Integer used to loop through turbine blades
        INTEGER(IntKi) :: n  ! Integer used to loop through notch filters
        REAL(DbKi)       :: NacVaneCosF                 ! Time-filtered x-component of NacVane (deg)
        REAL(DbKi)       :: NacVaneSinF                 ! Time-filtered y-component of NacVane (deg)

        ! If there's an error, don't even try to run
        IF (ErrVar%aviFAIL < 0) THEN
            RETURN
        ENDIF
        ! Filter the HSS (generator) and LSS (rotor) speed measurement:
        ! Apply Low-Pass Filter (choice between first- and second-order low-pass filter)
        IF (CntrPar%F_LPFType == 1) THEN
            LocalVar%GenSpeedF = LPFilter(LocalVar%GenSpeed, LocalVar%DT, CntrPar%F_LPFCornerFreq, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instLPF)
            LocalVar%RotSpeedF = LPFilter(LocalVar%RotSpeed, LocalVar%DT, CntrPar%F_LPFCornerFreq, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instLPF)
        ELSEIF (CntrPar%F_LPFType == 2) THEN   
            LocalVar%GenSpeedF = SecLPFilter(LocalVar%GenSpeed, LocalVar%DT, CntrPar%F_LPFCornerFreq, CntrPar%F_LPFDamping, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instSecLPF) ! Second-order low-pass filter on generator speed
            LocalVar%RotSpeedF = SecLPFilter(LocalVar%RotSpeed, LocalVar%DT, CntrPar%F_LPFCornerFreq, CntrPar%F_LPFDamping, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instSecLPF) ! Second-order low-pass filter on generator speed
        ENDIF
        
        ! Apply Notch Fitler to Gen Speed 
        DO n = 1,CntrPar%F_GenSpdNotch_N
            LocalVar%GenSpeedF = NotchFilter(LocalVar%GenSpeedF, LocalVar%DT, &
                                            CntrPar%F_NotchFreqs(CntrPar%F_GenSpdNotch_Ind(n)), &
                                            CntrPar%F_NotchBetaNum(CntrPar%F_GenSpdNotch_Ind(n)), &
                                            CntrPar%F_NotchBetaDen(CntrPar%F_GenSpdNotch_Ind(n)), &
                                            LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instNotch)
        END DO

        ! Filtering the tower fore-aft acceleration signal 
        ! Force to start at 0
        IF (LocalVar%iStatus == 0 .AND. LocalVar%Time == 0) THEN
            LocalVar%NacIMU_FA_RAcc = 0
            LocalVar%FA_Acc_Nac = 0
        ENDIF 

        ! Low pass
        LocalVar%NacIMU_FA_AccF = SecLPFilter(LocalVar%NacIMU_FA_RAcc, LocalVar%DT, CntrPar%F_FlCornerFreq(1), CntrPar%F_FlCornerFreq(2), LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instSecLPF) ! Fixed Damping
        LocalVar%FA_AccF = SecLPFilter(LocalVar%FA_Acc_Nac, LocalVar%DT, CntrPar%F_FlCornerFreq(1), CntrPar%F_FlCornerFreq(2), LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instSecLPF) ! Fixed Damping
        
        ! High pass
        LocalVar%NacIMU_FA_AccF = HPFilter(LocalVar%NacIMU_FA_AccF, LocalVar%DT, CntrPar%F_FlHighPassFreq, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instHPF) 
        LocalVar%FA_AccF = HPFilter(LocalVar%FA_AccF, LocalVar%DT, CntrPar%F_FlHighPassFreq, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instHPF) 
        
        ! Notch filters
        DO n = 1,CntrPar%F_TwrTopNotch_N
            LocalVar%NACIMU_FA_AccF = NotchFilter(LocalVar%NacIMU_FA_AccF, LocalVar%DT, &
                                                  CntrPar%F_NotchFreqs(CntrPar%F_TwrTopNotch_Ind(n)), &
                                                  CntrPar%F_NotchBetaNum(CntrPar%F_TwrTopNotch_Ind(n)), &
                                                  CntrPar%F_NotchBetaDen(CntrPar%F_TwrTopNotch_Ind(n)), &
                                                  LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instNotch)
            
            LocalVar%FA_AccF = NotchFilter(LocalVar%FA_AccF, LocalVar%DT, &
                                           CntrPar%F_NotchFreqs(CntrPar%F_TwrTopNotch_Ind(n)), &
                                           CntrPar%F_NotchBetaNum(CntrPar%F_TwrTopNotch_Ind(n)), &
                                           CntrPar%F_NotchBetaDen(CntrPar%F_TwrTopNotch_Ind(n)), &
                                           LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instNotch)
        END DO
        
        ! FA acc for ForeAft damping, condition matches whether it's used in Controllers.f90
        IF (CntrPar%TD_Mode > 0) THEN
            LocalVar%FA_AccHPF = HPFilter(LocalVar%FA_Acc_Nac, LocalVar%DT, CntrPar%FA_HPFCornerFreq, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instHPF)
        ENDIF
        
        ! Filter Wind Speed Estimator Signal
        LocalVar%We_Vw_F = LPFilter(LocalVar%WE_Vw, LocalVar%DT,CntrPar%F_WECornerFreq, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instLPF) 

        ! Blade root bending moment for IPC
        DO K = 1,LocalVar%NumBl
            IF ((CntrPar%IPC_ControlMode > 0) .OR. (CntrPar%Flp_Mode == 3)) THEN
                ! Moving inverted notch at rotor speed to isolate 1P
                LocalVar%RootMOOPF(K) = NotchFilterSlopes(LocalVar%rootMOOP(K), LocalVar%DT, LocalVar%RotSpeedF, 0.7_DbKi, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instNotchSlopes, .TRUE.)
            ELSEIF ( CntrPar%Flp_Mode == 2 ) THEN
                ! Filter Blade root bending moments
                LocalVar%RootMOOPF(K) = SecLPFilter(LocalVar%rootMOOP(K),LocalVar%DT, CntrPar%F_FlpCornerFreq(1), CntrPar%F_FlpCornerFreq(2), LocalVar%FP, LocalVar%iStatus, LocalVar%restart,objInst%instSecLPF)
                LocalVar%RootMOOPF(K) = HPFilter(LocalVar%rootMOOPF(K),LocalVar%DT, 0.1_DbKi, LocalVar%FP, LocalVar%iStatus, LocalVar%restart,objInst%instHPF)
                
                ! Use same as generator speed signal because that's how it was before
                LocalVar%RootMOOPF(K) = NotchFilter(LocalVar%RootMOOPF(K), LocalVar%DT, &
                                                    CntrPar%F_NotchFreqs(CntrPar%F_GenSpdNotch_Ind(n)), &
                                                    CntrPar%F_NotchBetaNum(CntrPar%F_GenSpdNotch_Ind(n)), &
                                                    CntrPar%F_NotchBetaDen(CntrPar%F_GenSpdNotch_Ind(n)), &
                                                    LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instNotch)
            ELSE
                LocalVar%RootMOOPF(K) = LocalVar%rootMOOP(K)
            ENDIF     
        END DO


        ! Control commands (used by WSE, mostly)
        LocalVar%VS_LastGenTrqF = SecLPFilter(LocalVar%VS_LastGenTrq, LocalVar%DT, CntrPar%F_LPFCornerFreq, 0.7_DbKi, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instSecLPF)
        LocalVar%BlPitchCMeasF    = SecLPFilter(LocalVar%BlPitchCMeas, LocalVar%DT, CntrPar%F_LPFCornerFreq*0.25, 0.7_DbKi, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instSecLPF)

        ! Wind vane signal
        NacVaneCosF = LPFilter(cos(LocalVar%NacVane*D2R), LocalVar%DT, CntrPar%F_YawErr, LocalVar%FP, LocalVar%iStatus, .FALSE., objInst%instLPF) ! (-)
        NacVaneSinF = LPFilter(sin(LocalVar%NacVane*D2R), LocalVar%DT, CntrPar%F_YawErr, LocalVar%FP, LocalVar%iStatus, .FALSE., objInst%instLPF) ! (-)
        LocalVar%NacVaneF = wrap_180(atan2(NacVaneSinF, NacVaneCosF) * R2D) ! (deg)

        ! Debug Variables
        DebugVar%GenSpeedF = LocalVar%GenSpeedF
        DebugVar%RotSpeedF = LocalVar%RotSpeedF
        DebugVar%NacIMU_FA_AccF = LocalVar%NacIMU_FA_AccF
        DebugVar%FA_AccF = LocalVar%FA_AccF
    END SUBROUTINE PreFilterMeasuredSignals
    END MODULE Filters

! Copyright 2019 NREL

! Licensed under the Apache License, Version 2.0 (the "License"); you may not use
! this file except in compliance with the License. You may obtain a copy of the
! License at http://www.apache.org/licenses/LICENSE-2.0

! Unless required by applicable law or agreed to in writing, software distributed
! under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
! CONDITIONS OF ANY KIND, either express or implied. See the License for the
! specific language governing permissions and limitations under the License.



MODULE Constants
    USE, INTRINSIC  :: ISO_C_Binding
    
    INTEGER, PARAMETER                  :: DbKi             = C_DOUBLE            !< Default kind for double floating-point numbers
    INTEGER, PARAMETER                  :: ReKi             = C_FLOAT             !< Default kind for single floating-point numbers
    INTEGER, PARAMETER                  :: IntKi            = C_INT               !< Default kind for integer numbers
    
    REAL(DbKi), PARAMETER               :: RPS2RPM          = 9.5492966           ! Factor to convert radians per second to revolutions per minute.
    REAL(DbKi), PARAMETER               :: R2D              = 57.2957795130       ! Factor to convert radians to degrees.
    REAL(DbKi), PARAMETER               :: D2R              = 0.01745329251       ! Factor to convert degrees to radians.
    REAL(DbKi), PARAMETER               :: PI               = 3.14159265359       ! Mathematical constant pi
    INTEGER(IntKi), PARAMETER           :: NP_1             = 1                   ! First rotational harmonic
    INTEGER(IntKi), PARAMETER           :: NP_2             = 2                   ! Second rotational harmonic

    ! NWTC Constants
    INTEGER(IntKi), PARAMETER     :: NWTC_MAX_DLL_PROC    = 3
    INTEGER(IntKi), PARAMETER     :: ErrID_None   = 0                              !< ErrStat parameter indicating "no error"
    INTEGER(IntKi), PARAMETER     :: ErrID_Info   = 1                              !< ErrStat parameter indicating "informational message"
    INTEGER(IntKi), PARAMETER     :: ErrID_Warn   = 2                              !< ErrStat parameter indicating "warning"
    INTEGER(IntKi), PARAMETER     :: ErrID_Severe = 3                              !< ErrStat parameter indicating "severe error"; 
    INTEGER(IntKi), PARAMETER     :: ErrID_Fatal  = 4                              !< ErrStat parameter indicating "fatal error"; simulation should end
    INTEGER, PARAMETER            :: BITS_IN_ADDR  = C_INTPTR_T*8                  !< The number of bits in an address (32-bit or 64-bit).

    CHARACTER(1), PARAMETER       :: Tab      = CHAR( 9 ) 

    ! Control Modes

    ! VS_ControlMode
    INTEGER(IntKi), PARAMETER     :: VS_Mode_Disabled   = 0
    INTEGER(IntKi), PARAMETER     :: VS_Mode_KOmega     = 1
    INTEGER(IntKi), PARAMETER     :: VS_Mode_WSE_TSR    = 2
    INTEGER(IntKi), PARAMETER     :: VS_Mode_Power_TSR  = 3
    INTEGER(IntKi), PARAMETER     :: VS_Mode_Torque_TSR = 4

    ! VS_ConstPower
    INTEGER(IntKi), PARAMETER     :: VS_Mode_ConstTrq = 0
    INTEGER(IntKi), PARAMETER     :: VS_Mode_ConstPwr = 1

    ! VS_FBP
    INTEGER(IntKi), PARAMETER     :: VS_FBP_Variable_Pitch  = 0
    INTEGER(IntKi), PARAMETER     :: VS_FBP_Power_Overspeed = 1
    INTEGER(IntKi), PARAMETER     :: VS_FBP_WSE_Ref         = 2
    INTEGER(IntKi), PARAMETER     :: VS_FBP_Torque_Ref      = 3

    ! VS_State
    INTEGER(IntKi), PARAMETER     :: VS_State_Error             = 0
    INTEGER(IntKi), PARAMETER     :: VS_State_Region_1_5        = 1
    INTEGER(IntKi), PARAMETER     :: VS_State_Region_2          = 2
    INTEGER(IntKi), PARAMETER     :: VS_State_Region_2_5        = 3
    INTEGER(IntKi), PARAMETER     :: VS_State_Region_3_ConstTrq = 4
    INTEGER(IntKi), PARAMETER     :: VS_State_Region_3_ConstPwr = 5
    INTEGER(IntKi), PARAMETER     :: VS_State_Region_3_FBP      = 6
    INTEGER(IntKi), PARAMETER     :: VS_State_PI                = 7

    ! PC_State
    INTEGER(IntKi), PARAMETER     :: PC_State_Disabled = 0
    INTEGER(IntKi), PARAMETER     :: PC_State_Enabled  = 1
    
    ! PRC Mode constants
    INTEGER(IntKi), PARAMETER      :: PRC_Comm_Constant    = 0     ! Constant based on discon input
    INTEGER(IntKi), PARAMETER      :: PRC_Comm_OpenLoop    = 1     ! Based on open loop input
    INTEGER(IntKi), PARAMETER      :: PRC_Comm_ZMQ         = 2     ! Determined using ZMQ input


END MODULE Constants

!**********************************************************************************************************************************
! LICENSING
! Copyright (C) 2021  National Renewable Energy Laboratory
!
!    This file is part of ROSCO.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.
!**********************************************************************************************************************************
MODULE SysSubs

    USE ROSCO_Types
    USE Constants
    USE, INTRINSIC :: ISO_C_Binding


    IMPLICIT NONE


! This module contains routines with system-specific logic and references, including all references to the console unit, CU.
! It also contains standard (but not system-specific) routines it uses.
! SysGnuLinux.f90 is specifically for the GNU Fortran (gfortran) compiler on Linux and macOS.

   INTEGER, PARAMETER            :: ConRecL     = 120                               ! The record length for console output.
   INTEGER, PARAMETER            :: CU          = 6                                 ! The I/O unit for the console.  Unit 6 causes ADAMS to crash.
   INTEGER, PARAMETER            :: MaxWrScrLen = 98                                ! The maximum number of characters allowed to be written to a line in WrScr
   LOGICAL, PARAMETER            :: KBInputOK   = .TRUE.                            ! A flag to tell the program that keyboard input is allowed in the environment.
   CHARACTER(*),  PARAMETER      :: NewLine     = ACHAR(10)                         ! The delimiter for New Lines [ Windows is CHAR(13)//CHAR(10); MAC is CHAR(13); Unix is CHAR(10) {CHAR(13)=\r is a line feed, CHAR(10)=\n is a new line}]
   CHARACTER(*),  PARAMETER      :: OS_Desc     = 'GNU Fortran for Linux'           ! Description of the language/OS
   CHARACTER( 1), PARAMETER      :: PathSep     = '/'                               ! The path separator.
   CHARACTER( 1), PARAMETER      :: SwChar      = '-'                               ! The switch character for command-line options.
   CHARACTER(11), PARAMETER      :: UnfForm     = 'UNFORMATTED'                     ! The string to specify unformatted I/O files.


    CONTAINS
!=================================================================================================================
    SUBROUTINE LoadDynamicLib ( DLL, ErrStat, ErrMsg )

        ! This SUBROUTINE is used to dynamically load a DLL.
    
        TYPE (ExtDLL_Type),           INTENT(INOUT)  :: DLL         ! The DLL to be loaded.
        INTEGER(IntKi),            INTENT(  OUT)  :: ErrStat     ! Error status of the operation
        CHARACTER(*),              INTENT(  OUT)  :: ErrMsg      ! Error message if ErrStat /= ErrID_None
    
    
    !bjj: these are values I found on the web; I have no idea if they actually work...
    !bjj: hopefully we can find them pre-defined in a header somewhere
        INTEGER(C_INT), PARAMETER :: RTLD_LAZY=1            ! "Perform lazy binding. Only resolve symbols as the code that references them is executed. If the symbol is never referenced, then it is never resolved. (Lazy binding is only performed for function references; references to variables are always immediately bound when the library is loaded.) "
        INTEGER(C_INT), PARAMETER :: RTLD_NOW=2             ! "If this value is specified, or the environment variable LD_BIND_NOW is set to a nonempty string, all undefined symbols in the library are resolved before dlopen() returns. If this cannot be done, an error is returned."
        INTEGER(C_INT), PARAMETER :: RTLD_GLOBAL=256        ! "The symbols defined by this library will be made available for symbol resolution of subsequently loaded libraries"
        INTEGER(C_INT), PARAMETER :: RTLD_LOCAL=0           ! "This is the converse of RTLD_GLOBAL, and the default if neither flag is specified. Symbols defined in this library are not made available to resolve references in subsequently loaded libraries."
    
        INTERFACE !linux API routines
        !bjj see http://linux.die.net/man/3/dlopen
        !    and https://developer.apple.com/library/mac/documentation/Darwin/Reference/ManPages/man3/dlopen.3.html
    
        FUNCTION dlOpen(filename,mode) BIND(C,NAME="dlopen")
        ! void *dlopen(const char *filename, int mode);
            USE ISO_C_BINDING
            IMPLICIT NONE
            TYPE(C_PTR)                   :: dlOpen
            CHARACTER(C_CHAR), INTENT(IN) :: filename(*)
            INTEGER(C_INT), VALUE         :: mode
        END FUNCTION
    
        END INTERFACE
    
        ErrStat = 0
        ErrMsg = ''
    
        ! Load the DLL and get the file address:
    
        DLL%FileAddrX = dlOpen( TRIM(DLL%FileName)//C_NULL_CHAR, RTLD_LAZY )  !the "C_NULL_CHAR" converts the Fortran string to a C-type string (i.e., adds //CHAR(0) to the end)
    
        IF( .NOT. C_ASSOCIATED(DLL%FileAddrX) ) THEN
        ErrStat = -1
        ! WRITE(ErrMsg,'(I2)') BITS_IN_ADDR
        ErrMsg  = 'The dynamic library '//TRIM(DLL%FileName)//' could not be loaded. Check that the file '// &
                    'exists in the specified location and that it is compiled for '//TRIM(ErrMsg)//'-bit applications.'
        RETURN
        END IF
    
        ! Get the procedure address:
    
        CALL LoadDynamicLibProc ( DLL, ErrStat, ErrMsg )

        RETURN
    END SUBROUTINE LoadDynamicLib
    !=======================================================================
    SUBROUTINE LoadDynamicLibProc ( DLL, ErrStat, ErrMsg )
    
        ! This SUBROUTINE is used to dynamically load a procedure from a DLL.
    
        TYPE (ExtDLL_Type),           INTENT(INOUT)  :: DLL         ! The DLL to be loaded.
        INTEGER(IntKi),            INTENT(  OUT)  :: ErrStat     ! Error status of the operation
        CHARACTER(*),              INTENT(  OUT)  :: ErrMsg      ! Error message if ErrStat /= ErrID_None
        INTEGER(IntKi)                            :: i
    
   
        INTERFACE !linux API routines
    
        !bjj see http://linux.die.net/man/3/dlsym
        !    and https://developer.apple.com/library/mac/documentation/Darwin/Reference/ManPages/man3/dlsym.3.html
        
        FUNCTION dlSym(handle,name) BIND(C,NAME="dlsym")
        ! void *dlsym(void *handle, const char *name);
            USE ISO_C_BINDING
            IMPLICIT NONE
            TYPE(C_FUNPTR)                :: dlSym ! A function pointer
            TYPE(C_PTR), VALUE            :: handle
            CHARACTER(C_CHAR), INTENT(IN) :: name(*)
        END FUNCTION
    
        END INTERFACE

        ErrStat = ErrID_None
        ErrMsg = ''
        
        ! Initialize ProcAddr
        DLL%ProcAddr = C_NULL_FUNPTR  ! Not sure if we need the (3)
        
        do i=1,NWTC_MAX_DLL_PROC
        if ( len_trim( DLL%ProcName(i) ) > 0 ) then
        
            DLL%ProcAddr(i) = dlSym( DLL%FileAddrX, TRIM(DLL%ProcName(i))//C_NULL_CHAR )  !the "C_NULL_CHAR" converts the Fortran string to a C-type string (i.e., adds //CHAR(0) to the end)
    
            IF(.NOT. C_ASSOCIATED(DLL%ProcAddr(i))) THEN
                ErrStat = ErrID_Fatal
                ErrMsg  = 'The procedure '//TRIM(DLL%ProcName(i))//' in file '//TRIM(DLL%FileName)//' could not be loaded.'
                RETURN
            END IF
            
        end if
        end do
        
        RETURN
    END SUBROUTINE LoadDynamicLibProc
    !=======================================================================
    SUBROUTINE FreeDynamicLib ( DLL, ErrStat, ErrMsg )
    
        ! This SUBROUTINE is used to free a dynamically loaded DLL (loaded in LoadDynamicLib).
    
        TYPE (ExtDLL_Type),           INTENT(INOUT)  :: DLL         ! The DLL to be freed.
        INTEGER(IntKi),            INTENT(  OUT)  :: ErrStat     ! Error status of the operation
        CHARACTER(*),              INTENT(  OUT)  :: ErrMsg      ! Error message if ErrStat /= ErrID_None
        INTEGER(C_INT)                            :: Success     ! Whether or not the call to dlClose was successful
        INTEGER(C_INT), PARAMETER                 :: TRUE  = 0
    
    !bjj: note that this is not tested.
    
        INTERFACE !linux API routine
        !bjj see http://linux.die.net/man/3/dlclose
        !    and https://developer.apple.com/library/mac/documentation/Darwin/Reference/ManPages/man3/dlclose.3.html
    
        FUNCTION dlClose(handle) BIND(C,NAME="dlclose")
        ! int dlclose(void *handle);
            USE ISO_C_BINDING
            IMPLICIT NONE
            INTEGER(C_INT)       :: dlClose
            TYPE(C_PTR), VALUE   :: handle
        END FUNCTION
    
        END INTERFACE
    
        ! Close the library:
    
        IF( .NOT. C_ASSOCIATED(DLL%FileAddrX) ) RETURN
        Success = dlClose( DLL%FileAddrX ) !The function dlclose() returns 0 on success, and nonzero on error.
    
        IF ( Success /= TRUE ) THEN !bjj: note that this is not the same as LOGICAL .TRUE.
        ErrStat = ErrID_Fatal
        ErrMsg  = 'The dynamic library could not be freed.'
        RETURN
        ELSE
        ErrStat = ErrID_None
        ErrMsg = ''
        DLL%FileAddrX = C_NULL_PTR
        END IF
        
    
        RETURN
    END SUBROUTINE FreeDynamicLib
    !=======================================================================

END MODULE SysSubs

! Copyright 2019 NREL

! Licensed under the Apache License, Version 2.0 (the "License"); you may not use
! this file except in compliance with the License. You may obtain a copy of the
! License at http://www.apache.org/licenses/LICENSE-2.0

! Unless required by applicable law or agreed to in writing, software distributed
! under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
! CONDITIONS OF ANY KIND, either express or implied. See the License for the
! specific language governing permissions and limitations under the License.
! -------------------------------------------------------------------------------------------

! High level run script

!=======================================================================
SUBROUTINE DISCON(avrSWAP, aviFAIL, accINFILE, avcOUTNAME, avcMSG) BIND (C, NAME='DISCON')
! DO NOT REMOVE or MODIFY LINES starting with "!DEC$" or "!GCC$"
! !DEC$ specifies attributes for IVF and !GCC$ specifies attributes for gfortran

USE, INTRINSIC  :: ISO_C_Binding
USE             :: ROSCO_Types
USE             :: ReadSetParameters
USE             :: ControllerBlocks
USE             :: Controllers
USE             :: Constants
USE             :: Filters
USE             :: Functions
USE             :: ExtControl
USE             :: ROSCO_IO
USE             :: ZeroMQInterface

IMPLICIT NONE
! Enable .dll export
#ifndef IMPLICIT_DLLEXPORT
!DEC$ ATTRIBUTES DLLEXPORT :: DISCON
!GCC$ ATTRIBUTES DLLEXPORT :: DISCON
#endif

!------------------------------------------------------------------------------------------------------------------------------
! Variable declaration and initialization
!------------------------------------------------------------------------------------------------------------------------------

! Passed Variables:
!REAL(ReKi), INTENT(IN)      :: from_SC(*)       ! DATA from the super controller
!REAL(ReKi), INTENT(INOUT)   :: to_SC(*)         ! DATA to the super controller

REAL(ReKi),                  INTENT(INOUT)   :: avrSWAP(*)                       ! The swap array, used to pass data to, and receive data from, the DLL controller.
INTEGER(C_INT),                 INTENT(INOUT)   :: aviFAIL                          ! A flag used to indicate the success of this DLL call set as follows: 0 if the DLL call was successful, >0 if the DLL call was successful but cMessage should be issued as a warning messsage, <0 if the DLL call was unsuccessful or for any other reason the simulation is to be stopped at this point with cMessage as the error message.
CHARACTER(KIND=C_CHAR),         INTENT(IN   )   :: accINFILE(NINT(avrSWAP(50)))     ! The name of the parameter input file
CHARACTER(KIND=C_CHAR),         INTENT(IN   )   :: avcOUTNAME(NINT(avrSWAP(51)))    ! OUTNAME (Simulation RootName)
CHARACTER(KIND=C_CHAR),         INTENT(INOUT)   :: avcMSG(NINT(avrSWAP(49)))        ! MESSAGE (Message from DLL to simulation code [ErrMsg])  The message which will be displayed by the calling program if aviFAIL <> 0.
CHARACTER(SIZE(avcOUTNAME))                   :: RootName                         ! a Fortran version of the input C string (not considered an array here)    [subtract 1 for the C null-character]
CHARACTER(SIZE(avcMSG)-1)                       :: ErrMsg                           ! a Fortran version of the C string argument (not considered an array here) [subtract 1 for the C null-character]

TYPE(ControlParameters),        SAVE           :: CntrPar
TYPE(LocalVariables),           SAVE           :: LocalVar
TYPE(ObjectInstances),          SAVE           :: objInst
TYPE(PerformanceData),          SAVE           :: PerfData
TYPE(DebugVariables),           SAVE           :: DebugVar
TYPE(ErrorVariables),           SAVE           :: ErrVar
TYPE(ExtControlType),           SAVE           :: ExtDLL


CHARACTER(*),                   PARAMETER      :: RoutineName = 'ROSCO'

RootName = TRANSFER(avcOUTNAME, RootName)
CALL GetRoot(RootName,RootName)
!------------------------------------------------------------------------------------------------------------------------------
! Main control calculations
!------------------------------------------------------------------------------------------------------------------------------

! Check for restart
IF ( (NINT(avrSWAP(1)) == -9) .AND. (aviFAIL >= 0))  THEN ! Read restart files
    CALL ReadRestartFile(avrSWAP, LocalVar, CntrPar, objInst, PerfData, RootName, SIZE(avcOUTNAME), ErrVar)
    IF ( CntrPar%LoggingLevel > 0 ) THEN
        CALL Debug(LocalVar, CntrPar, DebugVar, ErrVar, avrSWAP, RootName, SIZE(avcOUTNAME))
    END IF 
END IF

! Read avrSWAP array into derived types/variables
CALL ReadAvrSWAP(avrSWAP, LocalVar, CntrPar, ErrVar)

! Set Control Parameters
IF (ErrVar%aviFAIL >= 0) THEN
    CALL SetParameters(avrSWAP, accINFILE, SIZE(avcMSG), CntrPar, LocalVar, objInst, PerfData, RootName, ErrVar)
ENDIF

! Call external controller, if desired
IF (CntrPar%Ext_Mode > 0 .AND. ErrVar%aviFAIL >= 0) THEN
    CALL ExtController(avrSWAP, CntrPar, LocalVar, ExtDLL, ErrVar)
    ! Data from external dll is in ExtDLL%avrSWAP, it's unused in the following code
END IF

! Filter signals
IF (ErrVar%aviFAIL >= 0) THEN
    CALL PreFilterMeasuredSignals(CntrPar, LocalVar, DebugVar, objInst, ErrVar)
ENDIF

IF (((LocalVar%iStatus >= 0) .OR. (LocalVar%iStatus <= -8)) .AND. (ErrVar%aviFAIL >= 0))  THEN  ! Only compute control calculations if no error has occurred and we are not on the last time step
    IF ((LocalVar%iStatus == -8) .AND. (ErrVar%aviFAIL >= 0))  THEN ! Write restart files
        CALL WriteRestartFile(LocalVar, CntrPar, ErrVar, objInst, RootName, SIZE(avcOUTNAME))    
    ENDIF
    IF (CntrPar%ZMQ_Mode > 0) THEN
        CALL UpdateZeroMQ(LocalVar, CntrPar, ErrVar)
    ENDIF
    IF (CntrPar%SD_Mode > 0) THEN
        CALL Shutdown(LocalVar, CntrPar, objInst,ErrVar)
    ENDIF
    CALL WindSpeedEstimator(LocalVar, CntrPar, objInst, PerfData, DebugVar, ErrVar)
    CALL PowerControlSetpoints(CntrPar, LocalVar, objInst, DebugVar, ErrVar)  ! Everything before the pitch, torque set points are computeed
    IF (CntrPar%SU_Mode > 0) THEN
        CALL Startup(LocalVar, CntrPar, objInst,ErrVar)
    ENDIF
    CALL ComputeVariablesSetpoints(CntrPar, LocalVar, objInst, DebugVar, ErrVar)
    CALL StateMachine(CntrPar, LocalVar)
    CALL SetpointSmoother(LocalVar, CntrPar, objInst)
    CALL VariableSpeedControl(avrSWAP, CntrPar, LocalVar, objInst, ErrVar)
    IF (CntrPar%PC_ControlMode > 0) THEN
        CALL PitchControl(avrSWAP, CntrPar, LocalVar, objInst, DebugVar, ErrVar)
    END IF
    
    IF (CntrPar%Y_ControlMode > 0) THEN
        CALL YawRateControl(avrSWAP, CntrPar, LocalVar, objInst, DebugVar, ErrVar)
    END IF
    
    IF (CntrPar%Flp_Mode > 0) THEN
        CALL FlapControl(avrSWAP, CntrPar, LocalVar, objInst)
    END IF

    ! Cable control
    IF (CntrPar%CC_Mode > 0) THEN
        CALL CableControl(avrSWAP,CntrPar,LocalVar, objInst, ErrVar)
    END IF

    ! Structural control
    IF (CntrPar%StC_Mode > 0) THEN
        CALL StructuralControl(avrSWAP,CntrPar,LocalVar, objInst, ErrVar)
    END IF
    

ELSEIF ((LocalVar%iStatus == -1) .AND. (CntrPar%ZMQ_Mode > 0)) THEN
        CALL UpdateZeroMQ(LocalVar, CntrPar, ErrVar)
END IF

IF ((CntrPar%LoggingLevel > 0) .AND. (ErrVar%aviFAIL >= 0)) THEN
    CALL Debug(LocalVar, CntrPar, DebugVar, ErrVar, avrSWAP, RootName, SIZE(avcOUTNAME))
END IF 


! Add RoutineName to error message
IF (ErrVar%aviFAIL < 0) THEN
    ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
    print * , TRIM(ErrVar%ErrMsg)
ENDIF
ErrMsg = ADJUSTL(TRIM(ErrVar%ErrMsg))
avcMSG = TRANSFER(ErrMsg//C_NULL_CHAR, avcMSG, LEN(ErrMsg)+1)
avcMSG = TRANSFER(ErrMsg//C_NULL_CHAR, avcMSG, SIZE(avcMSG))
aviFAIL = ErrVar%aviFAIL
ErrVar%ErrMsg = ''

RETURN
END SUBROUTINE DISCON

!**********************************************************************************************************************************
! LICENSING
! Copyright (C) 2021  National Renewable Energy Laboratory
!
!    This file is part of ROSCO.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.
!**********************************************************************************************************************************
MODULE SysSubs

    USE ROSCO_Types
    USE Constants
    USE, INTRINSIC :: ISO_C_Binding


    IMPLICIT NONE


    INTEGER, PARAMETER            :: ConRecL     = 120                               ! The record length for console output.
    INTEGER, PARAMETER            :: CU          = 6                                 ! The I/O unit for the console.  Unit 6 causes ADAMS to crash.
    INTEGER, PARAMETER            :: MaxWrScrLen = 98                                ! The maximum number of characters allowed to be written to a line in WrScr
    LOGICAL, PARAMETER            :: KBInputOK   = .TRUE.                            ! A flag to tell the program that keyboard input is allowed in the environment.
    CHARACTER(*),  PARAMETER      :: NewLine     = ACHAR(10)                         ! The delimiter for New Lines [ Windows is CHAR(13)//CHAR(10); MAC is CHAR(13); Unix is CHAR(10) {CHAR(13)=\r is a line feed, CHAR(10)=\n is a new line}]
    CHARACTER(*),  PARAMETER      :: OS_Desc     = 'Intel Fortran for Linux'         ! Description of the language/OS
    CHARACTER( 1), PARAMETER      :: PathSep     = '/'                               ! The path separator.
    CHARACTER( 1), PARAMETER      :: SwChar      = '-'                               ! The switch character for command-line options.
    CHARACTER(11), PARAMETER      :: UnfForm     = 'UNFORMATTED'                     ! The string to specify unformatted I/O files.   
 


! This module contains routines with system-specific logic and references, including all references to the console unit, CU.
! It also contains standard (but not system-specific) routines it uses.
! SysGnuLinux.f90 is specifically for the GNU Fortran (gfortran) compiler on Linux and macOS.

    CONTAINS
!=======================================================================
    SUBROUTINE LoadDynamicLib ( DLL, ErrStat, ErrMsg )

        ! This SUBROUTINE is used to dynamically load a DLL.
     
        TYPE (ExtDLL_Type),           INTENT(INOUT)  :: DLL         ! The DLL to be loaded.
        INTEGER(IntKi),            INTENT(  OUT)  :: ErrStat     ! Error status of the operation
        CHARACTER(*),              INTENT(  OUT)  :: ErrMsg      ! Error message if ErrStat /= ErrID_None
     
#ifdef USE_DLL_INTERFACE         
     
     !bjj: these are values I found on the web; I have no idea if they actually work...
     !bjj: hopefully we can find them pre-defined in a header somewhere
        INTEGER(C_INT), PARAMETER :: RTLD_LAZY=1            ! "Perform lazy binding. Only resolve symbols as the code that references them is executed. If the symbol is never referenced, then it is never resolved. (Lazy binding is only performed for function references; references to variables are always immediately bound when the library is loaded.) "
        INTEGER(C_INT), PARAMETER :: RTLD_NOW=2             ! "If this value is specified, or the environment variable LD_BIND_NOW is set to a nonempty string, all undefined symbols in the library are resolved before dlopen() returns. If this cannot be done, an error is returned."
        INTEGER(C_INT), PARAMETER :: RTLD_GLOBAL=256        ! "The symbols defined by this library will be made available for symbol resolution of subsequently loaded libraries"
        INTEGER(C_INT), PARAMETER :: RTLD_LOCAL=0           ! "This is the converse of RTLD_GLOBAL, and the default if neither flag is specified. Symbols defined in this library are not made available to resolve references in subsequently loaded libraries."
     
        INTERFACE !linux API routines
           !bjj see http://linux.die.net/man/3/dlopen
           !    and https://developer.apple.com/library/mac/documentation/Darwin/Reference/ManPages/man3/dlopen.3.html
     
           FUNCTION dlOpen(filename,mode) BIND(C,NAME="dlopen")
           ! void *dlopen(const char *filename, int mode);
              USE ISO_C_BINDING
              IMPLICIT NONE
              TYPE(C_PTR)                   :: dlOpen
              CHARACTER(C_CHAR), INTENT(IN) :: filename(*)
              INTEGER(C_INT), VALUE         :: mode
           END FUNCTION
     
        END INTERFACE
     
        ErrStat = ErrID_None
        ErrMsg = ''
     
        ! Load the DLL and get the file address:
     
        DLL%FileAddrX = dlOpen( TRIM(DLL%FileName)//C_NULL_CHAR, RTLD_LAZY )  !the "C_NULL_CHAR" converts the Fortran string to a C-type string (i.e., adds //CHAR(0) to the end)
     
        IF( .NOT. C_ASSOCIATED(DLL%FileAddrX) ) THEN
           ErrStat = ErrID_Fatal
         !   WRITE(ErrMsg,'(I2)') BITS_IN_ADDR
           ErrMsg  = 'The dynamic library '//TRIM(DLL%FileName)//' could not be loaded. Check that the file '// &
                     'exists in the specified location and that it is compiled for '//TRIM(ErrMsg)//'-bit applications.'
           RETURN
        END IF
     
        ! Get the procedure address:
     
        CALL LoadDynamicLibProc ( DLL, ErrStat, ErrMsg )
#else
     
        ErrStat = ErrID_Fatal
        ErrMsg = ' LoadDynamicLib: Not compiled with -DUSE_DLL_INTERFACE for '//TRIM(OS_Desc)
           
#endif
        
        RETURN
     END SUBROUTINE LoadDynamicLib
     !=======================================================================
     SUBROUTINE LoadDynamicLibProc ( DLL, ErrStat, ErrMsg )
     
        ! This SUBROUTINE is used to dynamically load a procedure from a DLL.
     
        TYPE (ExtDLL_Type),           INTENT(INOUT)  :: DLL         ! The DLL to be loaded.
        INTEGER(IntKi),            INTENT(  OUT)  :: ErrStat     ! Error status of the operation
        CHARACTER(*),              INTENT(  OUT)  :: ErrMsg      ! Error message if ErrStat /= ErrID_None
        INTEGER(IntKi)                            :: i
     
#ifdef USE_DLL_INTERFACE           
     
        INTERFACE !linux API routines
     
           !bjj see http://linux.die.net/man/3/dlsym
           !    and https://developer.apple.com/library/mac/documentation/Darwin/Reference/ManPages/man3/dlsym.3.html
           
           FUNCTION dlSym(handle,name) BIND(C,NAME="dlsym")
           ! void *dlsym(void *handle, const char *name);
              USE ISO_C_BINDING
              IMPLICIT NONE
              TYPE(C_FUNPTR)                :: dlSym ! A function pointer
              TYPE(C_PTR), VALUE            :: handle
              CHARACTER(C_CHAR), INTENT(IN) :: name(*)
           END FUNCTION
     
        END INTERFACE
     
        ErrStat = ErrID_None
        ErrMsg = ''

         ! Initialize ProcAddr
        DLL%ProcAddr = C_NULL_FUNPTR
     
        do i=1,NWTC_MAX_DLL_PROC
           if ( len_trim( DLL%ProcName(i) ) > 0 ) then
        
              DLL%ProcAddr(i) = dlSym( DLL%FileAddrX, TRIM(DLL%ProcName(i))//C_NULL_CHAR )  !the "C_NULL_CHAR" converts the Fortran string to a C-type string (i.e., adds //CHAR(0) to the end)
     
              IF(.NOT. C_ASSOCIATED(DLL%ProcAddr(i))) THEN
                 ErrStat = ErrID_Fatal + i - 1
                 ErrMsg  = 'The procedure '//TRIM(DLL%ProcName(i))//' in file '//TRIM(DLL%FileName)//' could not be loaded.'
                 RETURN
              END IF
              
           end if
        end do
           
#else
     
        ErrStat = ErrID_Fatal
        ErrMsg = ' LoadDynamicLibProc: Not compiled with -DUSE_DLL_INTERFACE for '//TRIM(OS_Desc)
           
#endif
        
        RETURN
     END SUBROUTINE LoadDynamicLibProc
     !=======================================================================
     SUBROUTINE FreeDynamicLib ( DLL, ErrStat, ErrMsg )
     
           ! This SUBROUTINE is used to free a dynamically loaded DLL (loaded in LoadDynamicLib).
     
           TYPE (ExtDLL_Type),           INTENT(INOUT)  :: DLL         ! The DLL to be freed.
           INTEGER(IntKi),            INTENT(  OUT)  :: ErrStat     ! Error status of the operation
           CHARACTER(*),              INTENT(  OUT)  :: ErrMsg      ! Error message if ErrStat /= ErrID_None
           INTEGER(C_INT)                            :: Success     ! Whether or not the call to dlClose was successful
           INTEGER(C_INT), PARAMETER                 :: TRUE  = 0
     
#ifdef USE_DLL_INTERFACE           
     !bjj: note that this is not tested.
     
        INTERFACE !linux API routine
           !bjj see http://linux.die.net/man/3/dlclose
           !    and https://developer.apple.com/library/mac/documentation/Darwin/Reference/ManPages/man3/dlclose.3.html
     
           FUNCTION dlClose(handle) BIND(C,NAME="dlclose")
           ! int dlclose(void *handle);
              USE ISO_C_BINDING
              IMPLICIT NONE
              INTEGER(C_INT)       :: dlClose
              TYPE(C_PTR), VALUE   :: handle
           END FUNCTION
     
        END INTERFACE
     
        ! Close the library:
     
        IF( .NOT. C_ASSOCIATED(DLL%FileAddrX) ) RETURN
        Success = dlClose( DLL%FileAddrX ) !The function dlclose() returns 0 on success, and nonzero on error.
     
        IF ( Success /= TRUE ) THEN !bjj: note that this is not the same as LOGICAL .TRUE.
           ErrStat = ErrID_Fatal
           ErrMsg  = 'The dynamic library could not be freed.'
           RETURN
        ELSE
           ErrStat = ErrID_None
           ErrMsg = ''
           DLL%FileAddrX = C_NULL_PTR
        END IF
        
#else
     
           ErrStat = ErrID_Fatal
           ErrMsg = ' FreeDynamicLib: Not compiled with -DUSE_DLL_INTERFACE for '//TRIM(OS_Desc)
              
#endif
        
           RETURN
        END SUBROUTINE FreeDynamicLib
     !=======================================================================

END MODULE SysSubs

! Copyright 2019 NREL

! Licensed under the Apache License, Version 2.0 (the "License"); you may not use
! this file except in compliance with the License. You may obtain a copy of the
! License at http://www.apache.org/licenses/LICENSE-2.0

! Unless required by applicable law or agreed to in writing, software distributed
! under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
! CONDITIONS OF ANY KIND, either express or implied. See the License for the
! specific language governing permissions and limitations under the License.
! -------------------------------------------------------------------------------------------

! This module contains the primary controller routines

! Subroutines:
!           PitchControl: Blade pitch control high level subroutine
!           VariableSpeedControl: Variable speed generator torque control
!           YawRateControl: Nacelle yaw control
!           IPC: Individual pitch control
!           ForeAftDamping: Tower fore-aft damping control
!           FloatingFeedback: Tower fore-aft feedback for floating offshore wind turbines

MODULE ExtControl

    USE, INTRINSIC :: ISO_C_Binding
    USE Functions
    USE ROSCO_Types
    USE SysSubs
    USE Constants

    IMPLICIT NONE



    ABSTRACT INTERFACE
    SUBROUTINE BladedDLL_Legacy_Procedure ( avrSWAP, aviFAIL, accINFILE, avcOUTNAME, avcMSG )  BIND(C)
       USE, INTRINSIC :: ISO_C_Binding

       USE Constants

       REAL(ReKi),             INTENT(INOUT) :: avrSWAP   (*)  !< DATA
       INTEGER(C_INT),         INTENT(INOUT) :: aviFAIL        !< FLAG  (Status set in DLL and returned to simulation code)
       CHARACTER(KIND=C_CHAR), INTENT(IN)    :: accINFILE (*)  !< INFILE
       CHARACTER(KIND=C_CHAR), INTENT(INOUT) :: avcOUTNAME(*)  !< OUTNAME (in:Simulation RootName; out:Name:Units; of logging channels)
       CHARACTER(KIND=C_CHAR), INTENT(INOUT) :: avcMSG    (*)  !< MESSAGE (Message from DLL to simulation code [ErrMsg])
    END SUBROUTINE BladedDLL_Legacy_Procedure

    END INTERFACE

CONTAINS

    SUBROUTINE ExtController(avrSWAP, CntrPar, LocalVar, ExtDLL, ErrVar)
        ! Inputs
        TYPE(ControlParameters), INTENT(INOUT)      :: CntrPar
        TYPE(LocalVariables), INTENT(INOUT)         :: LocalVar
        TYPE(ErrorVariables), INTENT(INOUT)         :: ErrVar
        TYPE(ExtControlType), INTENT(INOUT)         :: ExtDLL


        REAL(ReKi), INTENT(INOUT)                   :: avrSWAP(*)   ! The swap array, used to pass data to, and receive data from the DLL controller.

        ! Temporary variables
        CHARACTER(100), PARAMETER                   :: ExtRootName   = 'external_control'

        ! Local Variables
        CHARACTER(*), PARAMETER                     :: RoutineName = 'ExtController'

        TYPE(ExtDLL_Type), SAVE                     :: DLL_Ext
        INTEGER(IntKi), PARAMETER                   :: max_avr_entries = 2000


        PROCEDURE(BladedDLL_Legacy_Procedure), POINTER :: DLL_Legacy_Subroutine          ! The address of the (legacy DISCON) procedure in the Bladed DLL
        CHARACTER(KIND=C_CHAR)                      :: accINFILE(LEN_TRIM(CntrPar%DLL_InFile)+1)  ! INFILE
        CHARACTER(KIND=C_CHAR)                      :: avcOUTNAME(LEN_TRIM(ExtRootName)+1)   ! OUTNAME (Simulation RootName)
        CHARACTER(KIND=C_CHAR)                      :: avcMSG(LEN(ErrVar%ErrMsg)+1)                ! MESSA


        INTEGER(C_INT)                              :: aviFAIL                        ! A flag used to indicate the success of this DLL call set as follows: 0 if the DLL call was successful, >0 if the DLL call was successful but cMessage should be issued as a warning messsage, <0 if the DLL call was unsuccessful or for any other reason the simulation is to be stopped at this point with cMessage as the error message.


        ! Initialize strings for external controller
        aviFAIL     = 0
        avcMSG     = TRANSFER( C_NULL_CHAR,                            avcMSG     )
        avcOUTNAME = TRANSFER( TRIM(ExtRootName)//C_NULL_CHAR,   avcOUTNAME )
        accINFILE  = TRANSFER( TRIM(CntrPar%DLL_InFile)//C_NULL_CHAR, accINFILE  )
                
        IF (LocalVar%iStatus == 0) THEN  

            !! Set up DLL, will come from ROSCO input   
            DLL_Ext%FileName = TRIM(CntrPar%DLL_FileName)
            DLL_Ext%ProcName = TRIM(CntrPar%DLL_ProcName)

            PRINT *, "ROSCO is calling an external dynamic library for control input:"
            PRINT *, "DLL_FileName:", TRIM(CntrPar%DLL_FileName)
            PRINT *, "DLL_InFile:", TRIM(CntrPar%DLL_InFile)
            PRINT *, "DLL_ProcName:", TRIM(CntrPar%DLL_ProcName)

            ! Load dynamic library, but first make sure that it's free
            ! CALL FreeDynamicLib(DLL_Ext, ErrVar%ErrStat, ErrVar%ErrMsg)
            CALL LoadDynamicLib(DLL_Ext, ErrVar%ErrStat, ErrVar%ErrMsg)
            ALLOCATE(ExtDLL%avrSWAP(max_avr_entries)) !(1:max_avr_entries)

            PRINT *, "Library loaded successfully"

        END IF

        ! Set avrSWAP of external DLL, inputs to external DLL
        ExtDLL%avrSWAP = avrSWAP(1:max_avr_entries)

        ! Set some length parameters
        ExtDLL%avrSWAP(49) = LEN(avcMSG)  + 1                     !> * Record 49: Maximum number of characters in the "MESSAGE" argument (-) [size of ExtErrMsg argument plus 1 (we add one for the C NULL CHARACTER)]
        ExtDLL%avrSWAP(50) = LEN_TRIM(CntrPar%DLL_InFile) +1  !> * Record 50: Number of characters in the "INFILE"  argument (-) [trimmed length of ExtDLL_InFile parameter plus 1 (we add one for the C NULL CHARACTER)]
        ExtDLL%avrSWAP(51) = LEN_TRIM(ExtRootName)   +1  !> * Record 51: Number of characters in the "OUTNAME" argument (-) [trimmed length of ExtRootName parameter plus 1 (we add one for the C NULL CHARACTER)]

        ! Call the DLL (first associate the address from the procedure in the DLL with the subroutine):
        CALL C_F_PROCPOINTER( DLL_Ext%ProcAddr(1), DLL_Legacy_Subroutine) 
        CALL DLL_Legacy_Subroutine (ExtDLL%avrSWAP, aviFAIL, accINFILE, avcOUTNAME, avcMSG ) 

        ! Clean up DLL 
        ! CALL FreeDynamicLib(DLL_Ext, ErrVar%ErrStat, ErrVar%ErrMsg)

        ! Add RoutineName to error message
        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
            print * , TRIM(ErrVar%ErrMsg)
        ENDIF


    END SUBROUTINE ExtController


!=================================================================================================================
!=================================================================================================================
!=================================================================================================================


END MODULE ExtControl

! Copyright 2019 NREL

! Licensed under the Apache License, Version 2.0 (the "License"); you may not use
! this file except in compliance with the License. You may obtain a copy of the
! License at http://www.apache.org/licenses/LICENSE-2.0

! Unless required by applicable law or agreed to in writing, software distributed
! under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
! CONDITIONS OF ANY KIND, either express or implied. See the License for the
! specific language governing permissions and limitations under the License.
! -------------------------------------------------------------------------------------------
! This module contains basic control-related functions

! Functions:
!       AeroDynTorque: Calculate aerodynamic torque
!       ColemanTransform: Perform Colemant transform
!       ColemanTransformInverse: Perform inverse Colemant transform
!       CPFunction: Find Cp using parameterized surface
!       Debug: Debug the controller
!       DFController: DF control
!       identity: Make identity matrix
!       interp1d: 1-d interpolation
!       interp2d: 2-d interpolation
!       matinv3: 3x3 matrix inverse
!       PIDController: implement a PID controller
!       ratelimit: Rate limit signal
!       saturate: Saturate signal

MODULE Functions

USE Constants

IMPLICIT NONE

CONTAINS
!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION saturate(inputValue, minValue, maxValue)
    ! Saturates inputValue. Makes sure it is not smaller than minValue and not larger than maxValue

        IMPLICIT NONE

        REAL(DbKi), INTENT(IN)     :: inputValue
        REAL(DbKi), INTENT(IN)     :: minValue
        REAL(DbKi), INTENT(IN)     :: maxValue

        saturate = REAL(MIN(MAX(inputValue,minValue), maxValue),DbKi)

    END FUNCTION saturate
    
!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION ratelimit(inputSignal, minRate, maxRate, DT, reset, rlP, inst, ResetValue)
    ! Saturates inputValue. Makes sure it is not smaller than minValue and not larger than maxValue
        USE ROSCO_Types, ONLY : rlParams

        
        IMPLICIT NONE

        REAL(DbKi), INTENT(IN)          :: inputSignal
        REAL(DbKi), INTENT(IN)          :: minRate
        REAL(DbKi), INTENT(IN)          :: maxRate
        REAL(DbKi), INTENT(IN)          :: DT
        LOGICAL,    INTENT(IN)         :: reset  
        TYPE(rlParams), INTENT(INOUT)   :: rlP
        INTEGER(IntKi), INTENT(INOUT)   :: inst
        REAL(DbKi), OPTIONAL,  INTENT(IN)          :: ResetValue           ! Value to base rate limit off if restarting

        ! Local variables
        REAL(DbKi)                 :: rate
        REAL(DbKi)                 :: ResetValue_

        ResetValue_ = inputSignal
        IF (PRESENT(ResetValue)) ResetValue_ = ResetValue   

        IF (reset) THEN
            rlP%LastSignal(inst) = ResetValue_
            ratelimit = ResetValue_
            
        ELSE
            rate = (inputSignal - rlP%LastSignal(inst))/DT                       ! Signal rate (unsaturated)
            rate = saturate(rate, minRate, maxRate)                 ! Saturate the signal rate

            ratelimit = rlP%LastSignal(inst) + rate*DT  

            rlP%LastSignal(inst) = ratelimit

        ENDIF

        ! Increment instance
        inst = inst + 1                     ! Saturate the overall command using the rate limit

    END FUNCTION ratelimit


    REAL(DbKi) FUNCTION interp1d(xData, yData, xq, ErrVar)
    ! interp1d 1-D interpolation (table lookup), xData should be strictly increasing
        
        USE ROSCO_Types, ONLY : ErrorVariables
        IMPLICIT NONE

        ! Inputs
        REAL(DbKi), DIMENSION(:), INTENT(IN)       :: xData        ! Provided x data (vector), to be interpolated
        REAL(DbKi), DIMENSION(:), INTENT(IN)       :: yData        ! Provided y data (vector), to be interpolated
        REAL(DbKi), INTENT(IN)                     :: xq           ! x-value for which the y value has to be interpolated
        INTEGER(IntKi)                              :: I            ! Iteration index

        ! Error Catching
        TYPE(ErrorVariables), INTENT(INOUT)     :: ErrVar
        INTEGER(IntKi)                              :: I_DIFF

        CHARACTER(*), PARAMETER                 :: RoutineName = 'interp1d'

        
        ! Catch Errors
        ! Are xData and yData the same size?
        IF (SIZE(xData) .NE. SIZE(yData)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = ' xData and yData are not the same size'
            WRITE(ErrVar%ErrMsg,"(A,I2,A,I2,A)") " SIZE(xData) =", SIZE(xData), & 
            ' and SIZE(yData) =', SIZE(yData),' are not the same'
        END IF

        ! Is xData non decreasing
        DO I_DIFF = 1, size(xData) - 1
            IF (xData(I_DIFF + 1) - xData(I_DIFF) <= 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = ' xData is not strictly increasing'
                EXIT 
            END IF
        END DO
        
        ! Interpolate
        IF (xq <= MINVAL(xData)) THEN
            interp1d = yData(1)
        ELSEIF (xq >= MAXVAL(xData)) THEN
            interp1d = yData(SIZE(xData))
        ELSE
            DO I = 1, SIZE(xData)
                IF (xq <= xData(I)) THEN
                    interp1d = yData(I-1) + (yData(I) - yData(I-1))/(xData(I) - xData(I-1))*(xq - xData(I-1))
                    EXIT
                ELSE
                    CONTINUE
                END IF
            END DO
        END IF

        ! Add RoutineName to error message
        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
        ENDIF
        
    END FUNCTION interp1d

!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION interp2d(xData, yData, zData, xq, yq, ErrVar)
    ! interp2d 2-D interpolation (table lookup). Query done using bilinear interpolation. 
    ! Note that the interpolated matrix with associated query vectors may be different than "standard", - zData should be formatted accordingly
    ! - xData follows the matrix from left to right
    ! - yData follows the matrix from top to bottom
    ! A simple case: xData = [1 2 3], yData = [4 5 6]
    !        | 1    2   3
    !       -------------
    !       4| a    b   c
    !       5| d    e   f
    !       6| g    H   i

        USE ROSCO_Types, ONLY : ErrorVariables
        USE ieee_arithmetic
        
        IMPLICIT NONE
    
        ! Inputs
        REAL(DbKi), DIMENSION(:),   INTENT(IN)     :: xData        ! Provided x data (vector), to find query point (should be strictly increasing)
        REAL(DbKi), DIMENSION(:),   INTENT(IN)     :: yData        ! Provided y data (vector), to find query point (should be strictly increasing)
        REAL(DbKi), DIMENSION(:,:), INTENT(IN)     :: zData        ! Provided z data (vector), to be interpolated
        REAL(DbKi),                 INTENT(IN)     :: xq           ! x-value for which the z value has to be interpolated
        REAL(DbKi),                 INTENT(IN)     :: yq           ! y-value for which the z value has to be interpolated

        ! Allocate variables
        INTEGER(IntKi)                              :: i            ! Iteration index & query index, x-direction
        INTEGER(IntKi)                              :: ii           ! Iteration index & second que .  ry index, x-direction
        INTEGER(IntKi)                              :: j            ! Iteration index & query index, y-direction
        INTEGER(IntKi)                              :: jj           ! Iteration index & second query index, y-direction
        REAL(DbKi), DIMENSION(2,2)                 :: fQ           ! zData value at query points for bilinear interpolation            
        REAL(DbKi), DIMENSION(1)                   :: fxy           ! Interpolated z-data point to be returned
        REAL(DbKi)                                 :: fxy1          ! zData value at query point for bilinear interpolation
        REAL(DbKi)                                 :: fxy2          ! zData value at query point for bilinear interpolation       
        LOGICAL                                 :: edge     

        ! Error Catching
        TYPE(ErrorVariables), INTENT(INOUT)     :: ErrVar
        INTEGER(IntKi)                              :: I_DIFF

        CHARACTER(*), PARAMETER                 :: RoutineName = 'interp2d'
        
        ! Error catching
        ! Are xData and zData(:,1) the same size?
        IF (SIZE(xData) .NE. SIZE(zData,2)) THEN
            ErrVar%aviFAIL = -1
            WRITE(ErrVar%ErrMsg,"(A,I4,A,I4,A)") " SIZE(xData) =", SIZE(xData), & 
            ' and SIZE(zData,1) =', SIZE(zData,2),' are not the same'
        END IF

        ! Are yData and zData(1,:) the same size?
        IF (SIZE(yData) .NE. SIZE(zData,1)) THEN
            ErrVar%aviFAIL = -1
            WRITE(ErrVar%ErrMsg,"(A,I4,A,I4,A)") " SIZE(yData) =", SIZE(yData), & 
            ' and SIZE(zData,2) =', SIZE(zData,1),' are not the same'
        END IF

        ! Is xData non decreasing
        DO I_DIFF = 1, size(xData) - 1
            IF (xData(I_DIFF + 1) - xData(I_DIFF) <= 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = ' xData is not strictly increasing'
                EXIT 
            END IF
        END DO

        ! Is yData non decreasing
        DO I_DIFF = 1, size(yData) - 1
            IF (yData(I_DIFF + 1) - yData(I_DIFF) <= 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = ' yData is not strictly increasing'
                EXIT 
            END IF
        END DO

        ! ---- Find corner indices surrounding desired interpolation point -----
            ! x-direction
        IF (xq <= MINVAL(xData) .OR. (ieee_is_nan(xq))) THEN       ! On lower x-bound, just need to find zData(yq)
            j = 1
            jj = 1
            interp2d = interp1d(yData,zData(:,j),yq,ErrVar)     
            RETURN
        ELSEIF (xq >= MAXVAL(xData)) THEN   ! On upper x-bound, just need to find zData(yq)
            j = size(xData)
            jj = size(xData)
            interp2d = interp1d(yData,zData(:,j),yq,ErrVar)
            RETURN
        ELSE
            DO j = 1,size(xData)            
                IF (xq == xData(j)) THEN ! On axis, just need 1d interpolation
                    jj = j
                    interp2d = interp1d(yData,zData(:,j),yq,ErrVar)  
                    RETURN
                ELSEIF (xq < xData(j)) THEN
                    jj = j
                    EXIT
                ELSE
                    CONTINUE
                END IF
            END DO
        ENDIF
        j = j-1 ! Move j back one
            ! y-direction
        IF (yq <= MINVAL(yData) .OR. (ieee_is_nan(yq))) THEN       ! On lower y-bound, just need to find zData(xq)
            i = 1
            ii = 1
            interp2d = interp1d(xData,zData(i,:),xq,ErrVar)     
            RETURN
        ELSEIF (yq >= MAXVAL(yData)) THEN   ! On upper y-bound, just need to find zData(xq)
            i = size(yData)
            ii = size(yData)
            interp2d = interp1d(xData,zData(i,:),xq,ErrVar)      
            RETURN
        ELSE
            DO i = 1,size(yData)
                IF (yq == yData(i)) THEN    ! On axis, just need 1d interpolation
                    ii = i
                    interp2d = interp1d(xData,zData(i,:),xq,ErrVar)        
                    RETURN
                ELSEIF (yq < yData(i)) THEN
                    ii = i
                    EXIT
                ELSE
                    CONTINUE
                END IF
            END DO
        ENDIF
        i = i-1 ! move i back one
        
        ! ---- Do bilinear interpolation ----
        ! Find values at corners 
        fQ(1,1) = zData(i,j)
        fQ(2,1) = zData(ii,j)
        fQ(1,2) = zData(i,jj)
        fQ(2,2) = zData(ii,jj)
        ! Interpolate
        fxy1 = (xData(jj) - xq)/(xData(jj) - xData(j))*fQ(1,1) + (xq - xData(j))/(xData(jj) - xData(j))*fQ(1,2)
        fxy2 = (xData(jj) - xq)/(xData(jj) - xData(j))*fQ(2,1) + (xq - xData(j))/(xData(jj) - xData(j))*fQ(2,2)
        fxy = (yData(ii) - yq)/(yData(ii) - yData(i))*fxy1 + (yq - yData(i))/(yData(ii) - yData(i))*fxy2

        interp2d = fxy(1)

        ! Add RoutineName to error message
        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
        ENDIF

    END FUNCTION interp2d

!-------------------------------------------------------------------------------------------------------------------------------
    FUNCTION matinv3(A) RESULT(B)
    ! Performs a direct calculation of the inverse of a 3×3 matrix.
    ! Source: http://fortranwiki.org/fortran/show/Matrix+inversion
        REAL(DbKi), INTENT(IN) :: A(3,3)   !! Matrix
        REAL(DbKi)             :: B(3,3)   !! Inverse matrix
        REAL(DbKi)             :: detinv

        ! Calculate the inverse determinant of the matrix
        detinv = 1/(A(1,1)*A(2,2)*A(3,3) - A(1,1)*A(2,3)*A(3,2)&
                - A(1,2)*A(2,1)*A(3,3) + A(1,2)*A(2,3)*A(3,1)&
                + A(1,3)*A(2,1)*A(3,2) - A(1,3)*A(2,2)*A(3,1))

        ! Calculate the inverse of the matrix
        B(1,1) = +detinv * (A(2,2)*A(3,3) - A(2,3)*A(3,2))
        B(2,1) = -detinv * (A(2,1)*A(3,3) - A(2,3)*A(3,1))
        B(3,1) = +detinv * (A(2,1)*A(3,2) - A(2,2)*A(3,1))
        B(1,2) = -detinv * (A(1,2)*A(3,3) - A(1,3)*A(3,2))
        B(2,2) = +detinv * (A(1,1)*A(3,3) - A(1,3)*A(3,1))
        B(3,2) = -detinv * (A(1,1)*A(3,2) - A(1,2)*A(3,1))
        B(1,3) = +detinv * (A(1,2)*A(2,3) - A(1,3)*A(2,2))
        B(2,3) = -detinv * (A(1,1)*A(2,3) - A(1,3)*A(2,1))
        B(3,3) = +detinv * (A(1,1)*A(2,2) - A(1,2)*A(2,1))
    END FUNCTION matinv3

!-------------------------------------------------------------------------------------------------------------------------------
    FUNCTION identity(n) RESULT(A)
    ! Produces an identity matrix of size n x n

        INTEGER, INTENT(IN)         :: n
        REAL(DbKi), DIMENSION(n, n)    :: A
        INTEGER                     :: i
        INTEGER                     :: j

        ! Build identity matrix 
        DO i=1,n  
            DO j = 1,n
                IF (i == j) THEN 
                    A(i,j) = 1.0
                ELSE
                    A(i,j) = 0.0
                ENDIF
            ENDDO
        ENDDO
    
    END FUNCTION identity

!-------------------------------------------------------------------------------------------------------------------------------
    SUBROUTINE ColemanTransform(rootMOOP, aziAngle, nHarmonic, axTOut, axYOut)
    ! The Coleman or d-q axis transformation transforms the root out of plane bending moments of each turbine blade
    ! to a direct axis and a quadrature axis

        IMPLICIT NONE
        ! Inputs
        REAL(DbKi), INTENT(IN)     :: rootMOOP(3)                      ! Root out of plane bending moments of each blade
        REAL(DbKi), INTENT(IN)     :: aziAngle                         ! Rotor azimuth angle
        INTEGER(IntKi), INTENT(IN)  :: nHarmonic                        ! The harmonic number, nP
        ! Outputs
        REAL(DbKi), INTENT(OUT)    :: axTOut, axYOut               ! Direct axis and quadrature axis outputted by this transform
        ! Local
        REAL(DbKi), PARAMETER      :: phi2 = 2.0/3.0*PI                ! Phase difference from first to second blade
        REAL(DbKi), PARAMETER      :: phi3 = 4.0/3.0*PI                ! Phase difference from first to third blade

        ! Body
        axTOut  = 2.0/3.0 * (cos(nHarmonic*(aziAngle))*rootMOOP(1) + cos(nHarmonic*(aziAngle+phi2))*rootMOOP(2) + cos(nHarmonic*(aziAngle+phi3))*rootMOOP(3))
        axYOut  = 2.0/3.0 * (sin(nHarmonic*(aziAngle))*rootMOOP(1) + sin(nHarmonic*(aziAngle+phi2))*rootMOOP(2) + sin(nHarmonic*(aziAngle+phi3))*rootMOOP(3))
        
    END SUBROUTINE ColemanTransform

!-------------------------------------------------------------------------------------------------------------------------------
    SUBROUTINE ColemanTransformInverse(axTIn, axYIn, aziAngle, nHarmonic, aziOffset, PitComIPC)
    ! The inverse Coleman or d-q axis transformation transforms the direct axis and quadrature axis
    ! back to root out of plane bending moments of each turbine blade
        IMPLICIT NONE
        ! Inputs
        REAL(DbKi), INTENT(IN)     :: axTIn, axYIn         ! Direct axis and quadrature axis
        REAL(DbKi), INTENT(IN)     :: aziAngle                     ! Rotor azimuth angle
        REAL(DbKi), INTENT(IN)     :: aziOffset                    ! Phase shift added to the azimuth angle
        INTEGER(IntKi), INTENT(IN)  :: nHarmonic                    ! The harmonic number, nP
        ! Outputs
        REAL(DbKi), INTENT(OUT)    :: PitComIPC(3)                   ! Commanded individual pitch (deg)
        ! Local
        REAL(DbKi), PARAMETER      :: phi2 = 2.0/3.0*PI                ! Phase difference from first to second blade
        REAL(DbKi), PARAMETER      :: phi3 = 4.0/3.0*PI                ! Phase difference from first to third blade

        ! Body
        PitComIPC(1) = cos(nHarmonic*(aziAngle+aziOffset))*axTIn + sin(nHarmonic*(aziAngle+aziOffset))*axYIn
        PitComIPC(2) = cos(nHarmonic*(aziAngle+aziOffset+phi2))*axTIn + sin(nHarmonic*(aziAngle+aziOffset+phi2))*axYIn
        PitComIPC(3) = cos(nHarmonic*(aziAngle+aziOffset+phi3))*axTIn + sin(nHarmonic*(aziAngle+aziOffset+phi3))*axYIn

    END SUBROUTINE ColemanTransformInverse

!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION CPfunction(CP, lambda)
    ! Paremeterized Cp(lambda) function for a fixed pitch angle. Circumvents the need of importing a look-up table
        IMPLICIT NONE
        
        ! Inputs
        REAL(DbKi), INTENT(IN) :: CP(4)    ! Parameters defining the parameterizable Cp(lambda) function
        REAL(DbKi), INTENT(IN) :: lambda    ! Estimated or measured tip-speed ratio input
        
        ! Lookup
        CPfunction = exp(-CP(1)/lambda)*(CP(2)/lambda-CP(3))+CP(4)*lambda
        CPfunction = saturate(CPfunction, 0.001_DbKi, 1.0_DbKi)
        
    END FUNCTION CPfunction

!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION AeroDynTorque(RotSpeed, BldPitch, LocalVar, CntrPar, PerfData, ErrVar)
    ! Function for computing the aerodynamic torque, divided by the effective rotor torque of the turbine, for use in wind speed estimation
        
        USE ROSCO_Types, ONLY : LocalVariables, ControlParameters, PerformanceData, ErrorVariables
        IMPLICIT NONE
    
        ! Inputs
        TYPE(ControlParameters), INTENT(IN) :: CntrPar
        TYPE(LocalVariables), INTENT(IN) :: LocalVar
        TYPE(PerformanceData), INTENT(IN) :: PerfData
        TYPE(ErrorVariables), INTENT(INOUT) :: ErrVar

        REAL(DbKi), INTENT(IN)  :: RotSpeed
        REAL(DbKi), INTENT(IN)  :: BldPitch
            
        ! Local
        REAL(DbKi) :: RotorArea
        REAL(DbKi) :: Cp
        REAL(DbKi) :: Lambda
        REAL(DbKi) :: WindSpeed

        CHARACTER(*), PARAMETER                 :: RoutineName = 'AeroDynTorque'

        ! Find Torque
        RotorArea = PI*CntrPar%WE_BladeRadius**2
        WindSpeed = MAX(LocalVar%WE_Vw,EPSILON(1.0_DbKi))
        Lambda = RotSpeed*CntrPar%WE_BladeRadius/WindSpeed

        ! Compute Cp
        Cp = interp2d(PerfData%Beta_vec,PerfData%TSR_vec,PerfData%Cp_mat, BldPitch*R2D, Lambda, ErrVar)
        
        AeroDynTorque = 0.5*(CntrPar%WE_RhoAir*RotorArea)*(LocalVar%WE_Vw**3/RotSpeed)*Cp
        AeroDynTorque = MAX(AeroDynTorque, 0.0_DbKi)

        ! Add RoutineName to error message
        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
        ENDIF
        
    END FUNCTION AeroDynTorque
!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION wrap_180(x) 
    ! Function modifies input angle, x, such that -180<=x<=180, preventing windup
        REAL(DbKi), INTENT(IN) :: x         ! angle, degrees

        IF (x .le. -180.0) THEN
            wrap_180 = x + 360.0
        ELSEIF (x .gt. 180.0) THEN
            wrap_180 = x - 360.0
        ELSE
            wrap_180 = x
        ENDIF

    END FUNCTION wrap_180
!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION wrap_360(x) 
    ! Function modifies input angle, x, such that 0<=x<=360, preventing windup
        REAL(DbKi), INTENT(IN) :: x         ! angle, degrees

        IF (x .lt. 0.0) THEN
            wrap_360 = x + 360.0
        ELSEIF (x .ge. 360.0) THEN
            wrap_360 = x - 360.0
        ELSE
            wrap_360 = x
        ENDIF

    END FUNCTION wrap_360
!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION sigma(x, x0, x1, y0, y1, ErrVar)
    ! Generic sigma function
        USE ROSCO_Types, ONLY : ErrorVariables
        IMPLICIT NONE
    
        ! Inputs
        TYPE(ErrorVariables), INTENT(INOUT) :: ErrVar

        REAL(DbKi), Intent(IN)  :: x, x0, x1
        REAL(DbKi), Intent(IN)  :: y0, y1
            
        ! Local
        REAL(DbKi) :: a3, a2, a1, a0

        CHARACTER(*), PARAMETER                 :: RoutineName = 'sigma'

        a3 = 2/(x0-x1)**3
        a2 = -3*(x0+x1)/(x0-x1)**3
        a1 = 6*x1*x0/(x0-x1)**3
        a0 = (x0-3*x1)*x0**2/(x0-x1)**3

        IF (x < x0) THEN
            sigma = y0
        ELSEIF (x > x1) THEN
            sigma = y1
        ELSE
            sigma = (a3*x**3 + a2*x**2 + a1*x + a0)*(y1-y0) + y0
        ENDIF 

        ! Add RoutineName to error message
        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
        ENDIF
        
    END FUNCTION sigma


!-------------------------------------------------------------------------------------------------------------------------------
    FUNCTION unwrap(x, ErrVar) result(y)
    ! Unwrap function
    ! If difference between signal elements is < -pi, add 2 pi to reset of signal, and the opposite
    ! Someday, generalize period and check difference is less than period/2
        USE ROSCO_Types, ONLY : ErrorVariables
        IMPLICIT NONE
    
        ! Inputs
        TYPE(ErrorVariables), INTENT(INOUT) :: ErrVar
        REAL(DbKi), DIMENSION(:), Intent(IN)  :: x

        ! Output
        REAL(DbKi), DIMENSION(SIZE(x)) :: y
            
        ! Local
        INTEGER(IntKi) :: i

        CHARACTER(*), PARAMETER                 :: RoutineName = 'unwrap'

        y = x ! set initial
        DO i = 2, SIZE(x)
            DO while (y(i) - y(i-1) .LE. -PI)
                y(i:SIZE(x)) = y(i:SIZE(x)) + 2 * PI
            END DO

            DO while (y(i) - y(i-1) .GE. PI)
                y(i:SIZE(x)) = y(i:SIZE(x)) - 2 * PI
            END DO
        END DO

        ! Add RoutineName to error message
        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
        ENDIF

        ! Debug
        ! write(400,*) x
        ! write(401,*) y
        
    END FUNCTION unwrap


!-------------------------------------------------------------------------------------------------------------------------------
END MODULE Functions

!**********************************************************************************************************************************
! LICENSING
! Copyright (C) 2021  National Renewable Energy Laboratory
!
!    This file is part of ROSCO.
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.
!**********************************************************************************************************************************
MODULE SysSubs

    USE ROSCO_Types
    USE Constants
    USE, INTRINSIC :: ISO_C_Binding


    IMPLICIT NONE





! This module contains routines with system-specific logic and references, including all references to the console unit, CU.
! It also contains standard (but not system-specific) routines it uses.
! SysGnuLinux.f90 is specifically for the GNU Fortran (gfortran) compiler on Linux and macOS.

    INTEGER, PARAMETER            :: ConRecL     = 120                               ! The record length for console output.
    INTEGER, PARAMETER            :: CU          = 6                                 ! The I/O unit for the console.  Unit 6 causes ADAMS to crash.
    INTEGER, PARAMETER            :: MaxWrScrLen = 98                                ! The maximum number of characters allowed to be written to a line in WrScr
    LOGICAL, PARAMETER            :: KBInputOK   = .TRUE.                            ! A flag to tell the program that keyboard input is allowed in the environment.
    CHARACTER(*),  PARAMETER      :: NewLine     = ACHAR(10)                         ! The delimiter for New Lines [ Windows is CHAR(13)//CHAR(10); MAC is CHAR(13); Unix is CHAR(10) {CHAR(13)=\r is a line feed, CHAR(10)=\n is a new line}]
    CHARACTER(*),  PARAMETER      :: OS_Desc     = 'LLVM Fortran for Windows'         ! Description of the language/OS
    CHARACTER( 1), PARAMETER      :: PathSep     = '\'                               ! The path separator.
    CHARACTER( 1), PARAMETER      :: SwChar      = '/'                               ! The switch character for command-line options.
    CHARACTER(11), PARAMETER      :: UnfForm     = 'UNFORMATTED'                     ! The string to specify unformatted I/O files.
 

    CONTAINS
!=======================================================================
    SUBROUTINE LoadDynamicLib ( DLL, ErrStat, ErrMsg )

        ! This SUBROUTINE is used to dynamically load a DLL.
     
        TYPE (ExtDLL_Type),           INTENT(INOUT)  :: DLL         ! The DLL to be loaded.
        INTEGER(IntKi),            INTENT(  OUT)  :: ErrStat     ! Error status of the operation
        CHARACTER(*),              INTENT(  OUT)  :: ErrMsg      ! Error message if ErrStat /= ErrID_None
     
        INTERFACE  ! Definitions of Windows API routines
     
           !...........................
           !bjj: I have been unable to find a solution that works with both IVF and gfortran...
           !bjj: note that "Intel Fortran does not support use of STDCALL with BIND(C) at this time"
           !     See this link: http://software.intel.com/en-us/articles/replacing-intel-fortran-attributes-with-c-interoperability-features
           !bjj: Until this is fixed, Intel uses kernel32.f90 definitions instead of the interface below:
           !...........................
     
           FUNCTION LoadLibrary(lpFileName) BIND(C,NAME='LoadLibraryA')
              USE, INTRINSIC :: ISO_C_BINDING
              IMPLICIT NONE
              !GCC$ ATTRIBUTES STDCALL :: LoadLibrary
              INTEGER(C_INTPTR_T)        :: LoadLibrary
              CHARACTER(KIND=C_CHAR)     :: lpFileName(*)
           END FUNCTION LoadLibrary
     
        END INTERFACE
     
        ErrStat = ErrID_None
        ErrMsg = ''
     
        ! Load the DLL and get the file address:
        DLL%FileAddr = LoadLibrary( TRIM(DLL%FileName)//C_NULL_CHAR )  !the "C_NULL_CHAR" converts the Fortran string to a C-type string (i.e., adds //CHAR(0) to the end)
        IF ( DLL%FileAddr == INT(0,C_INTPTR_T) ) THEN
           ErrStat = ErrID_Fatal
         !   WRITE(ErrMsg,'(I2)') BITS_IN_ADDR
           ErrMsg  = 'The dynamic library '//TRIM(DLL%FileName)//' could not be loaded. Check that the file '// &
                    'exists in the specified location and that it is compiled for '//TRIM(ErrMsg)//'-bit applications.'
           RETURN
        END IF
     
        ! Get the procedure address:
        CALL LoadDynamicLibProc ( DLL, ErrStat, ErrMsg )
     
        RETURN
     END SUBROUTINE LoadDynamicLib
     !=======================================================================
     SUBROUTINE LoadDynamicLibProc ( DLL, ErrStat, ErrMsg )
     
        ! This SUBROUTINE is used to dynamically load a procedure in a DLL.
     
        TYPE (ExtDLL_Type),           INTENT(INOUT)  :: DLL         ! The DLL to be loaded.
        INTEGER(IntKi),            INTENT(  OUT)  :: ErrStat     ! Error status of the operation
        CHARACTER(*),              INTENT(  OUT)  :: ErrMsg      ! Error message if ErrStat /= ErrID_None
        INTEGER(IntKi)                            :: i
     
        INTERFACE  ! Definitions of Windows API routines
     
           !...........................
           !bjj: I have been unable to find a solution that works with both IVF and gfortran...
           !bjj: note that "Intel Fortran does not support use of STDCALL with BIND(C) at this time"
           !     See this link: http://software.intel.com/en-us/articles/replacing-intel-fortran-attributes-with-c-interoperability-features
           !bjj: Until this is fixed, Intel uses kernel32.f90 definitions instead of the interface below:
           !...........................
     
           FUNCTION GetProcAddress(hModule, lpProcName) BIND(C, NAME='GetProcAddress')
              USE, INTRINSIC :: ISO_C_BINDING
              IMPLICIT NONE
              !GCC$ ATTRIBUTES STDCALL :: GetProcAddress
              TYPE(C_FUNPTR)             :: GetProcAddress
              INTEGER(C_INTPTR_T),VALUE  :: hModule
              CHARACTER(KIND=C_CHAR)     :: lpProcName(*)
           END FUNCTION GetProcAddress
     
        END INTERFACE
     
        ErrStat = ErrID_None
        ErrMsg = ''

         ! Initialize ProcAddr
        DLL%ProcAddr = C_NULL_FUNPTR
     
        ! Get the procedure addresses:
        do i=1,NWTC_MAX_DLL_PROC
           if ( len_trim( DLL%ProcName(i) ) > 0 ) then
              DLL%ProcAddr(i) = GetProcAddress( DLL%FileAddr, TRIM(DLL%ProcName(i))//C_NULL_CHAR )  !the "C_NULL_CHAR" converts the Fortran string to a C-type string (i.e., adds //CHAR(0) to the end)
              IF(.NOT. C_ASSOCIATED(DLL%ProcAddr(i))) THEN
                 ErrStat = ErrID_Fatal + i - 1
                 ErrMsg  = 'The procedure '//TRIM(DLL%ProcName(i))//' in file '//TRIM(DLL%FileName)//' could not be loaded.'
                 RETURN
              END IF
           end if
        end do
     
        RETURN
     END SUBROUTINE LoadDynamicLibProc
     !=======================================================================
     SUBROUTINE FreeDynamicLib ( DLL, ErrStat, ErrMsg )
     
        ! This SUBROUTINE is used to free a dynamically loaded DLL (loaded in LoadDynamicLib).
     
        TYPE (ExtDLL_Type),           INTENT(INOUT)  :: DLL         ! The DLL to be freed.
        INTEGER(IntKi),            INTENT(  OUT)  :: ErrStat     ! Error status of the operation
        CHARACTER(*),              INTENT(  OUT)  :: ErrMsg      ! Error message if ErrStat /= ErrID_None
     
        ! Local variable:
        INTEGER(C_INT)                            :: Success     ! Whether or not the call to FreeLibrary was successful
        INTEGER(C_INT), PARAMETER                 :: FALSE  = 0
     
        INTERFACE  ! Definitions of Windows API routines
     
           FUNCTION FreeLibrary(hLibModule) BIND(C, NAME='FreeLibrary')
              USE, INTRINSIC :: ISO_C_BINDING
              IMPLICIT NONE
              !GCC$ ATTRIBUTES STDCALL :: FreeLibrary
              INTEGER(C_INT)             :: FreeLibrary ! BOOL
              INTEGER(C_INTPTR_T),VALUE  :: hLibModule ! HMODULE hLibModule
           END FUNCTION
     
        END INTERFACE
     
        ! Free the DLL:
        IF ( DLL%FileAddr == INT(0,C_INTPTR_T) ) RETURN
     
        Success = FreeLibrary( DLL%FileAddr ) !If the function succeeds, the return value is nonzero. If the function fails, the return value is zero.
     
        IF ( Success == FALSE ) THEN !BJJ: note that this isn't the same as the Fortran LOGICAL .FALSE.
           ErrStat = ErrID_Fatal
           ErrMsg  = 'The dynamic library could not be freed.'
           RETURN
        ELSE
           ErrStat = ErrID_None
           ErrMsg = ''
           DLL%FileAddr = INT(0,C_INTPTR_T)
        END IF
     
        RETURN
     END SUBROUTINE FreeDynamicLib
     !=======================================================================

END MODULE SysSubs

! ROSCO IO
! This file is automatically generated by write_registry.py using ROSCO v2.10.1
! For any modification to the registry, please edit the rosco_types.yaml accordingly
 
MODULE ROSCO_IO
    USE, INTRINSIC :: ISO_C_Binding
    USE ROSCO_Types
    USE ReadSetParameters
    USE Constants
IMPLICIT NONE

CONTAINS

SUBROUTINE WriteRestartFile(LocalVar, CntrPar, ErrVar, objInst, RootName, size_avcOUTNAME)
    TYPE(LocalVariables), INTENT(IN)                :: LocalVar
    TYPE(ControlParameters), INTENT(INOUT)          :: CntrPar
    TYPE(ObjectInstances), INTENT(INOUT)            :: objInst
    TYPE(ErrorVariables), INTENT(INOUT)             :: ErrVar
    INTEGER(IntKi), INTENT(IN)                      :: size_avcOUTNAME
    CHARACTER(size_avcOUTNAME), INTENT(IN)        :: RootName 
    
    INTEGER(IntKi)               :: Un                  ! I/O unit for pack/unpack (checkpoint & restart)
    INTEGER(IntKi)               :: I                   ! Generic index.
    CHARACTER(128)               :: InFile              ! Input checkpoint file
    INTEGER(IntKi)               :: ErrStat
    CHARACTER(128)               :: ErrMsg              
    CHARACTER(128)               :: n_t_global          ! timestep number as a string

    WRITE(n_t_global, '(I0.0)' ) NINT(LocalVar%Time/LocalVar%DT)
    InFile = TRIM(RootName)//TRIM( n_t_global )//'.RO.chkp'
    CALL GetNewUnit(Un, ErrVar)
    OPEN(unit=Un, FILE=TRIM(InFile), STATUS='UNKNOWN', FORM='UNFORMATTED' , ACCESS='STREAM', IOSTAT=ErrStat, ACTION='WRITE' )

    IF ( ErrStat /= 0 ) THEN
        ErrVar%aviFAIL = 1
        ErrVar%ErrMsg  = 'ROSCO_IO: Cannot open checkpoint file '//TRIM(InFile)//' for writing'

    ELSE
        WRITE( Un, IOSTAT=ErrStat) LocalVar%iStatus
        WRITE( Un, IOSTAT=ErrStat) LocalVar%AlreadyInitialized
        WRITE( Un, IOSTAT=ErrStat) LocalVar%RestartWSE
        WRITE( Un, IOSTAT=ErrStat) LocalVar%Time
        WRITE( Un, IOSTAT=ErrStat) LocalVar%DT
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WriteThisStep
        WRITE( Un, IOSTAT=ErrStat) LocalVar%n_DT
        WRITE( Un, IOSTAT=ErrStat) LocalVar%Time_Last
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_GenPwr
        WRITE( Un, IOSTAT=ErrStat) LocalVar%GenSpeed
        WRITE( Un, IOSTAT=ErrStat) LocalVar%RotSpeed
        WRITE( Un, IOSTAT=ErrStat) LocalVar%NacHeading
        WRITE( Un, IOSTAT=ErrStat) LocalVar%NacVane
        WRITE( Un, IOSTAT=ErrStat) LocalVar%NacVaneF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WindDir
        WRITE( Un, IOSTAT=ErrStat) LocalVar%HorWindV
        WRITE( Un, IOSTAT=ErrStat) LocalVar%HorWindV_F
        WRITE( Un, IOSTAT=ErrStat) LocalVar%rootMOOP(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%rootMOOP(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%rootMOOP(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%rootMOOPF(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%rootMOOPF(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%rootMOOPF(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%BlPitch(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%BlPitch(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%BlPitch(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%BlPitchCMeas
        WRITE( Un, IOSTAT=ErrStat) LocalVar%Azimuth
        WRITE( Un, IOSTAT=ErrStat) LocalVar%OL_Azimuth
        WRITE( Un, IOSTAT=ErrStat) LocalVar%AzUnwrapped
        WRITE( Un, IOSTAT=ErrStat) LocalVar%AzError
        WRITE( Un, IOSTAT=ErrStat) LocalVar%GenTqAz
        WRITE( Un, IOSTAT=ErrStat) LocalVar%AzBuffer(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%AzBuffer(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%NumBl
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_Acc_TT
        WRITE( Un, IOSTAT=ErrStat) LocalVar%SS_Acc_TT
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_Acc_Nac
        WRITE( Un, IOSTAT=ErrStat) LocalVar%NacIMU_FA_RAcc
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_AccHPF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_AccHPFI
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_PitCom(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_PitCom(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_PitCom(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpd
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpd_TSR
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpd_TRA
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpd_RL
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_RefSpd
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_RefSpd_SS
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_RefSpd_PRC
        WRITE( Un, IOSTAT=ErrStat) LocalVar%RotSpeedF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%GenSpeedF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%GenTq
        WRITE( Un, IOSTAT=ErrStat) LocalVar%GenTqMeas
        WRITE( Un, IOSTAT=ErrStat) LocalVar%GenArTq
        WRITE( Un, IOSTAT=ErrStat) LocalVar%GenBrTq
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_KOmega2_GenTq
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_ConstPwr_GenTq
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_PitComF(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_PitComF(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_PitComF(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_KP
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_KI
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_KD
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_TF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_MaxPit
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_MinPit
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT_Last
        WRITE( Un, IOSTAT=ErrStat) LocalVar%BlPitchCMeasF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT_IPC(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT_IPC(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT_IPC(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_PwrErr
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_SpdErr
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_AxisTilt_1P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_AxisYaw_1P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_AxisTilt_2P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_AxisYaw_2P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%axisTilt_1P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%axisYaw_1P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%axisYawF_1P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%axisTilt_2P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%axisYaw_2P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%axisYawF_2P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_KI(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_KI(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_KP(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_KP(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_IntSat
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_State
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PitCom(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PitCom(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PitCom(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PitCom_SD(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PitCom_SD(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PitCom_SD(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PitComAct(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PitComAct(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PitComAct(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%SS_DelOmegaF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%TestType
        WRITE( Un, IOSTAT=ErrStat) LocalVar%Kp_Float
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_MaxTq
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_LastGenTrq
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_LastGenPwr
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_MechGenPwr
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_SpdErrAr
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_SpdErrBr
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_SpdErr
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_State
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_Rgn3Pitch
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE_Vw
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE_Vw_F
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE_VwI
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE_VwIdot
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE_Op
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE_Op_Last
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_LastGenTrqF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PRC_WSE_F
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PRC_R_Speed
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PRC_R_Torque
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PRC_R_Pitch
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PRC_R_Total
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PRC_Min_Pitch
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PS_Min_Pitch
        WRITE( Un, IOSTAT=ErrStat) LocalVar%OL_Index
        WRITE( Un, IOSTAT=ErrStat) LocalVar%SU_Stage
        WRITE( Un, IOSTAT=ErrStat) LocalVar%SU_LoadStageStartTime
        WRITE( Un, IOSTAT=ErrStat) LocalVar%SU_RotSpeedF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%SD_Trigger
        WRITE( Un, IOSTAT=ErrStat) LocalVar%SD_BlPitchF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%SD_NacVaneF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%SD_GenSpeedF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%SD_Stage
        WRITE( Un, IOSTAT=ErrStat) LocalVar%SD_StageStartTime
        WRITE( Un, IOSTAT=ErrStat) LocalVar%SD_MaxPitchRate
        WRITE( Un, IOSTAT=ErrStat) LocalVar%SD_MaxTorqueRate
        WRITE( Un, IOSTAT=ErrStat) LocalVar%GenTq_SD
        WRITE( Un, IOSTAT=ErrStat) LocalVar%Fl_PitCom
        WRITE( Un, IOSTAT=ErrStat) LocalVar%NACIMU_FA_AccF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_AccF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_Hist
        WRITE( Un, IOSTAT=ErrStat) LocalVar%TRA_LastRefSpd
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpeed
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTDX
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTDY
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTDZ
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRDX
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRDY
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRDZ
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTVX
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTVY
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTVZ
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRVX
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRVY
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRVZ
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTAX
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTAY
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTAZ
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRAX
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRAY
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRAZ
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(4)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(5)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(6)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(7)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(8)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(9)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(10)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(11)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(12)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(4)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(5)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(6)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(7)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(8)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(9)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(10)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(11)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(12)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(4)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(5)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(6)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(7)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(8)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(9)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(10)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(11)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(12)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(4)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(5)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(6)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(7)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(8)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(9)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(10)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(11)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(12)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%Flp_Angle(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%Flp_Angle(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%Flp_Angle(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%RootMyb_Last(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%RootMyb_Last(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%RootMyb_Last(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ACC_INFILE_SIZE
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ACC_INFILE
        WRITE( Un, IOSTAT=ErrStat) LocalVar%restart
        WRITE( Un, IOSTAT=ErrStat) LocalVar%AWC_complexangle(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%AWC_complexangle(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%AWC_complexangle(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%TiltMean
        WRITE( Un, IOSTAT=ErrStat) LocalVar%YawMean
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ZMQ_ID
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ZMQ_YawOffset
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ZMQ_TorqueOffset
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ZMQ_PitOffset(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ZMQ_PitOffset(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ZMQ_PitOffset(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ZMQ_R_Speed
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ZMQ_R_Torque
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ZMQ_R_Pitch
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE%om_r
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE%v_t
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE%v_m
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE%v_h
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE%P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE%xh
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE%K
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_a1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_a0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_b1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_b0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_InputSignalLast
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_OutputSignalLast
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_a2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_a1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_a0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_b2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_b1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_b0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_InputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_OutputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_InputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_OutputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_a2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_a1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_a0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_b2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_b1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_b0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_InputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_OutputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_InputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_OutputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%hpf_InputSignalLast
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%hpf_OutputSignalLast
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_OutputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_OutputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_InputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_InputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_b2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_b0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_a2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_a1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_a0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_OutputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_OutputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_InputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_InputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_b2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_b1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_b0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_a1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_a0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%piP%ITerm
        WRITE( Un, IOSTAT=ErrStat) LocalVar%piP%ITermLast
        WRITE( Un, IOSTAT=ErrStat) LocalVar%piP%ITerm2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%piP%ITermLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%piP%ELast
        WRITE( Un, IOSTAT=ErrStat) LocalVar%resP%res_OutputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%resP%res_OutputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%resP%res_InputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%resP%res_InputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%rlP%LastSignal
        WRITE( Un, IOSTAT=ErrStat) objInst%instLPF
        WRITE( Un, IOSTAT=ErrStat) objInst%instSecLPF
        WRITE( Un, IOSTAT=ErrStat) objInst%instSecLPFV
        WRITE( Un, IOSTAT=ErrStat) objInst%instHPF
        WRITE( Un, IOSTAT=ErrStat) objInst%instNotchSlopes
        WRITE( Un, IOSTAT=ErrStat) objInst%instNotch
        WRITE( Un, IOSTAT=ErrStat) objInst%instPI
        WRITE( Un, IOSTAT=ErrStat) objInst%instRes
        WRITE( Un, IOSTAT=ErrStat) objInst%instRL
        Close ( Un )
        IF ( ErrStat /= 0 ) THEN
            ErrVar%aviFAIL = 1
            ErrVar%ErrMsg  = 'ROSCO_IO: Error writing checkpoint file.'
        ENDIF
    ENDIF
END SUBROUTINE WriteRestartFile

 
SUBROUTINE ReadRestartFile(avrSWAP, LocalVar, CntrPar, objInst, PerfData, RootName, size_avcOUTNAME, ErrVar)
    TYPE(LocalVariables), INTENT(INOUT)             :: LocalVar
    TYPE(ControlParameters), INTENT(INOUT)          :: CntrPar
    TYPE(ObjectInstances), INTENT(INOUT)            :: objInst
    TYPE(PerformanceData), INTENT(INOUT)            :: PerfData
    TYPE(ErrorVariables), INTENT(INOUT)             :: ErrVar
    REAL(ReKi), INTENT(IN)                          :: avrSWAP(*)
    INTEGER(IntKi), INTENT(IN)                      :: size_avcOUTNAME
    CHARACTER(size_avcOUTNAME), INTENT(IN)        :: RootName 
    
    INTEGER(IntKi)               :: Un                  ! I/O unit for pack/unpack (checkpoint & restart)
    INTEGER(IntKi)               :: I                   ! Generic index.
    CHARACTER(128)               :: InFile              ! Input checkpoint file
    INTEGER(IntKi)               :: ErrStat
    CHARACTER(128)               :: ErrMsg              
    CHARACTER(128)               :: n_t_global          ! timestep number as a string

    WRITE(n_t_global, '(I0.0)' ) NINT(avrSWAP(2)/avrSWAP(3))
    InFile = TRIM(RootName)//TRIM( n_t_global )//'.RO.chkp'
    CALL GetNewUnit(Un, ErrVar)
    OPEN(unit=Un, FILE=TRIM(InFile), STATUS='UNKNOWN', FORM='UNFORMATTED' , ACCESS='STREAM', IOSTAT=ErrStat, ACTION='READ' )

    IF ( ErrStat /= 0 ) THEN
        ErrVar%aviFAIL = 1
        ErrVar%ErrMsg  = 'ROSCO_IO: Cannot open checkpoint file '//TRIM(InFile)//' for reading'

    ELSE
        READ( Un, IOSTAT=ErrStat) LocalVar%iStatus
        READ( Un, IOSTAT=ErrStat) LocalVar%AlreadyInitialized
        READ( Un, IOSTAT=ErrStat) LocalVar%RestartWSE
        READ( Un, IOSTAT=ErrStat) LocalVar%Time
        READ( Un, IOSTAT=ErrStat) LocalVar%DT
        READ( Un, IOSTAT=ErrStat) LocalVar%WriteThisStep
        READ( Un, IOSTAT=ErrStat) LocalVar%n_DT
        READ( Un, IOSTAT=ErrStat) LocalVar%Time_Last
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_GenPwr
        READ( Un, IOSTAT=ErrStat) LocalVar%GenSpeed
        READ( Un, IOSTAT=ErrStat) LocalVar%RotSpeed
        READ( Un, IOSTAT=ErrStat) LocalVar%NacHeading
        READ( Un, IOSTAT=ErrStat) LocalVar%NacVane
        READ( Un, IOSTAT=ErrStat) LocalVar%NacVaneF
        READ( Un, IOSTAT=ErrStat) LocalVar%WindDir
        READ( Un, IOSTAT=ErrStat) LocalVar%HorWindV
        READ( Un, IOSTAT=ErrStat) LocalVar%HorWindV_F
        READ( Un, IOSTAT=ErrStat) LocalVar%rootMOOP(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%rootMOOP(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%rootMOOP(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%rootMOOPF(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%rootMOOPF(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%rootMOOPF(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%BlPitch(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%BlPitch(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%BlPitch(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%BlPitchCMeas
        READ( Un, IOSTAT=ErrStat) LocalVar%Azimuth
        READ( Un, IOSTAT=ErrStat) LocalVar%OL_Azimuth
        READ( Un, IOSTAT=ErrStat) LocalVar%AzUnwrapped
        READ( Un, IOSTAT=ErrStat) LocalVar%AzError
        READ( Un, IOSTAT=ErrStat) LocalVar%GenTqAz
        READ( Un, IOSTAT=ErrStat) LocalVar%AzBuffer(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%AzBuffer(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%NumBl
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_Acc_TT
        READ( Un, IOSTAT=ErrStat) LocalVar%SS_Acc_TT
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_Acc_Nac
        READ( Un, IOSTAT=ErrStat) LocalVar%NacIMU_FA_RAcc
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_AccHPF
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_AccHPFI
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_PitCom(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_PitCom(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_PitCom(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpd
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpd_TSR
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpd_TRA
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpd_RL
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_RefSpd
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_RefSpd_SS
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_RefSpd_PRC
        READ( Un, IOSTAT=ErrStat) LocalVar%RotSpeedF
        READ( Un, IOSTAT=ErrStat) LocalVar%GenSpeedF
        READ( Un, IOSTAT=ErrStat) LocalVar%GenTq
        READ( Un, IOSTAT=ErrStat) LocalVar%GenTqMeas
        READ( Un, IOSTAT=ErrStat) LocalVar%GenArTq
        READ( Un, IOSTAT=ErrStat) LocalVar%GenBrTq
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_KOmega2_GenTq
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_ConstPwr_GenTq
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_PitComF(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_PitComF(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_PitComF(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_KP
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_KI
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_KD
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_TF
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_MaxPit
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_MinPit
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT_Last
        READ( Un, IOSTAT=ErrStat) LocalVar%BlPitchCMeasF
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT_IPC(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT_IPC(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT_IPC(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_PwrErr
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_SpdErr
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_AxisTilt_1P
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_AxisYaw_1P
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_AxisTilt_2P
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_AxisYaw_2P
        READ( Un, IOSTAT=ErrStat) LocalVar%axisTilt_1P
        READ( Un, IOSTAT=ErrStat) LocalVar%axisYaw_1P
        READ( Un, IOSTAT=ErrStat) LocalVar%axisYawF_1P
        READ( Un, IOSTAT=ErrStat) LocalVar%axisTilt_2P
        READ( Un, IOSTAT=ErrStat) LocalVar%axisYaw_2P
        READ( Un, IOSTAT=ErrStat) LocalVar%axisYawF_2P
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_KI(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_KI(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_KP(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_KP(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_IntSat
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_State
        READ( Un, IOSTAT=ErrStat) LocalVar%PitCom(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%PitCom(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%PitCom(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%PitCom_SD(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%PitCom_SD(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%PitCom_SD(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%PitComAct(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%PitComAct(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%PitComAct(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%SS_DelOmegaF
        READ( Un, IOSTAT=ErrStat) LocalVar%TestType
        READ( Un, IOSTAT=ErrStat) LocalVar%Kp_Float
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_MaxTq
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_LastGenTrq
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_LastGenPwr
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_MechGenPwr
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_SpdErrAr
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_SpdErrBr
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_SpdErr
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_State
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_Rgn3Pitch
        READ( Un, IOSTAT=ErrStat) LocalVar%WE_Vw
        READ( Un, IOSTAT=ErrStat) LocalVar%WE_Vw_F
        READ( Un, IOSTAT=ErrStat) LocalVar%WE_VwI
        READ( Un, IOSTAT=ErrStat) LocalVar%WE_VwIdot
        READ( Un, IOSTAT=ErrStat) LocalVar%WE_Op
        READ( Un, IOSTAT=ErrStat) LocalVar%WE_Op_Last
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_LastGenTrqF
        READ( Un, IOSTAT=ErrStat) LocalVar%PRC_WSE_F
        READ( Un, IOSTAT=ErrStat) LocalVar%PRC_R_Speed
        READ( Un, IOSTAT=ErrStat) LocalVar%PRC_R_Torque
        READ( Un, IOSTAT=ErrStat) LocalVar%PRC_R_Pitch
        READ( Un, IOSTAT=ErrStat) LocalVar%PRC_R_Total
        READ( Un, IOSTAT=ErrStat) LocalVar%PRC_Min_Pitch
        READ( Un, IOSTAT=ErrStat) LocalVar%PS_Min_Pitch
        READ( Un, IOSTAT=ErrStat) LocalVar%OL_Index
        READ( Un, IOSTAT=ErrStat) LocalVar%SU_Stage
        READ( Un, IOSTAT=ErrStat) LocalVar%SU_LoadStageStartTime
        READ( Un, IOSTAT=ErrStat) LocalVar%SU_RotSpeedF
        READ( Un, IOSTAT=ErrStat) LocalVar%SD_Trigger
        READ( Un, IOSTAT=ErrStat) LocalVar%SD_BlPitchF
        READ( Un, IOSTAT=ErrStat) LocalVar%SD_NacVaneF
        READ( Un, IOSTAT=ErrStat) LocalVar%SD_GenSpeedF
        READ( Un, IOSTAT=ErrStat) LocalVar%SD_Stage
        READ( Un, IOSTAT=ErrStat) LocalVar%SD_StageStartTime
        READ( Un, IOSTAT=ErrStat) LocalVar%SD_MaxPitchRate
        READ( Un, IOSTAT=ErrStat) LocalVar%SD_MaxTorqueRate
        READ( Un, IOSTAT=ErrStat) LocalVar%GenTq_SD
        READ( Un, IOSTAT=ErrStat) LocalVar%Fl_PitCom
        READ( Un, IOSTAT=ErrStat) LocalVar%NACIMU_FA_AccF
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_AccF
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_Hist
        READ( Un, IOSTAT=ErrStat) LocalVar%TRA_LastRefSpd
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpeed
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTDX
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTDY
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTDZ
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRDX
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRDY
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRDZ
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTVX
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTVY
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTVZ
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRVX
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRVY
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRVZ
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTAX
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTAY
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTAZ
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRAX
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRAY
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRAZ
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(4)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(5)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(6)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(7)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(8)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(9)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(10)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(11)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(12)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(4)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(5)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(6)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(7)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(8)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(9)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(10)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(11)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(12)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(4)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(5)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(6)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(7)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(8)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(9)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(10)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(11)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(12)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(4)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(5)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(6)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(7)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(8)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(9)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(10)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(11)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(12)
        READ( Un, IOSTAT=ErrStat) LocalVar%Flp_Angle(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%Flp_Angle(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%Flp_Angle(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%RootMyb_Last(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%RootMyb_Last(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%RootMyb_Last(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%ACC_INFILE_SIZE
        ALLOCATE(LocalVar%ACC_INFILE(LocalVar%ACC_INFILE_SIZE))
        READ( Un, IOSTAT=ErrStat) LocalVar%ACC_INFILE
        READ( Un, IOSTAT=ErrStat) LocalVar%restart
        READ( Un, IOSTAT=ErrStat) LocalVar%AWC_complexangle(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%AWC_complexangle(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%AWC_complexangle(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%TiltMean
        READ( Un, IOSTAT=ErrStat) LocalVar%YawMean
        READ( Un, IOSTAT=ErrStat) LocalVar%ZMQ_ID
        READ( Un, IOSTAT=ErrStat) LocalVar%ZMQ_YawOffset
        READ( Un, IOSTAT=ErrStat) LocalVar%ZMQ_TorqueOffset
        READ( Un, IOSTAT=ErrStat) LocalVar%ZMQ_PitOffset(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%ZMQ_PitOffset(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%ZMQ_PitOffset(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%ZMQ_R_Speed
        READ( Un, IOSTAT=ErrStat) LocalVar%ZMQ_R_Torque
        READ( Un, IOSTAT=ErrStat) LocalVar%ZMQ_R_Pitch
        READ( Un, IOSTAT=ErrStat) LocalVar%WE%om_r
        READ( Un, IOSTAT=ErrStat) LocalVar%WE%v_t
        READ( Un, IOSTAT=ErrStat) LocalVar%WE%v_m
        READ( Un, IOSTAT=ErrStat) LocalVar%WE%v_h
        READ( Un, IOSTAT=ErrStat) LocalVar%WE%P
        READ( Un, IOSTAT=ErrStat) LocalVar%WE%xh
        READ( Un, IOSTAT=ErrStat) LocalVar%WE%K
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_a1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_a0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_b1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_b0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_InputSignalLast
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_OutputSignalLast
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_a2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_a1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_a0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_b2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_b1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_b0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_InputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_OutputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_InputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_OutputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_a2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_a1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_a0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_b2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_b1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_b0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_InputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_OutputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_InputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_OutputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%hpf_InputSignalLast
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%hpf_OutputSignalLast
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_OutputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_OutputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_InputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_InputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_b2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_b0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_a2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_a1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_a0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_OutputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_OutputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_InputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_InputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_b2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_b1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_b0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_a1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_a0
        READ( Un, IOSTAT=ErrStat) LocalVar%piP%ITerm
        READ( Un, IOSTAT=ErrStat) LocalVar%piP%ITermLast
        READ( Un, IOSTAT=ErrStat) LocalVar%piP%ITerm2
        READ( Un, IOSTAT=ErrStat) LocalVar%piP%ITermLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%piP%ELast
        READ( Un, IOSTAT=ErrStat) LocalVar%resP%res_OutputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%resP%res_OutputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%resP%res_InputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%resP%res_InputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%rlP%LastSignal
        READ( Un, IOSTAT=ErrStat) objInst%instLPF
        READ( Un, IOSTAT=ErrStat) objInst%instSecLPF
        READ( Un, IOSTAT=ErrStat) objInst%instSecLPFV
        READ( Un, IOSTAT=ErrStat) objInst%instHPF
        READ( Un, IOSTAT=ErrStat) objInst%instNotchSlopes
        READ( Un, IOSTAT=ErrStat) objInst%instNotch
        READ( Un, IOSTAT=ErrStat) objInst%instPI
        READ( Un, IOSTAT=ErrStat) objInst%instRes
        READ( Un, IOSTAT=ErrStat) objInst%instRL
        Close ( Un )
        IF ( ErrStat /= 0 ) THEN
            ErrVar%aviFAIL = 1
            ErrVar%ErrMsg  = 'ROSCO_IO: Error reading checkpoint file.'
        ENDIF
    ENDIF
    ! Read Parameter files
    CALL ReadControlParameterFileSub(CntrPar, LocalVar, LocalVar%ACC_INFILE, LocalVar%ACC_INFILE_SIZE, RootName, ErrVar)
    IF (CntrPar%WE_Mode > 0) THEN
        CALL READCpFile(CntrPar, PerfData, ErrVar)
    ENDIF
END SUBROUTINE ReadRestartFile

 
SUBROUTINE Debug(LocalVar, CntrPar, DebugVar, ErrVar, avrSWAP, RootName, size_avcOUTNAME)
! Debug routine, defines what gets printed to DEBUG.dbg if LoggingLevel = 1

    TYPE(ControlParameters), INTENT(IN) :: CntrPar
    TYPE(LocalVariables), INTENT(IN) :: LocalVar
    TYPE(DebugVariables), INTENT(IN) :: DebugVar
    TYPE(ErrorVariables),       INTENT(INOUT)   :: ErrVar

    INTEGER(IntKi), INTENT(IN)      :: size_avcOUTNAME
    INTEGER(IntKi)                  :: I , nDebugOuts, nLocalVars   ! Generic index.
    CHARACTER(1), PARAMETER         :: Tab = CHAR(9)                ! The tab character.
    CHARACTER(100)                  :: FmtDat                       ! The format of the debugging data
    INTEGER(IntKi), SAVE            :: UnDb                         ! I/O unit for the debugging information
    INTEGER(IntKi), SAVE            :: UnDb2                        ! I/O unit for the debugging information, avrSWAP
    INTEGER(IntKi), SAVE            :: UnDb3                        ! I/O unit for the debugging information, avrSWAP
    REAL(ReKi), INTENT(INOUT)       :: avrSWAP(*)                   ! The swap array, used to pass data to, and receive data from, the DLL controller.
    CHARACTER(size_avcOUTNAME), INTENT(IN) :: RootName            ! a Fortran version of the input C string (not considered an array here)    [subtract 1 for the C null-character]
    CHARACTER(200)                  :: Version                      ! git version of ROSCO
    CHARACTER(15), ALLOCATABLE      :: DebugOutStrings(:), DebugOutUnits(:)

    ! Avr output writing
    INTEGER(IntKi), SAVE, DIMENSION(:), ALLOCATABLE     :: avrIndices
    INTEGER(IntKi)                  :: avrBaseLength = 85
    INTEGER(IntKi)                  :: Ind
    CHARACTER(100)                  :: avrFmt

    REAL(DbKi), ALLOCATABLE         :: DebugOutData(:)
 
    CHARACTER(15), DIMENSION(159)      :: LocalVarOutStrings
    REAL(DbKi), ALLOCATABLE         :: LocalVarOutData(:)
 
    nDebugOuts = 26
    Allocate(DebugOutData(nDebugOuts))
    Allocate(DebugOutStrings(nDebugOuts))
    Allocate(DebugOutUnits(nDebugOuts))
    DebugOutData(1) = DebugVar%WE_Cp
    DebugOutData(2) = DebugVar%WE_b
    DebugOutData(3) = DebugVar%WE_w
    DebugOutData(4) = DebugVar%WE_t
    DebugOutData(5) = DebugVar%WE_Vm
    DebugOutData(6) = DebugVar%WE_Vt
    DebugOutData(7) = DebugVar%WE_Vw
    DebugOutData(8) = DebugVar%WE_lambda
    DebugOutData(9) = DebugVar%PC_PICommand
    DebugOutData(10) = DebugVar%GenSpeedF
    DebugOutData(11) = DebugVar%RotSpeedF
    DebugOutData(12) = DebugVar%NacIMU_FA_AccF
    DebugOutData(13) = DebugVar%FA_AccF
    DebugOutData(14) = DebugVar%Fl_PitCom
    DebugOutData(15) = DebugVar%PC_MinPit
    DebugOutData(16) = DebugVar%axisTilt_1P
    DebugOutData(17) = DebugVar%axisYaw_1P
    DebugOutData(18) = DebugVar%axisTilt_2P
    DebugOutData(19) = DebugVar%axisYaw_2P
    DebugOutData(20) = DebugVar%YawRateCom
    DebugOutData(21) = DebugVar%NacHeadingTarget
    DebugOutData(22) = DebugVar%NacVaneOffset
    DebugOutData(23) = DebugVar%Yaw_Err
    DebugOutData(24) = DebugVar%YawState
    DebugOutData(25) = DebugVar%VS_RefSpd
    DebugOutData(26) = DebugVar%PC_RefSpd
    DebugOutStrings = [CHARACTER(15) ::  'WE_Cp', 'WE_b', 'WE_w', 'WE_t', 'WE_Vm', & 
                                      'WE_Vt', 'WE_Vw', 'WE_lambda', 'PC_PICommand', 'GenSpeedF', & 
                                      'RotSpeedF', 'NacIMU_FA_AccF', 'FA_AccF', 'Fl_PitCom', 'PC_MinPit', & 
                                      'axisTilt_1P', 'axisYaw_1P', 'axisTilt_2P', 'axisYaw_2P', 'YawRateCom', & 
                                      'NacHeadingTarget', 'NacVaneOffset', 'Yaw_Err', 'YawState', 'VS_RefSpd', & 
                                      'PC_RefSpd']
    DebugOutUnits = [CHARACTER(15) ::  '[-]', '[-]', '[-]', '[-]', '[m/s]', & 
                                      '[m/s]', '[m/s]', '[rad]', '[rad]', '[rad/s]', & 
                                      '[rad/s]', '[rad/s]', '[m/s]', '[rad]', '[rad]', & 
                                      '[N/A]', '[N/A]', '[N/A]', '[N/A]', '[rad/s]', & 
                                      '[deg]', '[deg]', '[deg]', '[N/A]', '[rad/s]', & 
                                      '[rad/s]']
    nLocalVars = 159
    Allocate(LocalVarOutData(nLocalVars))
    LocalVarOutData(1) = LocalVar%iStatus
    LocalVarOutData(2) = LocalVar%AlreadyInitialized
    LocalVarOutData(3) = LocalVar%RestartWSE
    LocalVarOutData(4) = LocalVar%Time
    LocalVarOutData(5) = LocalVar%DT
    LocalVarOutData(6) = LocalVar%n_DT
    LocalVarOutData(7) = LocalVar%Time_Last
    LocalVarOutData(8) = LocalVar%VS_GenPwr
    LocalVarOutData(9) = LocalVar%GenSpeed
    LocalVarOutData(10) = LocalVar%RotSpeed
    LocalVarOutData(11) = LocalVar%NacHeading
    LocalVarOutData(12) = LocalVar%NacVane
    LocalVarOutData(13) = LocalVar%NacVaneF
    LocalVarOutData(14) = LocalVar%WindDir
    LocalVarOutData(15) = LocalVar%HorWindV
    LocalVarOutData(16) = LocalVar%HorWindV_F
    LocalVarOutData(17) = LocalVar%rootMOOP(1)
    LocalVarOutData(18) = LocalVar%rootMOOPF(1)
    LocalVarOutData(19) = LocalVar%BlPitch(1)
    LocalVarOutData(20) = LocalVar%BlPitchCMeas
    LocalVarOutData(21) = LocalVar%Azimuth
    LocalVarOutData(22) = LocalVar%OL_Azimuth
    LocalVarOutData(23) = LocalVar%AzUnwrapped
    LocalVarOutData(24) = LocalVar%AzError
    LocalVarOutData(25) = LocalVar%GenTqAz
    LocalVarOutData(26) = LocalVar%AzBuffer(1)
    LocalVarOutData(27) = LocalVar%NumBl
    LocalVarOutData(28) = LocalVar%FA_Acc_TT
    LocalVarOutData(29) = LocalVar%SS_Acc_TT
    LocalVarOutData(30) = LocalVar%FA_Acc_Nac
    LocalVarOutData(31) = LocalVar%NacIMU_FA_RAcc
    LocalVarOutData(32) = LocalVar%FA_AccHPF
    LocalVarOutData(33) = LocalVar%FA_AccHPFI
    LocalVarOutData(34) = LocalVar%FA_PitCom(1)
    LocalVarOutData(35) = LocalVar%VS_RefSpd
    LocalVarOutData(36) = LocalVar%VS_RefSpd_TSR
    LocalVarOutData(37) = LocalVar%VS_RefSpd_TRA
    LocalVarOutData(38) = LocalVar%VS_RefSpd_RL
    LocalVarOutData(39) = LocalVar%PC_RefSpd
    LocalVarOutData(40) = LocalVar%PC_RefSpd_SS
    LocalVarOutData(41) = LocalVar%PC_RefSpd_PRC
    LocalVarOutData(42) = LocalVar%RotSpeedF
    LocalVarOutData(43) = LocalVar%GenSpeedF
    LocalVarOutData(44) = LocalVar%GenTq
    LocalVarOutData(45) = LocalVar%GenTqMeas
    LocalVarOutData(46) = LocalVar%GenArTq
    LocalVarOutData(47) = LocalVar%GenBrTq
    LocalVarOutData(48) = LocalVar%VS_KOmega2_GenTq
    LocalVarOutData(49) = LocalVar%VS_ConstPwr_GenTq
    LocalVarOutData(50) = LocalVar%IPC_PitComF(1)
    LocalVarOutData(51) = LocalVar%PC_KP
    LocalVarOutData(52) = LocalVar%PC_KI
    LocalVarOutData(53) = LocalVar%PC_KD
    LocalVarOutData(54) = LocalVar%PC_TF
    LocalVarOutData(55) = LocalVar%PC_MaxPit
    LocalVarOutData(56) = LocalVar%PC_MinPit
    LocalVarOutData(57) = LocalVar%PC_PitComT
    LocalVarOutData(58) = LocalVar%PC_PitComT_Last
    LocalVarOutData(59) = LocalVar%BlPitchCMeasF
    LocalVarOutData(60) = LocalVar%PC_PitComT_IPC(1)
    LocalVarOutData(61) = LocalVar%PC_PwrErr
    LocalVarOutData(62) = LocalVar%PC_SpdErr
    LocalVarOutData(63) = LocalVar%IPC_AxisTilt_1P
    LocalVarOutData(64) = LocalVar%IPC_AxisYaw_1P
    LocalVarOutData(65) = LocalVar%IPC_AxisTilt_2P
    LocalVarOutData(66) = LocalVar%IPC_AxisYaw_2P
    LocalVarOutData(67) = LocalVar%axisTilt_1P
    LocalVarOutData(68) = LocalVar%axisYaw_1P
    LocalVarOutData(69) = LocalVar%axisYawF_1P
    LocalVarOutData(70) = LocalVar%axisTilt_2P
    LocalVarOutData(71) = LocalVar%axisYaw_2P
    LocalVarOutData(72) = LocalVar%axisYawF_2P
    LocalVarOutData(73) = LocalVar%IPC_KI(1)
    LocalVarOutData(74) = LocalVar%IPC_KP(1)
    LocalVarOutData(75) = LocalVar%IPC_IntSat
    LocalVarOutData(76) = LocalVar%PC_State
    LocalVarOutData(77) = LocalVar%PitCom(1)
    LocalVarOutData(78) = LocalVar%PitCom_SD(1)
    LocalVarOutData(79) = LocalVar%PitComAct(1)
    LocalVarOutData(80) = LocalVar%SS_DelOmegaF
    LocalVarOutData(81) = LocalVar%TestType
    LocalVarOutData(82) = LocalVar%Kp_Float
    LocalVarOutData(83) = LocalVar%VS_MaxTq
    LocalVarOutData(84) = LocalVar%VS_LastGenTrq
    LocalVarOutData(85) = LocalVar%VS_LastGenPwr
    LocalVarOutData(86) = LocalVar%VS_MechGenPwr
    LocalVarOutData(87) = LocalVar%VS_SpdErrAr
    LocalVarOutData(88) = LocalVar%VS_SpdErrBr
    LocalVarOutData(89) = LocalVar%VS_SpdErr
    LocalVarOutData(90) = LocalVar%VS_State
    LocalVarOutData(91) = LocalVar%VS_Rgn3Pitch
    LocalVarOutData(92) = LocalVar%WE_Vw
    LocalVarOutData(93) = LocalVar%WE_Vw_F
    LocalVarOutData(94) = LocalVar%WE_VwI
    LocalVarOutData(95) = LocalVar%WE_VwIdot
    LocalVarOutData(96) = LocalVar%WE_Op
    LocalVarOutData(97) = LocalVar%WE_Op_Last
    LocalVarOutData(98) = LocalVar%VS_LastGenTrqF
    LocalVarOutData(99) = LocalVar%PRC_WSE_F
    LocalVarOutData(100) = LocalVar%PRC_R_Speed
    LocalVarOutData(101) = LocalVar%PRC_R_Torque
    LocalVarOutData(102) = LocalVar%PRC_R_Pitch
    LocalVarOutData(103) = LocalVar%PRC_R_Total
    LocalVarOutData(104) = LocalVar%PRC_Min_Pitch
    LocalVarOutData(105) = LocalVar%PS_Min_Pitch
    LocalVarOutData(106) = LocalVar%OL_Index
    LocalVarOutData(107) = LocalVar%SU_Stage
    LocalVarOutData(108) = LocalVar%SU_LoadStageStartTime
    LocalVarOutData(109) = LocalVar%SU_RotSpeedF
    LocalVarOutData(110) = LocalVar%SD_Trigger
    LocalVarOutData(111) = LocalVar%SD_BlPitchF
    LocalVarOutData(112) = LocalVar%SD_NacVaneF
    LocalVarOutData(113) = LocalVar%SD_GenSpeedF
    LocalVarOutData(114) = LocalVar%SD_Stage
    LocalVarOutData(115) = LocalVar%SD_StageStartTime
    LocalVarOutData(116) = LocalVar%SD_MaxPitchRate
    LocalVarOutData(117) = LocalVar%SD_MaxTorqueRate
    LocalVarOutData(118) = LocalVar%GenTq_SD
    LocalVarOutData(119) = LocalVar%Fl_PitCom
    LocalVarOutData(120) = LocalVar%NACIMU_FA_AccF
    LocalVarOutData(121) = LocalVar%FA_AccF
    LocalVarOutData(122) = LocalVar%FA_Hist
    LocalVarOutData(123) = LocalVar%TRA_LastRefSpd
    LocalVarOutData(124) = LocalVar%VS_RefSpeed
    LocalVarOutData(125) = LocalVar%PtfmTDX
    LocalVarOutData(126) = LocalVar%PtfmTDY
    LocalVarOutData(127) = LocalVar%PtfmTDZ
    LocalVarOutData(128) = LocalVar%PtfmRDX
    LocalVarOutData(129) = LocalVar%PtfmRDY
    LocalVarOutData(130) = LocalVar%PtfmRDZ
    LocalVarOutData(131) = LocalVar%PtfmTVX
    LocalVarOutData(132) = LocalVar%PtfmTVY
    LocalVarOutData(133) = LocalVar%PtfmTVZ
    LocalVarOutData(134) = LocalVar%PtfmRVX
    LocalVarOutData(135) = LocalVar%PtfmRVY
    LocalVarOutData(136) = LocalVar%PtfmRVZ
    LocalVarOutData(137) = LocalVar%PtfmTAX
    LocalVarOutData(138) = LocalVar%PtfmTAY
    LocalVarOutData(139) = LocalVar%PtfmTAZ
    LocalVarOutData(140) = LocalVar%PtfmRAX
    LocalVarOutData(141) = LocalVar%PtfmRAY
    LocalVarOutData(142) = LocalVar%PtfmRAZ
    LocalVarOutData(143) = LocalVar%CC_DesiredL(1)
    LocalVarOutData(144) = LocalVar%CC_ActuatedL(1)
    LocalVarOutData(145) = LocalVar%CC_ActuatedDL(1)
    LocalVarOutData(146) = LocalVar%StC_Input(1)
    LocalVarOutData(147) = LocalVar%Flp_Angle(1)
    LocalVarOutData(148) = LocalVar%RootMyb_Last(1)
    LocalVarOutData(149) = LocalVar%ACC_INFILE_SIZE
    LocalVarOutData(150) = LocalVar%AWC_complexangle(1)
    LocalVarOutData(151) = LocalVar%TiltMean
    LocalVarOutData(152) = LocalVar%YawMean
    LocalVarOutData(153) = LocalVar%ZMQ_ID
    LocalVarOutData(154) = LocalVar%ZMQ_YawOffset
    LocalVarOutData(155) = LocalVar%ZMQ_TorqueOffset
    LocalVarOutData(156) = LocalVar%ZMQ_PitOffset(1)
    LocalVarOutData(157) = LocalVar%ZMQ_R_Speed
    LocalVarOutData(158) = LocalVar%ZMQ_R_Torque
    LocalVarOutData(159) = LocalVar%ZMQ_R_Pitch

    LocalVarOutStrings(1) = 'iStatus'
    LocalVarOutStrings(2) = 'AlreadyInitialized'
    LocalVarOutStrings(3) = 'RestartWSE'
    LocalVarOutStrings(4) = 'Time'
    LocalVarOutStrings(5) = 'DT'
    LocalVarOutStrings(6) = 'n_DT'
    LocalVarOutStrings(7) = 'Time_Last'
    LocalVarOutStrings(8) = 'VS_GenPwr'
    LocalVarOutStrings(9) = 'GenSpeed'
    LocalVarOutStrings(10) = 'RotSpeed'
    LocalVarOutStrings(11) = 'NacHeading'
    LocalVarOutStrings(12) = 'NacVane'
    LocalVarOutStrings(13) = 'NacVaneF'
    LocalVarOutStrings(14) = 'WindDir'
    LocalVarOutStrings(15) = 'HorWindV'
    LocalVarOutStrings(16) = 'HorWindV_F'
    LocalVarOutStrings(17) = 'rootMOOP'
    LocalVarOutStrings(18) = 'rootMOOPF'
    LocalVarOutStrings(19) = 'BlPitch'
    LocalVarOutStrings(20) = 'BlPitchCMeas'
    LocalVarOutStrings(21) = 'Azimuth'
    LocalVarOutStrings(22) = 'OL_Azimuth'
    LocalVarOutStrings(23) = 'AzUnwrapped'
    LocalVarOutStrings(24) = 'AzError'
    LocalVarOutStrings(25) = 'GenTqAz'
    LocalVarOutStrings(26) = 'AzBuffer'
    LocalVarOutStrings(27) = 'NumBl'
    LocalVarOutStrings(28) = 'FA_Acc_TT'
    LocalVarOutStrings(29) = 'SS_Acc_TT'
    LocalVarOutStrings(30) = 'FA_Acc_Nac'
    LocalVarOutStrings(31) = 'NacIMU_FA_RAcc'
    LocalVarOutStrings(32) = 'FA_AccHPF'
    LocalVarOutStrings(33) = 'FA_AccHPFI'
    LocalVarOutStrings(34) = 'FA_PitCom'
    LocalVarOutStrings(35) = 'VS_RefSpd'
    LocalVarOutStrings(36) = 'VS_RefSpd_TSR'
    LocalVarOutStrings(37) = 'VS_RefSpd_TRA'
    LocalVarOutStrings(38) = 'VS_RefSpd_RL'
    LocalVarOutStrings(39) = 'PC_RefSpd'
    LocalVarOutStrings(40) = 'PC_RefSpd_SS'
    LocalVarOutStrings(41) = 'PC_RefSpd_PRC'
    LocalVarOutStrings(42) = 'RotSpeedF'
    LocalVarOutStrings(43) = 'GenSpeedF'
    LocalVarOutStrings(44) = 'GenTq'
    LocalVarOutStrings(45) = 'GenTqMeas'
    LocalVarOutStrings(46) = 'GenArTq'
    LocalVarOutStrings(47) = 'GenBrTq'
    LocalVarOutStrings(48) = 'VS_KOmega2_GenTq'
    LocalVarOutStrings(49) = 'VS_ConstPwr_GenTq'
    LocalVarOutStrings(50) = 'IPC_PitComF'
    LocalVarOutStrings(51) = 'PC_KP'
    LocalVarOutStrings(52) = 'PC_KI'
    LocalVarOutStrings(53) = 'PC_KD'
    LocalVarOutStrings(54) = 'PC_TF'
    LocalVarOutStrings(55) = 'PC_MaxPit'
    LocalVarOutStrings(56) = 'PC_MinPit'
    LocalVarOutStrings(57) = 'PC_PitComT'
    LocalVarOutStrings(58) = 'PC_PitComT_Last'
    LocalVarOutStrings(59) = 'BlPitchCMeasF'
    LocalVarOutStrings(60) = 'PC_PitComT_IPC'
    LocalVarOutStrings(61) = 'PC_PwrErr'
    LocalVarOutStrings(62) = 'PC_SpdErr'
    LocalVarOutStrings(63) = 'IPC_AxisTilt_1P'
    LocalVarOutStrings(64) = 'IPC_AxisYaw_1P'
    LocalVarOutStrings(65) = 'IPC_AxisTilt_2P'
    LocalVarOutStrings(66) = 'IPC_AxisYaw_2P'
    LocalVarOutStrings(67) = 'axisTilt_1P'
    LocalVarOutStrings(68) = 'axisYaw_1P'
    LocalVarOutStrings(69) = 'axisYawF_1P'
    LocalVarOutStrings(70) = 'axisTilt_2P'
    LocalVarOutStrings(71) = 'axisYaw_2P'
    LocalVarOutStrings(72) = 'axisYawF_2P'
    LocalVarOutStrings(73) = 'IPC_KI'
    LocalVarOutStrings(74) = 'IPC_KP'
    LocalVarOutStrings(75) = 'IPC_IntSat'
    LocalVarOutStrings(76) = 'PC_State'
    LocalVarOutStrings(77) = 'PitCom'
    LocalVarOutStrings(78) = 'PitCom_SD'
    LocalVarOutStrings(79) = 'PitComAct'
    LocalVarOutStrings(80) = 'SS_DelOmegaF'
    LocalVarOutStrings(81) = 'TestType'
    LocalVarOutStrings(82) = 'Kp_Float'
    LocalVarOutStrings(83) = 'VS_MaxTq'
    LocalVarOutStrings(84) = 'VS_LastGenTrq'
    LocalVarOutStrings(85) = 'VS_LastGenPwr'
    LocalVarOutStrings(86) = 'VS_MechGenPwr'
    LocalVarOutStrings(87) = 'VS_SpdErrAr'
    LocalVarOutStrings(88) = 'VS_SpdErrBr'
    LocalVarOutStrings(89) = 'VS_SpdErr'
    LocalVarOutStrings(90) = 'VS_State'
    LocalVarOutStrings(91) = 'VS_Rgn3Pitch'
    LocalVarOutStrings(92) = 'WE_Vw'
    LocalVarOutStrings(93) = 'WE_Vw_F'
    LocalVarOutStrings(94) = 'WE_VwI'
    LocalVarOutStrings(95) = 'WE_VwIdot'
    LocalVarOutStrings(96) = 'WE_Op'
    LocalVarOutStrings(97) = 'WE_Op_Last'
    LocalVarOutStrings(98) = 'VS_LastGenTrqF'
    LocalVarOutStrings(99) = 'PRC_WSE_F'
    LocalVarOutStrings(100) = 'PRC_R_Speed'
    LocalVarOutStrings(101) = 'PRC_R_Torque'
    LocalVarOutStrings(102) = 'PRC_R_Pitch'
    LocalVarOutStrings(103) = 'PRC_R_Total'
    LocalVarOutStrings(104) = 'PRC_Min_Pitch'
    LocalVarOutStrings(105) = 'PS_Min_Pitch'
    LocalVarOutStrings(106) = 'OL_Index'
    LocalVarOutStrings(107) = 'SU_Stage'
    LocalVarOutStrings(108) = 'SU_LoadStageStartTime'
    LocalVarOutStrings(109) = 'SU_RotSpeedF'
    LocalVarOutStrings(110) = 'SD_Trigger'
    LocalVarOutStrings(111) = 'SD_BlPitchF'
    LocalVarOutStrings(112) = 'SD_NacVaneF'
    LocalVarOutStrings(113) = 'SD_GenSpeedF'
    LocalVarOutStrings(114) = 'SD_Stage'
    LocalVarOutStrings(115) = 'SD_StageStartTime'
    LocalVarOutStrings(116) = 'SD_MaxPitchRate'
    LocalVarOutStrings(117) = 'SD_MaxTorqueRate'
    LocalVarOutStrings(118) = 'GenTq_SD'
    LocalVarOutStrings(119) = 'Fl_PitCom'
    LocalVarOutStrings(120) = 'NACIMU_FA_AccF'
    LocalVarOutStrings(121) = 'FA_AccF'
    LocalVarOutStrings(122) = 'FA_Hist'
    LocalVarOutStrings(123) = 'TRA_LastRefSpd'
    LocalVarOutStrings(124) = 'VS_RefSpeed'
    LocalVarOutStrings(125) = 'PtfmTDX'
    LocalVarOutStrings(126) = 'PtfmTDY'
    LocalVarOutStrings(127) = 'PtfmTDZ'
    LocalVarOutStrings(128) = 'PtfmRDX'
    LocalVarOutStrings(129) = 'PtfmRDY'
    LocalVarOutStrings(130) = 'PtfmRDZ'
    LocalVarOutStrings(131) = 'PtfmTVX'
    LocalVarOutStrings(132) = 'PtfmTVY'
    LocalVarOutStrings(133) = 'PtfmTVZ'
    LocalVarOutStrings(134) = 'PtfmRVX'
    LocalVarOutStrings(135) = 'PtfmRVY'
    LocalVarOutStrings(136) = 'PtfmRVZ'
    LocalVarOutStrings(137) = 'PtfmTAX'
    LocalVarOutStrings(138) = 'PtfmTAY'
    LocalVarOutStrings(139) = 'PtfmTAZ'
    LocalVarOutStrings(140) = 'PtfmRAX'
    LocalVarOutStrings(141) = 'PtfmRAY'
    LocalVarOutStrings(142) = 'PtfmRAZ'
    LocalVarOutStrings(143) = 'CC_DesiredL'
    LocalVarOutStrings(144) = 'CC_ActuatedL'
    LocalVarOutStrings(145) = 'CC_ActuatedDL'
    LocalVarOutStrings(146) = 'StC_Input'
    LocalVarOutStrings(147) = 'Flp_Angle'
    LocalVarOutStrings(148) = 'RootMyb_Last'
    LocalVarOutStrings(149) = 'ACC_INFILE_SIZE'
    LocalVarOutStrings(150) = 'AWC_complexangle'
    LocalVarOutStrings(151) = 'TiltMean'
    LocalVarOutStrings(152) = 'YawMean'
    LocalVarOutStrings(153) = 'ZMQ_ID'
    LocalVarOutStrings(154) = 'ZMQ_YawOffset'
    LocalVarOutStrings(155) = 'ZMQ_TorqueOffset'
    LocalVarOutStrings(156) = 'ZMQ_PitOffset'
    LocalVarOutStrings(157) = 'ZMQ_R_Speed'
    LocalVarOutStrings(158) = 'ZMQ_R_Torque'
    LocalVarOutStrings(159) = 'ZMQ_R_Pitch'
    ! Initialize debug file
    IF ((LocalVar%iStatus == 0) .OR. (LocalVar%iStatus == -9))  THEN ! .TRUE. if we're on the first call to the DLL
        IF (CntrPar%LoggingLevel > 0) THEN
            CALL GetNewUnit(UnDb, ErrVar)
            OPEN(unit=UnDb, FILE=TRIM(RootName)//'.RO.dbg')
            WRITE(UnDb, *)  'Generated on '//CurDate()//' at '//CurTime()//' using ROSCO-'//TRIM(rosco_version)
            WRITE(UnDb, '(99(a20,TR5:))') 'Time',   DebugOutStrings
            WRITE(UnDb, '(99(a20,TR5:))') '(sec)',  DebugOutUnits
        END IF

        IF (CntrPar%LoggingLevel > 1) THEN
            CALL GetNewUnit(UnDb2, ErrVar)
            OPEN(unit=UnDb2, FILE=TRIM(RootName)//'.RO.dbg2')
            WRITE(UnDb2, *)  'Generated on '//CurDate()//' at '//CurTime()//' using ROSCO-'//TRIM(rosco_version)
            WRITE(UnDb2, '(160(a20,TR5:))') 'Time',   LocalVarOutStrings
            WRITE(UnDb2, '(160(a20,TR5:))')
        END IF

        IF (CntrPar%LoggingLevel > 2) THEN
            ! Set avrIndices, start with basic indices
            Allocate(avrIndices(avrBaseLength))
            DO Ind = 1, avrBaseLength
                avrIndices(Ind) = Ind
            END DO

            ! Cable control indices
            IF (CntrPar%CC_Mode > 0) THEN
                DO Ind = 1, SIZE(CntrPar%CC_GroupIndex)
                    Call AddToList(avrIndices,CntrPar%CC_GroupIndex(Ind))
                    Call AddToList(avrIndices,CntrPar%CC_GroupIndex(Ind)+1)
                END DO
            END IF

            ! Structural control indices
            IF (CntrPar%StC_Mode > 0) THEN
                DO Ind = 1, SIZE(CntrPar%StC_GroupIndex)
                    Call AddToList(avrIndices,CntrPar%StC_GroupIndex(Ind))
                END DO
            END IF

            ! Format string
            avrFmt = '(A21,'//TRIM(Int2LStr(SIZE(avrIndices)))//'(TR12,"'//'AvrSWAP(",I4,")"))'

            CALL GetNewUnit(UnDb3, ErrVar)
            OPEN(unit=UnDb3, FILE=TRIM(RootName)//'.RO.dbg3')
            WRITE(UnDb3,'(/////)')
            WRITE(UnDb3,avrFmt)  'LocalVar%Time ', (avrIndices)
            WRITE(UnDb3,'(A21,'//TRIM(Int2LStr(SIZE(avrIndices)))//'(TR22,"(-)"))')  '(s)'
        END IF
    END IF

        ! Print simulation status, every 10 seconds
    IF (MODULO(LocalVar%Time, 10.0_DbKi) == 0) THEN
        WRITE(*, 100) LocalVar%GenSpeedF*RPS2RPM, LocalVar%BlPitch(1)*R2D, avrSWAP(15)/1000.0, LocalVar%WE_Vw
        100 FORMAT('Generator speed: ', f6.1, ' RPM, Pitch angle: ', f5.1, ' deg, Power: ', f7.1, ' kW, Est. wind Speed: ', f5.1, ' m/s')
    END IF

    ! Process DebugOutData, LocalVarOutData
    ! Remove very small numbers that cause ******** outputs
    DO I = 1,SIZE(DebugOutData)
        IF (ABS(DebugOutData(I)) < 1E-99) THEN
            DebugOutData(I) = 0
        END IF
        IF (ABS(DebugOutData(I)) > 1E+99) THEN
            DebugOutData(I) = 1E+99
        END IF
    END DO
    
    DO I = 1,SIZE(LocalVarOutData)
        IF (ABS(LocalVarOutData(I)) < 1E-99) THEN
            LocalVarOutData(I) = 0
        END IF
        IF (ABS(LocalVarOutData(I)) > 1E+99) THEN
            LocalVarOutData(I) = 1E+99
        END IF
    END DO
    
    ! Write debug files
    FmtDat = "(F20.5,TR5,159(ES20.5E2,TR5:))"   ! The format of the debugging data
    IF ( MOD(LocalVar%n_DT, CntrPar%n_DT_Out) == 0) THEN
        IF((CntrPar%LoggingLevel > 0) .AND. (LocalVar%iStatus .ge. 0)) THEN
            WRITE (UnDb, TRIM(FmtDat))  LocalVar%Time, DebugOutData
        END IF

        IF((CntrPar%LoggingLevel > 1) .AND. (LocalVar%iStatus .ge. 0)) THEN
            WRITE (UnDb2, TRIM(FmtDat))  LocalVar%Time, LocalVarOutData
        END IF

        IF((CntrPar%LoggingLevel > 2) .AND. (LocalVar%iStatus .ge. 0)) THEN
            WRITE (UnDb3, TRIM(FmtDat))    LocalVar%Time, avrSWAP(avrIndices)
        END IF
    END IF

    ! Close all files when simulation finished
    IF (LocalVar%iStatus < 0) THEN
        CLOSE(UnDb)
        CLOSE(UnDb2)
        CLOSE(UnDb3)
    ENDIF
END SUBROUTINE Debug

END MODULE ROSCO_IO

! Copyright 2019 NREL

! Licensed under the Apache License, Version 2.0 (the "License"); you may not use
! this file except in compliance with the License. You may obtain a copy of the
! License at http://www.apache.org/licenses/LICENSE-2.0

! Unless required by applicable law or agreed to in writing, software distributed
! under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
! CONDITIONS OF ANY KIND, either express or implied. See the License for the
! specific language governing permissions and limitations under the License.
! -------------------------------------------------------------------------------------------

! This module contains additional routines and functions to supplement the primary controllers used in the Controllers module

MODULE ControllerBlocks

USE, INTRINSIC :: ISO_C_Binding
USE Constants
USE Filters
USE Functions
USE SysSubs

IMPLICIT NONE

CONTAINS

    SUBROUTINE PowerControlSetpoints(CntrPar, LocalVar, objInst, DebugVar, ErrVar)
        USE ROSCO_Types, ONLY : ControlParameters, LocalVariables, ObjectInstances, DebugVariables, ErrorVariables
        USE Constants
        ! Allocate variables
        TYPE(ControlParameters),    INTENT(INOUT)       :: CntrPar
        TYPE(LocalVariables),       INTENT(INOUT)       :: LocalVar
        TYPE(ObjectInstances),      INTENT(INOUT)       :: objInst
        TYPE(DebugVariables),       INTENT(INOUT)       :: DebugVar
        TYPE(ErrorVariables),       INTENT(INOUT)       :: ErrVar

        ! Set up power control
        IF (CntrPar%PRC_Mode == 2) THEN  ! Using power reference control
            IF (CntrPar%PRC_Comm == PRC_Comm_Constant) THEN  ! Constant, from DISCON
                LocalVar%PRC_R_Speed = CntrPar%PRC_R_Speed
                LocalVar%PRC_R_Torque = CntrPar%PRC_R_Torque
                LocalVar%PRC_R_Pitch = CntrPar%PRC_R_Pitch

            ELSEIF (CntrPar%PRC_Comm == PRC_Comm_OpenLoop) THEN  ! Open loop

                IF (CntrPar%Ind_R_Speed > 0) THEN
                    LocalVar%PRC_R_Speed = interp1d(CntrPar%OL_Breakpoints,CntrPar%OL_R_Speed,LocalVar%OL_Index,ErrVar)
                    WRITE(401,*) LocalVar%PRC_R_Speed
                ELSE
                    LocalVar%PRC_R_Speed = 1.0_DbKi
                ENDIF

                IF (CntrPar%Ind_R_Torque > 0) THEN
                    LocalVar%PRC_R_Torque = interp1d(CntrPar%OL_Breakpoints,CntrPar%OL_R_Torque,LocalVar%OL_Index,ErrVar)
                ELSE
                    LocalVar%PRC_R_Torque = 1.0_DbKi
                ENDIF

                IF (CntrPar%Ind_R_Pitch > 0) THEN
                    LocalVar%PRC_R_Pitch = interp1d(CntrPar%OL_Breakpoints,CntrPar%OL_R_Pitch,LocalVar%OL_Index,ErrVar)
                ELSE
                    LocalVar%PRC_R_Pitch = 1.0_DbKi
                ENDIF

            ELSEIF (CntrPar%PRC_Comm == PRC_Comm_ZMQ) THEN  ! ZeroMQ
                LocalVar%PRC_R_Speed    = LocalVar%ZMQ_R_Speed
                LocalVar%PRC_R_Torque   = LocalVar%ZMQ_R_Torque
                LocalVar%PRC_R_Pitch    = LocalVar%ZMQ_R_Pitch

            ENDIF

            ! Set min pitch for power control, will be combined with peak shaving min pitch
            LocalVar%PRC_Min_Pitch = interp1d(CntrPar%PRC_R_Table,CntrPar%PRC_Pitch_Table,LocalVar%PRC_R_Pitch, ErrVar)

        ELSE
            LocalVar%PRC_R_Speed = 1.0_DbKi
            LocalVar%PRC_R_Torque = 1.0_DbKi
            LocalVar%PRC_R_Pitch = 1.0_DbKi
            LocalVar%PRC_Min_Pitch = CntrPar%PC_FinePit
        ENDIF


    END SUBROUTINE

! -----------------------------------------------------------------------------------
    ! Calculate setpoints for primary control actions    
    SUBROUTINE ComputeVariablesSetpoints(CntrPar, LocalVar, objInst, DebugVar, ErrVar)
        USE ROSCO_Types, ONLY : ControlParameters, LocalVariables, ObjectInstances, DebugVariables, ErrorVariables
        USE Constants
        ! Allocate variables
        TYPE(ControlParameters),    INTENT(INOUT)       :: CntrPar
        TYPE(LocalVariables),       INTENT(INOUT)       :: LocalVar
        TYPE(ObjectInstances),      INTENT(INOUT)       :: objInst
        TYPE(DebugVariables),       INTENT(INOUT)       :: DebugVar
        TYPE(ErrorVariables),       INTENT(INOUT)       :: ErrVar


        !   Change pitch reference speed
        LocalVar%PC_RefSpd_PRC = CntrPar%PC_RefSpd * LocalVar%PRC_R_Speed
        
        ! Lookup table for speed setpoint (PRC_Mode 1)
        IF (CntrPar%PRC_Mode == 1) THEN
            LocalVar%PRC_WSE_F = LPFilter(LocalVar%WE_Vw, LocalVar%DT,CntrPar%PRC_LPF_Freq, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instLPF) 
            LocalVar%PC_RefSpd_PRC = interp1d(CntrPar%PRC_WindSpeeds,CntrPar%PRC_GenSpeeds,LocalVar%PRC_WSE_F,ErrVar)
        ENDIF

        ! Implement setpoint smoothing
        IF (LocalVar%SS_DelOmegaF < 0) THEN
            LocalVar%PC_RefSpd_SS = LocalVar%PC_RefSpd_PRC - LocalVar%SS_DelOmegaF
        ELSE
            LocalVar%PC_RefSpd_SS = LocalVar%PC_RefSpd_PRC
        ENDIF

        ! Compute error for pitch controller
        LocalVar%PC_RefSpd = LocalVar%PC_RefSpd_SS        
        LocalVar%PC_SpdErr = LocalVar%PC_RefSpd - LocalVar%GenSpeedF            ! Speed error
        LocalVar%PC_PwrErr = CntrPar%VS_RtPwr - LocalVar%VS_GenPwr             ! Power error, unused

        ! ----- Torque controller reference errors -----
        ! Define VS reference generator speed [rad/s]
        IF (CntrPar%VS_ControlMode == VS_Mode_WSE_TSR) THEN
            ! Use unfiltered wind speed estimate, then filter below
            LocalVar%VS_RefSpd_TSR = (CntrPar%VS_TSRopt * LocalVar%WE_Vw / CntrPar%WE_BladeRadius) * CntrPar%WE_GearboxRatio

        ELSEIF (CntrPar%VS_ControlMode == VS_Mode_Power_TSR) THEN ! Genspeed reference that doesn't depend on wind speed estimate (https://doi.org/10.2172/1259805)
            LocalVar%VS_RefSpd_TSR = (MAX(LocalVar%VS_GenPwr, 0.0)/(CntrPar%VS_GenEff/100.0)/CntrPar%VS_Rgn2K)**(1./3.)

        ELSEIF (CntrPar%VS_ControlMode == VS_Mode_Torque_TSR) THEN ! Non-WSE TSR tracking based on square-root of torque
            LocalVar%VS_RefSpd_TSR = (MAX(LocalVar%GenTq, 0.0)/CntrPar%VS_Rgn2K)**(1./2.)

        ELSE ! Generate constant speed reference if K*Omega^2 in use or torque control disabled
            LocalVar%VS_RefSpd_TSR = CntrPar%VS_RefSpd
        ENDIF 

        ! Region 3 FBP reference logic, triggers if Region-2 reference speed is higher than rated
        ! DBS: Alternatively, each of these alternative reference modes could identify Region 3 using their reference-deriving signal, e.g. if WE_Vw > rated speed (accessible in ROSCO?) or GenTq > VS_RtTq
        IF (LocalVar%VS_RefSpd_TSR > CntrPar%VS_RefSpd) THEN
            IF (CntrPar%VS_FBP == VS_FBP_WSE_Ref) THEN ! Use WSE to look up speed reference in Region 3
                LocalVar%VS_RefSpd_TSR = interp1d(CntrPar%VS_FBP_U, CntrPar%VS_FBP_Omega, LocalVar%WE_Vw, ErrVar)

            ELSEIF (CntrPar%VS_FBP == VS_FBP_Torque_Ref) THEN ! Use torque to look up speed reference in Region 3
                LocalVar%VS_RefSpd_TSR = interp1d(CntrPar%VS_FBP_Tau, CntrPar%VS_FBP_Omega, LocalVar%GenTq, ErrVar)

            ENDIF
        ENDIF

        ! Change VS Ref speed based on R_Speed
        LocalVar%VS_RefSpd = LocalVar%VS_RefSpd_TSR * LocalVar%PRC_R_Speed


        ! Filter reference signal
        LocalVar%VS_RefSpd = LPFilter(LocalVar%VS_RefSpd_TSR, LocalVar%DT, CntrPar%F_VSRefSpdCornerFreq, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instLPF)


        ! Exclude reference speeds specified by user
        IF (CntrPar%TRA_Mode > 0) THEN
            CALL RefSpeedExclusion(LocalVar, CntrPar, objInst, DebugVar)
        END IF

        ! Saturate torque reference speed below rated speed if using pitch control in Region 3
        IF (CntrPar%VS_FBP == VS_FBP_Variable_Pitch) THEN
            LocalVar%VS_RefSpd = saturate(LocalVar%VS_RefSpd, CntrPar%VS_MinOMSpd, CntrPar%VS_RefSpd * LocalVar%PRC_R_Speed)
        END IF

        ! Simple lookup table for generator speed (PRC_Mode 1)
        IF (CntrPar%PRC_Mode == 1) THEN
            LocalVar%VS_RefSpd = interp1d(CntrPar%PRC_WindSpeeds,CntrPar%PRC_GenSpeeds,LocalVar%PRC_WSE_F,ErrVar)
        ENDIF

        ! Implement setpoint smoothing
        IF (LocalVar%SS_DelOmegaF > 0) THEN
            LocalVar%VS_RefSpd = LocalVar%VS_RefSpd - LocalVar%SS_DelOmegaF
        ENDIF

        ! Force minimum rotor speed
        LocalVar%VS_RefSpd = max(LocalVar%VS_RefSpd, CntrPar%VS_MinOmSpd)

        ! Compute speed error from reference
        LocalVar%VS_SpdErr = LocalVar%VS_RefSpd - LocalVar%GenSpeedF

        ! Define transition region setpoint errors
        LocalVar%VS_SpdErrAr = LocalVar%VS_RefSpd - LocalVar%GenSpeedF               ! Current speed error - Region 2.5 PI-control (Above Rated)
        LocalVar%VS_SpdErrBr = CntrPar%VS_MinOMSpd - LocalVar%GenSpeedF     ! Current speed error - Region 1.5 PI-control (Below Rated)
        
        ! Region 3 minimum pitch angle for state machine
        LocalVar%VS_Rgn3Pitch = LocalVar%PC_MinPit + CntrPar%PC_Switch

        ! Debug Vars
        DebugVar%VS_RefSpd = LocalVar%VS_RefSpd
        DebugVar%PC_RefSpd = LocalVar%PC_RefSpd


    END SUBROUTINE ComputeVariablesSetpoints
!-------------------------------------------------------------------------------------------------------------------------------
    SUBROUTINE StateMachine(CntrPar, LocalVar)
    ! State machine, determines the state of the wind turbine to specify the corresponding control actions
    ! PC States:
    !       PC_State = PC_State_Disabled (0), No pitch control active, BldPitch = PC_MinPit
    !       PC_State = PC_State_Enabled  (1), Active PI blade pitch control enabled
    ! VS States
    !       VS_State = VS_State_Error             (0), Error state, for debugging purposes, GenTq = VS_RtTq
    !       VS_State = VS_State_Region_1_5        (1), Region 1(.5) operation, torque control to keep the rotor at cut-in speed towards the Cp-max operational curve
    !       VS_State = VS_State_Region_2          (2), Region 2 operation, maximum rotor power efficiency (Cp-max) tracking using K*omega^2 law, fixed fine-pitch angle in BldPitch controller
    !       VS_State = VS_State_Region_2_5        (3), Region 2.5, transition between below and above-rated operating conditions (near-rated region) using PI torque control
    !       VS_State = VS_State_Region_3_ConstTrq (4), above-rated operation using pitch control (constant torque mode)
    !       VS_State = VS_State_Region_3_ConstPwr (5), above-rated operation using pitch and torque control (constant power mode)
    !       VS_State = VS_State_Region_3_FBP      (6), above-rated operation using fixed-pitch torque control
    !       VS_State = VS_State_PI                (7), Tip-Speed-Ratio tracking PI controller
        USE ROSCO_Types, ONLY : LocalVariables, ControlParameters
        IMPLICIT NONE
    
        ! Inputs
        TYPE(ControlParameters),    INTENT(IN   )       :: CntrPar
        TYPE(LocalVariables),       INTENT(INOUT)       :: LocalVar
        
        ! Initialize State machine if first call
        IF (LocalVar%iStatus == 0) THEN ! .TRUE. if we're on the first call to the DLL

            IF (LocalVar%PitCom(1) >= LocalVar%VS_Rgn3Pitch) THEN ! We are in region 3
                LocalVar%PC_State = PC_State_Enabled
                IF (CntrPar%VS_ConstPower == VS_Mode_ConstPwr) THEN ! Constant power tracking
                    LocalVar%VS_State = VS_State_Region_3_ConstPwr
                ELSE ! Constant torque tracking
                    LocalVar%VS_State = VS_State_Region_3_ConstTrq
                END IF
            ELSE ! We are in Region 2
                LocalVar%VS_State = VS_State_Region_2
                LocalVar%PC_State = PC_State_Disabled
            END IF

        ! Operational States
        ELSE
            ! --- Pitch controller state machine ---
            IF (CntrPar%PC_ControlMode == 1) THEN
                LocalVar%PC_State = PC_State_Enabled
            ELSE 
                LocalVar%PC_State = PC_State_Disabled
            END IF
            
            ! --- Torque control state machine ---
            IF (LocalVar%BlPitchCMeas >= LocalVar%VS_Rgn3Pitch) THEN       
                IF (CntrPar%VS_ConstPower == VS_Mode_ConstPwr) THEN                   ! Region 3
                    LocalVar%VS_State = VS_State_Region_3_ConstPwr ! Constant power tracking
                ELSE 
                    LocalVar%VS_State = VS_State_Region_3_ConstTrq ! Constant torque tracking
                END IF
            ELSE
                IF (LocalVar%GenArTq >= CntrPar%VS_MaxOMTq*1.01) THEN       ! Region 2 1/2 - active PI torque control
                    IF (CntrPar%VS_FBP == VS_FBP_Variable_Pitch) THEN
                        LocalVar%VS_State = VS_State_Region_2_5
                    ELSE
                        LocalVar%VS_State = VS_State_Region_3_FBP ! Region 3 - fixed blade pitch torque control
                    END IF
                ELSEIF ((LocalVar%GenSpeedF < CntrPar%VS_RefSpd) .AND. &
                        (LocalVar%GenBrTq >= CntrPar%VS_MinOMTq)) THEN      ! Region 2 - optimal torque is proportional to the square of the generator speed
                    LocalVar%VS_State = VS_State_Region_2
                ELSEIF (LocalVar%GenBrTq < CntrPar%VS_MinOMTq) THEN         ! Region 1 1/2
                
                    LocalVar%VS_State = VS_State_Region_1_5
                ELSE                                                        ! Error state, Debug
                    LocalVar%VS_State = VS_State_Error
                END IF
            END IF
        END IF
    END SUBROUTINE StateMachine
!-------------------------------------------------------------------------------------------------------------------------------
    SUBROUTINE WindSpeedEstimator(LocalVar, CntrPar, objInst, PerfData, DebugVar, ErrVar)
    ! Wind Speed Estimator estimates wind speed at hub height. Currently implements two types of estimators
    !       WE_Mode = 0, Filter hub height wind speed as passed from servodyn using first order low pass filter with 1Hz cornering frequency
    !       WE_Mode = 1, Use Inversion and Inveriance filter as defined by Ortege et. al. 
        USE ROSCO_Types, ONLY : LocalVariables, ControlParameters, ObjectInstances, PerformanceData, DebugVariables, ErrorVariables
        USE ieee_arithmetic
        IMPLICIT NONE
    
        ! Inputs
        TYPE(ControlParameters),    INTENT(IN   )       :: CntrPar
        TYPE(LocalVariables),       INTENT(INOUT)       :: LocalVar 
        TYPE(ObjectInstances),      INTENT(INOUT)       :: objInst
        TYPE(PerformanceData),      INTENT(INOUT)       :: PerfData
        TYPE(DebugVariables),       INTENT(INOUT)       :: DebugVar
        TYPE(ErrorVariables),       INTENT(INOUT)       :: ErrVar

        ! Allocate Variables
        REAL(DbKi)                 :: F_WECornerFreq   ! Corner frequency (-3dB point) for first order low pass filter for measured hub height wind speed [Hz]

        !       Only used in EKF, if WE_Mode = 2
        REAL(DbKi)                 :: L                ! Turbulent length scale parameter [m]
        REAL(DbKi)                 :: Ti               ! Turbulent intensity, [-]
        ! REAL(DbKi), DIMENSION(3,3) :: I
        !           - operating conditions
        REAL(DbKi)                 :: A_op             ! Estimated operational system pole [UNITS!]
        REAL(DbKi)                 :: Cp_op            ! Estimated operational Cp [-]
        REAL(DbKi)                 :: Tau_r            ! Estimated rotor torque [Nm]
        REAL(DbKi)                 :: a                ! wind variance
        REAL(DbKi)                 :: lambda           ! tip-speed-ratio [rad]
        REAL(DbKi)                 :: RotSpeed         ! Rotor Speed [rad], locally

        !           - Covariance matrices
        REAL(DbKi), DIMENSION(3,3)         :: F        ! First order system jacobian 
        REAL(DbKi), DIMENSION(1,3)         :: H        ! Output equation jacobian 
        REAL(DbKi), DIMENSION(3,1)         :: dxh      ! Estimated state matrix deviation from previous timestep
        REAL(DbKi), DIMENSION(3,3)         :: Q        ! Process noise covariance matrix
        REAL(DbKi), DIMENSION(1,1)         :: S        ! Innovation covariance 
        REAL(DbKi)                         :: R_m      ! Measurement noise covariance [(rad/s)^2]

        REAL(DbKi)              :: WE_Inp_Pitch
        REAL(DbKi)              :: WE_Inp_Torque
        REAL(DbKi)              :: WE_Inp_Speed
        REAL(DbKi)              :: Max_Op_Pitch
        
        CHARACTER(*), PARAMETER                 :: RoutineName = 'WindSpeedEstimator'
        CHARACTER(1024)                        :: WarningMessage

        

        ! Saturate inputs to WSE:
        ! Rotor speed
        IF (LocalVar%RotSpeedF < 0.25 * CntrPar%VS_MinOMSpd / CntrPar%WE_GearboxRatio) THEN
            WE_Inp_Speed = 0.25 * CntrPar%VS_MinOMSpd / CntrPar%WE_GearboxRatio + EPSILON(1.0_DbKi)  ! If this is 0, could cause problems...
        ELSE
            WE_Inp_Speed = LocalVar%RotSpeedF
        END IF

            
        ! Blade pitch
        IF (CntrPar%WE_Mode > 0) THEN ! PerfData is only loaded if WE_Mode > 0
            Max_Op_Pitch = PerfData%Beta_vec(SIZE(PerfData%Beta_vec)) * D2R     ! The Cp surface is only valid up to the end of Beta_vec
        ELSE
            Max_Op_Pitch = 0.0_DbKi    ! Doesn't matter if WE_Mode = 0
        ENDIF
        
        WE_Inp_Pitch = saturate(LocalVar%BlPitchCMeas, CntrPar%PC_MinPit,Max_Op_Pitch) 


        ! Gen torque
        IF (LocalVar%VS_LastGenTrqF < 0.0001 * CntrPar%VS_RtTq) THEN
            WE_Inp_Torque = 0.0001 * CntrPar%VS_RtTq
        ELSE
            WE_Inp_Torque = LocalVar%VS_LastGenTrqF
        END IF

        ! Check to see if in operational range
        LocalVar%WE_Op_Last = LocalVar%WE_Op
        IF (ABS(WE_Inp_Pitch - LocalVar%BlPitchCMeas) > 0) THEN
            LocalVar%WE_Op = 0
        ELSEIF (ABS(WE_Inp_Torque - LocalVar%VS_LastGenTrqF) > 0) THEN
            LocalVar%WE_Op = 0
        ELSEIF (ABS(WE_Inp_Speed - LocalVar%RotSpeedF) > 0) THEN
            LocalVar%WE_Op = 0
        ELSE
            LocalVar%WE_Op = 1
        ENDIF


        ! Restart flag for WSE
        LocalVar%RestartWSE = LocalVar%iStatus      ! Same as iStatus by default

        IF (CntrPar%WE_Mode > 0) THEN
            IF (LocalVar%WE_Op == 0 .AND. LocalVar%WE_Op_Last == 1) THEN   ! Transition from operational to non-operational
                WarningMessage = NewLine//'***************************************************************************************************************************************'//NewLine// &
                    'ROSCO Warning: The wind speed estimator is used, but an input (pitch, rotor speed, or torque) has left the bounds of normal operation.'//NewLine// &
                    'The filtered hub-height wind speed will be used instead. This warning will not persist even though the condition may.'//NewLine// &
                    'Check WE_Op in the ROSCO .dbg file to see if the WSE is enabled (1) or disabled (0).'//NewLine// &
                    '***************************************************************************************************************************************'
                PRINT *, TRIM(WarningMessage)

                LocalVar%RestartWSE = 0 ! Restart
            ENDIF

            IF (LocalVar%WE_Op == 1 .AND. LocalVar%WE_Op_Last == 0) THEN    ! Transition from non-operational to operational
                LocalVar%RestartWSE = 0  ! Restart
            ENDIF
        ENDIF

        ! Filter the wind speed at hub height regardless, only use if WE_Mode = 0 or WE_Op = 0
        ! Re-initialize at WE_Vw if leaving operational wind, WE_Vw is initialized at HorWindV
        LocalVar%HorWindV_F = cos(LocalVar%NacVaneF*D2R) * LPFilter(LocalVar%HorWindV, LocalVar%DT, CntrPar%F_WECornerFreq/10, LocalVar%FP, LocalVar%RestartWSE, LocalVar%restart, objInst%instLPF, LocalVar%WE_Vw)

        ! ---- Debug Inputs ------
        DebugVar%WE_b   = WE_Inp_Pitch
        DebugVar%WE_w   = WE_Inp_Speed
        DebugVar%WE_t   = WE_Inp_Torque

        ! ---- Define wind speed estimate ---- 
        
        ! Inversion and Invariance Filter implementation
        IF (CntrPar%WE_Mode == 1 .AND. LocalVar%WE_Op > 0) THEN      
            ! Compute AeroDynTorque
            Tau_r = AeroDynTorque(LocalVar%RotSpeedF, LocalVar%BlPitchCMeas, LocalVar, CntrPar, PerfData, ErrVar)

            LocalVar%WE_VwIdot = CntrPar%WE_Gamma/CntrPar%WE_Jtot*(LocalVar%VS_LastGenTrq*CntrPar%WE_GearboxRatio - Tau_r)
            LocalVar%WE_VwI = LocalVar%WE_VwI + LocalVar%WE_VwIdot*LocalVar%DT
            LocalVar%WE_Vw = LocalVar%WE_VwI + CntrPar%WE_Gamma*LocalVar%RotSpeedF

        ! Extended Kalman Filter (EKF) implementation
        ELSEIF (CntrPar%WE_Mode == 2 .AND. LocalVar%WE_Op > 0) THEN
            ! Define contant values
            L = 6.0 * CntrPar%WE_BladeRadius
            Ti = 0.18
            R_m = 0.02
            H = RESHAPE((/1.0 , 0.0 , 0.0/),(/1,3/))
            ! Define matrices to be filled
            F = RESHAPE((/0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/),(/3,3/))
            Q = RESHAPE((/0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/),(/3,3/))
            IF (LocalVar%RestartWSE == 0) THEN
                ! Initialize recurring values
                LocalVar%WE%om_r = WE_Inp_Speed
                LocalVar%WE%v_t = 0.0
                LocalVar%WE%v_m = max(LocalVar%HorWindV_F, 3.0_DbKi)   ! avoid divide by 0 below if HorWindV_F is 0, which some AMRWind setups create
                LocalVar%WE%v_h = max(LocalVar%HorWindV_F, 3.0_DbKi)   ! avoid divide by 0 below if HorWindV_F is 0, which some AMRWind setups create
                LocalVar%WE_Vw = LocalVar%WE%v_m + LocalVar%WE%v_t   ! Initialize WE_Vw to aviod divide by zero
                lambda = WE_Inp_Speed * CntrPar%WE_BladeRadius/LocalVar%WE%v_h
                LocalVar%WE%xh = RESHAPE((/LocalVar%WE%om_r, LocalVar%WE%v_t, LocalVar%WE%v_m/),(/3,1/))
                LocalVar%WE%P = RESHAPE((/0.01, 0.0, 0.0, 0.0, 0.01, 0.0, 0.0, 0.0, 1.0/),(/3,3/))
                LocalVar%WE%K = RESHAPE((/0.0,0.0,0.0/),(/3,1/))
                Cp_op   = 0.25  ! initialize so debug output doesn't give *****
                
            ELSE

                ! Find estimated operating Cp and system pole
                A_op = interp1d(CntrPar%WE_FOPoles_v,CntrPar%WE_FOPoles,LocalVar%WE%v_h,ErrVar)

                ! TEST INTERP2D
                lambda = max(WE_Inp_Speed, EPSILON(1.0_DbKi)) * CntrPar%WE_BladeRadius/LocalVar%WE%v_h
                Cp_op = interp2d(PerfData%Beta_vec,PerfData%TSR_vec,PerfData%Cp_mat, WE_Inp_Pitch*R2D, lambda , ErrVar)
                Cp_op = max(0.0,Cp_op)
                
                ! Update Jacobian
                F(1,1) = A_op
                F(1,2) = 1.0/(2.0*CntrPar%WE_Jtot) * CntrPar%WE_RhoAir * PI *CntrPar%WE_BladeRadius**2.0 * 1/LocalVar%WE%om_r * 3.0 * Cp_op * LocalVar%WE%v_h**2.0
                F(1,3) = 1.0/(2.0*CntrPar%WE_Jtot) * CntrPar%WE_RhoAir * PI *CntrPar%WE_BladeRadius**2.0 * 1/LocalVar%WE%om_r * 3.0 * Cp_op * LocalVar%WE%v_h**2.0
                F(2,2) = - PI * LocalVar%WE%v_m/(2.0*L)
                F(2,3) = - PI * LocalVar%WE%v_t/(2.0*L)
                
                ! Update process noise covariance
                Q(1,1) = 0.00001
                Q(2,2) =(PI * (LocalVar%WE%v_m**3.0) * (Ti**2.0)) / L
                Q(3,3) = (2.0**2.0)/600.0
                
                ! Prediction update
                Tau_r = AeroDynTorque(WE_Inp_Speed, WE_Inp_Pitch, LocalVar, CntrPar, PerfData, ErrVar)
                a = PI * LocalVar%WE%v_m/(2.0*L)
                dxh(1,1) = 1.0/CntrPar%WE_Jtot * (Tau_r - CntrPar%WE_GearboxRatio * WE_Inp_Torque)
                dxh(2,1) = -a*LocalVar%WE%v_t
                dxh(3,1) = 0.0
                
                LocalVar%WE%xh = LocalVar%WE%xh + LocalVar%DT * dxh ! state update
                LocalVar%WE%P = LocalVar%WE%P + LocalVar%DT*(MATMUL(F,LocalVar%WE%P) + MATMUL(LocalVar%WE%P,TRANSPOSE(F)) + Q - MATMUL(LocalVar%WE%K * R_m, TRANSPOSE(LocalVar%WE%K))) 
                
                ! Measurement update
                S = MATMUL(H,MATMUL(LocalVar%WE%P,TRANSPOSE(H))) + R_m        ! NJA: (H*T*H') \approx 0
                LocalVar%WE%K = MATMUL(LocalVar%WE%P,TRANSPOSE(H))/S(1,1)
                LocalVar%WE%xh = LocalVar%WE%xh + LocalVar%WE%K*(WE_Inp_Speed - LocalVar%WE%om_r)
                LocalVar%WE%P = MATMUL(identity(3) - MATMUL(LocalVar%WE%K,H),LocalVar%WE%P)
                
                
                ! Wind Speed Estimate
                LocalVar%WE%om_r = max(LocalVar%WE%xh(1,1), EPSILON(1.0_DbKi))
                LocalVar%WE%v_t = LocalVar%WE%xh(2,1)
                LocalVar%WE%v_m = LocalVar%WE%xh(3,1)
                LocalVar%WE%v_h = LocalVar%WE%v_t + LocalVar%WE%v_m
                LocalVar%WE_Vw = LocalVar%WE%v_m + LocalVar%WE%v_t

                IF (ieee_is_nan(LocalVar%WE%v_h)) THEN
                    LocalVar%WE%om_r = WE_Inp_Speed
                    LocalVar%WE%v_t = 0.0
                    LocalVar%WE%v_m = LocalVar%HorWindV
                    LocalVar%WE%v_h = LocalVar%HorWindV
                    LocalVar%WE_Vw = LocalVar%WE%v_m + LocalVar%WE%v_t
                ENDIF

            ENDIF
            ! Debug Outputs
            DebugVar%WE_Cp = Cp_op
            DebugVar%WE_Vm = LocalVar%WE%v_m
            DebugVar%WE_Vt = LocalVar%WE%v_t
            DebugVar%WE_lambda = lambda
        ELSE        
            ! Use filtered hub-height
            LocalVar%WE_Vw = LocalVar%HorWindV_F
        ENDIF 
        DebugVar%WE_Vw = LocalVar%WE_Vw
        ! Add RoutineName to error message
        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
        ENDIF

    END SUBROUTINE WindSpeedEstimator
!-------------------------------------------------------------------------------------------------------------------------------
    SUBROUTINE SetpointSmoother(LocalVar, CntrPar, objInst)
    ! Setpoint smoother modifies controller reference in order to separate generator torque and blade pitch control actions
    !       SS_Mode = 0, No setpoint smoothing
    !       SS_Mode = 1, Implement setpoint smoothing
        USE ROSCO_Types, ONLY : LocalVariables, ControlParameters, ObjectInstances
        IMPLICIT NONE
    
        ! Inputs
        TYPE(ControlParameters),    INTENT(IN   )       :: CntrPar
        TYPE(LocalVariables),       INTENT(INOUT)       :: LocalVar 
        TYPE(ObjectInstances),      INTENT(INOUT)       :: objInst
        ! Allocate Variables
        REAL(DbKi)                      :: DelOmega                            ! Reference generator speed shift, rad/s.
        REAL(DbKi)                      :: R_Total                            ! Total power rating command
        
        ! ------ Setpoint Smoothing ------
        IF ( CntrPar%SS_Mode == 1) THEN
            ! Find setpoint shift amount
            R_Total = LocalVar%PRC_R_Speed * LocalVar%PRC_R_Torque * LocalVar%PRC_R_Pitch
            DelOmega = ((LocalVar%BlPitchCMeas - LocalVar%PC_MinPit)/0.524) * CntrPar%SS_VSGain - ((CntrPar%VS_RtPwr * R_Total - LocalVar%VS_LastGenPwr))/CntrPar%VS_RtPwr * CntrPar%SS_PCGain ! Normalize to 30 degrees for now
            DelOmega = DelOmega * CntrPar%PC_RefSpd
            ! Filter
            LocalVar%SS_DelOmegaF = LPFilter(DelOmega, LocalVar%DT, CntrPar%F_SSCornerFreq, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instLPF) 
        ELSE
            LocalVar%SS_DelOmegaF = 0 ! No setpoint smoothing
        ENDIF

    END SUBROUTINE SetpointSmoother
!-------------------------------------------------------------------------------------------------------------------------------
    REAL(DbKi) FUNCTION PitchSaturation(LocalVar, CntrPar, objInst, DebugVar, ErrVar) 
    ! PitchSaturation defines a minimum blade pitch angle based on a lookup table provided by DISCON.IN
    ! Minimum pitch for power control also happens here


        USE ROSCO_Types, ONLY : LocalVariables, ControlParameters, ObjectInstances, DebugVariables, ErrorVariables
        IMPLICIT NONE
        ! Inputs
        TYPE(ControlParameters),    INTENT(IN   )       :: CntrPar
        TYPE(LocalVariables),       INTENT(INOUT)       :: LocalVar 
        TYPE(ObjectInstances),      INTENT(INOUT)       :: objInst
        TYPE(DebugVariables),       INTENT(INOUT)       :: DebugVar
        TYPE(ErrorVariables),       INTENT(INOUT)       :: ErrVar

        CHARACTER(*),               PARAMETER           :: RoutineName = 'PitchSaturation'

        ! Define minimum blade pitch angle for peak shaving as a function of estimated wind speed
        LocalVar%PS_Min_Pitch = interp1d(CntrPar%PS_WindSpeeds, CntrPar%PS_BldPitchMin, LocalVar%WE_Vw_F, ErrVar)

        ! Total min pitch limit is greater of peak shaving and power control pitch
        PitchSaturation = max(LocalVar%PS_Min_Pitch, LocalVar%PRC_Min_Pitch)

        ! Add RoutineName to error message
        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
        ENDIF

    END FUNCTION PitchSaturation
!-------------------------------------------------------------------------------------------------------------------------------
    SUBROUTINE Startup(LocalVar, CntrPar, objInst,ErrVar) 
    ! Start up procedure of turbine
        USE ROSCO_Types, ONLY : LocalVariables, ControlParameters, ObjectInstances
        IMPLICIT NONE
        ! Inputs
        TYPE(ControlParameters),    INTENT(IN   )       :: CntrPar
        TYPE(LocalVariables),       INTENT(INOUT)       :: LocalVar 
        TYPE(ObjectInstances),      INTENT(INOUT)       :: objInst
        TYPE(ErrorVariables),       INTENT(INOUT)       :: ErrVar
        
        ! Local Variables 
        CHARACTER(*),PARAMETER           :: RoutineName = 'Startup'
        Real(DbKi)              :: SU_PrevLoad             ! PRC_R_Toruqe value at the previous stage

        
        ! SU_Stage = -1  (pre startup waiting for transients)
        ! SU_Stage = 1  (freewheeling)
        ! SU_Stage = 2  (load stage 1)
        ! SU_Stage = 3  (load stage 2)
        ! SU_Stage = 4  (load stage 3)
        ! ...
        ! SU_Stage = 0  (startup complete, normal operation)
        
        !Filterd rotor speed
        LocalVar%SU_RotSpeedF = LPFilter(LocalVar%RotSpeed, LocalVar%DT, CntrPar%SU_RotorSpeedCornerFreq, LocalVar%FP,LocalVar%iStatus, LocalVar%restart, objInst%instLPF)

        !Initialize startup stage (SU_Stage)
        IF (LocalVar%iStatus == 0) THEN
            ! Initilize startup stage variable to 1 to denote FreeWheeling
            LocalVar%SU_Stage = -1
        ENDIF

        IF ((LocalVar%SU_Stage == -1) .AND. (LocalVar%Time > CntrPar%SU_StartTime)) THEN
            LocalVar%SU_Stage = 1
        ENDIF
        
        ! Determine last time at which rotor speed was below 0.95*threshold speed during freewheeling
        IF ((LocalVar%SU_Stage == 1) .AND. &
        (LocalVar%SU_RotSpeedF < 0.95_DbKi * CntrPar%SU_RotorSpeedThresh)) THEN
            LocalVar%SU_LoadStageStartTime = LocalVar%Time
        ENDIF
        
        !If free-wheeling exit criteria are met, swtich to load stages
        IF ((LocalVar%SU_Stage == 1) .AND. &
        (LocalVar%Time>=(CntrPar%SU_FW_MinDuration+LocalVar%SU_LoadStageStartTime))) THEN
            LocalVar%SU_LoadStageStartTime = LocalVar%Time
            LocalVar%SU_Stage = 2
        ENDIF

        ! Switch to next load stage when criteria are met
        IF ((LocalVar%SU_Stage .ge. 2) .AND. &
        (LocalVar%Time >= LocalVar%SU_LoadStageStartTime + CntrPar%SU_LoadRampDuration(LocalVar%SU_Stage-1) + &
        CntrPar%SU_LoadHoldDuration(LocalVar%SU_Stage-1)) .AND. &
        (LocalVar%SU_Stage .le. CntrPar%SU_LoadStages_N+1)) THEN
            LocalVar%SU_Stage = LocalVar%SU_Stage + 1
            LocalVar%SU_LoadStageStartTime = LocalVar%Time
        ENDIF

        ! Set PRC_R_Speed, SU_PrevLoad based on SU_Stage
        IF (LocalVar%SU_Stage == 1) THEN
            LocalVar%PRC_R_Speed = CntrPar%SU_RotorSpeedThresh / CntrPar%PC_RefSpd
        ELSEIF (LocalVar%SU_Stage == 2) THEN
            SU_PrevLoad = 0.0_DbKi
            ! Ramp up PRC_R_Speed to 1.0 in duration = SU_LoadRampDuration(1)
            LocalVar%PRC_R_Speed = sigma(LocalVar%Time,LocalVar%SU_LoadStageStartTime,    &
                LocalVar%SU_LoadStageStartTime + CntrPar%SU_LoadRampDuration(LocalVar%SU_Stage - 1),    &
                CntrPar%SU_RotorSpeedThresh / CntrPar%PC_RefSpd ,1.0_DbKi,ErrVar)
        ELSEIF ((LocalVar%SU_Stage .ge. 2) .AND. (LocalVar%SU_Stage .le. CntrPar%SU_LoadStages_N + 1)) THEN
            SU_PrevLoad = CntrPar%SU_LoadStages(LocalVar%SU_Stage-2)
        ELSEIF (LocalVar%SU_Stage == CntrPar%SU_LoadStages_N + 2) THEN
            ! Set SU_Stage = 0 when startup is over.
            LocalVar%SU_Stage = 0
        ENDIF

        ! Set PRC_R_Torque based on SU_Stage
        IF ((LocalVar%SU_Stage == 1) .OR. (LocalVar%SU_Stage == -1)) THEN
            LocalVar%PRC_R_Torque = 0.0_DbKi
        ELSEIF ((LocalVar%SU_Stage .ge. 2) .AND. (LocalVar%SU_Stage .le. CntrPar%SU_LoadStages_N + 1)) THEN
            IF (LocalVar%Time < LocalVar%SU_LoadStageStartTime + CntrPar%SU_LoadRampDuration(LocalVar%SU_Stage-1)) THEN
                LocalVar%PRC_R_Torque = sigma(LocalVar%Time,LocalVar%SU_LoadStageStartTime,    &
                LocalVar%SU_LoadStageStartTime + CntrPar%SU_LoadRampDuration(LocalVar%SU_Stage - 1),    &
                SU_PrevLoad,CntrPar%SU_LoadStages(LocalVar%SU_Stage - 1),ErrVar)
            ELSE
                LocalVar%PRC_R_Torque = CntrPar%SU_LoadStages(LocalVar%SU_Stage - 1)
            ENDIF
        ENDIF


    END SUBROUTINE Startup
!-------------------------------------------------------------------------------------------------------------------------------
    SUBROUTINE Shutdown(LocalVar, CntrPar, objInst,ErrVar) 
    ! Check for shutdown
        USE ROSCO_Types, ONLY : LocalVariables, ControlParameters, ObjectInstances
        IMPLICIT NONE
        ! Inputs
        TYPE(ControlParameters),    INTENT(IN   )       :: CntrPar
        TYPE(LocalVariables),       INTENT(INOUT)       :: LocalVar 
        TYPE(ObjectInstances),      INTENT(INOUT)       :: objInst
        TYPE(ErrorVariables),       INTENT(INOUT)       :: ErrVar
        
        ! Local Variables 
        CHARACTER(*),               PARAMETER           :: RoutineName = 'Shutdown'
        REAL(DbKi)       :: SD_NacVaneCosF                 ! Time-filtered x-component of NacVane (deg)
        REAL(DbKi)       :: SD_NacVaneSinF                 ! Time-filtered y-component of NacVane (deg)
        INTEGER(IntKi)   :: I_Stage                         ! Loop variable for shutdown stages

        !Initialize shutdown trigger variable
        IF (LocalVar%iStatus == 0) THEN
            LocalVar%SD_Trigger = 0
        ENDIF
        

        ! Filter pitch signal
        LocalVar%SD_BlPitchF = LPFilter(LocalVar%BlPitchCMeas, LocalVar%DT, CntrPar%SD_PitchCornerFreq, LocalVar%FP,LocalVar%iStatus, LocalVar%restart, objInst%instLPF)
        ! Filter generator speed
        LocalVar%SD_GenSpeedF = LPFilter(LocalVar%Genspeed, LocalVar%DT, CntrPar%SD_GenSpdCornerFreq, LocalVar%FP,LocalVar%iStatus, LocalVar%restart, objInst%instLPF)

        ! Filter yaw error signal (NacVane)
        SD_NacVaneCosF = LPFilter(cos(LocalVar%NacVane*D2R), LocalVar%DT, CntrPar%SD_YawErrorCornerFreq, LocalVar%FP,LocalVar%iStatus, LocalVar%restart, objInst%instLPF)
        SD_NacVaneSinF = LPFilter(sin(LocalVar%NacVane*D2R), LocalVar%DT, CntrPar%SD_YawErrorCornerFreq, LocalVar%FP,LocalVar%iStatus, LocalVar%restart, objInst%instLPF)
        LocalVar%SD_NacVaneF = wrap_180(atan2(SD_NacVaneSinF, SD_NacVaneCosF) * R2D) ! (in deg)
        
        ! See if we should shutdown
        IF ((LocalVar%SD_Trigger == 0) .AND. (LocalVar%Time>=CntrPar%SD_TimeActivate)) THEN
            IF (CntrPar%SD_EnablePitch==1 .AND. LocalVar%SD_BlPitchF > CntrPar%SD_MaxPit) THEN
                ! Shutdown if above pitch exceeds shutdown threshold
                LocalVar%SD_Trigger  = 1
            ENDIF
            IF (CntrPar%SD_EnableYawError==1 .AND. ABS(LocalVar%SD_NacVaneF) > CntrPar%SD_MaxYawError) THEN
                LocalVar%SD_Trigger = 2
            ENDIF
            IF (CntrPar%SD_EnableGenSpeed==1 .AND. LocalVar%SD_GenSpeedF > CntrPar%SD_MaxGenSpd) THEN
                LocalVar%SD_Trigger = 3
            ENDIF 
            IF (CntrPar%SD_EnableTime==1 .AND. LocalVar%Time > CntrPar%SD_Time) THEN
                LocalVar%SD_Trigger = 4
            ENDIF 
        ENDIF

        ! Method 1: stage depends on time
        IF (CntrPar%SD_Method == 1) THEN
            ! State machine for shutdown stages
            
            IF (LocalVar%SD_Stage == 0) THEN
                ! Normal operation, check for shutdown trigger
                IF (LocalVar%SD_Trigger > 0) THEN
                    LocalVar%SD_Stage = 1 ! First shutdown stage
                    LocalVar%SD_StageStartTime = LocalVar%Time
                ENDIF
                
                ! Set maximum pitch and torque rates (for completeness)
                LocalVar%SD_MaxPitchRate    = 0 
                LocalVar%SD_MaxTorqueRate   = 0 

            ELSEIF (LocalVar%SD_Stage .LE. CntrPar%SD_Stage_N) THEN
                LocalVar%SD_MaxPitchRate    = CntrPar%SD_MaxPitchRate(LocalVar%SD_Stage)
                LocalVar%SD_MaxTorqueRate   = CntrPar%SD_MaxTorqueRate(LocalVar%SD_Stage)
                
                ! Shutdown stage
                IF (LocalVar%Time >= LocalVar%SD_StageStartTime + CntrPar%SD_StageTime(LocalVar%SD_Stage)) THEN
                    LocalVar%SD_Stage = LocalVar%SD_Stage + 1 ! Next shutdown stage
                    LocalVar%SD_StageStartTime = LocalVar%Time
                ENDIF                

            ELSE  ! Stage > CntrPar%SD_Stage_N
                LocalVar%SD_MaxPitchRate    = CntrPar%PC_MaxRat
                LocalVar%SD_MaxTorqueRate   = CntrPar%VS_MaxRat
            ENDIF
       
        ! Shutdown method 2: stage depends on blade pitch (LocalVar%BlPitchCMeas)
        ELSEIF (CntrPar%SD_Method == 2) THEN
            ! State machine for shutdown stages
            
            IF (LocalVar%SD_Stage == 0) THEN
                ! Normal operation, check for shutdown trigger
                IF (LocalVar%SD_Trigger > 0) THEN
                    LocalVar%SD_Stage = 1 ! First shutdown stage
                ENDIF
                
                ! Set maximum pitch and torque rates (for completeness)
                LocalVar%SD_MaxPitchRate    = 0 
                LocalVar%SD_MaxTorqueRate   = 0 

            ELSE ! Stage > 0
                
                ! Figure out what stage we are in
                DO I_Stage = 1, CntrPar%SD_Stage_N
                    IF (LocalVar%BlPitchCMeas >= CntrPar%SD_StagePitch(I_Stage)) THEN
                        LocalVar%SD_Stage = I_Stage + 1
                    ENDIF
                ENDDO
                
                ! Set maximum pitch and torque rates
                IF (LocalVar%SD_Stage > CntrPar%SD_Stage_N) THEN
                    LocalVar%SD_MaxPitchRate    = CntrPar%PC_MaxRat
                    LocalVar%SD_MaxTorqueRate   = CntrPar%VS_MaxRat
                ELSE
                    LocalVar%SD_MaxPitchRate    = CntrPar%SD_MaxPitchRate(LocalVar%SD_Stage)
                    LocalVar%SD_MaxTorqueRate   = CntrPar%SD_MaxTorqueRate(LocalVar%SD_Stage)
                ENDIF 

            ENDIF
        ENDIF



        
        ! Add RoutineName to error message
        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
        ENDIF

    END SUBROUTINE Shutdown
!-------------------------------------------------------------------------------------------------------------------------------
!-------------------------------------------------------------------------------------------------------------------------------
    SUBROUTINE RefSpeedExclusion(LocalVar, CntrPar, objInst, DebugVar) 
    ! Reference speed exclusion:
    !   Changes torque controllerr reference speed to avoid specified frequencies by a prescribed bandwidth
        USE ROSCO_Types, ONLY : LocalVariables, ControlParameters, DebugVariables, ObjectInstances
        IMPLICIT NONE
        ! Inputs
        TYPE(ControlParameters),    INTENT(IN   )       :: CntrPar
        TYPE(LocalVariables),       INTENT(INOUT)       :: LocalVar 
        TYPE(DebugVariables),      INTENT(INOUT)        :: DebugVar
        TYPE(ObjectInstances),      INTENT(INOUT)       :: objInst

        
        REAL(DbKi)                             :: VS_RefSpeed_LSS
        
        ! Get LSS Ref speed
        VS_RefSpeed_LSS = LocalVar%VS_RefSpd/CntrPar%WE_GearboxRatio

        IF ((VS_RefSpeed_LSS > CntrPar%TRA_ExclSpeed - CntrPar%TRA_ExclBand / 2) .AND. &
            (VS_RefSpeed_LSS < CntrPar%TRA_ExclSpeed + CntrPar%TRA_ExclBand / 2)) THEN
            ! In hysteresis zone, hold reference speed
            LocalVar%FA_Hist = 1 ! Set negative hysteris if ref < exclusion band
        ELSE
            LocalVar%FA_Hist = 0
        END IF

        ! Initialize last reference speed state
        IF (LocalVar%restart) THEN
            ! If starting in hist band
            IF (LocalVar%FA_Hist > 0) THEN
                IF (VS_RefSpeed_LSS > CntrPar%TRA_ExclSpeed) THEN
                    LocalVar%TRA_LastRefSpd = CntrPar%TRA_ExclSpeed + CntrPar%TRA_ExclBand / 2
                ELSE
                    LocalVar%TRA_LastRefSpd = CntrPar%TRA_ExclSpeed - CntrPar%TRA_ExclBand / 2
                ENDIF
            ELSE
                LocalVar%TRA_LastRefSpd = VS_RefSpeed_LSS
            END IF
        END IF 


        IF (LocalVar%FA_Hist > 0) THEN
            LocalVar%VS_RefSpd_TRA = LocalVar%TRA_LastRefSpd
        ELSE
            LocalVar%VS_RefSpd_TRA = VS_RefSpeed_LSS
        END IF

        ! Save last reference speed       
        LocalVar%TRA_LastRefSpd = LocalVar%VS_RefSpd_TRA

        ! Rate limit reference speed
        LocalVar%VS_RefSpd_RL = ratelimit(LocalVar%VS_RefSpd_TRA, -CntrPar%TRA_RateLimit, CntrPar%TRA_RateLimit, LocalVar%DT, LocalVar%restart, LocalVar%rlP,objInst%instRL)
        LocalVar%VS_RefSpd = LocalVar%VS_RefSpd_RL * CntrPar%WE_GearboxRatio


        
    END SUBROUTINE RefSpeedExclusion
!-------------------------------------------------------------------------------------------------------------------------------
END MODULE ControllerBlocks

! Copyright 2019 NREL

! Licensed under the Apache License, Version 2.0 (the "License"); you may not use
! this file except in compliance with the License. You may obtain a copy of the
! License at http://www.apache.org/licenses/LICENSE-2.0

! Unless required by applicable law or agreed to in writing, software distributed
! under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
! CONDITIONS OF ANY KIND, either express or implied. See the License for the
! specific language governing permissions and limitations under the License.
! -------------------------------------------------------------------------------------------
! Read and set the parameters used by the controller

MODULE ReadSetParameters

    USE, INTRINSIC :: ISO_C_Binding

    USE Constants
    USE Functions
    USE Filters
    USE SysSubs
    USE ROSCO_Helpers
    IMPLICIT NONE


CONTAINS
 ! -----------------------------------------------------------------------------------
    ! Read avrSWAP array passed from ServoDyn    
    SUBROUTINE ReadAvrSWAP(avrSWAP, LocalVar, CntrPar, ErrVar)
        USE ROSCO_Types, ONLY : LocalVariables

        REAL(ReKi), INTENT(INOUT) :: avrSWAP(*)   ! The swap array, used to pass data to, and receive data from, the DLL controller.
        TYPE(LocalVariables), INTENT(INOUT) :: LocalVar
        TYPE(ControlParameters), INTENT(IN) :: CntrPar
        TYPE(ErrorVariables), INTENT(INOUT) :: ErrVar

        ! Allocate Variables:
        INTEGER(IntKi)                                  :: K         ! Index used for looping through blades.

        ! Load variables from calling program (See Appendix A of Bladed User's Guide):
        LocalVar%iStatus            = NINT(avrSWAP(1))
        LocalVar%Time               = avrSWAP(2)
        LocalVar%DT                 = avrSWAP(3)
        LocalVar%VS_MechGenPwr      = avrSWAP(14)
        LocalVar%VS_GenPwr          = avrSWAP(15)
        LocalVar%GenSpeed           = avrSWAP(20)
        LocalVar%RotSpeed           = avrSWAP(21)
        LocalVar%GenTqMeas          = avrSWAP(23)
        LocalVar%NacVane            = avrSWAP(24) * R2D
        LocalVar%HorWindV           = avrSWAP(27)
        LocalVar%rootMOOP(1)        = avrSWAP(30)
        LocalVar%rootMOOP(2)        = avrSWAP(31)
        LocalVar%rootMOOP(3)        = avrSWAP(32)
        LocalVar%NacHeading         = avrSWAP(37) * R2D
        LocalVar%FA_Acc_TT          = avrSWAP(53)  ! This is the translational acceleration of the tower top in the non-rotating frame
        LocalVar%SS_Acc_TT          = avrSWAP(54)  ! This is the translational acceleration of the tower top in the non-rotating frame
        LocalVar%NacIMU_FA_RAcc      = avrSWAP(83)  ! This is the rotational aceleration of the nacelle in the shaft frame
        LocalVar%Azimuth            = avrSWAP(60)
        LocalVar%NumBl              = NINT(avrSWAP(61))

        if (CntrPar%Ext_Interface > 0) THEN ! Use extended bladed interface

            ! Platform signals 
            LocalVar%PtfmTDX            = avrSWAP(1001)
            LocalVar%PtfmTDY            = avrSWAP(1002)
            LocalVar%PtfmTDZ            = avrSWAP(1003)
            LocalVar%PtfmRDX            = avrSWAP(1004)
            LocalVar%PtfmRDY            = avrSWAP(1005)
            LocalVar%PtfmRDZ            = avrSWAP(1006)
            LocalVar%PtfmTVX            = avrSWAP(1007)
            LocalVar%PtfmTVY            = avrSWAP(1008)
            LocalVar%PtfmTVZ            = avrSWAP(1009)
            LocalVar%PtfmRVX            = avrSWAP(1010)
            LocalVar%PtfmRVY            = avrSWAP(1011)
            LocalVar%PtfmRVZ            = avrSWAP(1012)
            LocalVar%PtfmTAX            = avrSWAP(1013)
            LocalVar%PtfmTAY            = avrSWAP(1014)
            LocalVar%PtfmTAZ            = avrSWAP(1015)
            LocalVar%PtfmRAX            = avrSWAP(1016)
            LocalVar%PtfmRAY            = avrSWAP(1017)
            LocalVar%PtfmRAZ            = avrSWAP(1018)

        ENDIF


        ! Check that we haven't already loaded this dynamic library
        IF (LocalVar%iStatus == 0) THEN
            IF (LocalVar%AlreadyInitialized == 0) THEN
                LocalVar%AlreadyInitialized = 1
            ELSE
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'ERROR: This ROSCO dynamic library has already been loaded.'
                RETURN
            ENDIF
        ENDIF


        

        ! --- NJA: usually feedback back the previous pitch command helps for numerical stability, sometimes it does not...
        IF (LocalVar%iStatus == 0) THEN
            LocalVar%BlPitch(1) = avrSWAP(4)
            LocalVar%BlPitch(2) = avrSWAP(33)
            LocalVar%BlPitch(3) = avrSWAP(34)
        ELSE
            
            ! Subtract pitch actuator fault for blade K - This in a sense would make the controller blind to the pitch fault
            IF (CntrPar%PF_Mode == 1) THEN
                DO K = 1, LocalVar%NumBl
                    ! This assumes that the pitch actuator fault is hardware fault
                    LocalVar%BlPitch(K) = LocalVar%PitComAct(K) - CntrPar%PF_Offsets(K) ! why is PitCom used and not PitComAct??
                END DO
            ELSE
                LocalVar%BlPitch(1) = LocalVar%PitComAct(1)
                LocalVar%BlPitch(2) = LocalVar%PitComAct(2)
                LocalVar%BlPitch(3) = LocalVar%PitComAct(3)     
            END IF

        ENDIF

        LocalVar%BlPitchCMeas = (1 / REAL(LocalVar%NumBl)) * (LocalVar%BlPitch(1) + LocalVar%BlPitch(2) + LocalVar%BlPitch(3)) 

        IF (LocalVar%iStatus == 0) THEN     ! TODO: Technically, LocalVar%Time > 0, too, but this restart is in many places as a reset
            LocalVar%restart = .True.
        ELSE
            LocalVar%restart = .False.
        ENDIF

        ! FA_Acc_TT is in the non-rotating tower-top frame, so we need to convert it to the rotating (nacelle) frame of reference
        LocalVar%FA_Acc_Nac = LocalVar%FA_Acc_TT * COS(LocalVar%NacHeading * D2R) + LocalVar%SS_Acc_TT * SIN(LocalVar%NacHeading * D2R)


        ! Increment timestep counter
        IF (LocalVar%iStatus == 0 .AND. LocalVar%Time == 0) THEN
            LocalVar%n_DT = 0
        ELSE
            LocalVar%n_DT = LocalVar%n_DT + 1
        ENDIF

    END SUBROUTINE ReadAvrSWAP    
! -----------------------------------------------------------------------------------
    ! Define parameters for control actions
    SUBROUTINE SetParameters(avrSWAP, accINFILE, size_avcMSG, CntrPar, LocalVar, objInst, PerfData, RootName, ErrVar)
                
        USE ROSCO_Types, ONLY : ControlParameters, LocalVariables, ObjectInstances, PerformanceData, ErrorVariables
        
        REAL(ReKi),                 INTENT(INOUT)   :: avrSWAP(*)          ! The swap array, used to pass data to, and receive data from, the DLL controller.
        CHARACTER(C_CHAR),          INTENT(IN   )   :: accINFILE(NINT(avrSWAP(50)))     ! The name of the parameter input file

        INTEGER(IntKi),             INTENT(IN   )   :: size_avcMSG
        TYPE(ControlParameters),    INTENT(INOUT)   :: CntrPar
        TYPE(LocalVariables),       INTENT(INOUT)   :: LocalVar
        TYPE(ObjectInstances),      INTENT(INOUT)   :: objInst
        TYPE(PerformanceData),      INTENT(INOUT)   :: PerfData
        TYPE(ErrorVariables),       INTENT(INOUT)   :: ErrVar
        CHARACTER(NINT(avrSWAP(50))-1), INTENT(IN)  :: RootName 

        
        INTEGER(IntKi)                              :: K, I, I_OL    ! Index used for looping through blades.
        CHARACTER(1024)                             :: OL_String                    ! Open description loop string
        INTEGER(IntKi)                              :: OL_Count                     ! Number of open loop channels
        INTEGER(IntKi)                              :: UnOpenLoop       ! Open Loop file unit
        INTEGER(IntKi)                              :: N_OL_Cables
        INTEGER(IntKi)                              :: N_OL_StCs

        CHARACTER(*),               PARAMETER       :: RoutineName = 'SetParameters'

        
        
        ! Error Catching Variables
        ! Set ErrVar%aviFAIL to 0 in each iteration:
        ErrVar%aviFAIL = 0
        ! ALLOCATE(ErrVar%ErrMsg(size_avcMSG-1))
        ErrVar%size_avcMSG  = size_avcMSG
        
        ! Initialize all filter instance counters at 1
        objInst%instLPF         = 1
        objInst%instSecLPF      = 1
        objInst%instSecLPFV     = 1
        objInst%instHPF         = 1
        objInst%instNotchSlopes = 1
        objInst%instNotch       = 1
        objInst%instPI          = 1
        objInst%instRes         = 1
        objInst%instRL          = 1
        
        ! Set unused outputs to zero (See Appendix A of Bladed User's Guide):
        avrSWAP(35) = 1.0 ! Generator contactor status: 1=main (high speed) variable-speed generator
        avrSWAP(36) = 0.0 ! Shaft brake status: 0=off
        avrSWAP(41) = 0.0 ! Demanded yaw actuator torque
        avrSWAP(46) = 0.0 ! Demanded pitch rate (Collective pitch)
        avrSWAP(55) = 0.0 ! Pitch override: 0=yes
        avrSWAP(56) = 0.0 ! Torque override: 0=yes
        avrSWAP(65) = 0.0 ! Number of variables returned for logging
        avrSWAP(72) = 0.0 ! Generator start-up resistance
        avrSWAP(79) = 4.0 ! Request for loads: 0=none
        avrSWAP(80) = 0.0 ! Variable slip current status
        avrSWAP(81) = 0.0 ! Variable slip current demand
        
        ! Read any External Controller Parameters specified in the User Interface
        !   and initialize variables:
        IF (LocalVar%iStatus == 0) THEN ! .TRUE. if we're on the first call to the DLL
            
            ! Inform users that we are using this user-defined routine:
            ! ErrVar%aviFAIL = 1
            write (*,*) '                                                                              '//NEW_LINE('A')// &
                        '------------------------------------------------------------------------------'//NEW_LINE('A')// &
                        'Running ROSCO-'//TRIM(rosco_version)//NEW_LINE('A')// &
                        'A wind turbine controller framework for public use in the scientific field    '//NEW_LINE('A')// &
                        'Developed in collaboration: National Renewable Energy Laboratory              '//NEW_LINE('A')// &
                        '                            Delft University of Technology, The Netherlands   '//NEW_LINE('A')// &
                        '------------------------------------------------------------------------------'
            ! Specifically save accINFILE info (DISCON.IN)
            LocalVar%ACC_INFILE_SIZE = NINT(avrSWAP(50))
            Allocate(LocalVar%ACC_INFILE(LocalVar%ACC_INFILE_SIZE))
            LocalVar%ACC_INFILE = accINFILE

            ! Read Control Parameter File
            CALL ReadControlParameterFileSub(CntrPar, LocalVar, accINFILE, NINT(avrSWAP(50)), RootName, ErrVar)
            ! If there's been an file reading error, don't continue
            ! Add RoutineName to error message
            IF (ErrVar%aviFAIL < 0) THEN
                ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
                RETURN
            ENDIF

            IF (CntrPar%WE_Mode > 0) THEN
                CALL READCpFile(CntrPar,PerfData,ErrVar)
            ENDIF
        
            ! Initialize the Local variables:
            LocalVar%PitCom     = LocalVar%BlPitch ! This will ensure that the variable speed controller picks the correct control region and the pitch controller picks the correct gain on the first call

            ! Wind speed estimator initialization
            LocalVar%WE_Vw      = LocalVar%HorWindV
            LocalVar%WE_VwI     = LocalVar%WE_Vw - CntrPar%WE_Gamma*LocalVar%RotSpeed
            LocalVar%WE_Op      = 1
            LocalVar%WE_Op_Last = 1
            
            ! Setpoint Smoother initialization to zero
            LocalVar%SS_DelOmegaF = 0

            IF (CntrPar%VS_FBP == VS_FBP_Variable_Pitch) THEN
                ! Generator Torque at K omega^2 or rated
                IF (LocalVar%GenSpeed > 0.98 * CntrPar%PC_RefSpd) THEN
                    LocalVar%GenTq = CntrPar%VS_RtTq
                ELSE
                    LocalVar%GenTq = min(CntrPar%VS_RtTq, CntrPar%VS_Rgn2K*LocalVar%GenSpeed*LocalVar%GenSpeed)
                ENDIF
            ELSE
                ! Set torque initial condition based on operating schedule at current wind speed
                LocalVar%GenTq = interp1d(CntrPar%VS_FBP_U, CntrPar%VS_FBP_Tau, LocalVar%HorWindV, ErrVar)
            ENDIF
            LocalVar%VS_LastGenTrq = LocalVar%GenTq
            LocalVar%VS_MaxTq      = CntrPar%VS_MaxTq
            LocalVar%VS_GenPwr     = LocalVar%GenTq * LocalVar%GenSpeed * CntrPar%VS_GenEff/100.0
            
            ! Initialize variables
            LocalVar%CC_DesiredL = 0
            LocalVar%CC_ActuatedL = 0
            LocalVar%CC_ActuatedDL = 0
            LocalVar%StC_Input = 0

            LocalVar%ZMQ_YawOffset = 0
            LocalVar%ZMQ_PitOffset = 0
            LocalVar%ZMQ_ID = CntrPar%ZMQ_ID

            ! Check validity of input parameters:
            CALL CheckInputs(LocalVar, CntrPar, avrSWAP, ErrVar, size_avcMSG)

            ! Add RoutineName to error message
            IF (ErrVar%aviFAIL < 0) THEN
                ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
            ENDIF


        ENDIF

        ! Initialize other values on each timestep
        
        ! Open Loop index
        IF (CntrPar%OL_BP_Mode == 0) THEN
            LocalVar%OL_Index = LocalVar%Time

        ELSE
            ! Wind speed, OL_BP_Mode = 1
            LocalVar%OL_Index = LocalVar%WE_Vw
            IF (CntrPar%OL_BP_FiltFreq > 0) THEN
                LocalVar%OL_Index = LPFilter(LocalVar%WE_Vw, LocalVar%DT,CntrPar%OL_BP_FiltFreq, LocalVar%FP, LocalVar%iStatus, LocalVar%restart, objInst%instLPF)
            ENDIF

        ENDIF

    END SUBROUTINE SetParameters
    
    ! -----------------------------------------------------------------------------------
    ! Read all constant control parameters from DISCON.IN parameter file
    ! Also, all computed CntrPar%* parameters should be computed in this subroutine
    SUBROUTINE ReadControlParameterFileSub(CntrPar, LocalVar, accINFILE, accINFILE_size, RootName, ErrVar)!, accINFILE_size)
        USE, INTRINSIC :: ISO_C_Binding
        USE ROSCO_Types, ONLY : ControlParameters, ErrorVariables, LocalVariables

        INTEGER(IntKi)                                  :: accINFILE_size               ! size of DISCON input filename
        CHARACTER(accINFILE_size),  INTENT(IN   )       :: accINFILE(accINFILE_size)    ! DISCON input filename
        TYPE(ControlParameters),    INTENT(INOUT)       :: CntrPar                      ! Control parameter type
        TYPE(LocalVariables),        INTENT(INOUT)       :: LocalVar                       ! Control parameter type
        TYPE(ErrorVariables),       INTENT(INOUT)       :: ErrVar                       ! Control parameter type
        CHARACTER(accINFILE_size),  INTENT(IN)          :: RootName 

        
        INTEGER(IntKi)                                  :: UnControllerParameters  ! Unit number to open file

        CHARACTER(1024)                                 :: PriPath        ! Path name of the primary DISCON file

        CHARACTER(2048)                                 :: TmpLine        ! Path name of the primary DISCON file
        INTEGER(IntKi)                                  :: NumLines, IOS, I_LINE, ErrStat
        INTEGER(IntKi)                                  :: UnEc
        CHARACTER(128)                                  :: EchoFilename              ! Input checkpoint file
        CHARACTER(MaxLineLength), DIMENSION(:), ALLOCATABLE      :: FileLines

        INTEGER(IntKi)                                  :: I, I_OL    ! Index used for looping through blades.
        CHARACTER(1024)                                 :: OL_String                    ! Open description loop string
        INTEGER(IntKi)                                  :: OL_Count                     ! Number of open loop channels
        INTEGER(IntKi)                                  :: UnOpenLoop       ! Open Loop file unit
        INTEGER(IntKi)                                  :: N_OL_Cables
        INTEGER(IntKi)                                  :: N_OL_StCs
        
        CHARACTER(*),               PARAMETER           :: RoutineName = 'ReadControlParameterFileSub'

        ! Get primary path of DISCON.IN file (accINFILE(1) here)
        CALL GetPath( accINFILE(1), PriPath )     ! Input files will be relative to the path where the primary input file is located.
        CALL GetNewUnit(UnControllerParameters, ErrVar)
        OPEN(unit=UnControllerParameters, file=accINFILE(1), status='old', action='read')

        ! Read all lines, first get the number of lines
        NumLines = 0
        IOS = 0
        DO WHILE (IOS == 0)  ! read the rest of the file (until an error occurs)
            NumLines = NumLines + 1
            READ(UnControllerParameters,'(A)',IOSTAT=IOS) TmpLine        
        END DO !WHILE

        ALLOCATE(FileLines(NumLines))
        REWIND( UnControllerParameters )

        DO I_LINE = 1,NumLines
            READ(UnControllerParameters,'(A)',IOSTAT=IOS) FileLines(I_LINE)
        END DO

        ! Close Input File
        CLOSE(UnControllerParameters)

        ! Read Echo first, so file can be set up, if desired
        CALL ParseInput(FileLines,'Echo',           CntrPar%Echo,               accINFILE(1), ErrVar)
        IF (ErrVar%aviFAIL < 0) RETURN

        ! Set up echo file
        UnEc = 0
        IF (CntrPar%Echo > 0) THEN
            EchoFilename = TRIM(RootName)//'.RO.echo'
            CALL GetNewUnit(UnEc, ErrVar)
            OPEN(unit=UnEc, FILE=TRIM(EchoFilename), IOSTAT=ErrStat, ACTION='WRITE' )
            IF ( ErrStat /= 0 ) THEN
                ErrVar%ErrMsg  = 'Cannot open file '//TRIM( EchoFilename )//'. Another program may have locked it for writing.'
                ErrVar%aviFAIL = 1
            ELSE
                WRITE( UnEc, *) 'ROSCO ECHO file'
                WRITE( UnEc, *) 'Generated on '//CurDate()//' at '//CurTime()//' using ROSCO-'//TRIM(rosco_version)
                WRITE( UnEc, *)  NEW_LINE('A')
                WRITE( UnEc, *) 'Line Number',Tab,'Parameter',Tab,'Value'
                WRITE( UnEc, *) '-----------------------------------------'
            ENDIF
        ENDIF

        !----------------------- Simulation Control --------------------------
        CALL ParseInput(FileLines,'LoggingLevel',   CntrPar%LoggingLevel,       accINFILE(1), ErrVar, .TRUE., UnEc=UnEc)
        CALL ParseInput(FileLines,'DT_Out',         CntrPar%DT_Out,             accINFILE(1), ErrVar, .TRUE., UnEc=UnEc)
        CALL ParseInput(FileLines,'Ext_Interface',  CntrPar%Ext_Interface,      accINFILE(1), ErrVar, .TRUE., UnEc=UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !----------------- CONTROLLER FLAGS ---------------------
        CALL ParseInput(FileLines,'F_LPFType',       CntrPar%F_LPFType,         accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'IPC_ControlMode', CntrPar%IPC_ControlMode,   accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'VS_ControlMode',  CntrPar%VS_ControlMode,    accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'VS_ConstPower',   CntrPar%VS_ConstPower,     accINFILE(1), ErrVar, .TRUE., UnEc=UnEc) ! Default is 0
        CALL ParseInput(FileLines,'VS_FBP',          CntrPar%VS_FBP,            accINFILE(1), ErrVar, .TRUE., UnEc=UnEc) ! Default is 0
        CALL ParseInput(FileLines,'PC_ControlMode',  CntrPar%PC_ControlMode,    accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'Y_ControlMode',   CntrPar%Y_ControlMode,     accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'SS_Mode',         CntrPar%SS_Mode,           accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'PRC_Mode',        CntrPar%PRC_Mode,          accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'WE_Mode',         CntrPar%WE_Mode,           accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'PS_Mode',         CntrPar%PS_Mode,           accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'SU_Mode',         CntrPar%SU_Mode,           accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'SD_Mode',         CntrPar%SD_Mode,           accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'FL_Mode',         CntrPar%FL_Mode,           accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'TD_Mode',         CntrPar%TD_Mode,           accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'TRA_Mode',        CntrPar%TRA_Mode,          accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'Flp_Mode',        CntrPar%Flp_Mode,          accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'OL_Mode',         CntrPar%OL_Mode,           accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'PA_Mode',         CntrPar%PA_Mode,           accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'PF_Mode',         CntrPar%PF_Mode,           accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'AWC_Mode',        CntrPar%AWC_Mode,          accINFILE(1), ErrVar, UnEc=UnEc)
        CALL ParseInput(FileLines,'Ext_Mode',        CntrPar%Ext_Mode,          accINFILE(1), ErrVar, UnEc=UnEc)
		CALL ParseInput(FileLines,'ZMQ_Mode',        CntrPar%ZMQ_Mode,          accINFILE(1), ErrVar, UnEc=UnEc)
		CALL ParseInput(FileLines,'CC_Mode',         CntrPar%CC_Mode,           accINFILE(1), ErrVar, UnEc=UnEc)
		CALL ParseInput(FileLines,'StC_Mode',        CntrPar%StC_Mode,          accINFILE(1), ErrVar, UnEc=UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !----------------- FILTER CONSTANTS ---------------------
        CALL ParseInput(FileLines,  'F_LPFCornerFreq',      CntrPar%F_LPFCornerFreq,                             accINFILE(1), ErrVar, .FALSE., UnEc)
        CALL ParseInput(FileLines,  'F_LPFDamping',         CntrPar%F_LPFDamping,                                accINFILE(1), ErrVar, CntrPar%F_LPFType == 1, UnEc)
        CALL ParseInput(FileLines,  'F_NumNotchFilts',      CntrPar%F_NumNotchFilts,                             accINFILE(1), ErrVar, .TRUE., UnEc)
        CALL ParseAry(  FileLines,  'F_NotchFreqs',         CntrPar%F_NotchFreqs,       CntrPar%F_NumNotchFilts, accINFILE(1), ErrVar, CntrPar%F_NumNotchFilts == 0, UnEc)
        CALL ParseAry(  FileLines,  'F_NotchBetaNum',       CntrPar%F_NotchBetaNum,     CntrPar%F_NumNotchFilts, accINFILE(1), ErrVar, CntrPar%F_NumNotchFilts == 0, UnEc)
        CALL ParseAry(  FileLines,  'F_NotchBetaDen',       CntrPar%F_NotchBetaDen,     CntrPar%F_NumNotchFilts, accINFILE(1), ErrVar, CntrPar%F_NumNotchFilts == 0, UnEc)
        CALL ParseInput(FileLines,  'F_GenSpdNotch_N',      CntrPar%F_GenSpdNotch_N,                             accINFILE(1), ErrVar, CntrPar%F_NumNotchFilts == 0, UnEc)
        CALL ParseInput(FileLines,  'F_TwrTopNotch_N',      CntrPar%F_TwrTopNotch_N,                             accINFILE(1), ErrVar, CntrPar%F_NumNotchFilts == 0, UnEc)
        CALL ParseInput(FileLines,  'F_SSCornerFreq',       CntrPar%F_SSCornerFreq,                              accINFILE(1), ErrVar, CntrPar%SS_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'F_WECornerFreq',       CntrPar%F_WECornerFreq,                              accINFILE(1), ErrVar, .FALSE., UnEc)
        CALL ParseInput(FileLines,  'F_YawErr',             CntrPar%F_YawErr,                                    accINFILE(1), ErrVar, CntrPar%Y_ControlMode == 0, UnEc)
        CALL ParseAry(  FileLines,  'F_FlCornerFreq',       CntrPar%F_FlCornerFreq,     2,                       accINFILE(1), ErrVar, CntrPar%FL_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'F_FlHighPassFreq',     CntrPar%F_FlHighPassFreq,                            accINFILE(1), ErrVar, CntrPar%FL_Mode == 0, UnEc)
        CALL ParseAry(  FileLines,  'F_FlpCornerFreq',      CntrPar%F_FlpCornerFreq,    2,                       accINFILE(1), ErrVar, CntrPar%Flp_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'F_VSRefSpdCornerFreq', CntrPar%F_VSRefSpdCornerFreq,                        accINFILE(1), ErrVar, CntrPar%VS_ControlMode < 2, UnEc)

        ! Optional filter inds
        IF (CntrPar%F_GenSpdNotch_N > 0) THEN
            CALL ParseAry(FileLines,    'F_GenSpdNotch_Ind',    CntrPar%F_GenSpdNotch_Ind,  CntrPar%F_GenSpdNotch_N, accINFILE(1), ErrVar, CntrPar%F_GenSpdNotch_N == 0, UnEc)
        ENDIF
        IF (CntrPar%F_TwrTopNotch_N > 0) THEN
            CALL ParseAry(FileLines,    'F_TwrTopNotch_Ind',    CntrPar%F_TwrTopNotch_Ind,  CntrPar%F_TwrTopNotch_N, accINFILE(1), ErrVar, CntrPar%F_TwrTopNotch_N == 0, UnEc)
        ENDIF

        IF (ErrVar%aviFAIL < 0) RETURN

        !----------- BLADE PITCH CONTROLLER CONSTANTS -----------
        CALL ParseInput(FileLines,  'PC_GS_n',      CntrPar%PC_GS_n,                        accINFILE(1), ErrVar, CntrPar%PC_ControlMode == 0, UnEc)
        CALL ParseAry(  FileLines,  'PC_GS_angles', CntrPar%PC_GS_angles, CntrPar%PC_GS_n,  accINFILE(1), ErrVar, CntrPar%PC_ControlMode == 0, UnEc)
        CALL ParseAry(  FileLines,  'PC_GS_KP',     CntrPar%PC_GS_KP,     CntrPar%PC_GS_n,  accINFILE(1), ErrVar, CntrPar%PC_ControlMode == 0, UnEc)
        CALL ParseAry(  FileLines,  'PC_GS_KI',     CntrPar%PC_GS_KI,     CntrPar%PC_GS_n,  accINFILE(1), ErrVar, CntrPar%PC_ControlMode == 0, UnEc)
        CALL ParseAry(  FileLines,  'PC_GS_KD',     CntrPar%PC_GS_KD,     CntrPar%PC_GS_n,  accINFILE(1), ErrVar, CntrPar%PC_ControlMode == 0, UnEc)
        CALL ParseAry(  FileLines,  'PC_GS_TF',     CntrPar%PC_GS_TF,     CntrPar%PC_GS_n,  accINFILE(1), ErrVar, CntrPar%PC_ControlMode == 0, UnEc)
        CALL ParseInput(FileLines,  'PC_MaxPit',    CntrPar%PC_MaxPit,                      accINFILE(1), ErrVar, CntrPar%PC_ControlMode == 0, UnEc)
        CALL ParseInput(FileLines,  'PC_MinPit',    CntrPar%PC_MinPit,                      accINFILE(1), ErrVar, CntrPar%PC_ControlMode == 0, UnEc)
        CALL ParseInput(FileLines,  'PC_MaxRat',    CntrPar%PC_MaxRat,                      accINFILE(1), ErrVar, CntrPar%PC_ControlMode == 0, UnEc)
        CALL ParseInput(FileLines,  'PC_MinRat',    CntrPar%PC_MinRat,                      accINFILE(1), ErrVar, CntrPar%PC_ControlMode == 0, UnEc)
        CALL ParseInput(FileLines,  'PC_RefSpd',    CntrPar%PC_RefSpd,                      accINFILE(1), ErrVar, CntrPar%PC_ControlMode == 0, UnEc)
        CALL ParseInput(FileLines,  'PC_FinePit',   CntrPar%PC_FinePit,                     accINFILE(1), ErrVar, CntrPar%PC_ControlMode == 0, UnEc)
        CALL ParseInput(FileLines,  'PC_Switch',    CntrPar%PC_Switch,                      accINFILE(1), ErrVar, CntrPar%PC_ControlMode == 0, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !------------------- IPC CONSTANTS -----------------------
        CALL ParseAry(  FileLines,  'IPC_Vramp',        CntrPar%IPC_Vramp,          2,  accINFILE(1),   ErrVar, CntrPar%IPC_ControlMode == 0, UnEc)
        CALL ParseInput(FileLines,  'IPC_SatMode',      CntrPar%IPC_SatMode,            accINFILE(1),   ErrVar, CntrPar%IPC_ControlMode == 0, UnEc)
        CALL ParseInput(FileLines,  'IPC_IntSat',       CntrPar%IPC_IntSat,             accINFILE(1),   ErrVar, CntrPar%IPC_ControlMode == 0, UnEc)
        CALL ParseAry(  FileLines,  'IPC_KP',           CntrPar%IPC_KP,             2,  accINFILE(1),   ErrVar, CntrPar%IPC_ControlMode == 0, UnEc)
        CALL ParseAry(  FileLines,  'IPC_KI',           CntrPar%IPC_KI,             2,  accINFILE(1),   ErrVar, CntrPar%IPC_ControlMode == 0, UnEc)
        CALL ParseAry(  FileLines,  'IPC_aziOffset',    CntrPar%IPC_aziOffset,      2,  accINFILE(1),   ErrVar, CntrPar%IPC_ControlMode == 0, UnEc)
        CALL ParseInput(FileLines,  'IPC_CornerFreqAct',CntrPar%IPC_CornerFreqAct,      accINFILE(1),   ErrVar, CntrPar%IPC_ControlMode == 0, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !------------ VS TORQUE CONTROL CONSTANTS ----------------
        CALL ParseInput(FileLines,  'VS_GenEff',    CntrPar%VS_GenEff,                  accINFILE(1), ErrVar, .FALSE., UnEc)
        CALL ParseInput(FileLines,  'VS_ArSatTq',   CntrPar%VS_ArSatTq,                 accINFILE(1), ErrVar, CntrPar%VS_ControlMode .NE. 1, UnEc)
        CALL ParseInput(FileLines,  'VS_MaxRat',    CntrPar%VS_MaxRat,                  accINFILE(1), ErrVar, CntrPar%VS_ControlMode .NE. 1, UnEc)
        CALL ParseInput(FileLines,  'VS_MaxTq',     CntrPar%VS_MaxTq,                   accINFILE(1), ErrVar, .FALSE., UnEc)
        CALL ParseInput(FileLines,  'VS_MinTq',     CntrPar%VS_MinTq,                   accINFILE(1), ErrVar, .FALSE., UnEc)
        CALL ParseInput(FileLines,  'VS_MinOMSpd',  CntrPar%VS_MinOMSpd,                accINFILE(1), ErrVar)   ! Default 0 is fin, UnEce
        CALL ParseInput(FileLines,  'VS_Rgn2K',     CntrPar%VS_Rgn2K,                   accINFILE(1), ErrVar, CntrPar%VS_ControlMode == 2, UnEc)
        CALL ParseInput(FileLines,  'VS_RtPwr',     CntrPar%VS_RtPwr,                   accINFILE(1), ErrVar, .FALSE., UnEc)
        CALL ParseInput(FileLines,  'VS_RtTq',      CntrPar%VS_RtTq,                    accINFILE(1), ErrVar, .FALSE., UnEc)
        CALL ParseInput(FileLines,  'VS_RefSpd',    CntrPar%VS_RefSpd,                  accINFILE(1), ErrVar, .FALSE., UnEc)
        CALL ParseInput(FileLines,  'VS_n',         CntrPar%VS_n,                       accINFILE(1), ErrVar, .FALSE., UnEc)
        CALL ParseAry(  FileLines,  'VS_KP',        CntrPar%VS_KP,      CntrPar%VS_n,   accINFILE(1), ErrVar, .FALSE., UnEc)
        CALL ParseAry(  FileLines,  'VS_KI',        CntrPar%VS_KI,      CntrPar%VS_n,   accINFILE(1), ErrVar, .FALSE., UnEc)
        CALL ParseInput(FileLines,  'VS_TSRopt',    CntrPar%VS_TSRopt,                  accINFILE(1), ErrVar, CntrPar%VS_ControlMode < 2, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !------------ Fixed-Pitch Region 3 Control ------------
        CALL ParseInput(FileLines,  'VS_FBP_n',       CntrPar%VS_FBP_n,                          accINFILE(1), ErrVar, CntrPar%VS_FBP == VS_FBP_Variable_Pitch, UnEc)
        CALL ParseAry(  FileLines,  'VS_FBP_U',       CntrPar%VS_FBP_U,        CntrPar%VS_FBP_n, accINFILE(1), ErrVar, CntrPar%VS_FBP == VS_FBP_Variable_Pitch, UnEc)
        CALL ParseAry(  FileLines,  'VS_FBP_Omega',   CntrPar%VS_FBP_Omega,    CntrPar%VS_FBP_n, accINFILE(1), ErrVar, CntrPar%VS_FBP == VS_FBP_Variable_Pitch, UnEc)
        CALL ParseAry(  FileLines,  'VS_FBP_Tau',     CntrPar%VS_FBP_Tau,      CntrPar%VS_FBP_n, accINFILE(1), ErrVar, CntrPar%VS_FBP == VS_FBP_Variable_Pitch, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !------- Setpoint Smoother --------------------------------
        CALL ParseInput(FileLines,  'SS_VSGain',    CntrPar%SS_VSGain,  accINFILE(1), ErrVar, CntrPar%SS_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SS_PCGain',    CntrPar%SS_PCGain,  accINFILE(1), ErrVar, CntrPar%SS_Mode == 0, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !------------ POWER REFERENCE TRACKING SETPOINTS --------------
        CALL ParseInput(FileLines,  'PRC_Comm',         CntrPar%PRC_Comm,                                   accINFILE(1), ErrVar, CntrPar%PRC_Mode .NE. 1, UnEc)
        CALL ParseInput(FileLines,  'PRC_R_Torque',     CntrPar%PRC_R_Torque,                               accINFILE(1), ErrVar, (CntrPar%PRC_Mode .NE. 2) .OR. (CntrPar%PRC_Comm .NE. PRC_Comm_Constant), UnEc)
        CALL ParseInput(FileLines,  'PRC_R_Speed',      CntrPar%PRC_R_Speed,                                accINFILE(1), ErrVar, (CntrPar%PRC_Mode .NE. 2) .OR. (CntrPar%PRC_Comm .NE. PRC_Comm_Constant), UnEc)
        CALL ParseInput(FileLines,  'PRC_R_Pitch',      CntrPar%PRC_R_Pitch,                                accINFILE(1), ErrVar, (CntrPar%PRC_Mode .NE. 2) .OR. (CntrPar%PRC_Comm .NE. PRC_Comm_Constant), UnEc)
        CALL ParseInput(FileLines,  'PRC_Table_n',      CntrPar%PRC_Table_n,                                accINFILE(1), ErrVar, (CntrPar%PRC_Mode .NE. 2) .OR. (CntrPar%PRC_R_Pitch == 1.0), UnEc)
        CALL ParseAry(FileLines,    'PRC_R_Table',      CntrPar%PRC_R_Table,        CntrPar%PRC_Table_n,    accINFILE(1), ErrVar, (CntrPar%PRC_Mode .NE. 2) .OR. (CntrPar%PRC_R_Pitch == 1.0), UnEc)
        CALL ParseAry(FileLines,    'PRC_Pitch_Table',  CntrPar%PRC_Pitch_Table,    CntrPar%PRC_Table_n,    accINFILE(1), ErrVar, (CntrPar%PRC_Mode .NE. 2) .OR. (CntrPar%PRC_R_Pitch == 1.0), UnEc)
        CALL ParseInput(FileLines,  'PRC_n',            CntrPar%PRC_n,                            accINFILE(1), ErrVar,   CntrPar%PRC_Mode == 0)
        CALL ParseInput(FileLines,  'PRC_LPF_Freq',     CntrPar%PRC_LPF_Freq,                     accINFILE(1), ErrVar,   CntrPar%PRC_Mode == 0)
        CALL ParseAry(  FileLines,  'PRC_WindSpeeds',   CntrPar%PRC_WindSpeeds,   CntrPar%PRC_n,  accINFILE(1), ErrVar,   CntrPar%PRC_Mode == 0)
        CALL ParseAry(  FileLines,  'PRC_GenSpeeds',    CntrPar%PRC_GenSpeeds,    CntrPar%PRC_n,  accINFILE(1), ErrVar,   CntrPar%PRC_Mode == 0)

        !------------ WIND SPEED ESTIMATOR CONTANTS --------------
        CALL ParseInput(FileLines,  'WE_BladeRadius',   CntrPar%WE_BladeRadius,                         accINFILE(1), ErrVar, .FALSE., UnEc)
        CALL ParseInput(FileLines,  'WE_Gamma',         CntrPar%WE_Gamma,                               accINFILE(1), ErrVar, CntrPar%WE_Mode .NE. 1, UnEc)
        CALL ParseInput(FileLines,  'WE_GearboxRatio',  CntrPar%WE_GearboxRatio,                        accINFILE(1), ErrVar, .FALSE., UnEc)
        CALL ParseInput(FileLines,  'WE_Jtot',          CntrPar%WE_Jtot,                                accINFILE(1), ErrVar, CntrPar%WE_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'WE_RhoAir',        CntrPar%WE_RhoAir,                              accINFILE(1), ErrVar, CntrPar%WE_Mode .NE. 2, UnEc)
        CALL ParseInput(FileLines,  'PerfFileName',     CntrPar%PerfFileName,                           accINFILE(1), ErrVar, CntrPar%WE_Mode == 0, UnEc )
        CALL ParseAry(  FileLines,  'PerfTableSize',    CntrPar%PerfTableSize,  2,                      accINFILE(1), ErrVar, CntrPar%WE_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'WE_FOPoles_N',     CntrPar%WE_FOPoles_N,                           accINFILE(1), ErrVar, CntrPar%WE_Mode .NE. 2, UnEc)
        CALL ParseAry(FileLines,    'WE_FOPoles_v',     CntrPar%WE_FOPoles_v,   CntrPar%WE_FOPoles_N,   accINFILE(1), ErrVar, CntrPar%WE_Mode .NE. 2, UnEc)
        CALL ParseAry(FileLines,    'WE_FOPoles',       CntrPar%WE_FOPoles,     CntrPar%WE_FOPoles_N,   accINFILE(1), ErrVar, CntrPar%WE_Mode .NE. 2, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        ! Retired WSE inputs:  not used anywhere in code
        ! CALL ParseInput(FileLines,  'WE_CP_n',accINFILE(1),CntrPar%WE_CP_n,ErrVar, UnEc)
        ! CALL ParseAry(  FileLines,  'WE_CP', CntrPar%WE_CP, CntrPar%WE_CP_n, accINFILE(1), ErrVar, .FALSE. , UnEc)

        !-------------- YAW CONTROLLER CONSTANTS -----------------
        CALL ParseInput(FileLines,  'Y_uSwitch',    CntrPar%Y_uSwitch,         accINFILE(1), ErrVar,    CntrPar%Y_ControlMode == 0, UnEc)
        CALL ParseAry(  FileLines,  'Y_ErrThresh',  CntrPar%Y_ErrThresh,    2, accINFILE(1), ErrVar,    CntrPar%Y_ControlMode == 0, UnEc)
        CALL ParseInput(FileLines,  'Y_Rate',       CntrPar%Y_Rate,            accINFILE(1), ErrVar,    CntrPar%Y_ControlMode == 0, UnEc)
        CALL ParseInput(FileLines,  'Y_MErrSet',    CntrPar%Y_MErrSet,         accINFILE(1), ErrVar,    CntrPar%Y_ControlMode == 0, UnEc)
        CALL ParseInput(FileLines,  'Y_IPC_IntSat', CntrPar%Y_IPC_IntSat,      accINFILE(1), ErrVar,    CntrPar%Y_ControlMode == 0, UnEc)
        CALL ParseInput(FileLines,  'Y_IPC_KP',     CntrPar%Y_IPC_KP,          accINFILE(1), ErrVar,    CntrPar%Y_ControlMode == 0, UnEc)
        CALL ParseInput(FileLines,  'Y_IPC_KI',     CntrPar%Y_IPC_KI,          accINFILE(1), ErrVar,    CntrPar%Y_ControlMode == 0, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !------------ FORE-AFT TOWER DAMPER CONSTANTS ------------
        CALL ParseInput(FileLines,  'TRA_ExclSpeed',    CntrPar%TRA_ExclSpeed,          accINFILE(1),   ErrVar, CntrPar%TRA_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'TRA_ExclBand',     CntrPar%TRA_ExclBand,           accINFILE(1),   ErrVar, CntrPar%TRA_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'TRA_RateLimit',    CntrPar%TRA_RateLimit,          accINFILE(1),   ErrVar, CntrPar%TRA_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'FA_KI',            CntrPar%FA_KI,                  accINFILE(1),   ErrVar, CntrPar%TD_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'FA_HPFCornerFreq', CntrPar%FA_HPFCornerFreq,       accINFILE(1),   ErrVar, CntrPar%TD_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'FA_IntSat',        CntrPar%FA_IntSat,              accINFILE(1),   ErrVar, CntrPar%TD_Mode == 0, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !------------ PEAK SHAVING ------------
        CALL ParseInput(FileLines,  'PS_BldPitchMin_N', CntrPar%PS_BldPitchMin_N,                               accINFILE(1), ErrVar, CntrPar%PS_Mode == 0, UnEc)
        CALL ParseAry(  FileLines,  'PS_WindSpeeds',    CntrPar%PS_WindSpeeds,      CntrPar%PS_BldPitchMin_N,   accINFILE(1), ErrVar, CntrPar%PS_Mode == 0, UnEc)
        CALL ParseAry(  FileLines,  'PS_BldPitchMin',   CntrPar%PS_BldPitchMin,     CntrPar%PS_BldPitchMin_N,   accINFILE(1), ErrVar, CntrPar%PS_Mode == 0, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN
        
        !------------ STARTUP ------------
        CALL ParseInput(FileLines,  'SU_StartTime',             CntrPar%SU_StartTime,                                           accINFILE(1),   ErrVar, CntrPar%SU_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SU_FW_MinDuration',        CntrPar%SU_FW_MinDuration,                                      accINFILE(1),   ErrVar, CntrPar%SU_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SU_RotorSpeedThresh',      CntrPar%SU_RotorSpeedThresh,                                    accINFILE(1),   ErrVar, CntrPar%SU_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SU_RotorSpeedCornerFreq',  CntrPar%SU_RotorSpeedCornerFreq,                                accINFILE(1),   ErrVar, CntrPar%SU_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SU_LoadStages_N',          CntrPar%SU_LoadStages_N,                                        accINFILE(1),   ErrVar, CntrPar%SU_Mode == 0, UnEc)
        CALL ParseAry(FileLines,    'SU_LoadStages',            CntrPar%SU_LoadStages,              CntrPar%SU_LoadStages_N,    accINFILE(1),   ErrVar, CntrPar%SU_LoadStages_N == 0, UnEc)
        CALL ParseAry(FileLines,    'SU_LoadRampDuration',      CntrPar%SU_LoadRampDuration,        CntrPar%SU_LoadStages_N,    accINFILE(1),   ErrVar, CntrPar%SU_LoadStages_N == 0, UnEc)
        CALL ParseAry(FileLines,    'SU_LoadHoldDuration',      CntrPar%SU_LoadHoldDuration,        CntrPar%SU_LoadStages_N,    accINFILE(1),   ErrVar, CntrPar%SU_LoadStages_N == 0, UnEc)

        !------------ SHUTDOWN ------------
        CALL ParseInput(FileLines,  'SD_TimeActivate',       CntrPar%SD_TimeActivate,  accINFILE(1),   ErrVar, CntrPar%SD_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SD_EnablePitch',        CntrPar%SD_EnablePitch,   accINFILE(1),   ErrVar, CntrPar%SD_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SD_EnableYawError',     CntrPar%SD_EnableYawError,accINFILE(1),   ErrVar, CntrPar%SD_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SD_EnableGenSpeed',     CntrPar%SD_EnableGenSpeed,accINFILE(1),   ErrVar, CntrPar%SD_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SD_EnableTime',         CntrPar%SD_EnableTime,    accINFILE(1),   ErrVar, CntrPar%SD_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SD_MaxPit',             CntrPar%SD_MaxPit,        accINFILE(1),   ErrVar, CntrPar%SD_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SD_PitchCornerFreq',    CntrPar%SD_PitchCornerFreq,   accINFILE(1),   ErrVar, CntrPar%SD_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SD_MaxYawError',        CntrPar%SD_MaxYawError,       accINFILE(1),   ErrVar, CntrPar%SD_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SD_YawErrorCornerFreq', CntrPar%SD_YawErrorCornerFreq,accINFILE(1),   ErrVar, CntrPar%SD_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SD_MaxGenSpd',          CntrPar%SD_MaxGenSpd,      accINFILE(1),   ErrVar, CntrPar%SD_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SD_GenSpdCornerFreq',   CntrPar%SD_GenSpdCornerFreq,  accINFILE(1),   ErrVar, CntrPar%SD_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SD_Time',               CntrPar%SD_Time,      accINFILE(1),   ErrVar, CntrPar%SD_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SD_Method',             CntrPar%SD_Method,    accINFILE(1),   ErrVar, CntrPar%SD_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'SD_Stage_N',            CntrPar%SD_Stage_N,    accINFILE(1),   ErrVar, CntrPar%SD_Mode == 0, UnEc)
        CALL ParseAry(FileLines,    'SD_StageTime',         CntrPar%SD_StageTime,      CntrPar%SD_Stage_N,   accINFILE(1),   ErrVar, CntrPar%SD_Method .NE. 1, UnEc)
        CALL ParseAry(FileLines,    'SD_StagePitch',         CntrPar%SD_StagePitch,      CntrPar%SD_Stage_N,   accINFILE(1),   ErrVar, CntrPar%SD_Method .NE. 2, UnEc)
        CALL ParseAry(FileLines,    'SD_MaxTorqueRate',      CntrPar%SD_MaxTorqueRate,   CntrPar%SD_Stage_N,   accINFILE(1),   ErrVar, CntrPar%SD_Mode == 0, UnEc)
        CALL ParseAry(FileLines,    'SD_MaxPitchRate',       CntrPar%SD_MaxPitchRate,    CntrPar%SD_Stage_N,   accINFILE(1),   ErrVar, CntrPar%SD_Mode == 0, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !------------ FLOATING ------------
        CALL ParseInput(FileLines,  'Fl_n',     CntrPar%Fl_n,                   accINFILE(1), ErrVar, .TRUE., UnEc)
        IF (CntrPar%Fl_n == 0) CntrPar%Fl_n = 1   ! Default is 1
        CALL ParseAry(FileLines,    'Fl_Kp',      CntrPar%Fl_Kp,  CntrPar%Fl_n,   accINFILE(1), ErrVar, CntrPar%FL_Mode == 0, UnEc)
        CALL ParseAry(FileLines,    'Fl_U',       CntrPar%Fl_U,  CntrPar%Fl_n,   accINFILE(1), ErrVar, CntrPar%Fl_n == 1, UnEc)  ! Allow default if only one Fl_Kp
        IF (ErrVar%aviFAIL < 0) RETURN

        !------------ Flaps ------------
        CALL ParseInput(FileLines, 'Flp_Angle',     CntrPar%Flp_Angle,      accINFILE(1), ErrVar,   CntrPar%Flp_Mode == 0, UnEc)
        CALL ParseInput(FileLines, 'Flp_Kp',        CntrPar%Flp_Kp,         accINFILE(1), ErrVar,   CntrPar%Flp_Mode == 0, UnEc)
        CALL ParseInput(FileLines, 'Flp_Ki',        CntrPar%Flp_Ki,         accINFILE(1), ErrVar,   CntrPar%Flp_Mode == 0, UnEc)
        CALL ParseInput(FileLines, 'Flp_MaxPit',    CntrPar%Flp_MaxPit,     accINFILE(1), ErrVar,   CntrPar%Flp_Mode == 0, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !------------ Open loop input ------------
        ! Indices can be left 0 by default, checked later
        CALL ParseInput(FileLines, 'OL_Filename',       CntrPar%OL_Filename,            accINFILE(1),   ErrVar, CntrPar%OL_Mode == 0,   UnEc)
        CALL ParseInput(FileLines, 'OL_BP_Mode',        CntrPar%OL_BP_Mode,             accINFILE(1),   ErrVar, CntrPar%OL_Mode == 0,   UnEc)
        CALL ParseInput(FileLines, 'OL_BP_FiltFreq',    CntrPar%OL_BP_FiltFreq,         accINFILE(1),   ErrVar, CntrPar%OL_Mode == 0,   UnEc)
        CALL ParseInput(FileLines, 'Ind_Breakpoint',    CntrPar%Ind_Breakpoint,         accINFILE(1),   ErrVar,                         UnEc=UnEc)
        CALL ParseAry(  FileLines, 'Ind_BldPitch',      CntrPar%Ind_BldPitch,       3,  accINFILE(1),   ErrVar,                         UnEc=UnEc)
        CALL ParseInput(FileLines, 'Ind_GenTq',         CntrPar%Ind_GenTq,              accINFILE(1),   ErrVar,                         UnEc=UnEc)
        CALL ParseInput(FileLines, 'Ind_YawRate',       CntrPar%Ind_YawRate,            accINFILE(1),   ErrVar,                         UnEc=UnEc)
        CALL ParseInput(FileLines, 'Ind_Azimuth',       CntrPar%Ind_Azimuth,            accINFILE(1),   ErrVar, CntrPar%OL_Mode .NE. 2, UnEc=UnEc)
        CALL ParseInput(FileLines, 'Ind_R_Speed',       CntrPar%Ind_R_Speed,            accINFILE(1),   ErrVar, CntrPar%OL_Mode .NE. 2, UnEc=UnEc)
        CALL ParseInput(FileLines, 'Ind_R_Torque',      CntrPar%Ind_R_Torque,           accINFILE(1),   ErrVar, CntrPar%OL_Mode .NE. 2, UnEc=UnEc)
        CALL ParseInput(FileLines, 'Ind_R_Pitch',       CntrPar%Ind_R_Pitch,            accINFILE(1),   ErrVar, CntrPar%OL_Mode .NE. 2, UnEc=UnEc)
        CALL ParseAry(  FileLines, 'RP_Gains',          CntrPar%RP_Gains,           4,  accINFILE(1),   ErrVar, CntrPar%OL_Mode .NE. 2, UnEc=UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !------------ Pitch Actuator Inputs ------------
        CALL ParseInput(FileLines, 'PA_CornerFreq',     CntrPar%PA_CornerFreq,  accINFILE(1),   ErrVar, CntrPar%PA_Mode == 0, UnEc)
        CALL ParseInput(FileLines, 'PA_Damping',        CntrPar%PA_Damping,     accINFILE(1),   ErrVar, CntrPar%PA_Mode == 0, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !------------ Pitch Actuator Faults ------------
        CALL ParseAry(FileLines,    'PF_Offsets',   CntrPar%PF_Offsets,     3,  accINFILE(1),    ErrVar, CntrPar%PF_Mode .NE. 1, UnEc)
        CALL ParseAry(FileLines,    'PF_TimeStuck', CntrPar%PF_TimeStuck,   3,  accINFILE(1),    ErrVar, CntrPar%PF_Mode .NE. 2, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !------------ AWC input ------------
        CALL ParseInput(FileLines, 'AWC_NumModes',    CntrPar%AWC_NumModes,                           accINFILE(1), ErrVar, CntrPar%AWC_Mode == 0, UnEc)
        CALL ParseAry(  FileLines, 'AWC_n',           CntrPar%AWC_n,          CntrPar%AWC_NumModes,   accINFILE(1), ErrVar, CntrPar%AWC_Mode /= 1, UnEc)
        CALL ParseAry(  FileLines, 'AWC_harmonic',    CntrPar%AWC_harmonic,   CntrPar%AWC_NumModes,   accINFILE(1), ErrVar, CntrPar%AWC_Mode < 2,  UnEc)
        CALL ParseAry(  FileLines, 'AWC_freq',        CntrPar%AWC_freq,       CntrPar%AWC_NumModes,   accINFILE(1), ErrVar, CntrPar%AWC_Mode == 0, UnEc)
        CALL ParseAry(  FileLines, 'AWC_amp',         CntrPar%AWC_amp,        CntrPar%AWC_NumModes,   accINFILE(1), ErrVar, CntrPar%AWC_Mode == 0, UnEc)
        CALL ParseAry(  FileLines, 'AWC_clockangle',  CntrPar%AWC_clockangle, CntrPar%AWC_NumModes,   accINFILE(1), ErrVar, CntrPar%AWC_Mode == 0, UnEc)
        CALL ParseInput(FileLines, 'AWC_phaseoffset', CntrPar%AWC_phaseoffset,                        accINFILE(1), ErrVar, CntrPar%AWC_Mode == 0, UnEc)
        CALL ParseAry(  FileLines, 'AWC_CntrGains',   CntrPar%AWC_CntrGains,  2,                      accINFILE(1), ErrVar, CntrPar%AWC_Mode < 3, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !------------ External control interface ------------
        CALL ParseInput(FileLines, 'DLL_FileName',  CntrPar%DLL_FileName,   accINFILE(1), ErrVar,   CntrPar%Ext_Mode == 0, UnEc)
        CALL ParseInput(FileLines, 'DLL_InFile',    CntrPar%DLL_InFile,     accINFILE(1), ErrVar,   CntrPar%Ext_Mode == 0, UnEc)
        CALL ParseInput(FileLines, 'DLL_ProcName',  CntrPar%DLL_ProcName,   accINFILE(1), ErrVar,   CntrPar%Ext_Mode == 0, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !------------ ZeroMQ ------------
        CALL ParseInput(FileLines, 'ZMQ_ID',    CntrPar%ZMQ_ID,     accINFILE(1), ErrVar, .TRUE., UnEc=UnEc)
        CALL ParseInput(FileLines, 'ZMQ_CommAddress',   CntrPar%ZMQ_CommAddress,    accINFILE(1),   ErrVar,    CntrPar%ZMQ_Mode == 0, UnEc)
        CALL ParseInput(FileLines, 'ZMQ_UpdatePeriod',  CntrPar%ZMQ_UpdatePeriod,   accINFILE(1),   ErrVar,    CntrPar%ZMQ_Mode == 0, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !------------- Cable Control ----- 
        CALL ParseInput(FileLines,  'CC_Group_N',    CntrPar%CC_Group_N,                        accINFILE(1), ErrVar, CntrPar%CC_Mode == 0, UnEc)
        CALL ParseAry( FileLines,   'CC_GroupIndex', CntrPar%CC_GroupIndex, CntrPar%CC_Group_N, accINFILE(1), ErrVar, CntrPar%CC_Mode == 0, UnEc)
        CALL ParseInput(FileLines,  'CC_ActTau',     CntrPar%CC_ActTau,                         accINFILE(1), ErrVar, CntrPar%CC_Mode == 0, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        !------------- StC Control ----- 
        CALL ParseInput(FileLines,  'StC_Group_N',      CntrPar%StC_Group_N,                            accINFILE(1), ErrVar, CntrPar%StC_Mode == 0, UnEc)
        CALL ParseAry(  FileLines,  'StC_GroupIndex',   CntrPar%StC_GroupIndex, CntrPar%StC_Group_N,    accINFILE(1), ErrVar, CntrPar%StC_Mode == 0, UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        ! Open loop cable, structural control, needs number of groups
        CALL ParseAry(  FileLines, 'Ind_CableControl',   CntrPar%Ind_CableControl,  CntrPar%CC_Group_N,     accINFILE(1),   ErrVar,  CntrPar%CC_Mode .NE. 2,    UnEc=UnEc)
        CALL ParseAry(  FileLines, 'Ind_StructControl',  CntrPar%Ind_StructControl, CntrPar%StC_Group_N,    accINFILE(1),   ErrVar,  CntrPar%StC_Mode .NE. 2,   UnEc=UnEc)
        IF (ErrVar%aviFAIL < 0) RETURN

        IF (UnEc > 0) CLOSE(UnEc)     ! Close echo file

        !-------------------
        !------------------- CALCULATED CONSTANTS -----------------------
        !----------------------------------------------------------------

        ! Fix defaults manually for now
        IF (CntrPar%DT_Out == 0) THEN
            CntrPar%DT_Out = LocalVar%DT
        ENDIF

        ! DT_Out
        CntrPar%n_DT_Out = NINT(CntrPar%DT_Out / LocalVar%DT)
        CntrPar%n_DT_ZMQ = NINT(CntrPar%ZMQ_UpdatePeriod / LocalVar%DT)


        ! Fix Paths (add relative paths if called from another dir, UnEc)
        IF (PathIsRelative(CntrPar%PerfFileName)) CntrPar%PerfFileName = TRIM(PriPath)//TRIM(CntrPar%PerfFileName)
        IF (PathIsRelative(CntrPar%OL_Filename)) CntrPar%OL_Filename = TRIM(PriPath)//TRIM(CntrPar%OL_Filename)
        
        ! Convert yaw rate to deg/s
        CntrPar%Y_Rate = CntrPar%Y_Rate * R2D
        

        CntrPar%PC_RtTq99 = CntrPar%VS_RtTq*0.99
        CntrPar%VS_MinOMTq = CntrPar%VS_Rgn2K*CntrPar%VS_MinOMSpd**2
        CntrPar%VS_MaxOMTq = CntrPar%VS_Rgn2K*CntrPar%VS_RefSpd**2

        ! Read open loop input, if desired
        IF (CntrPar%OL_Mode > 0) THEN
            OL_String = ''      ! Display string
            OL_Count  = 1
            IF (CntrPar%Ind_BldPitch(1) > 0) THEN
                OL_String   = TRIM(OL_String)//' BldPitch1 '
                OL_Count    = OL_Count + 1
            ENDIF

            IF (CntrPar%Ind_BldPitch(2) > 0) THEN
                OL_String   = TRIM(OL_String)//' BldPitch2 '
                ! If there are duplicate indices, don't increment OL_Count
                IF (.NOT. ((CntrPar%Ind_BldPitch(2) == CntrPar%Ind_BldPitch(1)) .OR. &
                (CntrPar%Ind_BldPitch(2) == CntrPar%Ind_BldPitch(3)))) THEN
                    OL_Count    = OL_Count + 1
                ENDIF
            ENDIF

            IF (CntrPar%Ind_BldPitch(3) > 0) THEN
                OL_String   = TRIM(OL_String)//' BldPitch3 '
                ! If there are duplicate indices, don't increment OL_Count
                IF (.NOT. ((CntrPar%Ind_BldPitch(3) == CntrPar%Ind_BldPitch(1)) .OR. &
                (CntrPar%Ind_BldPitch(3) == CntrPar%Ind_BldPitch(2)))) THEN
                    OL_Count    = OL_Count + 1
                ENDIF
            ENDIF

            IF (CntrPar%Ind_GenTq > 0) THEN
                OL_String   = TRIM(OL_String)//' GenTq '
                OL_Count    = OL_Count + 1  ! Read channel still, so we don't have issues
            ENDIF

            IF (CntrPar%Ind_YawRate > 0) THEN
                OL_String   = TRIM(OL_String)//' YawRate '
                OL_Count    = OL_Count + 1
            ENDIF

            IF (CntrPar%Ind_Azimuth > 0) THEN
                IF (CntrPar%OL_Mode == 2) THEN
                    OL_String   = TRIM(OL_String)//' Azimuth '
                    OL_Count    = OL_Count + 1
                END IF
            ENDIF

            IF (CntrPar%Ind_R_Speed > 0) THEN
                IF (CntrPar%OL_Mode == 1) THEN
                    OL_String   = TRIM(OL_String)//' R_Speed '
                    OL_Count    = OL_Count + 1
                END IF
            ENDIF

            IF (CntrPar%Ind_R_Torque > 0) THEN
                IF (CntrPar%OL_Mode == 1) THEN
                    OL_String   = TRIM(OL_String)//' R_Torque '
                    OL_Count    = OL_Count + 1
                END IF
            ENDIF

            IF (CntrPar%Ind_R_Pitch > 0) THEN
                IF (CntrPar%OL_Mode == 1) THEN
                    OL_String   = TRIM(OL_String)//' R_Pitch '
                    OL_Count    = OL_Count + 1
                END IF
            ENDIF

            N_OL_Cables = 0
            IF (ANY(CntrPar%Ind_CableControl > 0)) THEN
                DO I = 1,SIZE(CntrPar%Ind_CableControl)
                    IF (CntrPar%Ind_CableControl(I) > 0) THEN
                        OL_String   = TRIM(OL_String)//' Cable'//TRIM(Int2LStr(I))//' '
                        OL_Count    = OL_Count + 1
                        N_OL_Cables = N_OL_Cables + 1
                    ENDIF
                ENDDO
            ENDIF

            N_OL_StCs = 0
            IF (ANY(CntrPar%Ind_StructControl > 0)) THEN
                DO I = 1,SIZE(CntrPar%Ind_StructControl)
                    IF (CntrPar%Ind_StructControl(I) > 0) THEN
                        OL_String   = TRIM(OL_String)//' StC'//TRIM(Int2LStr(I))//' '
                        OL_Count    = OL_Count + 1
                        N_OL_StCs   = N_OL_StCs + 1
                    ENDIF
                ENDDO
            ENDIF


            PRINT *, 'ROSCO: Implementing open loop control for'//TRIM(OL_String)
            IF (CntrPar%OL_Mode == 2) THEN
                PRINT *, 'ROSCO: OL_Mode = 2 will change generator torque control for Azimuth tracking'
            ENDIF

            CALL GetNewUnit(UnOpenLoop, ErrVar)
            CALL Read_OL_Input(CntrPar%OL_Filename,UnOpenLoop,OL_Count,CntrPar%OL_Channels, ErrVar)
            IF (ErrVar%aviFAIL < 0) THEN
                RETURN
            ENDIF

            CntrPar%OL_Breakpoints = CntrPar%OL_Channels(:,CntrPar%Ind_Breakpoint)

            ! Set OL Inputs based on indices
            IF (CntrPar%Ind_BldPitch(1) > 0) THEN
                CntrPar%OL_BldPitch1 = CntrPar%OL_Channels(:,CntrPar%Ind_BldPitch(1))
            ENDIF

            IF (CntrPar%Ind_BldPitch(2) > 0) THEN
                CntrPar%OL_BldPitch2 = CntrPar%OL_Channels(:,CntrPar%Ind_BldPitch(2))
            ENDIF

            IF (CntrPar%Ind_BldPitch(3) > 0) THEN
                CntrPar%OL_BldPitch3 = CntrPar%OL_Channels(:,CntrPar%Ind_BldPitch(3))
            ENDIF

            IF (CntrPar%Ind_GenTq > 0) THEN
                CntrPar%OL_GenTq = CntrPar%OL_Channels(:,CntrPar%Ind_GenTq)
            ENDIF

            IF (CntrPar%Ind_YawRate > 0) THEN
                CntrPar%OL_YawRate = CntrPar%OL_Channels(:,CntrPar%Ind_YawRate)
            ENDIF

            IF (CntrPar%Ind_Azimuth > 0) THEN
                CntrPar%OL_Azimuth = Unwrap(CntrPar%OL_Channels(:,CntrPar%Ind_Azimuth),ErrVar)
            ENDIF

            IF (CntrPar%Ind_R_Speed > 0) THEN
                CntrPar%OL_R_Speed = CntrPar%OL_Channels(:,CntrPar%Ind_R_Speed)
            ENDIF

            IF (CntrPar%Ind_R_Torque > 0) THEN
                CntrPar%OL_R_Torque = CntrPar%OL_Channels(:,CntrPar%Ind_R_Torque)
            ENDIF

            IF (CntrPar%Ind_R_Pitch > 0) THEN
                CntrPar%OL_R_Pitch = CntrPar%OL_Channels(:,CntrPar%Ind_R_Pitch)
            ENDIF
            
            IF (ANY(CntrPar%Ind_CableControl > 0)) THEN
                ALLOCATE(CntrPar%OL_CableControl(N_OL_Cables,SIZE(CntrPar%OL_Channels,DIM=1)))
                I_OL = 1
                DO I = 1,SIZE(CntrPar%Ind_CableControl)
                    IF (CntrPar%Ind_CableControl(I) > 0) THEN
                        CntrPar%OL_CableControl(I_OL,:) = CntrPar%OL_Channels(:,CntrPar%Ind_CableControl(I))
                        I_OL = I_OL + 1
                    ENDIF
                ENDDO
            ENDIF

            IF (ANY(CntrPar%Ind_StructControl > 0)) THEN
                ALLOCATE(CntrPar%OL_StructControl(N_OL_StCs,SIZE(CntrPar%OL_Channels,DIM=1)))
                I_OL = 1
                DO I = 1,SIZE(CntrPar%Ind_StructControl)
                    IF (CntrPar%Ind_StructControl(I) > 0) THEN
                        CntrPar%OL_StructControl(I_OL,:) = CntrPar%OL_Channels(:,CntrPar%Ind_StructControl(I))
                        I_OL = I_OL + 1
                    ENDIF
                ENDDO
            ENDIF

        END IF

        
        !------------------- HOUSEKEEPING -----------------------
        CntrPar%PerfFileName = TRIM(CntrPar%PerfFileName)
        

        ! Add RoutineName to error message
        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
        ENDIF


    END SUBROUTINE ReadControlParameterFileSub
    ! -----------------------------------------------------------------------------------
    ! Read all constant control parameters from DISCON.IN parameter file
    SUBROUTINE ReadCpFile(CntrPar,PerfData, ErrVar)
        USE ROSCO_Types, ONLY : PerformanceData, ControlParameters, ErrorVariables
        
        TYPE(ControlParameters),    INTENT(INOUT)   :: CntrPar
        TYPE(PerformanceData),      INTENT(INOUT)   :: PerfData
        TYPE(ErrorVariables),       INTENT(INOUT)   :: ErrVar
        
        ! Local variables
        INTEGER(IntKi)                                  :: UnPerfParameters
        INTEGER(IntKi)                                  :: i ! iteration index

        INTEGER(IntKi)                                  :: CurLine 
        INTEGER                                         :: IOS   
        CHARACTER(256)                                  :: IOM
        CHARACTER(*), PARAMETER                         :: RoutineName = 'ReadCpFile'
        REAL(DbKi), DIMENSION(:), ALLOCATABLE           :: TmpPerf

        CurLine = 1
        CALL GetNewUnit(UnPerfParameters, ErrVar)
        OPEN(unit=UnPerfParameters, file=TRIM(CntrPar%PerfFileName), status='old', action='read')
                
        ! ----------------------- Axis Definitions ------------------------
        CALL ReadEmptyLine(UnPerfParameters,CurLine)
        CALL ReadEmptyLine(UnPerfParameters,CurLine)
        CALL ReadEmptyLine(UnPerfParameters,CurLine)
        CALL ReadEmptyLine(UnPerfParameters,CurLine)
        CALL ParseAry(UnPerfParameters, CurLine, 'Pitch angle vector', PerfData%Beta_vec, CntrPar%PerfTableSize(1), TRIM(CntrPar%PerfFileName), ErrVar, .FALSE.)
        CALL ReadEmptyLine(UnPerfParameters,CurLine) 
        CALL ParseAry(UnPerfParameters, CurLine, 'TSR vector', PerfData%TSR_vec, CntrPar%PerfTableSize(2), TRIM(CntrPar%PerfFileName), ErrVar, .FALSE.)

        ! ----------------------- Read Cp, Ct, Cq, Tables ------------------------
        CALL ReadEmptyLine(UnPerfParameters,CurLine) 
        CALL ReadEmptyLine(UnPerfParameters,CurLine) ! Input file should contains wind speed information here - unneeded for now
        CALL ReadEmptyLine(UnPerfParameters,CurLine) 
        CALL ReadEmptyLine(UnPerfParameters,CurLine) 
        CALL ReadEmptyLine(UnPerfParameters,CurLine) 
        ALLOCATE(PerfData%Cp_mat(CntrPar%PerfTableSize(2),CntrPar%PerfTableSize(1)))
        DO i = 1,CntrPar%PerfTableSize(2)
            READ(UnPerfParameters, *,IOSTAT=IOS,IOMSG=IOM) PerfData%Cp_mat(i,:) ! Read Cp table
            IF (IOS > 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = "Error reading "//TRIM(CntrPar%PerfFileName)//" Cp table, IOMSG="//IOM//"Please check formatting and size of matrices in that file."
                CLOSE(UnPerfParameters)
                RETURN
            ENDIF
        END DO
        CALL ReadEmptyLine(UnPerfParameters,CurLine) 
        CALL ReadEmptyLine(UnPerfParameters,CurLine) 
        CALL ReadEmptyLine(UnPerfParameters,CurLine) 
        CALL ReadEmptyLine(UnPerfParameters,CurLine) 
        ALLOCATE(PerfData%Ct_mat(CntrPar%PerfTableSize(2),CntrPar%PerfTableSize(1)))
        DO i = 1,CntrPar%PerfTableSize(2)
            READ(UnPerfParameters, *,IOSTAT=IOS,IOMSG=IOM) PerfData%Ct_mat(i,:) ! Read Ct table
            IF (IOS > 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = "Error reading "//TRIM(CntrPar%PerfFileName)//" Cp table, IOMSG="//IOM//"Please check formatting and size of matrices in that file."
                CLOSE(UnPerfParameters)
                RETURN
            ENDIF
        END DO
        CALL ReadEmptyLine(UnPerfParameters,CurLine) 
        CALL ReadEmptyLine(UnPerfParameters,CurLine) 
        CALL ReadEmptyLine(UnPerfParameters,CurLine) 
        CALL ReadEmptyLine(UnPerfParameters,CurLine) 
        ALLOCATE(PerfData%Cq_mat(CntrPar%PerfTableSize(2),CntrPar%PerfTableSize(1)))
        DO i = 1,CntrPar%PerfTableSize(2)
            READ(UnPerfParameters, *,IOSTAT=IOS,IOMSG=IOM) PerfData%Cq_mat(i,:) ! Read Cq table
            IF (IOS > 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = "Error reading "//TRIM(CntrPar%PerfFileName)//" Cp table IOMSG="//IOM//"Please check formatting and size of matrices in that file."
                CLOSE(UnPerfParameters)
                RETURN
            ENDIF
        END DO

        ! Close file
        CLOSE(UnPerfParameters)

        ! Add RoutineName to error message
        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
        ENDIF
    
    END SUBROUTINE ReadCpFile
    ! -----------------------------------------------------------------------------------
    ! Check for errors before any execution
    SUBROUTINE CheckInputs(LocalVar, CntrPar, avrSWAP, ErrVar, size_avcMSG)
        USE, INTRINSIC :: ISO_C_Binding
        USE ROSCO_Types, ONLY : LocalVariables, ControlParameters, ErrorVariables
    
        IMPLICIT NONE
    
        ! Inputs
        TYPE(ControlParameters),    INTENT(INOUT)       :: CntrPar
        TYPE(LocalVariables),       INTENT(INOUT)       :: LocalVar
        TYPE(ErrorVariables),       INTENT(INOUT)       :: ErrVar
        INTEGER(IntKi),                 INTENT(IN   )       :: size_avcMSG
        INTEGER(IntKi)                                  :: Imode       ! Index used for looping through AWC modes
        REAL(ReKi),              INTENT(IN   )       :: avrSWAP(*)          ! The swap array, used to pass data to, and receive data from, the DLL controller.
        
        CHARACTER(*), PARAMETER                         :: RoutineName = 'CheckInputs'
        ! Local

        INTEGER(IntKi)                                  :: I
        INTEGER(IntKi), ALLOCATABLE                     :: All_OL_Indices(:)
        
        !..............................................................................................................................
        ! Check validity of input parameters:
        !..............................................................................................................................

        !------- DEBUG ------------------------------------------------------------

        ! LoggingLevel
        IF ((CntrPar%LoggingLevel < 0) .OR. (CntrPar%LoggingLevel > 3)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'LoggingLevel must be 0 - 3.'
        ENDIF

        IF (CntrPar%DT_Out .le. 0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'DT_Out must be greater than 0'
        ENDIF

        IF (CntrPar%DT_Out < LocalVar%DT) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'DT_Out must be greater than or equal to DT in OpenFAST'
        ENDIF

        IF (ABS(CntrPar%DT_out - Localvar%DT * CntrPar%n_DT_Out) > 0.001_DbKi) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'DT_Out must be a factor of DT in OpenFAST'
        ENDIF

        IF (CntrPar%ZMQ_Mode > 0) THEN
            IF (ABS(CntrPar%ZMQ_UpdatePeriod - Localvar%DT * CntrPar%n_DT_ZMQ) > 0.001_DbKi) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'ZMQ_UpdatePeriod must be a factor of DT in OpenFAST'
            ENDIF
        ENDIF
        !------- CONTROLLER FLAGS -------------------------------------------------

        ! F_LPFType
        IF ((CntrPar%F_LPFType < 1) .OR. (CntrPar%F_LPFType > 2)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'F_LPFType must be 1 or 2.'
        ENDIF

        ! IPC_ControlMode
        IF ((CntrPar%IPC_ControlMode < 0) .OR. (CntrPar%IPC_ControlMode > 2)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'IPC_ControlMode must be 0, 1, or 2.'
        ENDIF

        ! VS_ControlMode
        IF ((CntrPar%VS_ControlMode < 0) .OR. (CntrPar%VS_ControlMode > 4)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'VS_ControlMode must be between 0 and 4.'
        ENDIF

        ! VS_ConstPower
        IF ((CntrPar%VS_ConstPower < 0) .OR. (CntrPar%VS_ConstPower > 1)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'VS_ConstPower must be 0 or 1.'
        ENDIF

        ! VS_FBP
        IF ((CntrPar%VS_FBP < 0) .OR. (CntrPar%VS_FBP > 3)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'VS_FBP must be between 0 and 3.'
        ENDIF
        IF ((CntrPar%VS_FBP > 0) .AND. (CntrPar%PC_ControlMode > 0)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'VS_FBP and PC_ControlMode cannot both be greater than 0.'
        ENDIF

        IF ((CntrPar%VS_FBP > 0) .AND. (CntrPar%PRC_Mode > 0)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'Fixed blade pitch control (VS_FBP) and power reference control (PRC_Mode) cannot both be enabled.'
        ENDIF

        IF ((CntrPar%VS_FBP > 0) .AND. (CntrPar%VS_ConstPower > 0)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'Fixed blade pitch control (VS_FBP) and constant power torque control (VS_ConstPower) cannot both be enabled.'
        ENDIF

        ! PC_ControlMode
        IF ((CntrPar%PC_ControlMode < 0) .OR. (CntrPar%PC_ControlMode > 1)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'PC_ControlMode must be 0 or 1.'
        ENDIF

        ! Y_ControlMode
        IF ((CntrPar%Y_ControlMode < 0) .OR. (CntrPar%Y_ControlMode > 2)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'Y_ControlMode must be 0, 1 or 2.'
        ENDIF

        IF ((CntrPar%IPC_ControlMode > 0) .AND. (CntrPar%Y_ControlMode > 1)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'IPC control for load reductions and yaw-by-IPC cannot be activated simultaneously'
        ENDIF

        ! SS_Mode
        IF ((CntrPar%SS_Mode < 0) .OR. (CntrPar%SS_Mode > 1)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'SS_Mode must be 0 or 1.'
        ENDIF

        ! WE_Mode
        IF ((CntrPar%WE_Mode < 0) .OR. (CntrPar%WE_Mode > 2)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'WE_Mode must be 0, 1, or 2.'
        ENDIF

        ! PS_Mode
        IF ((CntrPar%PS_Mode < 0) .OR. (CntrPar%PS_Mode > 3)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'PS_Mode must be 0 or 1.'
        ENDIF
        
        ! SU_Mode
        IF ((CntrPar%SU_Mode < 0) .OR. (CntrPar%SU_Mode > 1)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'SU_Mode must be 0 or 1.'
        ENDIF

        ! SD_Mode
        IF ((CntrPar%SD_Mode < 0) .OR. (CntrPar%SD_Mode > 1)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'SD_Mode must be 0 or 1.'
        ENDIF

        ! Fl_Mode
        IF ((CntrPar%Fl_Mode < 0) .OR. (CntrPar%Fl_Mode > 2)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'Fl_Mode must be 0, 1, or 2.'
        ENDIF

        ! Flp_Mode
        IF ((CntrPar%Flp_Mode < 0) .OR. (CntrPar%Flp_Mode > 3)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'Flp_Mode must be 0, 1, 2, or 3.'
        ENDIF

        IF ((CntrPar%IPC_ControlMode > 0) .AND. (CntrPar%Flp_Mode > 0)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg   = 'ROSCO does not currently support IPC_ControlMode and Flp_Mode > 0'
        ENDIF
        !------- FILTERS ----------------------------------------------------------
        
        ! F_LPFCornerFreq
        IF (CntrPar%F_LPFCornerFreq <= 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'F_LPFCornerFreq must be greater than zero.'
        ENDIF

        ! F_LPFDamping
        IF (CntrPar%F_LPFType == 2) THEN
            IF (CntrPar%F_LPFDamping <= 0.0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'F_LPFDamping must be greater than zero.'
            ENDIF
        ENDIF

        ! Notch Filter Params
        IF (CntrPar%F_NumNotchFilts > 0) THEN

            ! F_NotchCornerFreq
            IF (ANY(CntrPar%F_NotchFreqs <= 0.0)) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'F_NotchFreqs must be greater than zero.'
            ENDIF

            ! F_NotchBetaDen
            IF (ANY(CntrPar%F_NotchBetaDen <= 0.0)) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'F_NotchBetaDen must be greater than zero.'
            ENDIF
        ENDIF

        ! F_SSCornerFreq
        IF (CntrPar%F_SSCornerFreq <= 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'F_SSCornerFreq must be greater than zero.'
        ENDIF

        ! F_WECornerFreq
        IF (CntrPar%F_WECornerFreq <= 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'F_WECornerFreq must be greater than zero.'
        ENDIF

        IF (CntrPar%Fl_Mode > 0) THEN
            ! F_FlCornerFreq(1)  (frequency)
            IF (CntrPar%F_FlCornerFreq(1) <= 0.0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'F_FlCornerFreq(1) must be greater than zero.'
            ENDIF

            ! F_FlCornerFreq(2)  (damping)
            IF (CntrPar%F_FlCornerFreq(2) <= 0.0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'F_FlCornerFreq(2) must be greater than zero.'
            ENDIF

            ! F_FlHighPassFreq
            IF (CntrPar%F_FlHighPassFreq <= 0.0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'F_FlHighPassFreq must be greater than zero.'
            ENDIF
        ENDIF

        IF (CntrPar%Flp_Mode > 0) THEN
            ! F_FlpCornerFreq(1)  (frequency)
            IF (CntrPar%F_FlpCornerFreq(1) <= 0.0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'F_FlpCornerFreq(1) must be greater than zero.'
            ENDIF

            ! F_FlpCornerFreq(2)  (damping)
            IF (CntrPar%F_FlpCornerFreq(2) < 0.0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'F_FlpCornerFreq(2) must be greater than or equal to zero.'
            ENDIF
        ENDIF
                     
        
        !------- BLADE PITCH CONTROL ----------------------------------------------

        ! PC_GS_n
        IF (CntrPar%PC_GS_n <= 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'PC_GS_n must be greater than 0'
        ENDIF

        ! PC_GS_angles
        IF (CntrPar%PC_ControlMode .NE. 0 .AND. .NOT. NonDecreasing(CntrPar%PC_GS_angles)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'PC_GS_angles must be non-decreasing'
        ENDIF

        ! PC_GS_KP and PC_GS_KI
        ! I'd like to throw warnings if these are positive

        ! PC_MinPit and PC_MaxPit
        IF (CntrPar%PC_MinPit >= CntrPar%PC_MaxPit)  THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'PC_MinPit must be less than PC_MaxPit.'
        ENDIF

        ! PC_RefSpd
        IF (CntrPar%PC_RefSpd <= 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'PC_RefSpd must be greater than zero.'
        ENDIF
        
        ! PC_MaxRat
        IF (CntrPar%PC_MaxRat <= 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'PC_MaxRat must be greater than zero.'
        ENDIF

        ! PC_MinRat
        IF (CntrPar%PC_MinRat >= 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'PC_MinRat must be less than zero.'
        ENDIF

        !------- INDIVIDUAL PITCH CONTROL -----------------------------------------

        IF (CntrPar%IPC_CornerFreqAct < 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'Corner frequency of IPC actuator model must be positive, or set to 0 to disable.'
        ENDIF

        IF (CntrPar%IPC_SatMode < 0 .OR. CntrPar%IPC_SatMode > 3)  THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'IPC_SatMode must be 0, 1, 2, or 3.'
        ENDIF

        IF (CntrPar%IPC_KI(1) < 0.0)  THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'IPC_KI(1) must be zero or greater than zero.'
        ENDIF
        
        IF (CntrPar%IPC_KI(2) < 0.0)  THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'IPC_KI(2) must be zero or greater than zero.'
        ENDIF

        IF (CntrPar%IPC_KI(1) < 0.0)  THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'IPC_KP(1) must be zero or greater than zero.'
        ENDIF
        
        IF (CntrPar%IPC_KI(2) < 0.0)  THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'IPC_KP(2) must be zero or greater than zero.'
        ENDIF

        !------- VS TORQUE CONTROL ------------------------------------------------
       
        IF (CntrPar%VS_MaxRat <= 0.0) THEN
            ErrVar%aviFAIL =  -1
            ErrVar%ErrMsg  = 'VS_MaxRat must be greater than zero.'
        ENDIF
        
        
        
        ! VS_Rgn2K
        IF (CntrPar%VS_Rgn2K < 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'VS_Rgn2K must not be negative.'
        ENDIF
        
        ! VS_RtTq
        IF (CntrPar%VS_MaxTq < CntrPar%VS_RtTq) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'VS_RtTq must not be greater than VS_MaxTq.'
        ENDIF

        ! VS_RtPwr
        IF (CntrPar%VS_RtPwr < 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'VS_RtPwr must not be negative.'
        ENDIF

        ! VS_RtTq
        IF (CntrPar%VS_RtTq < 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'VS_RtTq must not be negative.'
        ENDIF

        ! VS_KP
        IF (CntrPar%VS_KP(1) > 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'VS_KP must be less than zero.'
        ENDIF
        
        ! VS_KI
        IF (CntrPar%VS_KI(1) > 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'VS_KI must be less than zero.'
        ENDIF

        ! VS_TSRopt
        IF (CntrPar%VS_TSRopt < 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'VS_TSRopt must be greater than zero.'
        ENDIF
        
        !------- SETPOINT SMOOTHER ---------------------------------------------

        ! SS_VSGain
        IF (CntrPar%SS_VSGain < 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'SS_VSGain must be greater than zero.'
        ENDIF

        ! SS_PCGain
        IF (CntrPar%SS_PCGain < 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'SS_PCGain must be greater than zero.'
        ENDIF

        IF ((CntrPar%PRC_Mode < 0) .OR. (CntrPar%PRC_Mode > 2)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'PRC_Mode must be 0, 1, or 2.'
        ENDIF

        IF (CntrPar%PRC_Mode == 2) THEN
            PRINT *, "Note: PRC Mode = ", CntrPar%PRC_Mode, ", which will affect VS_RefSpeed, VS_TSRopt, and PC_RefSpeed"

            IF (CntrPar%PRC_Comm == 0) THEN
                IF (CntrPar%PRC_R_Pitch < 0) THEN
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg  = 'PRC_R_Pitch must be greater than or equal to zero.'
                ENDIF

                IF (CntrPar%PRC_R_Speed < 0) THEN
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg  = 'PRC_R_Speed must be greater than or equal to zero.'
                ENDIF

                IF (CntrPar%PRC_R_Torque < 0) THEN
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg  = 'PRC_R_Torque must be greater than or equal to zero.'
                ENDIF

            ENDIF

            IF ((CntrPar%PRC_Comm == 1) .AND. (CntrPar%OL_Mode .NE. 1)) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'OL_Mode must be 1 to use open loop inputs for power control (PRC_Comm = 1).'
            ENDIF

            IF ((CntrPar%PRC_Comm == 2) .AND. (CntrPar%ZMQ_Mode .NE. 1)) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'ZMQ_Mode must be 1 to use ZeroMQ inputs for power control (PRC_Comm = 2).'
            ENDIF

        ENDIF
        
        !------- WIND SPEED ESTIMATOR ---------------------------------------------

        ! WE_BladeRadius
        IF (CntrPar%WE_BladeRadius < 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'WE_BladeRadius must be greater than zero.'
        ENDIF

        ! WE_GearboxRatio
        IF (CntrPar%WE_GearboxRatio < 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'WE_GearboxRatio must be greater than zero.'
        ENDIF

        ! WE_Jtot
        IF (CntrPar%WE_Jtot < 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'WE_Jtot must be greater than zero.'
        ENDIF

        ! WE_RhoAir
        IF (CntrPar%WE_RhoAir < 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'WE_RhoAir must be greater than zero.'
        ENDIF

        ! PerfTableSize(1)
        IF (CntrPar%PerfTableSize(1) < 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'PerfTableSize(1) must be greater than zero.'
        ENDIF

        ! PerfTableSize(2)
        IF (CntrPar%PerfTableSize(2) < 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'PerfTableSize(2) must be greater than zero.'
        ENDIF

        ! WE_FOPoles_N
        IF (CntrPar%WE_FOPoles_N < 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'WE_FOPoles_N must be greater than zero.'
        ENDIF

        ! WE_FOPoles_v
        IF (CntrPar%WE_Mode == 2 .AND. .NOT. NonDecreasing(CntrPar%WE_FOPoles_v)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'WE_FOPoles_v must be non-decreasing.'
        ENDIF

        ! ---- Yaw Control ----
        IF (CntrPar%Y_ControlMode > 0) THEN
            IF (CntrPar%Y_ControlMode == 1) THEN
                IF (CntrPar%Y_ErrThresh(1) <= 0.0)  THEN
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg  = 'Y_ErrThresh must be greater than zero.'
                ENDIF

                IF (CntrPar%Y_Rate <= 0.0)  THEN
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg  = 'CntrPar%Y_Rate must be greater than zero.'
                ENDIF
            ENDIF
        ENDIF

        ! ---- Tower Control ----
        IF (CntrPar%TD_Mode < 0 .OR. CntrPar%TD_Mode > 1) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'TD_Mode must be 0 or 1.'
        END IF

        IF (CntrPar%TRA_Mode < 0 .OR. CntrPar%TRA_Mode > 1) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'TRA_Mode must be 0 or 1.'
        END IF

        IF (CntrPar%TRA_Mode > 1) THEN  ! Frequency avoidance is active
            IF (CntrPar%TRA_ExclSpeed < 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'TRA_ExclSpeed must be greater than 0.'
            END IF

            IF (CntrPar%TRA_ExclBand < 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'TRA_ExclBand must be greater than 0.'
            END IF

            IF (CntrPar%TRA_RateLimit < 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'TRA_RateLimit must be greater than 0.'
            END IF

            IF ( .NOT. ((CntrPar%VS_ControlMode == VS_Mode_WSE_TSR) .OR. (CntrPar%VS_ControlMode == VS_Mode_Power_TSR) )) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'VS_ControlMode must be 2 or 3 to use frequency avoidance control.'
            END IF

            IF (CntrPar%PRC_Mode == 1) THEN
                PRINT *, "ROSCO Warning: Note that frequency avoidance control (TRA_Mode > 1) will affect PRC set points"
            END IF           

        END IF

        !------- MINIMUM PITCH SATURATION -------------------------------------------
        IF (CntrPar%PS_Mode > 0) THEN

            ! PS_BldPitchMin_N
            IF (CntrPar%PS_BldPitchMin_N < 0.0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'PS_BldPitchMin_N must be greater than zero.'
            ENDIF

            ! PS_WindSpeeds
            IF (.NOT. NonDecreasing(CntrPar%PS_WindSpeeds)) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'PS_WindSpeeds must be non-decreasing.'
            ENDIF


        ENDIF

        ! --- Startup ---
        IF (CntrPar%SU_Mode > 0) THEN

            ! SU_FW_MinDuration
            IF (CntrPar%SU_FW_MinDuration < 0.0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'SU_FW_MinDuration must be greater than zero.'
            ENDIF

            ! SU_RotorSpeedThresh
            IF (CntrPar%SU_RotorSpeedThresh < 0.0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'SU_RotorSpeedThresh must be greater than zero.'
            ENDIF
            
            ! SU_RotorSpeedCornerFreq
            IF (CntrPar%SU_RotorSpeedCornerFreq < 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'SU_RotorSpeedCornerFreq must be greater than or equal to 0.'
            ENDIF
            
            ! SU_LoadStages_N
            IF (CntrPar%SU_LoadStages_N < 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'SU_LoadStages_N must be greater than or equal to 0.'
            ENDIF

            ! SU_LoadStages
            IF (ANY(CntrPar%SU_LoadStages < 0)) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'SU_LoadStages must be positive.'
            ENDIF

            ! SU_LoadRampDuration
            IF (ANY(CntrPar%SU_LoadRampDuration < 0)) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'SU_LoadRampDuration must be positive.'
            ENDIF

            ! SU_LoadHoldDuration
            IF (ANY(CntrPar%SU_LoadHoldDuration < 0)) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'SU_LoadHoldDuration must be positive.'
            ENDIF
        ENDIF

        ! --- Shutdown ---
        IF (CntrPar%SD_Mode > 0) THEN
        
            ! SD_Method
            IF (CntrPar%SD_Method < 1 .OR. CntrPar%SD_Method > 2) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'SD_Method must be 1 or 2.'
            ENDIF

            ! SD_MaxPitchRate
            IF (MAXVAL(CntrPar%SD_MaxPitchRate) > CntrPar%PC_MaxRat) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'SD_MaxPitchRate(s) should be less than or equal to PC_MaxRat.'
            ENDIF

                
            ! SD_MaxTorqueRate
            IF (MAXVAL(CntrPar%SD_MaxTorqueRate) > CntrPar%VS_MaxRat) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'SD_MaxTorqueRate(s) should be less than or equal to VS_MaxRat.'
            ENDIF

            IF (CntrPar%SD_Stage_N < 1) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg  = 'SD_Stage_N must be greater than or equal to 1.'
            ENDIF

            IF (CntrPar%SD_Method == 1) THEN
                ! SD_StageTime must be greater than zero
                IF ( MINVAL(CntrPar%SD_StageTime) < 0.0) THEN
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg  = 'SD_StageTime(s) must be greater than or equal to zero.'
                ENDIF

            ELSEIF (CntrPar%SD_Method == 2) THEN
                ! SD_StagePitch must be increasing
                IF (.NOT. NonDecreasing(CntrPar%SD_StagePitch)) THEN
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg  = 'SD_StagePitch must be non-decreasing.'
                ENDIF

            ENDIF
        ENDIF

        ! --- Open loop control ---
        IF (CntrPar%OL_Mode > 0) THEN
            ! Get all open loop indices
            ALLOCATE(All_OL_Indices(5))   ! Will need to increase to 5 when IPC
            All_OL_Indices =    (/CntrPar%Ind_BldPitch, & 
                                CntrPar%Ind_GenTq, &
                                CntrPar%Ind_YawRate, &
                                CntrPar%Ind_R_Speed, &
                                CntrPar%Ind_R_Torque, &
                                CntrPar%Ind_R_Pitch/)

            DO I = 1,SIZE(CntrPar%Ind_CableControl)
                Call AddToList(All_OL_Indices, CntrPar%Ind_CableControl(I))           
            ENDDO
            
            DO I = 1,SIZE(CntrPar%Ind_StructControl)
                Call AddToList(All_OL_Indices, CntrPar%Ind_StructControl(I))             
            ENDDO       

            IF (ANY(All_OL_Indices < 0)) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'All open loop control indices must be greater than zero'
            ENDIF

            IF (CntrPar%Ind_Breakpoint < 1) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'Ind_Breakpoint must be non-zero if OL_Mode is non-zero'
            ENDIF

            IF (ALL(All_OL_Indices < 1)) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'At least one open loop input channel must be non-zero'
            ENDIF

            IF (CntrPar%OL_Mode == 2) THEN
                IF ((CntrPar%Ind_BldPitch(1) == 0) .OR. &
                (CntrPar%Ind_BldPitch(2) == 0) .OR. &
                (CntrPar%Ind_BldPitch(3) == 0) .OR. &
                (CntrPar%Ind_GenTq == 0) .OR. &
                (CntrPar%Ind_Azimuth == 0)) THEN
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg = 'If OL_Mode = 2, Ind_BldPitch, Ind_GenTq, and Ind_Azimuth must be greater than zero'
                ENDIF
            ENDIF

            IF (ANY(CntrPar%Ind_CableControl > 0) .AND. CntrPar%CC_Mode .NE. 2) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'CC_Mode must be 2 if using open loop cable control via Ind_CableControl'
            ENDIF

            IF (ANY(CntrPar%Ind_StructControl > 0) .AND. CntrPar%StC_Mode .NE. 2) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'CC_Mode must be 2 if using open loop struct control via Ind_StructControl'
            ENDIF

            IF ((CntrPar%OL_BP_Mode < 0) .OR. (CntrPar%OL_BP_Mode > 1)) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'OL_BP_Mode must be 0 or 1.'
            ENDIF

            IF (CntrPar%OL_BP_FiltFreq < 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'OL_BP_FiltFreq must be greater than or equal to 0.'
            ENDIF

            IF ((CntrPar%OL_BP_Mode == 1) .AND. (CntrPar%OL_Mode == 2)) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'Rotor position control (OL_Mode = 2) is not compatible with wind speed breakpoints (OL_BP_Mode = 1)'
            ENDIF

        ENDIF

        ! ---- AWC vs. IPC
        IF (CntrPar%AWC_Mode > 0 .AND. CntrPar%IPC_ControlMode > 0) THEN
            PRINT *, "ROSCO WARNING: Individual pitch control and active wake control are both enabled. Performance may be compromised."
        ENDIF



        ! --- Pitch Actuator ---
        IF (CntrPar%PA_Mode > 0) THEN
            IF ((CntrPar%PA_Mode < 0) .OR. (CntrPar%PA_Mode > 2)) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'PA_Mode must be 0, 1, or 2'
            END IF
            IF (CntrPar%PA_CornerFreq < 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'PA_CornerFreq must be greater than 0'
            END IF
            IF (CntrPar%PA_Damping < 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'PA_Damping must be greater than 0'
            END IF
        END IF

        ! --- Active Wake Control ---
        IF (CntrPar%AWC_Mode > 0) THEN
            IF (CntrPar%AWC_NumModes < 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'AWC_NumModes must be a positive integer if AWC_Mode = 1'
            END IF
            DO Imode = 1,CntrPar%AWC_NumModes
                IF (CntrPar%AWC_freq(Imode) < 0.0) THEN
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg = 'AWC_freq cannot be less than 0'
                END IF
            END DO
            IF (CntrPar%AWC_Mode == 1) THEN
                DO Imode = 1,CntrPar%AWC_NumModes
                    IF ((CntrPar%AWC_clockangle(Imode) > 360.0) .OR. (CntrPar%AWC_clockangle(Imode) < 0.0)) THEN
                        ErrVar%aviFAIL = -1
                        ErrVar%ErrMsg = 'AWC_clockangle must be between 0 and 360 in AWC_Mode = 1'
                    END IF
                END DO    
            END IF

            IF (CntrPar%AWC_Mode == 2) THEN
                IF ((CntrPar%AWC_NumModes > 2) .OR. (CntrPar%AWC_NumModes < 1)) THEN
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg = 'AWC_NumModes must be either 1 or 2 if AWC_Mode = 2'
                END IF
                DO Imode = 1,CntrPar%AWC_NumModes
                    IF ((CntrPar%AWC_clockangle(Imode) > 360.0) .OR. (CntrPar%AWC_clockangle(Imode) < -360.0)) THEN
                        ErrVar%aviFAIL = -1
                        ErrVar%ErrMsg = 'AWC_clockangle must be between -360 and 360 in AWC_Mode = 2'
                    END IF
                    IF (CntrPar%AWC_harmonic(Imode) < 0) THEN
                        ErrVar%aviFAIL = -1
                        ErrVar%ErrMsg = 'AWC_harmonic must be a positive integer'
                    END IF
                END DO
            END IF
        END IF

        IF ((CntrPar%CC_Mode < 0) .OR. (CntrPar%CC_Mode > 2)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg = 'CC_Mode must be 0 or 1'
        END IF

        IF (CntrPar%CC_Mode > 0) THEN

            ! Extended avrSWAP must be used
            IF (CntrPar%Ext_Interface == 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'The OpenFAST extended bladed interface must be used with Ext_Interface > 0 in the DISCON'
            ENDIF

            IF (CntrPar%CC_ActTau .LE. 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'CC_ActTau must be greater than 0.'
            END IF

            DO I = 1,CntrPar%CC_Group_N
                IF (CntrPar%CC_GroupIndex(I) < 2601) THEN
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg = 'CC_GroupIndices must be greater than 2601.'        !< Starting index for the cable control
                END IF
            END DO
        END IF

        IF (CntrPar%StC_Mode > 0) THEN

            ! Extended avrSWAP must be used
            IF (CntrPar%Ext_Interface == 0) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'The OpenFAST extended bladed interface must be used with Ext_Interface > 0 in the DISCON'
            ENDIF

            ! Check indices
            DO I = 1,CntrPar%StC_Group_N
                IF (CntrPar%StC_GroupIndex(I) < 2801) THEN
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg = 'StC_GroupIndices must be greater than 2801.'        !< Starting index for the cable control
                END IF
            END DO
        END IF

        ! Check that open loop control active if using open loop cable/struct control
        IF (CntrPar%CC_Mode == 2 .AND. CntrPar%OL_Mode .NE. 1) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg = 'OL_Mode must be 1 if using CC_Mode = 2 (open loop)'
        END IF

        IF (CntrPar%StC_Mode == 2 .AND. CntrPar%OL_Mode .NE. 1) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg = 'OL_Mode must be 1 if using StC_Mode = 2 (open loop)'
        END IF
            

        
        ! Abort if the user has not requested a pitch angle actuator (See Appendix A
        ! of Bladed User's Guide):
        IF (NINT(avrSWAP(10)) /= 0)  THEN ! .TRUE. if a pitch angle actuator hasn't been requested
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'Pitch angle actuator not requested.'
        ENDIF
        
        IF ((NINT(avrSWAP(28)) == 0) .AND. &
            ((CntrPar%IPC_ControlMode > 0) .OR. &
             (CntrPar%Y_ControlMode > 1) .OR. & 
             (CntrPar%Ind_BldPitch(2) > 0) .OR. &
             (CntrPar%Ind_BldPitch(3) > 0) &
             )) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'IPC enabled, but Ptch_Cntrl in ServoDyn has a value of 0. Set it to 1 for individual pitch control.'
        ENDIF

        ! PF_Mode = 1
        IF (NINT(avrSWAP(28)) == 0 .AND. (CntrPar%PF_Mode == 1)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'Pitch offset fault enabled (PF_Mode = 1), but Ptch_Cntrl in ServoDyn has a value of 0. Set it to 1 for individual pitch control.'
        ENDIF

        IF (NINT(avrSWAP(28)) == 0 .AND. (CntrPar%AWC_Mode > 1)) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'AWC enabled, but Ptch_Cntrl in ServoDyn has a value of 0. Set it to 1 for individual pitch control.'
        ENDIF

        ! DT
        IF (LocalVar%DT <= 0.0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg  = 'DT must be greater than zero.'
        ENDIF

        IF (ErrVar%aviFAIL < 0) THEN
            ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
        ENDIF

    END SUBROUTINE CheckInputs
    
END MODULE ReadSetParameters

! Copyright 2019 NREL

! Licensed under the Apache License, Version 2.0 (the "License"); you may not use
! this file except in compliance with the License. You may obtain a copy of the
! License at http://www.apache.org/licenses/LICENSE-2.0

! Unless required by applicable law or agreed to in writing, software distributed
! under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
! CONDITIONS OF ANY KIND, either express or implied. See the License for the
! specific language governing permissions and limitations under the License.
! -------------------------------------------------------------------------------------------
! Helper functions, primarily borrowed from NWTC_IO, for reading inputs and carrying out other helpful tasks

MODULE ROSCO_Helpers

    USE, INTRINSIC :: ISO_C_Binding
    USE ROSCO_Types
    USE CONSTANTS
    USE SysSubs


    IMPLICIT NONE

    ! Global Variables
    LOGICAL, PARAMETER     :: DEBUG_PARSING = .FALSE.      ! debug flag to output parsing information, set up Echo file later
    
    INTERFACE ParseInput                                                         ! Parses a character variable name and value from a string.
        MODULE PROCEDURE ParseInput_Str                                             ! Parses a character string from a string.
        MODULE PROCEDURE ParseInput_Dbl                                             ! Parses a double-precision REAL from a string.
        MODULE PROCEDURE ParseInput_Int                                             ! Parses an INTEGER from a string.
        MODULE PROCEDURE ParseInput_Int_Opt                                             ! Parses an INTEGER from a string.  Optional input.
        MODULE PROCEDURE ParseInput_Dbl_Opt                                             ! Parses an double-precision REAL from a string.  Optional input.
        MODULE PROCEDURE ParseInput_Str_Opt                                             ! Parses an character string from a string.  Optional input.
        ! MODULE PROCEDURE ParseInput_Log                                             ! Parses an LOGICAL from a string.
    END INTERFACE

    INTERFACE ParseAry                                                         ! Parse an array of numbers from a string.
        MODULE PROCEDURE ParseDbAry                                             ! Parse an array of double-precision REAL values.
        MODULE PROCEDURE ParseInAry                                             ! Parse an array of whole numbers.
        MODULE PROCEDURE ParseInAry_Opt                                         ! Parse an array of whole numbers. Optional inputs.
        MODULE PROCEDURE ParseDbAry_Opt                                         ! Parse an array of double-precision REAL values.  Optional inputs.
    END INTERFACE

    INTEGER(IntKi), PARAMETER       :: MaxLineLength    = 2048      ! characters
    INTEGER(IntKi), PARAMETER       :: MaxParamLength   = 200         ! characters, file paths can be long

CONTAINS

    !=======================================================================
    ! Parse integer input: read line, check that variable name is in line, handle errors
    subroutine ParseInput_Int(Un, CurLine, VarName, FileName, Variable, ErrVar, CheckName)
        USE ROSCO_Types, ONLY : ErrorVariables

        CHARACTER(MaxLineLength)                    :: Line
        INTEGER(IntKi),             INTENT(IN   )   :: Un   ! Input file unit
        CHARACTER(*),           INTENT(IN   )       :: VarName   ! Input file unit
        CHARACTER(*),           INTENT(IN   )       :: FileName   ! Input file unit
        INTEGER(IntKi),             INTENT(INOUT)   :: CurLine   ! Current line of input
        TYPE(ErrorVariables),   INTENT(INOUT)       :: ErrVar   ! Current line of input
        CHARACTER(MaxParamLength)                   :: Words       (2)               ! The two "words" parsed from the line

        INTEGER(IntKi),             INTENT(INOUT)   :: Variable   ! Variable
        INTEGER(IntKi)                              :: ErrStatLcl                    ! Error status local to this routine.
        LOGICAL, OPTIONAL,      INTENT(IN   )   :: CheckName

        LOGICAL                                 :: CheckName_

        ! Figure out if we're checking the name, default to .TRUE.
        CheckName_ = .TRUE.
        if (PRESENT(CheckName)) CheckName_ = CheckName 

        ! If we've already failed, don't read anything
        IF (ErrVar%aviFAIL >= 0) THEN

            ! Read the whole line as a string
            READ(Un, '(A)') Line

            ! Separate line string into 2 words
            CALL GetWords ( Line, Words, 2 )  

            ! Debugging: show what's being read, turn into Echo later
            IF (DEBUG_PARSING) THEN
                print *, 'Read: '//TRIM(Words(1))//' and '//TRIM(Words(2)),' on line ', CurLine
            END IF

            ! Check that Variable Name is in Words
            IF (CheckName_) THEN
                CALL ChkParseData ( Words, VarName, FileName, CurLine, ErrVar )
            END IF

            ! IF We haven't failed already
            IF (ErrVar%aviFAIL >= 0) THEN        

                ! Read the variable
                READ (Words(1),*,IOSTAT=ErrStatLcl)  Variable
                IF ( ErrStatLcl /= 0 )  THEN
                    ErrVar%aviFAIL  = -1
                    ErrVar%ErrMsg   =  NewLine//' >> A fatal error occurred when parsing data from "' &
                        //TRIM( FileName )//'".'//NewLine//  &
                        ' >> The variable "'//TRIM( Words(2) )//'" was not assigned valid INTEGER value on line #' &
                        //TRIM( Int2LStr( CurLine ) )//'.'//NewLine//&
                        ' >> The text being parsed was :'//NewLine//'    "'//TRIM( Line )//'"'
                ENDIF

            ENDIF   

            ! Increment line counter
            CurLine = CurLine + 1
        END IF

    END subroutine ParseInput_Int

    !=======================================================================
    ! Parse integer input: read line, check that variable name is in line, handle errors
    subroutine ParseInput_Int_Opt(FileLines, VarName, Variable, FileName, ErrVar, AllowDefault, UnEc)
        USE ROSCO_Types, ONLY : ErrorVariables

        CHARACTER(*),           INTENT(IN   ), DIMENSION(:) :: FileLines   ! Input file unit
        CHARACTER(*),           INTENT(IN   )               :: VarName   ! Input file unit
        CHARACTER(*),           INTENT(IN   )               :: FileName   ! Input file unit
        TYPE(ErrorVariables),   INTENT(INOUT)               :: ErrVar   ! Current line of input
        INTEGER(IntKi),         INTENT(INOUT)               :: Variable   ! Variable
        Integer(IntKi), OPTIONAL, INTENT(IN   )               :: UnEc   ! Variable


        ! Flag (usually control mode) specifying whether default is allowed, 0 - yes, nonzero - no
        LOGICAL, OPTIONAL,      INTENT(IN   )        :: AllowDefault   
        
        INTEGER(IntKi)                          :: CurLine   ! Current line of input
        CHARACTER(MaxParamLength)               :: Words       (2)               ! The two "words" parsed from the line
        CHARACTER(MaxParamLength)               :: VarNameUC
        CHARACTER(MaxLineLength)                :: Line
        INTEGER(IntKi)                          :: ErrStatLcl           ! Error status local to this routine.
        INTEGER(IntKi)                          :: I, VarLineIndex                    ! Line indexer
        LOGICAL                                 :: AllowDefault_, FoundLine
        CHARACTER(*), PARAMETER                 :: RoutineName = 'ParseInput_Int_Opt'


        ! Figure out if we allow default
        AllowDefault_ = .TRUE.
        if (PRESENT(AllowDefault)) AllowDefault_ = AllowDefault    

        ! If we've already failed, don't read anything
        IF (ErrVar%aviFAIL >= 0) THEN

            CALL FindLine(FileLines, VarName, FoundLine, Line, CurLine)

            ! Separate line again
            CALL GetWords ( Line, Words, 2 )  

            ! PRINT *, "Line: ", Line

            ! Print warning with default
            IF (.NOT. FoundLine) THEN
                IF (.NOT. AllowDefault_) THEN
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg = RoutineName//':Missing or default values are not allowed for '//TRIM( VarName )//'. Please check control modes.'
                    RETURN
                ENDIF

                Variable = 0     ! Default of integer inputs is 0 for now
                PRINT *, "ROSCO Warning: Did not find "//TRIM( VarName )//" in input file.  Using default value of ", Variable
            ENDIF

            ! Debugging: show what's being read, turn into Echo later
            IF (DEBUG_PARSING) THEN
                print *, 'Read: '//TRIM(Words(1))//' and '//TRIM(Words(2)),' on line ', CurLine
            END IF

            ! IF We haven't failed already
            IF (ErrVar%aviFAIL >= 0 .AND. FoundLine) THEN        

                ! Read the variable
                READ (Words(1),*,IOSTAT=ErrStatLcl)  Variable
                IF ( ErrStatLcl /= 0 )  THEN
                    ErrVar%aviFAIL  = -1
                    ErrVar%ErrMsg   =  NewLine//' >> A fatal error occurred when parsing data from "' &
                        //TRIM( FileName )//'".'//NewLine//  &
                        ' >> The variable "'//TRIM( Words(2) )//'" was not assigned valid INTEGER value on line #' &
                        //TRIM( Int2LStr( CurLine ) )//'.'//NewLine//&
                        ' >> The text being parsed was :'//NewLine//'    "'//TRIM( Line )//'"'
                ENDIF

            ENDIF   

            IF ( PRESENT(UnEc))  THEN
                IF ( UnEc > 0 )  WRITE (UnEc,*)  CurLine, Tab, VarName, Tab, Variable
            END IF

        END IF

    END subroutine ParseInput_Int_Opt

     !=======================================================================
    ! Parse integer input: read line, check that variable name is in line, handle errors
    subroutine ParseInput_Dbl_Opt(FileLines, VarName, Variable, FileName, ErrVar, AllowDefault, UnEc)
        USE ROSCO_Types, ONLY : ErrorVariables

        CHARACTER(*),           INTENT(IN   ), DIMENSION(:) :: FileLines   ! Input file unit
        CHARACTER(*),           INTENT(IN   )               :: VarName   ! Input file unit
        CHARACTER(*),           INTENT(IN   )               :: FileName   ! Input file unit
        TYPE(ErrorVariables),   INTENT(INOUT)               :: ErrVar   ! Current line of input
        REAL(DbKi),             INTENT(INOUT)               :: Variable   ! Variable
        Integer(IntKi), OPTIONAL, INTENT(IN   )               :: UnEc   ! Variable

        
        ! Flag (usually control mode) specifying whether default is allowed, 0 - yes, nonzero - no
        LOGICAL, OPTIONAL,      INTENT(IN   )        :: AllowDefault   
        
        INTEGER(IntKi)                          :: CurLine   ! Current line of input
        CHARACTER(MaxParamLength)               :: Words       (2)               ! The two "words" parsed from the line
        CHARACTER(MaxParamLength)               :: VarNameUC
        CHARACTER(MaxLineLength)                :: Line
        INTEGER(IntKi)                          :: ErrStatLcl           ! Error status local to this routine.
        INTEGER(IntKi)                          :: I, VarLineIndex                    ! Line indexer
        LOGICAL                                 :: AllowDefault_, FoundLine
        CHARACTER(*), PARAMETER                 :: RoutineName = 'ParseInput_Dbl_Opt'


        ! Figure out if we allow default
        AllowDefault_ = .TRUE.
        if (PRESENT(AllowDefault)) AllowDefault_ = AllowDefault    

        ! If we've already failed, don't read anything
        IF (ErrVar%aviFAIL >= 0) THEN

            CALL FindLine(FileLines, VarName, FoundLine, Line, CurLine)


            ! Separate line again
            CALL GetWords ( Line, Words, 2 )  

            ! PRINT *, "Line: ", Line

            ! Print warning with default
            IF (.NOT. FoundLine) THEN
                IF (.NOT. AllowDefault_) THEN
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg = RoutineName//':Missing or default values are not allowed for '//TRIM( VarName )//'. Please check control modes.'
                    RETURN
                ENDIF

                Variable = 0     ! Default of integer inputs is 0 for now
                PRINT *, "ROSCO Warning: Did not find "//TRIM( VarName )//" in input file.  Using default value of ", Variable
            ENDIF

            ! Debugging: show what's being read, turn into Echo later
            IF (DEBUG_PARSING) THEN
                print *, 'Read: '//TRIM(Words(1))//' and '//TRIM(Words(2)),' on line ', CurLine
            END IF

            ! IF We haven't failed already
            IF (ErrVar%aviFAIL >= 0 .AND. FoundLine) THEN        

                ! Read the variable
                READ (Words(1),*,IOSTAT=ErrStatLcl)  Variable
                IF ( ErrStatLcl /= 0 )  THEN
                    ErrVar%aviFAIL  = -1
                    ErrVar%ErrMsg   =  NewLine//' >> A fatal error occurred when parsing data from "' &
                        //TRIM( FileName )//'".'//NewLine//  &
                        ' >> The variable "'//TRIM( Words(2) )//'" was not assigned valid REAL value on line #' &
                        //TRIM( Int2LStr( CurLine ) )//'.'//NewLine//&
                        ' >> The text being parsed was :'//NewLine//'    "'//TRIM( Line )//'"'
                ENDIF

            ENDIF   

            IF ( PRESENT(UnEc))  THEN
                IF ( UnEc > 0 )  WRITE (UnEc,*)  CurLine, Tab, VarName, Tab, Variable
            END IF

        END IF

    END subroutine ParseInput_Dbl_Opt

        !=======================================================================
    ! Parse integer input: read line, check that variable name is in line, handle errors
    subroutine ParseInput_Str_Opt(FileLines, VarName, Variable, FileName, ErrVar, AllowDefault, UnEc)
        USE ROSCO_Types, ONLY : ErrorVariables

        CHARACTER(*),           INTENT(IN   ), DIMENSION(:) :: FileLines   ! Input file unit
        CHARACTER(*),           INTENT(IN   )               :: VarName   ! Input file unit
        CHARACTER(*),           INTENT(IN   )               :: FileName   ! Input file unit
        TYPE(ErrorVariables),   INTENT(INOUT)               :: ErrVar   ! Current line of input
        CHARACTER(*),           INTENT(INOUT)               :: Variable   ! Variable
        Integer(IntKi), OPTIONAL, INTENT(IN   )               :: UnEc   ! Variable

        ! Flag (usually control mode) specifying whether default is allowed, 0 - yes, nonzero - no
        LOGICAL, OPTIONAL,      INTENT(IN   )        :: AllowDefault   
        
        INTEGER(IntKi)                          :: CurLine   ! Current line of input
        CHARACTER(MaxParamLength)               :: Words       (2)               ! The two "words" parsed from the line
        CHARACTER(MaxParamLength)               :: VarNameUC
        CHARACTER(MaxLineLength)                :: Line
        INTEGER(IntKi)                          :: ErrStatLcl           ! Error status local to this routine.
        INTEGER(IntKi)                          :: I, VarLineIndex                    ! Line indexer
        LOGICAL                                 :: AllowDefault_, FoundLine
        CHARACTER(*), PARAMETER                 :: RoutineName = 'ParseInput_Str_Opt'


        ! Figure out if we allow default
        AllowDefault_ = .TRUE.
        if (PRESENT(AllowDefault)) AllowDefault_ = AllowDefault    

        ! If we've already failed, don't read anything
        IF (ErrVar%aviFAIL >= 0) THEN

            CALL FindLine(FileLines, VarName, FoundLine, Line, CurLine)


            ! Separate line again
            CALL GetWords ( Line, Words, 2 )  

            ! PRINT *, "Line: ", TRIM(Line)

            ! Print warning with default
            IF (.NOT. FoundLine) THEN
                IF (.NOT. AllowDefault_) THEN
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg = RoutineName//':Missing or default values are not allowed for '//TRIM( VarName )//'. Please check control modes.'
                    RETURN
                ENDIF

                Variable = 'unused'     ! Default of string input is unused for now
                PRINT *, "ROSCO Warning: Did not find "//TRIM( VarName )//" in input file.  Using default value of ", TRIM(Variable)
            ENDIF

            ! Debugging: show what's being read, turn into Echo later
            IF (DEBUG_PARSING) THEN
                print *, 'Read: '//TRIM(Words(1))//' and '//TRIM(Words(2)),' on line ', CurLine
            END IF

            IF (ErrVar%aviFAIL >= 0 .AND. FoundLine) THEN        

                ! Read the variable
                READ (Words(1),'(A)',IOSTAT=ErrStatLcl)  Variable
                IF ( ErrStatLcl /= 0 )  THEN
                    ErrVar%aviFAIL  = -1
                    ErrVar%ErrMsg   =  NewLine//' >> A fatal error occurred when parsing data from "' &
                        //TRIM( FileName )//'".'//NewLine//  &
                        ' >> The variable "'//TRIM( Words(2) )//'" was not assigned valid INTEGER value on line #' &
                        //TRIM( Int2LStr( CurLine ) )//'.'//NewLine//&
                        ' >> The text being parsed was :'//NewLine//'    "'//TRIM( Line )//'"'
                ENDIF

            ENDIF   

            IF ( PRESENT(UnEc))  THEN
                IF ( UnEc > 0 )  WRITE (UnEc,*)  CurLine, Tab, VarName, Tab, Variable
            END IF

        END IF

    END subroutine ParseInput_Str_Opt


    !=======================================================================
    ! Parse double input, this is a copy of ParseInput_Int and a change in the variable definitions
    subroutine ParseInput_Dbl(Un, CurLine, VarName, FileName, Variable, ErrVar, CheckName)
        USE ROSCO_Types, ONLY : ErrorVariables

        CHARACTER(1024)                         :: Line
        INTEGER(IntKi),             INTENT(IN   )   :: Un   ! Input file unit
        CHARACTER(*),           INTENT(IN   )   :: VarName   ! Input file unit
        CHARACTER(*),           INTENT(IN   )   :: FileName   ! Input file unit
        INTEGER(IntKi),             INTENT(INOUT)   :: CurLine   ! Current line of input
        TYPE(ErrorVariables),   INTENT(INOUT)   :: ErrVar   ! Current line of input
        CHARACTER(20)                           :: Words       (2)               ! The two "words" parsed from the line
        LOGICAL, OPTIONAL,      INTENT(IN   )   :: CheckName

        REAL(DbKi),             INTENT(INOUT)      :: Variable   ! Variable
        INTEGER(IntKi)                              :: ErrStatLcl                    ! Error status local to this routine.

        LOGICAL                                 :: CheckName_

        ! Figure out if we're checking the name, default to .TRUE.
        CheckName_ = .TRUE.
        if (PRESENT(CheckName)) CheckName_ = CheckName 

        ! If we've already failed, don't read anything
        IF (ErrVar%aviFAIL >= 0) THEN

            ! Read the whole line as a string
            READ(Un, '(A)') Line

            ! Separate line string into 2 words
            CALL GetWords ( Line, Words, 2 )  

            ! Debugging: show what's being read, turn into Echo later
            IF (DEBUG_PARSING) THEN
            print *, 'Read: '//TRIM(Words(1))//' and '//TRIM(Words(2)),' on line ', CurLine
            END IF

            ! Check that Variable Name is in Words
            IF (CheckName_) THEN
                CALL ChkParseData ( Words, VarName, FileName, CurLine, ErrVar )
            END IF

            ! IF We haven't failed already
            IF (ErrVar%aviFAIL >= 0) THEN        

                ! Read the variable
                READ (Words(1),*,IOSTAT=ErrStatLcl)  Variable
                IF ( ErrStatLcl /= 0 )  THEN
                    ErrVar%aviFAIL  = -1
                    ErrVar%ErrMsg   =  NewLine//' >> A fatal error occurred when parsing data from "' &
                        //TRIM( FileName )//'".'//NewLine//  &
                        ' >> The variable "'//TRIM( Words(2) )//'" was not assigned valid INTEGER value on line #' &
                        //TRIM( Int2LStr( CurLine ) )//'.'//NewLine//&
                        ' >> The text being parsed was :'//NewLine//'    "'//TRIM( Line )//'"'
                ENDIF

            ENDIF   

            ! Increment line counter
            CurLine = CurLine + 1
        END IF

    END subroutine ParseInput_Dbl

    !=======================================================================
    ! Parse string input, this is a copy of ParseInput_Int and a change in the variable definitions
    subroutine ParseInput_Str(Un, CurLine, VarName, FileName, Variable, ErrVar, CheckName)
        USE ROSCO_Types, ONLY : ErrorVariables

        CHARACTER(1024)                         :: Line
        INTEGER(IntKi),             INTENT(IN   )   :: Un   ! Input file unit
        CHARACTER(*),           INTENT(IN   )   :: VarName   ! Input file unit
        CHARACTER(*),           INTENT(IN   )   :: FileName   ! Input file unit
        INTEGER(IntKi),             INTENT(INOUT)   :: CurLine   ! Current line of input
        TYPE(ErrorVariables),   INTENT(INOUT)   :: ErrVar   ! Current line of input
        CHARACTER(200)                          :: Words       (2)               ! The two "words" parsed from the line
        LOGICAL, OPTIONAL,      INTENT(IN   )   :: CheckName

        CHARACTER(*),           INTENT(INOUT)   :: Variable   ! Variable
        INTEGER(IntKi)                              :: ErrStatLcl                    ! Error status local to this routine.

        LOGICAL                                 :: CheckName_

        ! Figure out if we're checking the name, default to .TRUE.
        CheckName_ = .TRUE.
        if (PRESENT(CheckName)) CheckName_ = CheckName 

        ! If we've already failed, don't read anything
        IF (ErrVar%aviFAIL >= 0) THEN

            ! Read the whole line as a string
            READ(Un, '(A)') Line

            ! Separate line string into 2 words
            CALL GetWords ( Line, Words, 2 )  

            ! Debugging: show what's being read, turn into Echo later
            if (DEBUG_PARSING) THEN
                print *, 'Read: '//TRIM(Words(1))//' and '//TRIM(Words(2)),' on line ', CurLine
            END IF

            ! Check that Variable Name is in Words
            IF (CheckName_) THEN
                CALL ChkParseData ( Words, VarName, FileName, CurLine, ErrVar )
            END IF

            ! IF We haven't failed already
            IF (ErrVar%aviFAIL >= 0) THEN        

                ! Read the variable
                READ (Words(1),'(A)',IOSTAT=ErrStatLcl)  Variable
                IF ( ErrStatLcl /= 0 )  THEN
                    ErrVar%aviFAIL  = -1
                    ErrVar%ErrMsg   =  NewLine//' >> A fatal error occurred when parsing data from "' &
                        //TRIM( FileName )//'".'//NewLine//  &
                        ' >> The variable "'//TRIM( Words(2) )//'" was not assigned valid STRING value on line #' &
                        //TRIM( Int2LStr( CurLine ) )//'.'//NewLine//&
                        ' >> The text being parsed was :'//NewLine//'    "'//TRIM( Line )//'"'
                ENDIF

            ENDIF   

            ! Increment line counter
            CurLine = CurLine + 1
        END IF

    END subroutine ParseInput_Str

!=======================================================================
!> This subroutine parses the specified line of text for AryLen REAL values.
!! Generate an error message if the value is the wrong type.
!! Use ParseAry (nwtc_io::parseary) instead of directly calling a specific routine in the generic interface.   
    SUBROUTINE ParseDbAry ( Un, LineNum, ParamName, Ary, AryLen, FileName, ErrVar, CheckName )

        USE ROSCO_Types, ONLY : ErrorVariables

        ! Arguments declarations.
        INTEGER(IntKi),             INTENT(IN   )   :: Un   ! Input file unit
        INTEGER,                INTENT(IN   )   :: AryLen                        !< The length of the array to parse.

        REAL(DbKi), ALLOCATABLE,   INTENT(INOUT)   :: Ary(:)            !< The array to receive the input values.

        INTEGER(IntKi),             INTENT(INOUT)   :: LineNum                       !< The number of the line to parse.
        CHARACTER(*),           INTENT(IN)      :: FileName                      !< The name of the file being parsed.


        CHARACTER(*),           INTENT(IN   )   :: ParamName                       !< The array name we are trying to fill.

        TYPE(ErrorVariables),   INTENT(INOUT)   :: ErrVar   ! Current line of input

        LOGICAL, OPTIONAL,      INTENT(IN   )   :: CheckName


        ! Local declarations.

        CHARACTER(1024)                         :: Line
        INTEGER(IntKi)                              :: ErrStatLcl                    ! Error status local to this routine.
        INTEGER(IntKi)                              :: i

        CHARACTER(200), ALLOCATABLE             :: Words_Ary       (:)               ! The array "words" parsed from the line.
        CHARACTER(1024)                         :: Debug_String 
        CHARACTER(*), PARAMETER                 :: RoutineName = 'ParseDbAry'
        LOGICAL                                 :: CheckName_

        ! Figure out if we're checking the name, default to .TRUE.
        CheckName_ = .TRUE.
        if (PRESENT(CheckName)) CheckName_ = CheckName 

        ! If we've already failed, don't read anything
        IF (ErrVar%aviFAIL >= 0) THEN
            ! Read the whole line as a string
            READ(Un, '(A)') Line

            ! Allocate array and handle errors
            ALLOCATE ( Ary(AryLen) , STAT=ErrStatLcl )
            IF ( ErrStatLcl /= 0 ) THEN
                IF ( ALLOCATED(Ary) ) THEN
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg = RoutineName//':Error allocating memory for the '//TRIM( ParamName )//' array; array was already allocated.'
                ELSE
                    ErrVar%aviFAIL = -1
                    ErrVar%ErrMsg = RoutineName//':Error allocating memory for '//TRIM(Int2LStr( AryLen ))//' characters in the '//TRIM( ParamName )//' array.'
                END IF
            END IF
        
            ! Allocate words array
            ALLOCATE ( Words_Ary( AryLen + 1 ) , STAT=ErrStatLcl )
            IF ( ErrStatLcl /= 0 )  THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = RoutineName//':Fatal error allocating memory for the Words array.'
                CALL Cleanup()
                RETURN
            ENDIF

            ! Separate line string into AryLen + 1 words, should include variable name
            CALL GetWords ( Line, Words_Ary, AryLen + 1 )  

            ! Debug Output
            IF (DEBUG_PARSING) THEN
                Debug_String = ''
                DO i = 1,AryLen+1
                    Debug_String = TRIM(Debug_String)//TRIM(Words_Ary(i))
                    IF (i < AryLen + 1) THEN
                        Debug_String = TRIM(Debug_String)//','
                    END IF
                END DO
                print *, 'Read: '//TRIM(Debug_String)//' on line ', LineNum
            END IF

            ! Check that Variable Name is at the end of Words, will also check length of array
            IF (CheckName_) THEN
                CALL ChkParseData ( Words_Ary(AryLen:AryLen+1), ParamName, FileName, LineNum, ErrVar )
            END IF
        
            ! Read array
            READ (Line,*,IOSTAT=ErrStatLcl)  Ary
            IF ( ErrStatLcl /= 0 )  THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = RoutineName//':A fatal error occurred when parsing data from "' &
                                //TRIM( FileName )//'".'//NewLine//  &
                                ' >> The "'//TRIM( ParamName )//'" array was not assigned valid REAL values on line #' &
                                //TRIM( Int2LStr( LineNum ) )//'.'//NewLine//' >> The text being parsed was :'//NewLine &
                                //'    "'//TRIM( Line )//'"' 
                RETURN
                CALL Cleanup()         
            ENDIF

            LineNum = LineNum + 1
            CALL Cleanup()
        ENDIF

        RETURN

        !=======================================================================
        CONTAINS
        !=======================================================================
            SUBROUTINE Cleanup ( )

                ! This subroutine cleans up the parent routine before exiting.

                ! Deallocate the Words array if it had been allocated.

                IF ( ALLOCATED( Words_Ary ) ) DEALLOCATE( Words_Ary )


                RETURN

            END SUBROUTINE Cleanup

  END SUBROUTINE ParseDbAry

  !=======================================================================
!> This subroutine parses the specified line of text for AryLen INTEGER values.
!! Generate an error message if the value is the wrong type.
!! Use ParseAry (nwtc_io::parseary) instead of directly calling a specific routine in the generic interface.   
  SUBROUTINE ParseInAry ( Un, LineNum, ParamName, Ary, AryLen, FileName, ErrVar, CheckName )

    USE ROSCO_Types, ONLY : ErrorVariables

    ! Arguments declarations.
    INTEGER(IntKi),             INTENT(IN   )   :: Un   ! Input file unit
    INTEGER,                INTENT(IN   )   :: AryLen                        !< The length of the array to parse.

    INTEGER(IntKi), ALLOCATABLE,   INTENT(INOUT)   :: Ary(:)            !< The array to receive the input values.

    INTEGER(IntKi),             INTENT(INOUT)   :: LineNum                       !< The number of the line to parse.
    CHARACTER(*),           INTENT(IN)      :: FileName                      !< The name of the file being parsed.


    CHARACTER(*),           INTENT(IN   )   :: ParamName                       !< The array name we are trying to fill.

    TYPE(ErrorVariables),   INTENT(INOUT)   :: ErrVar   ! Current line of input

    LOGICAL, OPTIONAL,      INTENT(IN   )   :: CheckName

    ! Local declarations.

    CHARACTER(1024)                         :: Line
    INTEGER(IntKi)                              :: ErrStatLcl                    ! Error status local to this routine.
    INTEGER(IntKi)                              :: i

    CHARACTER(200), ALLOCATABLE             :: Words_Ary       (:)               ! The array "words" parsed from the line.
    CHARACTER(1024)                         :: Debug_String 
    CHARACTER(*), PARAMETER                 :: RoutineName = 'ParseInAry'

    LOGICAL                                 :: CheckName_

    ! Figure out if we're checking the name, default to .TRUE.
    CheckName_ = .TRUE.
    if (PRESENT(CheckName)) CheckName_ = CheckName    

    ! If we've already failed, don't read anything
    IF (ErrVar%aviFAIL >= 0) THEN
        ! Read the whole line as a string
        READ(Un, '(A)') Line

        ! Allocate array and handle errors
        ALLOCATE ( Ary(AryLen) , STAT=ErrStatLcl )
        IF ( ErrStatLcl /= 0 ) THEN
            IF ( ALLOCATED(Ary) ) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = RoutineName//':Error allocating memory for the '//TRIM( ParamName )//' array; array was already allocated.'
            ELSE
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = RoutineName//':Error allocating memory for '//TRIM(Int2LStr( AryLen ))//' characters in the '//TRIM( ParamName )//' array.'
            END IF
        END IF
    
        ! Allocate words array
        ALLOCATE ( Words_Ary( AryLen + 1 ) , STAT=ErrStatLcl )
        IF ( ErrStatLcl /= 0 )  THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg = RoutineName//':Fatal error allocating memory for the Words array.'
            CALL Cleanup()
            RETURN
        ENDIF

        ! Separate line string into AryLen + 1 words, should include variable name
        CALL GetWords ( Line, Words_Ary, AryLen + 1 )  

        ! Debug Output
        IF (DEBUG_PARSING) THEN
            Debug_String = ''
            DO i = 1,AryLen+1
                Debug_String = TRIM(Debug_String)//TRIM(Words_Ary(i))
                IF (i < AryLen + 1) THEN
                    Debug_String = TRIM(Debug_String)//','
                END IF
            END DO
            print *, 'Read: '//TRIM(Debug_String)//' on line ', LineNum
        END IF

        ! Check that Variable Name is at the end of Words, will also check length of array
        IF (CheckName_) THEN
            CALL ChkParseData ( Words_Ary(AryLen:AryLen+1), ParamName, FileName, LineNum, ErrVar )
        END IF
    
        ! Read array
        READ (Line,*,IOSTAT=ErrStatLcl)  Ary
        IF ( ErrStatLcl /= 0 )  THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg = RoutineName//':A fatal error occurred when parsing data from "' &
                            //TRIM( FileName )//'".'//NewLine//  &
                            ' >> The "'//TRIM( ParamName )//'" array was not assigned valid INTEGER values on line #' &
                            //TRIM( Int2LStr( LineNum ) )//'.'//NewLine//' >> The text being parsed was :'//NewLine &
                            //'    "'//TRIM( Line )//'"' 
            RETURN
            CALL Cleanup()         
        ENDIF

    !  IF ( PRESENT(UnEc) )  THEN
    !     IF ( UnEc > 0 )  WRITE (UnEc,'(A)')  TRIM( FileInfo%Lines(LineNum) )
    !  END IF

        LineNum = LineNum + 1
        CALL Cleanup()
    ENDIF

    RETURN

    !=======================================================================
    CONTAINS
    !=======================================================================
        SUBROUTINE Cleanup ( )

            ! This subroutine cleans up the parent routine before exiting.

            ! Deallocate the Words array if it had been allocated.

            IF ( ALLOCATED( Words_Ary ) ) DEALLOCATE( Words_Ary )


            RETURN

        END SUBROUTINE Cleanup

END SUBROUTINE ParseInAry

!=======================================================================

!=======================================================================
!> This subroutine parses the specified line of text for AryLen INTEGER values.
!! Generate an error message if the value is the wrong type.
!! Use ParseAry (nwtc_io::parseary) instead of directly calling a specific routine in the generic interface.   
  SUBROUTINE ParseInAry_Opt( FileLines, ParamName, Ary, AryLen, FileName, ErrVar, AllowDefault, UnEc )

    USE ROSCO_Types, ONLY : ErrorVariables

    ! Arguments declarations.
    CHARACTER(*),  INTENT(IN   ), DIMENSION(:)     :: FileLines   ! Input file unit
    INTEGER,                INTENT(IN   )          :: AryLen                        !< The length of the array to parse.
    INTEGER(IntKi), ALLOCATABLE,   INTENT(INOUT)   :: Ary(:)            !< The array to receive the input values.
    CHARACTER(*),           INTENT(IN)             :: FileName                      !< The name of the file being parsed.
    CHARACTER(*),           INTENT(IN)             :: ParamName                       !< The array name we are trying to fill.
    TYPE(ErrorVariables),   INTENT(INOUT)          :: ErrVar   ! Current line of input
    Integer(IntKi), OPTIONAL, INTENT(IN   )               :: UnEc   ! Variable
    LOGICAL, OPTIONAL,      INTENT(IN   )        :: AllowDefault   

    ! Local declarations.
    INTEGER(IntKi)                                 :: FinalAryLen                   !< Final array length, non-input
    INTEGER(IntKi)                                 :: LineNum                       !< The number of the line to parse.
    CHARACTER(MaxLineLength)                       :: Line
    INTEGER(IntKi)                                 :: ErrStatLcl                    ! Error status local to this routine.
    INTEGER(IntKi)                                 :: i

    CHARACTER(MaxParamLength), ALLOCATABLE          :: Words_Ary       (:)               ! The array "words" parsed from the line.
    CHARACTER(MaxLineLength)                        :: Debug_String 
    CHARACTER(*), PARAMETER                         :: RoutineName = 'ParseInAry_Opt'
    CHARACTER(MaxParamLength)                       :: ParamNameUC
    LOGICAL                                         :: AllowDefault_, FoundLine

    ! Figure out if we allow default
    AllowDefault_ = .TRUE.
    if (PRESENT(AllowDefault)) AllowDefault_ = AllowDefault    

    ! If we've already failed, don't read anything
    IF (ErrVar%aviFAIL >= 0) THEN
        
        CALL FindLine(FileLines, ParamName, FoundLine, Line, LineNum, AryLen)

        ! PRINT *, "Line: ", TRIM(Line)

        ! Minimum array length
        IF (AryLen < 1) THEN
            FinalAryLen = 1
        ELSE
            FinalAryLen = AryLen
        ENDIF

        ! Allocate array and handle errors
         ALLOCATE ( Ary(FinalAryLen) , STAT=ErrStatLcl )
        IF ( ErrStatLcl /= 0 ) THEN
            IF ( ALLOCATED(Ary) ) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = RoutineName//':Error allocating memory for the '//TRIM( ParamName )//' array; array was already allocated.'
            ELSE
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = RoutineName//':Error allocating memory for '//TRIM(Int2LStr( AryLen ))//' characters in the '//TRIM( ParamName )//' array.'
            END IF
        END IF

        ! Print warning with default
        IF (.NOT. FoundLine) THEN
            IF (.NOT. AllowDefault_) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = RoutineName//':Missing or default values are not allowed for '//TRIM( ParamName )//'. Please check control modes and array length.'
                RETURN
            ENDIF

            Ary = 0     ! Default of allocatable arrays is 0 for now
            PRINT *, "ROSCO Warning: Did not find correct size "//TRIM( ParamName )//" in input file.  Using default value of [", Ary, "]"
        ENDIF

        IF (FoundLine) THEN
    
            ! Allocate words array
            ALLOCATE ( Words_Ary( AryLen + 1 ) , STAT=ErrStatLcl )
            IF ( ErrStatLcl /= 0 )  THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = RoutineName//':Fatal error allocating memory for the Words array.'
                CALL Cleanup()
                RETURN
            ENDIF

            ! Separate line string into AryLen + 1 words, should include variable name
            CALL GetWords ( Line, Words_Ary, AryLen + 1 )  

            ! Debug Output
            IF (DEBUG_PARSING) THEN
                Debug_String = ''
                DO i = 1,AryLen+1
                    Debug_String = TRIM(Debug_String)//TRIM(Words_Ary(i))
                    IF (i < AryLen + 1) THEN
                        Debug_String = TRIM(Debug_String)//','
                    END IF
                END DO
                print *, 'Read: '//TRIM(Debug_String)//' on line ', LineNum
            END IF
        
            ! Read array
            READ (Line,*,IOSTAT=ErrStatLcl)  Ary
            IF ( ErrStatLcl /= 0 )  THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = RoutineName//':A fatal error occurred when parsing data from "' &
                                //TRIM( FileName )//'".'//NewLine//  &
                                ' >> The "'//TRIM( ParamName )//'" array was not assigned valid REAL values on line #' &
                                //TRIM( Int2LStr( LineNum ) )//'.'//NewLine//' >> The text being parsed was :'//NewLine &
                                //'    "'//TRIM( Line )//'"' 
                RETURN
                CALL Cleanup()         
            ENDIF

        ENDIF

        IF ( PRESENT(UnEc))  THEN
            IF ( UnEc > 0 )  WRITE (UnEc,*)  LineNum, Tab, ParamName, Tab, Ary
        END IF

        CALL Cleanup()
    ENDIF

    RETURN

    !=======================================================================
    CONTAINS
    !=======================================================================
        SUBROUTINE Cleanup ( )

            ! This subroutine cleans up the parent routine before exiting.

            ! Deallocate the Words array if it had been allocated.

            IF ( ALLOCATED( Words_Ary ) ) DEALLOCATE( Words_Ary )


            RETURN

        END SUBROUTINE Cleanup

END SUBROUTINE ParseInAry_Opt

!=======================================================================
!> This subroutine parses the specified line of text for AryLen INTEGER values.
!! Generate an error message if the value is the wrong type.
!! Use ParseAry (nwtc_io::parseary) instead of directly calling a specific routine in the generic interface.   
  SUBROUTINE ParseDbAry_Opt ( FileLines, ParamName, Ary, AryLen, FileName, ErrVar, AllowDefault, UnEc )

    USE ROSCO_Types, ONLY : ErrorVariables

    ! Arguments declarations.
    CHARACTER(*),  INTENT(IN   ), DIMENSION(:)     :: FileLines   ! Input file unit
    INTEGER,                INTENT(IN)             :: AryLen                        !< The length of the array to parse.
    REAL(DbKi), ALLOCATABLE,   INTENT(INOUT)       :: Ary(:)            !< The array to receive the input values.
    CHARACTER(*),           INTENT(IN)             :: FileName                      !< The name of the file being parsed.
    CHARACTER(*),           INTENT(IN)             :: ParamName                       !< The array name we are trying to fill.
    TYPE(ErrorVariables),   INTENT(INOUT)          :: ErrVar   ! Current line of input
    LOGICAL, OPTIONAL,      INTENT(IN   )          :: AllowDefault   
    Integer(IntKi), OPTIONAL, INTENT(IN   )        :: UnEc   ! Variable

    ! Local declarations.
    INTEGER(IntKi)                                 :: LineNum                       !< The number of the line to parse.
    INTEGER(IntKi)                                 :: FinalAryLen                   !< Final array length, non-input
    CHARACTER(MaxLineLength)                       :: Line
    INTEGER(IntKi)                                 :: ErrStatLcl                    ! Error status local to this routine.
    INTEGER(IntKi)                                 :: i

    CHARACTER(MaxParamLength), ALLOCATABLE          :: Words_Ary       (:)               ! The array "words" parsed from the line.
    CHARACTER(MaxLineLength)                        :: Debug_String 
    CHARACTER(*), PARAMETER                         :: RoutineName = 'ParseDbAry_Opt'
    CHARACTER(MaxParamLength)                       :: ParamNameUC, FileLineUC
    LOGICAL                                         :: AllowDefault_, FoundLine

    ! Figure out if we allow default
    AllowDefault_ = .TRUE.
    if (PRESENT(AllowDefault)) AllowDefault_ = AllowDefault    

    ! If we've already failed, don't read anything
    IF (ErrVar%aviFAIL >= 0) THEN
        
        CALL FindLine(FileLines, ParamName, FoundLine, Line, LineNum, AryLen)
        
        ! Minimum array length
        IF (AryLen < 1) THEN
            FinalAryLen = 1
        ELSE
            FinalAryLen = AryLen
        ENDIF

        ! Allocate array and handle errors
        ALLOCATE ( Ary(FinalAryLen) , STAT=ErrStatLcl )
        IF ( ErrStatLcl /= 0 ) THEN
            IF ( ALLOCATED(Ary) ) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = RoutineName//':Error allocating memory for the '//TRIM( ParamName )//' array; array was already allocated.'
            ELSE
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = RoutineName//':Error allocating memory for '//TRIM(Int2LStr( AryLen ))//' characters in the '//TRIM( ParamName )//' array.'
            END IF
        END IF

        ! Print warning with default
        IF (.NOT. FoundLine) THEN
            IF (.NOT. AllowDefault_) THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = RoutineName//':Missing or default values are not allowed for '//TRIM( ParamName )//'. Please check control modes and array length.'
                RETURN
            ENDIF

            Ary = 0     ! Default of allocatable arrays is 0 for now
            PRINT *, "ROSCO Warning: Did not find correct size "//TRIM( ParamName )//" in input file.  Using default value of [", Ary, "]"
        ENDIF

        IF (FoundLine) THEN
    
            ! Allocate words array
            ALLOCATE ( Words_Ary( AryLen + 1 ) , STAT=ErrStatLcl )
            IF ( ErrStatLcl /= 0 )  THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = RoutineName//':Fatal error allocating memory for the Words array.'
                CALL Cleanup()
                RETURN
            ENDIF

            ! Separate line string into AryLen + 1 words, should include variable name
            CALL GetWords ( Line, Words_Ary, AryLen + 1 )  

            ! Debug Output
            IF (DEBUG_PARSING) THEN
                Debug_String = ''
                DO i = 1,AryLen+1
                    Debug_String = TRIM(Debug_String)//TRIM(Words_Ary(i))
                    IF (i < AryLen + 1) THEN
                        Debug_String = TRIM(Debug_String)//','
                    END IF
                END DO
                print *, 'Read: '//TRIM(Debug_String)//' on line ', LineNum
            END IF
        
            ! Read array
            READ (Line,*,IOSTAT=ErrStatLcl)  Ary
            IF ( ErrStatLcl /= 0 )  THEN
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = RoutineName//':A fatal error occurred when parsing data from "' &
                                //TRIM( FileName )//'".'//NewLine//  &
                                ' >> The "'//TRIM( ParamName )//'" array was not assigned valid REAL values on line #' &
                                //TRIM( Int2LStr( LineNum ) )//'.'//NewLine//' >> The text being parsed was :'//NewLine &
                                //'    "'//TRIM( Line )//'"' 
                RETURN
                CALL Cleanup()         
            ENDIF

        ENDIF

        IF ( PRESENT(UnEc))  THEN
            IF ( UnEc > 0 )  WRITE (UnEc,*)  LineNum, Tab, ParamName, Tab, Ary
        END IF

        CALL Cleanup()
    ENDIF

    RETURN

    !=======================================================================
    CONTAINS
    !=======================================================================
        SUBROUTINE Cleanup ( )

            ! This subroutine cleans up the parent routine before exiting.

            ! Deallocate the Words array if it had been allocated.

            IF ( ALLOCATED( Words_Ary ) ) DEALLOCATE( Words_Ary )


            RETURN

        END SUBROUTINE Cleanup

END SUBROUTINE ParseDbAry_Opt



!=======================================================================

 !> This subroutine checks the data to be parsed to make sure it finds
    !! the expected variable name and an associated value.
SUBROUTINE ChkParseData ( Words, ExpVarName, FileName, FileLineNum, ErrVar )

    USE ROSCO_Types, ONLY : ErrorVariables


        ! Arguments declarations.
    TYPE(ErrorVariables),         INTENT(INOUT)          :: ErrVar   ! Current line of input

    INTEGER(IntKi), INTENT(IN)             :: FileLineNum                   !< The number of the line in the file being parsed.
    INTEGER(IntKi)                        :: NameIndx                      !< The index into the Words array that points to the variable name.

    CHARACTER(*),   INTENT(IN)             :: ExpVarName                    !< The expected variable name.
    CHARACTER(*),   INTENT(IN)             :: Words       (2)               !< The two words to be parsed from the line.

    CHARACTER(*),   INTENT(IN)             :: FileName                      !< The name of the file being parsed.


        ! Local declarations.

    CHARACTER(20)                          :: ExpUCVarName                  ! The uppercase version of ExpVarName.
    CHARACTER(20)                          :: FndUCVarName                  ! The uppercase version of the word being tested.




        ! Convert the found and expected names to uppercase.

    FndUCVarName = Words(1)
    ExpUCVarName = ExpVarName

    CALL Conv2UC ( FndUCVarName )
    CALL Conv2UC ( ExpUCVarName )

    ! See which word is the variable name.  Generate an error if it is the first
        
    IF ( TRIM( FndUCVarName ) == TRIM( ExpUCVarName ) )  THEN
        NameIndx = 1
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg = ' >> A fatal error occurred when parsing data from "'//TRIM( FileName ) &
                            //'".'//NewLine//' >> The variable "'//TRIM( Words(1) )//'" was not assigned a valid value on line #' &
                            //TRIM( Int2LStr( FileLineNum ) )//'.' 
        RETURN
    ELSE
        FndUCVarName = Words(2)
        CALL Conv2UC ( FndUCVarName )
        IF ( TRIM( FndUCVarName ) == TRIM( ExpUCVarName ) )  THEN
        NameIndx = 2
        ELSE
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg = ' >> A fatal error occurred when parsing data from "'//TRIM( FileName ) &
                            //'".'//NewLine//' >> The variable "'//TRIM( ExpVarName )//'" was not assigned a valid value on line #' &
                            //TRIM( Int2LStr( FileLineNum ) )//'.' 
        RETURN
        ENDIF
    ENDIF


END SUBROUTINE ChkParseData 

SUBROUTINE FindLine(FileLines, ParamName, FoundLine, Line, LineNum, AryLen)
    CHARACTER(*),   INTENT(IN   ), DIMENSION(:)    :: FileLines   ! Input file unit
    CHARACTER(*),   INTENT(IN)                     :: ParamName                       !< The array name we are trying to fill.
    INTEGER(IntKi), INTENT(OUT)                    :: LineNum                       !< The number of the line to parse.
    LOGICAL, INTENT(OUT)                    :: FoundLine
    INTEGER(IntKi), OPTIONAL,      INTENT(IN   )          :: AryLen
    CHARACTER(MaxLineLength), INTENT(OUT)          :: Line
    
    
    CHARACTER(MaxParamLength), ALLOCATABLE  :: Words(:)               ! The two "words" parsed from the line

    CHARACTER(MaxParamLength)                      :: ParamNameUC, FileLineUC
    INTEGER(IntKi)                                 :: I, WordInd

    IF (.NOT. PRESENT(AryLen)) THEN
        WordInd = 2
    ELSE
        WordInd = AryLen + 1
    ENDIF

    ALLOCATE(Words(WordInd))   ! TODO: check error
    
    ! Make name uppercase
    ParamNameUC = ParamName
    CALL Conv2UC(ParamNameUC)
    
    ! Search for line in FileLines
    FoundLine = .FALSE.
    LineNum = 0
    DO I = 1,SIZE(FileLines)

        ! Separate line string into 2 words
        CALL GetWords ( FileLines(I), Words, WordInd )  
        
        ! Make FileLines uppercase
        FileLineUC = Words(WordInd)
        CALL Conv2UC(FileLineUC)

        ! WRITE(500,*) Words

        ! PRINT *, TRIM(ParamNameUC), '==', TRIM(FileLineUC), '=', TRIM(FileLineUC)==TRIM(ParamNameUC)
        
        IF (FileLineUC == ParamNameUC) THEN
            Line = FileLines(I)
            LineNum = I
            FoundLine = .TRUE.
        END IF
    END DO

END subroutine FindLine

!=======================================================================
subroutine ReadEmptyLine(Un,CurLine)
    INTEGER(IntKi),         INTENT(IN   )          :: Un   ! Input file unit
    INTEGER(IntKi),         INTENT(INOUT)          :: CurLine   ! Current line of input

    CHARACTER(1024)                            :: Line

    READ(Un, '(A)') Line
    CurLine = CurLine + 1

END subroutine ReadEmptyLine

!=======================================================================
!> This subroutine is used to get the NumWords "words" from a line of text.
!! It uses spaces, tabs, commas, semicolons, single quotes, and double quotes ("whitespace")
!! as word separators. If there aren't NumWords in the line, the remaining array elements will remain empty.
!! Use CountWords (nwtc_io::countwords) to count the number of words in a line.
SUBROUTINE GetWords ( Line, Words, NumWords )

    ! Argument declarations.

    INTEGER, INTENT(IN)          :: NumWords                                     !< The number of words to look for.

    CHARACTER(*), INTENT(IN)     :: Line                                         !< The string to search.
    CHARACTER(*), INTENT(OUT)    :: Words(NumWords)                              !< The array of found words.


        ! Local declarations.

    INTEGER                      :: Ch                                           ! Character position within the string.
    INTEGER                      :: IW                                           ! Word index.
    INTEGER                      :: NextWhite                                    ! The location of the next whitespace in the string.
    CHARACTER(1), PARAMETER       :: Tab      = CHAR( 9 ) 



        ! Let's prefill the array with blanks.

    DO IW=1,NumWords
        Words(IW) = ' '
    END DO ! IW


        ! Let's make sure we have text on this line.

    IF ( LEN_TRIM( Line ) == 0 )  RETURN


        ! Parse words separated by any combination of spaces, tabs, commas,
        ! semicolons, single quotes, and double quotes ("whitespace").

    Ch = 0
    IW = 0

    DO

        NextWhite = SCAN( Line(Ch+1:) , ' ,!;''"'//Tab )

        IF ( NextWhite > 1 )  THEN

        IW        = IW + 1
        Words(IW) = Line(Ch+1:Ch+NextWhite-1)

        IF ( IW == NumWords )  EXIT

        Ch = Ch + NextWhite

        ELSE IF ( NextWhite == 1 )  THEN

        Ch = Ch + 1

        CYCLE

        ELSE

        EXIT

        END IF

    END DO


    RETURN
END SUBROUTINE GetWords
!=======================================================================
!> Let's parse the path name from the name of the given file.
!! We'll count everything before (and including) the last "\" or "/".
SUBROUTINE GetPath ( GivenFil, PathName )

    ! Argument declarations.

 CHARACTER(*), INTENT(IN)     :: GivenFil                                     !< The name of the given file.
 CHARACTER(*), INTENT(OUT)    :: PathName                                     !< The path name of the given file (based solely on the GivenFil text string).


    ! Local declarations.

 INTEGER                      :: I                                            ! DO index for character position.


    ! Look for path separators

 I = INDEX( GivenFil, '\', BACK=.TRUE. )
 I = MAX( I, INDEX( GivenFil, '/', BACK=.TRUE. ) )

 IF ( I == 0 ) THEN
    ! we don't have a path specified, return '.'
    PathName = '.'//PathSep
 ELSE
    PathName = GivenFil(:I)
 END IF


 RETURN
 END SUBROUTINE GetPath
!=======================================================================
!> Let's parse the root file name from the name of the given file.
!! We'll count everything after the last period as the extension.
!! Borrowed from NWTC_IO...thanks!

   SUBROUTINE GetRoot ( GivenFil, RootName )

      ! Argument declarations.

   CHARACTER(*), INTENT(IN)     :: GivenFil                                     !< The name of the given file.
   CHARACTER(*), INTENT(OUT)    :: RootName                                     !< The parsed root name of the given file.


      ! Local declarations.

   INTEGER                      :: I                                            ! DO index for character position.



      ! Deal with a couple of special cases.

   IF ( ( TRIM( GivenFil ) == "." ) .OR. (  TRIM( GivenFil ) == ".." ) )  THEN
      RootName = TRIM( GivenFil )
      RETURN
   END IF


      ! More-normal cases.

   DO I=LEN_TRIM( GivenFil ),1,-1


      IF ( GivenFil(I:I) == '.' )  THEN


         IF ( I < LEN_TRIM( GivenFil ) ) THEN                   ! Make sure the index I is okay
            IF ( INDEX( '\/', GivenFil(I+1:I+1)) == 0 ) THEN    ! Make sure we don't have the RootName in a different directory
               RootName = GivenFil(:I-1)
            ELSE
               RootName = GivenFil                              ! This does not have a file extension
            END IF
         ELSE
            IF ( I == 1 ) THEN
               RootName = ''
            ELSE
               RootName = GivenFil(:I-1)
            END IF
         END IF

         RETURN

      END IF
   END DO ! I

   RootName =  GivenFil


   RETURN
   END SUBROUTINE GetRoot
!=======================================================================
!> This routine determines if the given file name is absolute or relative.
!! We will consider an absolute path one that satisfies one of the
!! following four criteria:
!!     1. It contains ":/"
!!     2. It contains ":\"
!!     3. It starts with "/"
!!     4. It starts with "\"
!!   
!! All others are considered relative.
 FUNCTION PathIsRelative ( GivenFil )

    ! Argument declarations.

 CHARACTER(*), INTENT(IN)     :: GivenFil                                            !< The name of the given file.
 LOGICAL                      :: PathIsRelative                                      !< The function return value

 

    ! Determine if file name begins with an absolute path name or if it is relative 
    !    note that Doxygen has serious issues if you use the single quote instead of  
    !    double quote characters in the strings below:

 PathIsRelative = .FALSE.

 IF ( ( INDEX( GivenFil, ":/") == 0 ) .AND. ( INDEX( GivenFil, ":\") == 0 ) ) THEN   ! No drive is specified (by ":\" or ":/")

    IF ( INDEX( "/\", GivenFil(1:1) ) == 0 ) THEN                                    ! The file name doesn't start with "\" or "/"

       PathIsRelative = .TRUE.

    END IF

 END IF

 RETURN
 END FUNCTION PathIsRelative
!=======================================================================
! ------------------------------------------------------
    ! Read Open Loop Control Inputs
    ! 
    ! Timeseries or lookup tables of the form
    ! index (time or wind speed)   channel_1 \t channel_2 \t channel_3 ...
    ! This could be used to read any group of data of unspecified length ...
SUBROUTINE Read_OL_Input(OL_InputFileName, Unit_OL_Input, NumChannels, Channels, ErrVar)

    USE ROSCO_Types, ONLY : ErrorVariables

    CHARACTER(1024), INTENT(IN)                             :: OL_InputFileName    ! DISCON input filename
    INTEGER(IntKi), INTENT(IN)                              :: Unit_OL_Input 
    INTEGER(IntKi), INTENT(IN)                              :: NumChannels     ! Number of open loop channels being defined
    ! REAL(DbKi), INTENT(OUT), DIMENSION(:), ALLOCATABLE      :: Breakpoints    ! Breakpoints of open loop Channels
    REAL(DbKi), INTENT(OUT), DIMENSION(:,:), ALLOCATABLE    :: Channels         ! Open loop channels
    TYPE(ErrorVariables),         INTENT(INOUT)          :: ErrVar   ! Current line of input


    LOGICAL                                                 :: FileExists
    INTEGER                                                 :: IOS                                                 ! I/O status of OPEN.
    CHARACTER(1024)                                         :: Line              ! Temp variable for reading whole line from file
    INTEGER(IntKi)                                          :: NumComments
    INTEGER(IntKi)                                          :: NumDataLines
    REAL(DbKi)                                              :: TmpData(NumChannels)  ! Temp variable for reading all columns from a line
    CHARACTER(15)                                           :: NumString

    INTEGER(IntKi)                                          :: I,J

    CHARACTER(*),               PARAMETER                   :: RoutineName = 'Read_OL_Input'

    !-------------------------------------------------------------------------------------------------
    ! Read from input file, borrowed (read: copied) from (Open)FAST team...thanks!
    !-------------------------------------------------------------------------------------------------

    !-------------------------------------------------------------------------------------------------
    ! Open the file for reading
    !-------------------------------------------------------------------------------------------------

    INQUIRE (FILE = OL_InputFileName, EXIST = FileExists)

    IF ( .NOT. FileExists) THEN
        ErrVar%aviFAIL = -1
        ErrVar%ErrMsg = TRIM(OL_InputFileName)// ' does not exist'

    ELSE

        OPEN( Unit_OL_Input, FILE=TRIM(OL_InputFileName), STATUS='OLD', FORM='FORMATTED', IOSTAT=IOS, ACTION='READ' )

        IF (IOS /= 0) THEN
            ErrVar%aviFAIL = -1
            ErrVar%ErrMsg = 'Cannot open '//TRIM(OL_InputFileName)
        
        ELSE
            ! Do all the stuff!
            !-------------------------------------------------------------------------------------------------
            ! Find the number of comment lines
            !-------------------------------------------------------------------------------------------------

            LINE = '!'                          ! Initialize the line for the DO WHILE LOOP
            NumComments = -1                    ! the last line we read is not a comment, so we'll initialize this to -1 instead of 0

            DO WHILE ( (INDEX( LINE, '!' ) > 0) .OR. (INDEX( LINE, '#' ) > 0) .OR. (INDEX( LINE, '%' ) > 0) ) ! Lines containing "!" are treated as comment lines
                NumComments = NumComments + 1
                
                READ(Unit_OL_Input,'( A )',IOSTAT=IOS) LINE

                ! NWTC_IO has some error catching here that we'll skip for now
        
            END DO !WHILE

            !-------------------------------------------------------------------------------------------------
            ! Find the number of data lines
            !-------------------------------------------------------------------------------------------------

            NumDataLines = 0

            READ(LINE,*,IOSTAT=IOS) ( TmpData(I), I=1,NumChannels ) ! this line was read when we were figuring out the comment lines; let's make sure it contains

            DO WHILE (IOS == 0)  ! read the rest of the file (until an error occurs)
                NumDataLines = NumDataLines + 1
                
                READ(Unit_OL_Input,*,IOSTAT=IOS) ( TmpData(I), I=1,NumChannels )
            
            END DO !WHILE
        
        
            IF (NumDataLines < 1) THEN
                WRITE (NumString,'(I11)')  NumComments
                ErrVar%aviFAIL = -1
                ErrVar%ErrMsg = 'Error: '//TRIM(NumString)//' comment lines were found in the uniform wind file, '// &
                            'but the first data line does not contain the proper format.'
                CLOSE(Unit_OL_Input)
            END IF

            !-------------------------------------------------------------------------------------------------
            ! Allocate arrays for the uniform wind data
            !-------------------------------------------------------------------------------------------------
            ALLOCATE(Channels(NumDataLines,NumChannels))

            !-------------------------------------------------------------------------------------------------
            ! Rewind the file (to the beginning) and skip the comment lines
            !-------------------------------------------------------------------------------------------------

            REWIND( Unit_OL_Input )

            DO I=1,NumComments
                READ(Unit_OL_Input,'( A )',IOSTAT=IOS) LINE
            END DO !I
        
            !-------------------------------------------------------------------------------------------------
            ! Read the data arrays
            !-------------------------------------------------------------------------------------------------
        
            DO I=1,NumDataLines
            
                READ(Unit_OL_Input,*,IOSTAT=IOS) ( TmpData(J), J=1,NumChannels )

                IF (IOS > 0) THEN
                    CLOSE(Unit_OL_Input)
                END IF

                Channels(I,:)        = TmpData
        
            END DO !I     
        END IF
    END IF

    IF (ErrVar%aviFAIL < 0) THEN
        ErrVar%ErrMsg = RoutineName//':'//TRIM(ErrVar%ErrMsg)
    ENDIF

END SUBROUTINE Read_OL_Input

!=======================================================================
!> This routine returns the next unit number greater than 9 that is not currently in use.
!! If it cannot find any unit between 10 and 99 that is available, it either aborts or returns an appropriate error status/message.   
   SUBROUTINE GetNewUnit ( UnIn, ErrVar )



      ! Argument declarations.

   INTEGER,        INTENT(OUT)            :: UnIn                                         !< Logical unit for the file.                           !< The error message, if an error occurred
   TYPE(ErrorVariables), INTENT(INOUT)             :: ErrVar


      ! Local declarations.

   INTEGER                                :: Un                                           ! Unit number
   LOGICAL                                :: Opened                                       ! Flag indicating whether or not a file is opened.
   INTEGER(IntKi), PARAMETER              :: StartUnit = 10                               ! Starting unit number to check (numbers less than 10 reserved)
   ! NOTE: maximum unit numbers in fortran 90 and later is 2**31-1.  However, there are limits within the OS.
   !     macos -- 256  (change with ulimit -n)
   !     linux -- 1024 (change with ulimit -n)
   !     windows -- 512 (not sure how to change -- ADP)
   INTEGER(IntKi), PARAMETER              :: MaxUnit   = 1024                             ! The maximum unit number available (or 10 less than the number of files you want to have open at a time)

      ! Initialize subroutine outputs

   Un = StartUnit

      ! See if unit is connected to an open file. Check the next largest number until it is not opened.

   DO

      INQUIRE ( UNIT=Un , OPENED=Opened )

      IF ( .NOT. Opened )  EXIT
      Un = Un + 1

      IF ( Un > MaxUnit ) THEN

         ErrVar%aviFAIL = -1
         ErrVar%ErrMsg  = 'GetNewUnit() was unable to find an open file unit specifier between '//TRIM(Int2LStr(StartUnit)) &
                                                                            //' and '//TRIM(Int2LStr(MaxUnit))//'.'

         EXIT           ! stop searching now

      END IF


   END DO

   UnIn = Un

   RETURN
   END SUBROUTINE GetNewUnit

!=======================================================================
!> This function returns a character string encoded with the time in the form "hh:mm:ss".
    FUNCTION CurTime( )

    ! Function declaration.

    CHARACTER(8)                 :: CurTime                                      !< The current time in the form "hh:mm:ss".


    ! Local declarations.

    CHARACTER(10)                :: CTime                                        ! String to hold the returned value from the DATE_AND_TIME subroutine call.



    CALL DATE_AND_TIME ( TIME=CTime )

    CurTime = CTime(1:2)//':'//CTime(3:4)//':'//CTime(5:6)


    RETURN
    END FUNCTION CurTime

!=======================================================================
! This function checks whether an array is non-decreasing
    LOGICAL Function NonDecreasing(Array)

    IMPLICIT NONE

    REAL(DbKi), DIMENSION(:)            :: Array
    INTEGER(IntKi)         :: I_DIFF

    NonDecreasing = .TRUE.
    ! Is Array non decreasing
    DO I_DIFF = 1, size(Array) - 1
        IF (Array(I_DIFF + 1) - Array(I_DIFF) <= 0) THEN
            NonDecreasing = .FALSE.
            RETURN
        END IF
    END DO

    RETURN
    END FUNCTION NonDecreasing

!=======================================================================
!> This routine converts all the text in a string to upper case.
    SUBROUTINE Conv2UC ( Str )

        ! Argument declarations.
  
     CHARACTER(*), INTENT(INOUT)  :: Str                                          !< The string to be converted to UC (upper case).
  
  
        ! Local declarations.
  
     INTEGER                      :: IC                                           ! Character index
  
  
  
     DO IC=1,LEN_TRIM( Str )
  
        IF ( ( Str(IC:IC) >= 'a' ).AND.( Str(IC:IC) <= 'z' ) )  THEN
           Str(IC:IC) = CHAR( ICHAR( Str(IC:IC) ) - 32 )
        END IF
  
     END DO ! IC
  
  
     RETURN
     END SUBROUTINE Conv2UC

!=======================================================================
     !> This function returns a left-adjusted string representing the passed numeric value. 
    !! It eliminates trailing zeroes and even the decimal point if it is not a fraction. \n
    !! Use Num2LStr (nwtc_io::num2lstr) instead of directly calling a specific routine in the generic interface.   
    FUNCTION Int2LStr ( Num )

        CHARACTER(11)                :: Int2LStr                                     !< string representing input number.
    
    
        ! Argument declarations.
    
        INTEGER, INTENT(IN)          :: Num                                          !< The number to convert to a left-justified string.
    
    
    
        WRITE (Int2LStr,'(I11)')  Num
    
        Int2Lstr = ADJUSTL( Int2LStr )
    
    
        RETURN
        END FUNCTION Int2LStr

!=======================================================================

    subroutine AddToList(list, element)
        ! Credit to: https://stackoverflow.com/questions/28048508/how-to-add-new-element-to-dynamical-array-in-fortran-90
        ! This is set up for integers, will need to make interface for other types
          IMPLICIT NONE

          integer :: i, isize
          Integer(IntKi), intent(in) :: element
          Integer(IntKi), dimension(:), allocatable, intent(inout) :: list
          Integer(IntKi), dimension(:), allocatable :: clist


          if(allocated(list)) then
              isize = size(list)
              allocate(clist(isize+1))
              do i=1,isize          
              clist(i) = list(i)
              end do
              clist(isize+1) = element

              deallocate(list)
              call move_alloc(clist, list)

          else
              allocate(list(1))
              list(1) = element
          end if


      end subroutine AddToList

    !-------------------------------------------------------------------------------------------------------------------------------
    ! Copied from NWTC_IO.f90
    !> This function returns a character string encoded with today's date in the form dd-mmm-ccyy.
    FUNCTION CurDate( )

    ! Function declaration.

    CHARACTER(11)                :: CurDate                                      !< 'dd-mmm-yyyy' string with the current date


    ! Local declarations.

    CHARACTER(8)                 :: CDate                                        ! String to hold the returned value from the DATE_AND_TIME subroutine call.



    !  Call the system date function.

    CALL DATE_AND_TIME ( CDate )


    !  Parse out the day.

    CurDate(1:3) = CDate(7:8)//'-'


    !  Parse out the month.

    SELECT CASE ( CDate(5:6) )
    CASE ( '01' )
        CurDate(4:6) = 'Jan'
    CASE ( '02' )
        CurDate(4:6) = 'Feb'
    CASE ( '03' )
        CurDate(4:6) = 'Mar'
    CASE ( '04' )
        CurDate(4:6) = 'Apr'
    CASE ( '05' )
        CurDate(4:6) = 'May'
    CASE ( '06' )
        CurDate(4:6) = 'Jun'
    CASE ( '07' )
        CurDate(4:6) = 'Jul'
    CASE ( '08' )
        CurDate(4:6) = 'Aug'
    CASE ( '09' )
        CurDate(4:6) = 'Sep'
    CASE ( '10' )
        CurDate(4:6) = 'Oct'
    CASE ( '11' )
        CurDate(4:6) = 'Nov'
    CASE ( '12' )
        CurDate(4:6) = 'Dec'
    END SELECT


    !  Parse out the year.

    CurDate(7:11) = '-'//CDate(1:4)


    RETURN
    END FUNCTION CurDate


END MODULE ROSCO_Helpers

#!/bin/bash

mkdir build
cd build 

cmake \
    -DCMAKE_Fortran_FLAGS="-ffree-line-length-0" \
    -DCMAKE_INSTALL_PREFIX=${PREFIX} \
    -DCMAKE_BUILD_TYPE=Release \
    ..

make -j${CPU_COUNT} install

python setup.py install

cmake -G "MinGW Makefiles" ^
    -D CMAKE_INSTALL_PREFIX="%LIBRARY_PREFIX%" ^
    -D CMAKE_PREFIX_PATH="%LIBRARY_PREFIX%" ^
    ROSCO
if errorlevel 1 exit 1

cmake --build . --target install
if errorlevel 1 exit 1

#!/bin/bash
#SBATCH --account=ssc
#SBATCH --time=1:00:00
#SBATCH --job-name=rosco_test
#SBATCH --nodes=1             # This should be nC/36 (36 cores on eagle)
#SBATCH --ntasks-per-node=36
#SBATCH --mail-user dzalkind@nrel.gov
#SBATCH --mail-type BEGIN,END,FAIL
#SBATCH --output=logs/output.%j.out
#SBATCH --qos=high
#SBATCH --partition=debug

nDV=1 # Number of design variables (x2 for central difference)
nOF=60  # Number of openfast runs per finite-difference evaluation
nC=$((nDV + nDV * nOF)) # Number of cores needed. Make sure to request an appropriate number of nodes = N / 36
## nC=72

# module load conda
# conda activate rt-env
# source activate /home/dzalkind/.conda-envs/rosco-env
source /home/dzalkind/.bashrc
conda activate /kfs3/scratch/dzalkind/envs/rosco-scratch
# which python

# module purge
# module load conda
# module load comp-intel intel-mpi mkl

module list


# mpirun -n 36 python run_Testing.py
python run_Testing.py
#  python weis_driver.py

#!/bin/bash

# Change the directory to the script's location
cd "$(dirname "$0")"

# Create a temporary directory for cloning
temp_dir=$(mktemp -d)
echo "Created temporary directory: $temp_dir"

# Clone the repository
git clone -b develop https://github.com/IEAWindTask37/IEA-15-240-RWT "$temp_dir"

# Check if clone was successful
if [ $? -ne 0 ]; then
    echo "Failed to clone repository"
    rm -rf "$temp_dir"
    exit 1
fi

# Create IEA-15-240-RWT directory if it doesn't exist
mkdir -p IEA-15-240-RWT

# Copy OpenFAST directory contents
cp -r "$temp_dir/OpenFAST/"* IEA-15-240-RWT/

# Clean up temporary directory
rm -rf "$temp_dir"

echo "Files copied successfully to IEA-15-240-RWT directory"

---
name: Bug report
about: Create a report to help us improve
title: ''
labels: ''
assignees: ''

---

## Desired use case
_If you are able, please provide some background about your ROSCO use case. It helps guide our development and could help us better fix your issue._

## Description
_Describe the bug here_

### Steps to reproduce issue
_Please provide a minimum working example (MWE) if possible_

1. …
2. …
3. …

### Current behavior
…

### Expected behavior
…


### Code versions
_List versions only if relevant_
- Python
- …

## Description and Purpose

## Type of change
What types of change is it?
_Select the appropriate type(s) that describe this PR_

- [ ] Bugfix (non-breaking change which fixes an issue)
- [ ] New feature (non-breaking change which adds functionality)
- [ ] Breaking change (non-backwards-compatible fix or feature)
- [ ] Code style update (formatting, renaming)
- [ ] Refactoring (no functional changes, no API changes)
- [ ] Documentation update
- [ ] Maintenance update
- [ ] Other (please describe)

TODO Items General:
- [ ] Add example/test for new feature
- [ ] Update registry
- [ ] Run testing

TODO Items API Change:
- [ ] Update docs with API change
- [ ] Run update_rosco_discons.py in Test_Cases/
- [ ] Update DISCON schema

## Github issues addressed, if one exists

## Examples/Testing, if applicable

---
name: Feature request
about: Suggest an idea for this project
title: ''
labels: ''
assignees: ''

---

# Description of feature
Describe the feature here and provide some context. Under what scenario would this be useful?

# Potential solution
Can you think of ways to implement this?
